#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <engine>
#include <zombieplaguenightmare>

new const D7_CHAT_TAG[] = "^1[^4ZPNM^1] "

new const g_szClassInfoTarget[] = "info_target"
new const g_szClassBreakAble[] = "func_breakable"
new const g_szClassNameBazooka[] = "n4d_bazooka"
new const g_szClassNameRocket[] = "n4d_rocket"
new const g_szModelVBazooka[] = "models/zs/v_jp.mdl"
new const g_szModelPBazooka[] = "models/zs/p_jp.mdl"
new const g_szModelWBazooka[] = "models/zs/w_jp.mdl"
new const g_szModelRocket[] = "models/rpgrocket.mdl"
new const g_szSoundPickup[] = "items/gunpickup2.wav"
new const g_szSoundShoot[] = "zs/at4-1.wav"
new const g_szSoundTravel[] = "zs/bfuu.wav"
new const g_szSoundPickup[] = "items/gunpickup2.wav"

//Uncomment this to draw ring effect
#define DrawRing

//Uncomment to remove jetpack X time after drop
#define TimeRemove

new g_bHasBazooka[33];
new Float:g_fCountDown[33];
new SprExp, SprTrail, g_iItemID;
new CvarRadius, CvarDamage, CvarCooldown, CvarRocketSpeed;
new Float:CRadius, Float:CDamage, Float:CCooldown;

#if defined DrawRing
new SprRing;
#endif

#if defined TimeRemove
new CvarRemove, Float:CRemove
#endif

public plugin_precache()
{
	precache_sound(g_szSoundPickup)
	precache_sound(g_szSoundShoot)
	precache_sound(g_szSoundTravel)
	precache_sound(g_szSoundPickup)
	
	SprExp = precache_model("sprites/zerogxplode.spr")
	SprTrail = precache_model("sprites/smoke.spr")
	
	#if defined DrawRing
	SprRing = precache_model("sprites/shockwave.spr")
	#endif
	
	precache_model(g_szModelVBazooka)
	precache_model(g_szModelPBazooka)
	precache_model(g_szModelWBazooka)
	precache_model(g_szModelRocket)
}

public plugin_init()
{
	register_plugin("New Jetpack", "0.0.3", "Bad_Bud, ZmOutStanding, ConnorMcLeod, wbyokomo, D i 5 7 i n c T")
	
	register_event("HLTV", "OnNewRound", "a", "1=0", "2=0")
	
	RegisterHam(Ham_Killed, "player", "OnPlayerKilled", 1)
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_knife", "OnKnifePrimAtkPost", 1)
	RegisterHam(Ham_Item_Deploy, "weapon_knife", "OnKnifeDeployPost", 1)
	
	register_touch(g_szClassNameRocket, "*", "OnTouchRocket")
	register_touch(g_szClassNameBazooka, "player", "OnTouchJetPack")
	register_think(g_szClassNameBazooka, "OnThinkJetPack")
	
	CvarRadius = register_cvar("bzk_radius", "250.0")
	CvarDamage = register_cvar("bzk_damage", "600.0")
	CvarCooldown = register_cvar("bzk_cooldown", "10.0")
	CvarRocketSpeed = register_cvar("bzk_rocket_speed", "1757")
	
	#if defined TimeRemove
	CvarRemove = register_cvar("bzk_remove_time", "600.0")
	#endif
	
	g_iItemID = zp_register_extra_item("Bazooka", 37, ZP_TEAM_HUMAN | ZP_TEAM_SURVIVOR | ZP_TEAM_SNIPER)
	
	register_clcmd("drop", "CmdDropJP")
}

public client_putinserver(id)
	ResetValues(id)

public client_disconnect(id)
{
	remove_task(id)
	
	DropJetPack(id)
	
	ResetValues(id)
}

public OnNewRound()
{
	RemoveAllJetPack()
	CRadius = get_pcvar_float(CvarRadius)
	CDamage = get_pcvar_float(CvarDamage)
	CCooldown = get_pcvar_float(CvarCooldown)
	
	#if defined TimeRemove
	CRemove = get_pcvar_float(CvarRemove)
	#endif
}

public OnPlayerKilled(id)
{
	remove_task(id)
	
	DropJetPack(id)
	
	ResetValues(id)
}

public zp_user_infected_post(id)
{
	remove_task(id)
	
	DropJetPack(id)
	
	ResetValues(id)
}

public zp_extra_item_selected(id, item)
{
	if (item != g_iItemID)
		return PLUGIN_CONTINUE;
	
	if (g_bHasBazooka[id])
	{
		colored_chat(id, "^3You already have a bazooka^1!")
		
		return ZP_PLUGIN_HANDLED;
	}
	
	g_bHasBazooka[id] = true;
	
	if (task_exists(id))
	{
		remove_task(id)
		ProgressBar(id, 0)
	}
	
	engclient_cmd(id, "weapon_knife")
	
	ReplaceModel(id)
	
	emit_sound(id, CHAN_STATIC, g_szSoundPickup, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	
	return PLUGIN_CONTINUE;
}

public OnKnifePrimAtkPost(ent2)
{
	if (pev_valid(ent2) != 2)
		return;
	
	static id;
	id = get_pdata_cbase(ent2, 41, 4)
	
	if (!is_user_alive(id) || !g_bHasBazooka[id])
		return;
	
	static Float:ctime;
	ctime = get_gametime()
	
	if (g_fCountDown[id] >= ctime)
		return;
	
	new ent = create_entity(g_szClassInfoTarget)
	
	if (ent)
	{
		engfunc(EngFunc_SetModel, ent, g_szModelRocket)
		engfunc(EngFunc_SetSize, ent, Float:{0.0, 0.0, 0.0}, Float:{0.0, 0.0, 0.0})
		new Float:fOrigin[3]
		pev(id, pev_origin, fOrigin)
		fOrigin[2] += 16.0
		engfunc(EngFunc_SetOrigin, ent, fOrigin)
		set_pev(ent, pev_classname, g_szClassNameRocket)
		set_pev(ent, pev_dmg, 100.0)
		set_pev(ent, pev_owner, id)
		velocity_by_aim(id, get_pcvar_num(CvarRocketSpeed), fOrigin)
		set_pev(ent, pev_velocity, fOrigin)
		new Float:vecAngles[3]
		engfunc(EngFunc_VecToAngles, fOrigin, vecAngles)
		set_pev(ent, pev_angles, vecAngles)	
		set_pev(ent, pev_movetype, MOVETYPE_FLY)
		set_pev(ent, pev_effects, EF_LIGHT)
		set_pev(ent, pev_solid, SOLID_BBOX)
		
		emit_sound(id, CHAN_STATIC, g_szSoundShoot, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		emit_sound(ent, CHAN_WEAPON, g_szSoundTravel, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_BEAMFOLLOW)
		write_short(ent)
		write_short(SprTrail)
		write_byte(40)
		write_byte(5)
		write_byte(224)
		write_byte(224)
		write_byte(255)
		write_byte(192)
		message_end()
		
		g_fCountDown[id] = ctime+CCooldown
	}
	else
	{
		client_print(id, print_chat, "[JpDebug] Failed to create rocket.")
		g_fCountDown[id] = ctime+1.5
	}
}

public OnKnifeDeployPost(ent)
{
	if (pev_valid(ent) != 2)
		return;
	
	static id; id = get_pdata_cbase(ent, 41, 4);
	
	if (is_user_alive(id) && g_bHasBazooka[id])
		ReplaceModel(id);
}

public OnTouchRocket(ent, id)
{
	static Float:fOrigin[3]
	pev(ent, pev_origin, fOrigin)
	
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, fOrigin, 0)
	write_byte(TE_EXPLOSION)
	engfunc(EngFunc_WriteCoord, fOrigin[0])
	engfunc(EngFunc_WriteCoord, fOrigin[1])
	engfunc(EngFunc_WriteCoord, fOrigin[2])
	write_short(SprExp)
	write_byte(40)
	write_byte(30)
	write_byte(10)
	message_end()
	
	#if defined DrawRing
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, fOrigin, 0)
	write_byte(TE_BEAMCYLINDER)
	engfunc(EngFunc_WriteCoord, fOrigin[0])
	engfunc(EngFunc_WriteCoord, fOrigin[1])
	engfunc(EngFunc_WriteCoord, fOrigin[2])
	engfunc(EngFunc_WriteCoord, fOrigin[0])
	engfunc(EngFunc_WriteCoord, fOrigin[1])
	engfunc(EngFunc_WriteCoord, fOrigin[2]+555.0)
	write_short(SprRing)
	write_byte(0)
	write_byte(1)
	write_byte(6)
	write_byte(8)
	write_byte(10)
	write_byte(224)
	write_byte(224)
	write_byte(255)
	write_byte(192)
	write_byte(5)
	message_end()
	#endif
	
	static attacker; attacker = pev(ent, pev_owner)
	if (!is_user_connected(attacker))
	{
		engfunc(EngFunc_RemoveEntity, ent)
		return PLUGIN_CONTINUE;
	}
	
	static victim; victim = -1;
	while((victim = engfunc(EngFunc_FindEntityInSphere, victim, fOrigin, CRadius)) != 0)
	{
		if (!pev_valid(victim))
			continue;
		
		static Float:originV[3], Float:dist, Float:damage;
		
		pev(victim, pev_origin, originV)
		dist = get_distance_f(fOrigin, originV)
		damage = CDamage-(CDamage/CRadius)*dist
		
		if (damage <= 0.0)
			continue;
		
		if (!is_user_connected(victim))
		{
			static szClassName[32];
			pev(victim, pev_classname, szClassName, 31)
			
			if (!equali(szClassName, g_szClassBreakAble) || pev(victim, pev_solid) == SOLID_NOT)
				continue;
			
			static Float:fHealth;
		
			if ((fHealth = pev(victim, pev_health)) > damage)
				set_pev(victim, pev_health, fHealth - damage)
			else
				dllfunc(DLLFunc_Use, victim, ent)
		}
		else
		{
			if (!is_user_alive(victim) || !zp_get_user_zombie(victim))
				continue;
			
			if (get_user_health(id) > floatround(damage/*, floatround_floor*/))
				ExecuteHamB(Ham_TakeDamage, victim, ent, attacker, damage, DMG_BULLET)
			else
				ExecuteHamB(Ham_Killed, victim, attacker, 2)
			//client_print(attacker, print_chat, "[JpDebug] Rocket damage: %.1f", damage)
		}
	}
	
	engfunc(EngFunc_RemoveEntity, ent)
	
	return PLUGIN_CONTINUE;
}

public OnTouchJetPack(ent, id)
{
	if (pev(ent, pev_iuser4) == 11111 || !is_user_alive(id) || g_bHasBazooka[id] || zp_get_user_zombie(id))
		return;
	
	engfunc(EngFunc_RemoveEntity, ent)
	g_bHasBazooka[id] = true
	emit_sound(id, CHAN_STATIC, g_szSoundPickup, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	engclient_cmd(id, "weapon_knife")
	ReplaceModel(id)
}

public OnThinkJetPack(ent)
{
	if (pev_valid(ent) != 2)
		return;
	
	switch(pev(ent, pev_flTimeStepSound))
	{
		case 200:
		{
			set_pev(ent, pev_iuser4, 22222)
			
			#if defined TimeRemove
			set_pev(ent, pev_flTimeStepSound, 201)
			set_pev(ent, pev_nextthink, get_gametime()+CRemove)
			#endif
		}
		#if defined TimeRemove
		case 201:
			engfunc(EngFunc_RemoveEntity, ent)
		#endif
	}
}

public CmdDropJP(id)
{
	if (!is_user_alive(id) || !g_bHasBazooka[id] || get_user_weapon(id) != CSW_KNIFE)
		return PLUGIN_CONTINUE;
	
	DropJetPack(id)
	g_bHasBazooka[id] = false
	set_pev(id, pev_viewmodel2, "models/v_knife.mdl")
	set_pev(id, pev_weaponmodel2, "models/p_knife.mdl")
	
	return PLUGIN_CONTINUE;
}

ReplaceModel(const id)
{
	set_pev(id, pev_viewmodel2, g_szModelVBazooka)
	set_pev(id, pev_weaponmodel2, g_szModelPBazooka)
}

DropJetPack(id)
{
	new ent = create_entity(g_szClassInfoTarget)
	if (!ent) return;
	
	engfunc(EngFunc_SetModel, ent, g_szModelWBazooka)
	engfunc(EngFunc_SetSize, ent, Float:{-8.0, -8.0, -8.0}, Float:{8.0, 8.0, 8.0})
	new Float:fOrigin[3]
	pev(id, pev_origin, fOrigin)
	fOrigin[2] += 16.0
	engfunc(EngFunc_SetOrigin, ent, fOrigin)
	set_pev(ent, pev_classname, g_szClassNameBazooka)
	velocity_by_aim(id, 157, fOrigin) //if it too far then reduce it
	set_pev(ent, pev_velocity, fOrigin)	
	set_pev(ent, pev_movetype, MOVETYPE_TOSS)
//	set_pev(ent, pev_effects, EF_LIGHT)
	set_pev(ent, pev_iuser4, 11111)
	set_pev(ent, pev_solid, SOLID_TRIGGER)
	set_pev(ent, pev_flTimeStepSound, 200)
	set_pev(ent, pev_nextthink, get_gametime() + 0.57) // prevent drop/pickup exploit
	
	fm_set_rendering(ent)
}

RemoveAllJetPack()
{
	new ent = engfunc(EngFunc_FindEntityByString, -1, "classname", g_szClassNameBazooka)
	while(ent > 0)
	{
		engfunc(EngFunc_RemoveEntity, ent)
		ent = engfunc(EngFunc_FindEntityByString, -1, "classname", g_szClassNameBazooka)
	}
}

ResetValues(id)
{
	g_bHasBazooka[id] = false
}

stock colored_chat(const iTarget, const szMessage[], any:...)
{
	if (!is_user_connected(iTarget))
		return;
	
	static szBuffer[192];
	
	// Format message for player
	vformat(szBuffer, 191, szMessage, 3)
	format(szBuffer, 191, "%s%s", D7_CHAT_TAG, szBuffer)
	
	static msgSayText;
	if (!msgSayText)
		msgSayText = get_user_msgid("SayText");
	
	message_begin(MSG_ONE, msgSayText, _, iTarget)
	write_byte(iTarget)
	write_string(szBuffer)
	message_end()
}

// Set entity's rendering type (from fakemeta_util)
stock fm_set_rendering(const iEnt)
{
	static Float:flColor[3];
	flColor[0] = random_float(57.7, 255.0);
	flColor[1] = random_float(0.0, 255.0);
	flColor[2] = random_float(0.0, 255.0);
	
	set_pev(iEnt, pev_renderfx, kRenderFxGlowShell)
	set_pev(iEnt, pev_rendercolor, flColor)
	set_pev(iEnt, pev_rendermode, kRenderNormal)
	set_pev(iEnt, pev_renderamt, random_float(57.7, 75.7))
}

stock ProgressBar(const iID, const iTime, iStartPercent = 0)
{
	static msgBarTime2;
	if (!msgBarTime2)
		msgBarTime2 = get_user_msgid("BarTime2");
	
	message_begin(MSG_ONE, msgBarTime2, _, iID)
	write_short(iTime)
	write_short(iStartPercent)
	message_end()
}
