#include <amxmodx>
#include <colorchat>
#include <zpnm_sys_regeneration>
#include <zombieplaguenightmare>

new cvar_health, cvar_delay, cvar_interval, cvar_damage, cvar_duration, cvar_duration_type
new g_extra_regen, g_regeneration[33]

public plugin_init()
{
	register_plugin("[ZPNM] Regeneration(Zombies)", "1.1", "D i 5 7 i n c T")
	register_dictionary("zpnm_regeneration.txt")
	
	cvar_health = register_cvar("zpnm_regen_zm_health", "5")
	cvar_delay = register_cvar("zpnm_regen_zm_delay", "1.57")
	cvar_interval = register_cvar("zpnm_regen_zm_interval", "0.1")
	cvar_damage = register_cvar("zpnm_regen_zm_damage_stop", "3")
	cvar_duration = register_cvar("zpnm_regen_zm_duration", "1")
	cvar_duration_type = register_cvar("zpnm_regen_zm_duration_type", "2")
	
	g_extra_regen = zp_register_extra_item("Health regeneration", 10, ZP_TEAM_ZOMBIE)
}

public client_disconnect(id)
{
	remove_task(id)
	g_regeneration[id] = 0
}

public zpnm_user_spawn_post(id)
{
	remove_task(id)
	
	if (g_regeneration[id] == 0)
		return;
	
	zpnm_set_user_regeneration(id, TYPE_HEALTH, REGEN_REMOVE)
	
	if (g_regeneration[id] == -3)
		g_regeneration[id] = 0
}

zpnm_get_max_class_health(id)
{
	static health, classmaxhp
	health = get_user_health(id)
	classmaxhp = zp_get_zombie_maxhealth(id)
	
	if (health > classmaxhp)
		classmaxhp = health
	
	return classmaxhp;
}

public zp_extra_item_selected(id, itemid)
{
	if (itemid != g_extra_regen)
		return PLUGIN_CONTINUE;
	
	if (g_regeneration[id] != 0)
	{
		client_print(id, print_center, "%L", id, "ZPNM_REGENERATE_ALREADY")
		
		return ZP_PLUGIN_HANDLED;
	}
	
	static regen[64], interval[21], limit[10], stop[2], delay[21]
	zpnm_get_user_regeneration(id, TYPE_HEALTH, regen, 63)
	parse(regen, regen, 63, interval, 20, limit, 9, stop, 1, delay, 20)
	
	static chp, Float:citv, maxhp, cdmg, Float:cdl
	chp = get_pcvar_num(cvar_health)
	citv = get_pcvar_float(cvar_interval)
	cdmg = get_pcvar_num(cvar_damage)
	cdl = get_pcvar_float(cvar_delay)
	maxhp = zpnm_get_max_class_health(id)
	
	if (str_to_num(regen) >= chp && str_to_float(interval) <= citv &&
	str_to_num(limit) >= maxhp && str_to_num(stop) <= cdmg && str_to_float(delay) <= cdl)
	{
		client_print(id, print_center, "%L", id, "ZPNM_REGENERATE_ALREADY")
		
		return ZP_PLUGIN_HANDLED;
	}
	
	zpnm_set_user_regeneration(id, TYPE_HEALTH, chp, citv, maxhp, cdmg, cdl)
	
	g_regeneration[id] = get_pcvar_num(cvar_duration)
	
	return PLUGIN_CONTINUE;
}

public zp_user_infected_post(id, inf, nem, ass, bomb)
{
	if (nem || ass)
	{
		remove_task(id)
		
		if (g_regeneration[id] == 0)
			return;
		
		zpnm_set_user_regeneration(id, TYPE_HEALTH, REGEN_REMOVE)
		
		if (g_regeneration[id] == -3)
			g_regeneration[id] = 0
		
		return;
	}
	
	if (get_pcvar_num(cvar_duration) > -2)
	{
		if (g_regeneration[id] == 0)
			return;
	}
	else
		g_regeneration[id] = -2
	
	if (!bomb && zp_has_round_started() == 1 || zp_get_user_first_zombie(id))
		zpnm_start_regeneration(id)
	else
		set_task(0.11, "zpnm_start_regeneration", id)
}

public zpnm_start_regeneration(id)
{
	zpnm_set_user_regeneration(id, TYPE_HEALTH, get_pcvar_num(cvar_health), get_pcvar_float(cvar_interval), zpnm_get_max_class_health(id), get_pcvar_num(cvar_damage), get_pcvar_float(cvar_delay))
	
	if (g_regeneration[id] > -1 && get_pcvar_num(cvar_duration_type) < 2)
	{
		g_regeneration[id]--
		
		if (g_regeneration[id] == 0)
			g_regeneration[id] = -3
	}
}

public zp_user_humanized_post(id)
{
	remove_task(id)
	
	if (g_regeneration[id] == 0)
		return;
	
	zpnm_set_user_regeneration(id, TYPE_HEALTH, REGEN_REMOVE)
	
	if (g_regeneration[id] == -3)
		g_regeneration[id] = 0
}

public zpnm_user_killed_post(id)
{
	remove_task(id)
	
	if (g_regeneration[id] == -3)
		g_regeneration[id] = 0
}

public zp_round_ended()
{
	if (get_pcvar_num(cvar_duration_type) < 2)
		return;
	
	static id, maxplayers
	
	if (!maxplayers)
		maxplayers = get_maxplayers()
	
	for (id = 1; id <= maxplayers; id++)
	{
		remove_task(id)
		
		if (g_regeneration[id] > 0)
		{
			g_regeneration[id]--
			
			if (g_regeneration[id] == 0)
				g_regeneration[id] = -3
		}
	}
}
