#include <amxmodx>
#include <cstrike>
#include <fakemeta>
#include <dhudmessage>
#include <zombieplaguenightmare>

//#define ZP_COMPAT

#define TASK_DELAY 7575

const Float:HUD_SPECT_X = 0.57 //0.6
const Float:HUD_SPECT_Y = 0.75 //0.8
const Float:HUD_STATS_X = -1.0 //0.02
const Float:HUD_STATS_Y = 0.8957 //0.9

const PEV_SPEC_TARGET = pev_iuser2

new cvar_refresh, Float:g_refresh, g_msgMoney, g_class[33][32], g_ammo[33]//, g_name[33][31]
new cvar_hcolor[3], cvar_zcolor[3]

public plugin_init()
{
	register_plugin("[ZPNM] Display ammo as money", "1.0.7", "D i 5 7 i n c T")
	register_dictionary("zombie_plague.txt")
	register_dictionary("zombie_plague_nightmare.txt")
	
	cvar_refresh = register_cvar("zpnm_hud_refresh_rate", "0.577")
	
	g_msgMoney = get_user_msgid("Money")
#if defined ZP_COMPAT
	register_message(g_msgMoney, "message_money")
#endif
}

public plugin_cfg()
{
	set_task(0.757, "change_settings")
	set_task(1.57, "cache_settings")
}

public change_settings()
{
	set_pcvar_num(get_cvar_pointer("zp_hud_display"), 0)
#if !defined ZP_COMPAT
	set_pcvar_num(get_cvar_pointer("zp_remove_money"), 1)
#else
	set_pcvar_num(get_cvar_pointer("zp_remove_money"), 0)
#endif
}

public cache_settings()
{
	cvar_zcolor[0] = get_pcvar_num(get_cvar_pointer("zp_nvg_color_R"))
	cvar_zcolor[1] = get_pcvar_num(get_cvar_pointer("zp_nvg_color_G"))
	cvar_zcolor[2] = get_pcvar_num(get_cvar_pointer("zp_nvg_color_B"))
	cvar_hcolor[0] = get_pcvar_num(get_cvar_pointer("zp_nvg_hum_color_R"))
	cvar_hcolor[1] = get_pcvar_num(get_cvar_pointer("zp_nvg_hum_color_G"))
	cvar_hcolor[2] = get_pcvar_num(get_cvar_pointer("zp_nvg_hum_color_B"))
}	

public client_putinserver(id)
{
//	g_ammo[id] = zp_get_user_ammo_packs(id)
	g_refresh = get_pcvar_float(cvar_refresh)
	set_task(g_refresh, "ShowDeadHUD", id, _, _, "b")
	
	new flash[2]; flash[0] = 0
	set_task(0.757, "UpdateAmmoAndHUD", id+TASK_DELAY, flash, 1)
}
/*
public client_infochanged(id)
	get_user_info(id, "name", g_name[id], 30)*/

public UpdateAmmoAndHUD(flash[], taskid)
{
	static id
	id = taskid - TASK_DELAY
	
	g_ammo[id] = zp_get_user_ammo_packs(id)
	zpnm_display_money(id, g_ammo[id], flash[0])
}

public client_disconnect(id)
{
	remove_task(id)
	remove_task(id+TASK_DELAY)
	g_refresh = get_pcvar_float(cvar_refresh)
}

public zpnm_user_spawn_post(id)
{
	remove_task(id)
	
#if !defined ZP_COMPAT
	zpnm_get_class_name(1, zpnm_get_user_human_class(id), g_class[id], 31)
	ShowAliveHumanHUD(id)
	set_task(g_refresh, "ShowAliveHumanHUD", id, _, _, "b")
#else
	g_class[id] = "CLASS_HUMAN"
	ShowAliveSpecialHumanHUD(id)
	set_task(g_refresh, "ShowAliveSpecialHumanHUD", id, _, _, "b")
#endif
	
//	g_ammo[id] = zp_get_user_ammo_packs(id)
//	
	remove_task(id+TASK_DELAY)
	new flash[2]; flash[0] = 0
	set_task(0.2, "UpdateAmmoAndHUD", id+TASK_DELAY, flash, 1)
//	zpnm_display_money(id, g_ammo[id], 0)
}

public zp_user_infected_post(id, infector, nemesis, assassin)
{
	remove_task(id+TASK_DELAY)
	new flash[2]; flash[0] = 0
	set_task(0.1, "UpdateAmmoAndHUD", id+TASK_DELAY, flash, 1)
	
	remove_task(id)
	
	if (!assassin)
	{
		if (!nemesis)
		{
#if !defined ZP_COMPAT
			zpnm_get_class_name(0, zp_get_user_zombie_class(id), g_class[id], 31)
			ShowAliveZombieHUD(id)
			set_task(g_refresh, "ShowAliveZombieHUD", id, _, _, "b")
#else
			g_class[id] = "CLASS_ZOMBIE"
			ShowAliveSpecialZombieHUD(id)
			set_task(g_refresh, "ShowAliveSpecialZombieHUD", id, _, _, "b")
#endif
			
			return;
		}
		else
			g_class[id] = "CLASS_NEMESIS"
	}
	else
		g_class[id] = "CLASS_ASSASSIN"
	
	ShowAliveSpecialZombieHUD(id)
	set_task(g_refresh, "ShowAliveSpecialZombieHUD", id, _, _, "b")
}

public zp_user_humanized_post(id, survivor, sniper)
{
	remove_task(id)
	
	if (!sniper)
	{
		if (!survivor)
		{
#if !defined ZP_COMPAT
			zpnm_get_class_name(1, zpnm_get_user_human_class(id), g_class[id], 31)
			ShowAliveHumanHUD(id)
			set_task(g_refresh, "ShowAliveHumanHUD", id, _, _, "b")
#else
			g_class[id] = "CLASS_HUMAN"
			ShowAliveSpecialHumanHUD(id)
			set_task(g_refresh, "ShowAliveSpecialHumanHUD", id, _, _, "b")
#endif
			
			return;
		}
		else
			g_class[id] = "CLASS_SURVIVOR"
	}
	else
		g_class[id] = "CLASS_SNIPER"
	
	ShowAliveSpecialHumanHUD(id)
	set_task(g_refresh, "ShowAliveSpecialHumanHUD", id, _, _, "b")
}

public zpnm_user_get_ammo_pack(id)
{
//	g_ammo[id] = zp_get_user_ammo_packs(id)
//	
	remove_task(id+TASK_DELAY)
	new flash[2];
	
	if (is_user_alive(id))
	{
		flash[0] = 1
//		zpnm_display_money(id, g_ammo[id])
	}
	
	set_task(0.1, "UpdateAmmoAndHUD", id+TASK_DELAY, flash, 1)
}

public zp_extra_item_selected(id)
{
//	g_ammo[id] = zp_get_user_ammo_packs(id)
//	
	remove_task(id+TASK_DELAY)
	new flash[2]; flash[0] = 1
	set_task(0.1, "UpdateAmmoAndHUD", id+TASK_DELAY, flash, 1)
//	zpnm_display_money(id, g_ammo[id])
}

public zpnm_user_killed_post(id, attacker)
{
	remove_task(id)
	remove_task(id+TASK_DELAY)
	set_task(g_refresh, "ShowDeadHUD", id, _, _, "b")
	
	if (!zpnm_get_user_valid(attacker))
		return;
	
	new flash[2]; flash[0] = 1
	set_task(0.1, "UpdateAmmoAndHUD", attacker+TASK_DELAY, flash, 1)
}

zpnm_display_money(id, amount, flash = 1)
{
	message_begin(MSG_ONE_UNRELIABLE, g_msgMoney, _, id)
	write_long(amount)
	write_byte(flash)
	message_end()
}

public ShowAliveHumanHUD(id)
{
	set_dhudmessage(cvar_zcolor[0], cvar_zcolor[1], cvar_zcolor[2], HUD_STATS_X, HUD_STATS_Y, 0, 6.0, g_refresh + 0.0757, 0.0, 0.0) // | , -1)
	show_dhudmessage(id, "[%L: %d][%L: %d][%L %s]", id, "ZOMBIE_ATTRIB1", get_user_health(id), id, "ZOMBIE_ATTRIB5", get_user_armor(id), id, "CLASS_CLASS", g_class[id])
}

public ShowAliveSpecialHumanHUD(id)
{
	set_dhudmessage(cvar_zcolor[0], cvar_zcolor[1], cvar_zcolor[2], HUD_STATS_X, HUD_STATS_Y, 0, 6.0, g_refresh + 0.0757, 0.0, 0.0) // | , -1)
	show_dhudmessage(id, "[%L: %d][%L: %d][%L %L]", id, "ZOMBIE_ATTRIB1", get_user_health(id), id, "ZOMBIE_ATTRIB5", get_user_armor(id), id, "CLASS_CLASS", id, g_class[id])
}

public ShowAliveZombieHUD(id)
{
	set_dhudmessage(cvar_hcolor[0], cvar_hcolor[1], cvar_hcolor[2], HUD_STATS_X, HUD_STATS_Y, 0, 6.0, g_refresh + 0.0757, 0.0, 0.0) // | , -1)
	show_dhudmessage(id, "[%L: %d][%L: %d][%L %s]", id, "ZOMBIE_ATTRIB1", get_user_health(id), id, "ZOMBIE_ATTRIB5", get_user_armor(id), id, "CLASS_CLASS", g_class[id])
}

public ShowAliveSpecialZombieHUD(id)
{
	set_dhudmessage(cvar_hcolor[0], cvar_hcolor[1], cvar_hcolor[2], HUD_STATS_X, HUD_STATS_Y, 0, 6.0, g_refresh + 0.0757, 0.0, 0.0) // | , -1)
	show_dhudmessage(id, "[%L: %d][%L: %d][%L %L]", id, "ZOMBIE_ATTRIB1", get_user_health(id), id, "ZOMBIE_ATTRIB5", get_user_armor(id), id, "CLASS_CLASS", id, g_class[id])
}

public ShowDeadHUD(id)
{
	static id2
	id2 = pev(id, PEV_SPEC_TARGET)
	
	if (!id2 || id == id2)
		return;
	
	set_dhudmessage(cvar_zcolor[0], cvar_zcolor[1], cvar_zcolor[2], HUD_SPECT_X, HUD_SPECT_Y, 0, 6.0, g_refresh + 0.0757, 0.0, 0.0) // | , -1)
	
	if (containi(g_class[id2], "CLASS_") == -1)
		show_dhudmessage(id, "[%L %d][%L: %d]^n[%L %s]^n[%L %d]", id, "ZOMBIE_ATTRIB1", get_user_health(id2), id, "ZOMBIE_ATTRIB5", get_user_armor(id2), id, "CLASS_CLASS", g_class[id2], id, "AMMO_PACKS1", g_ammo[id2])
	else
		show_dhudmessage(id, "[%L %d][%L: %d]^n[%L %L]^n[%L %d]", id, "ZOMBIE_ATTRIB1", get_user_health(id2), id, "ZOMBIE_ATTRIB5", get_user_armor(id2), id, "CLASS_CLASS", id, g_class[id2], id, "AMMO_PACKS1", g_ammo[id2])		
}

#if defined ZP_COMPAT
// Take off player's money
public message_money(msg_id, msg_dest, id)
{
	if (pev_valid(id) != 2)
		return PLUGIN_CONTINUE;
	
	set_pdata_int(id, 115, 0, 5)
	
	return PLUGIN_HANDLED;
}
#endif
