#include <amxmodx>
#include <cstrike>
#include <hamsandwich>
#include <zombieplaguenightmare>

// Maximum number of addresses to remember(don't remove the " + 1")
const g_iMaxAddresses = 64 + 1;

new g_szRespawnedAddresses[g_iMaxAddresses][26], g_szPlayerAddress[33][26], g_iSeconds[33];

public plugin_init()
{
	register_plugin("[ZPNM] Auto Spawn on Connect", "1.1", "D i 5 7 i n c T")
	register_dictionary("zpnm_auto_connect_spawn.txt")
	
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0")
	
	register_clcmd("joinclass", "clcmd_joinclass")
	
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn_Post", 1)
}

public event_round_start()
{
	static iMaxPlayers;
	if (!iMaxPlayers)
		iMaxPlayers = get_maxplayers() + 1;
	
	new iPlayerID, iAddressConnected;
	
	for (new i; i < g_iMaxAddresses; i++)
	{
		if (!g_szRespawnedAddresses[i][0])
			continue;
		
		iAddressConnected = false;
		
		for (iPlayerID = 1; iPlayerID < iMaxPlayers; iPlayerID++)
		{
			if (!is_user_connected(iPlayerID) || containi(g_szRespawnedAddresses[i], g_szPlayerAddress[iPlayerID]) == -1)
				continue;
			
			iAddressConnected = true;
			
			break;
		}
		
		if (!iAddressConnected)
			continue;
		
		g_szRespawnedAddresses[i] = ""
	}
}

public client_putinserver(id)
	get_user_ip(id, g_szPlayerAddress[id], 25)

public client_disconnect(id)
{
	remove_task(id)
	g_iSeconds[id] = 0;
}

public clcmd_joinclass(id)
{
	if (g_iSeconds[id] < 0)
		return;
	
	new iNoRespawn;
	
	for (new i; i < g_iMaxAddresses; i++)
	{
		if (!g_szRespawnedAddresses[i][0] || containi(g_szRespawnedAddresses[i], g_szPlayerAddress[id]) == -1)
			continue;
		
		iNoRespawn = true;
		
		break;
	}
	
	if (iNoRespawn)
		return;
	
	static pcvDelay;
	if (!pcvDelay)
		pcvDelay = get_cvar_pointer("zp_spawn_delay");
	
	zpnm_respawn_player_countdown(id)
}

public zpnm_respawn_player_countdown(const id)
{
	if (g_iSeconds[id])
	{
		client_print(id, print_center, "%L", id, "ZPNM_AUTO_SPAWN", g_iSeconds[id])
		
		g_iSeconds[id]--
		set_task(1.0, "zpnm_respawn_player_countdown", id)
	}
	else
	{
		if (cs_get_user_team(id) == CS_TEAM_UNASSIGNED
		|| cs_get_user_team(id) == CS_TEAM_SPECTATOR)
			return;
		
		zp_respawn_user(id)
	}
}

public fw_PlayerSpawn_Post(id)
{
	if (!is_user_alive(id) || g_iSeconds[id] < 0)
		return;
	
	g_iSeconds[id] = -1;
	
	remove_task(id)
	g_szRespawnedAddresses[id] = true
}
