#include <amxmodx>
#include <fun>
#include <zp50_colorchat>
#include <zombieplaguenightmare>

new g_extra_antidote, g_pcvars[5]
new g_timer[33], g_hits[33], g_zombie_nvg[3]

enum
{
	delay,
	hits,
	antidote,
	effects,
	reward
}

public plugin_init()
{
	register_plugin("[ZPNM] Delayed Infection", "1.2", "D i 5 7 i n c T")
	
	register_dictionary("zpnm_delayed_infection.txt")
	
	g_pcvars[delay] = register_cvar("zpnm_delayed_infection_time", "15")
	g_pcvars[hits] = register_cvar("zpnm_delayed_infection_hits", "3")
	g_pcvars[antidote] = register_cvar("zpnm_delayed_infection_antidote", "1")
	g_pcvars[effects] = register_cvar("zpnm_delayed_infection_effects", "1")
	g_pcvars[reward] = register_cvar("zpnm_delayed_infection_reward", "0")
}

public plugin_precache()
	g_extra_antidote = zp_register_extra_item("Contamination Antidote", 11, ZP_TEAM_HUMAN)

public plugin_cfg()
	set_task(1.57, "cache_settings")

public cache_settings()
{
	g_pcvars[delay] = get_pcvar_num(g_pcvars[delay])
	g_pcvars[hits] = get_pcvar_num(g_pcvars[hits])
	g_pcvars[antidote] = get_pcvar_num(g_pcvars[antidote])
	g_pcvars[effects] = get_pcvar_num(g_pcvars[effects])
	g_pcvars[reward] = get_pcvar_num(g_pcvars[reward])
	
	g_zombie_nvg[0] = get_cvar_num("zp_nvg_color_R")
	g_zombie_nvg[1] = get_cvar_num("zp_nvg_color_G")
	g_zombie_nvg[2] = get_cvar_num("zp_nvg_color_B")
}

public client_disconnect(id)
	remove_task(id)

public zpnm_user_spawn_post(id)
{
	g_hits[id] = 0
	
	if (task_exists(id))
	{
		remove_task(id)
		set_user_rendering(id)
	}
}

public zp_user_infect_attempt(id, infector, nem, ass, nade)
{
	if (!infector || nade)
		return PLUGIN_CONTINUE;
	
	g_hits[id]++
	
	if (g_hits[id] == g_pcvars[hits])
		return PLUGIN_CONTINUE;
	
	if (!task_exists(id))
	{
		static temp[1]
		temp[0] = infector
		
		g_timer[id] = g_pcvars[delay]
		zpnm_infect_user_countdown(temp, id)
		
		if (g_pcvars[effects])
			set_user_rendering(id, kRenderFxGlowShell, g_zombie_nvg[0], g_zombie_nvg[1], g_zombie_nvg[2], kRenderNormal, 0)
		
		if (g_pcvars[reward])
		{
			zp_set_user_ammo_packs(infector, zp_get_user_ammo_packs(infector) + g_pcvars[reward])
			zp_colored_print(infector, "You received %d ammo pack%s for contamining a human.", g_pcvars[reward], g_pcvars[reward] > 1 ? "s" : "")
		}
	}
	
	return ZP_PLUGIN_HANDLED;
}

public zp_user_infected_post(id, infector, nemesis, assassin)
{
	g_hits[id] = 0
	remove_task(id)
	
	if (nemesis && get_cvar_num("zp_nem_glow") || assassin && get_cvar_num("zpnm_ass_glow"))
		return;
	
	set_user_rendering(id)
}

public zp_user_humanized_post(id, survivor, sniper)
{
	g_hits[id] = 0
	remove_task(id)
	
	if (survivor && get_cvar_num("zp_surv_glow") || sniper && get_cvar_num("zpnm_snip_glow"))
		return;
	
	set_user_rendering(id)
}

public zp_user_last_human(id)
{
	g_hits[id] = 0
	
	if (!task_exists(id))
		return;
	
	remove_task(id)
	set_user_rendering(id)
	zp_colored_print(id, "As the last human remaining, you became immune to the infection.")
}

public zp_extra_item_selected(id, itemid)
{
	if (itemid != g_extra_antidote)
		return PLUGIN_CONTINUE;
	
	if (!get_pcvar_num(g_pcvars[antidote]))
	{
		zp_colored_print(id, "Contamination antidote is inaccesable.")
		return ZP_PLUGIN_HANDLED;
	}
	
	if (!task_exists(id))
	{
		zp_colored_print(id, "You are not contamined with the virus!")
		return ZP_PLUGIN_HANDLED;
	}
	
	g_hits[id] = 0
	remove_task(id)
	set_user_rendering(id)
	zp_colored_print(id, "Antidote taken and contamination neutralized!")
	
	return PLUGIN_CONTINUE;
}

public zpnm_infect_user_countdown(infector[], id)
{
	if (g_timer[id] > 0)
	{
		if (get_pcvar_num(g_pcvars[antidote]))
			client_print(id, print_center, "%L %L", id, "ZPNM_DI_CONTAMINATED", id, "ZPNM_DI_ANTIDOTE")
		else
			client_print(id, print_center, "%L %L", id, "ZPNM_DI_CONTAMINATED", id, "ZPNM_DI_INFECTED")
		
		g_timer[id]--
		set_task(1.0, "zpnm_infect_user_countdown", id, infector, 1)
	}
	else
	{
		if (zpnm_get_user_valid(infector[0]) && zp_get_user_zombie(infector[0]))
			zp_infect_user(id, infector[0], 0, 1)
		else
			zp_infect_user(id)
	}
}
