/* Debug :) */
//#define DEBUG
//#define DEBUG_WITH_MODEL

/* Only enable ONE! */
#define ACCURACY_100_PERCENT // 8 native
//#define ACCURACY_80_PERCENT // 6 native
//#define ACCURACY_30_PERCENT // 6 native

#include <amxmodx>
#include <engine>
#include <fakemeta>
#if defined DEBUG
#include <hamsandwich>
#endif // DEBUG

new g_bitPlayerFlashlight, g_iMaxPlayers;

#define VectorAdd(%0,%1,%2)		(%2[0] = %0[0] + %1[0], %2[1] = %0[1] + %1[1], %2[2] = %0[2] + %1[2])
#define VectorMA(%0,%1,%2,%3)	(%3[0] = %0[0] + %1 * %2[0], %3[1] = %0[1] + %1 * %2[1], %3[2] = %0[2] + %1 * %2[2])
#define VectorMS(%0,%1,%2)		(%2[0] = %0[0] * %1, %2[1] = %0[1] * %1, %2[2] = %0[2] * %1)

#define MarkPlayerFlashLight(%0)	g_bitPlayerFlashlight |= 1<<(%0&31)
#define ClearPlayerFlashLight(%0)	g_bitPlayerFlashlight &= ~(1<<(%0&31))
#define HasPlayerFlashLightOn(%0)	(g_bitPlayerFlashlight & 1<<(%0&31))

public plugin_init()
{
	register_plugin("[ZPNM] Flashlight Fix", "1.3.0", "schmurgel1983, ConnorMcLeod, D i 5 7 i n c T")
	
	register_event("Flashlight", "Event_Flashlight", "b") // is b thats ok
	register_event("StatusValue", "ShowStatus", "be", "1=2", "2!0")
	register_event("StatusValue", "HideStatus", "be", "1=1", "2=0")
	
	#if defined DEBUG
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn_Post", 1)
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled_Post", 1)
	#endif // DEBUG
	
	g_iMaxPlayers = get_maxplayers()
}

#if defined DEBUG_WITH_MODEL
public plugin_precache()
{
	engfunc(EngFunc_PrecacheModel, "models/rpgrocket.mdl")
}
#endif // DEBUG_WITH_MODEL

public client_disconnect(id)
{
	remove_task(id)
	ClearPlayerFlashLight(id)
}

#if defined DEBUG
public fw_PlayerSpawn_Post(id)
#else // DEBUG
public zpnm_user_spawn_post(id)
#endif // !DEBUG
{
	#if defined DEBUG
	if (!is_user_alive(id))
		return;
	
	engfunc(EngFunc_LightStyle, 0, "b")
	set_cvar_num("sv_skycolor_r", 0)
	set_cvar_num("sv_skycolor_g", 0)
	set_cvar_num("sv_skycolor_b", 0)
	#endif // DEBUG
	
	remove_task(id)
	ClearPlayerFlashLight(id)
}

#if defined DEBUG
public fw_PlayerKilled_Post(id)
#else // DEBUG
public zpnm_user_killed_post(id)
#endif // !DEBUG
{
	remove_task(id)
	ClearPlayerFlashLight(id)
}

public Event_Flashlight(id)
{
	if (read_data(1))
	{
		MarkPlayerFlashLight(id)
		
		new iAim, iBodyPart;
		get_user_aiming(id, iAim, iBodyPart)
		
		if (iAim < 1 || iAim > g_iMaxPlayers || !is_user_alive(iAim)) // || HasPlayerFlashLightOn(iAim)
			return;
		
		LightTarget(id)
		set_task(0.1, "LightTarget", id, _, _, "b")
	}
	else
	{
		remove_task(id)
		ClearPlayerFlashLight(id)
	}
}

public ShowStatus(id)
{
	if (!HasPlayerFlashLightOn(id))
		return;
	
	new iAim = read_data(2);
    
	if (iAim < 1 || iAim > g_iMaxPlayers || !is_user_alive(iAim)) // || HasPlayerFlashLightOn(iAim)
		return;
	
	LightTarget(id)
	set_task(0.1, "LightTarget", id, _, _, "b")
}

public HideStatus(id)
	remove_task(id)

/* LightTarget 100% */
#if defined ACCURACY_100_PERCENT
public LightTarget(id)
{
	new Float:flOrigin[3], Float:flDirection[3]
	
	GetGunPosition(id, flOrigin)
	GetForwardDirection(id, flDirection)
	
	Lighting(id, flOrigin, flDirection)
}

Lighting(const id, const Float:flOrigin[3], const Float:flDirection[3])
{
    new Float:flEnd[3]
    new Float:flEndPos[3]
    
    VectorMA(flOrigin, 1500.0, flDirection, flEnd)
	
    // -- T1 : source -> end
    trace_line(id, flOrigin, flEnd, flEndPos)
	
    VectorMA(flEndPos, -24.0, flDirection, flEndPos)
    
    // -- T2 : End Position #1 - 24 units -> end.
    trace_line(id, flOrigin, flEndPos, flEndPos)
    
	#if defined DEBUG_WITH_MODEL
	new ent = create_entity("info_target")
	if (pev_valid(ent))
	{
		register_think("Light_Model", "CacheCvars")
		
		engfunc(EngFunc_SetOrigin, ent, flEndPos)
		engfunc(EngFunc_SetModel, ent, "models/rpgrocket.mdl")
		set_pev(ent, pev_classname, "Light_Model")
		fm_set_rendering(ent, kRenderFxGlowShell, 255, 255, 255, kRenderNormal, 8);
		set_pev(ent, pev_nextthink, get_gametime() + 1.0)
	}
	#endif // DEBUG_WITH_MODEL
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_ELIGHT) // TE id
	write_short(0) // let this 0 !
	engfunc(EngFunc_WriteCoord, flEndPos[0]) // x light origin
	engfunc(EngFunc_WriteCoord, flEndPos[1]) // y done
	engfunc(EngFunc_WriteCoord, flEndPos[2]) // z
	write_coord(9) // radius (35)
	write_byte(255) // r
	write_byte(255) // g
	write_byte(255) // b
	write_byte(2) // life
	write_coord(0) // decay rate
	message_end()
}

GetGunPosition(const id, Float:flOrigin[3])
{
    new Float:flViewOfs[3]
    
    pev(id, pev_origin, flOrigin)
    pev(id, pev_view_ofs, flViewOfs)
    
    VectorAdd(flOrigin, flViewOfs, flOrigin)
}

GetForwardDirection(const id, Float:flDirection[3])
{
    new Float:flViewAngles[3], Float:flPunchAngles[3]
    
    pev(id, pev_v_angle, flViewAngles)
    pev(id, pev_punchangle, flPunchAngles) 
    
    VectorAdd(flViewAngles, flPunchAngles, flViewAngles)
    engfunc(EngFunc_MakeVectors, flViewAngles)
    
    global_get(glb_v_forward, flDirection)
}
#endif // ACCURACY_100_PERCENT

/* LightTarget 80% */
#if defined ACCURACY_80_PERCENT
public LightTarget(id)
{
	static iOrigin[3], iAiming[3]
	get_user_origin(id, iOrigin, 0)
	get_user_origin(id, iAiming, 3)
	
	if (get_distance(iOrigin, iAiming) > 1500)
		return
	
	new Float:flOrigin[3], Float:flAimOrigin[3]
	pev(id, pev_origin, flOrigin)
	velocity_by_aim(id, get_distance(iOrigin, iAiming) - 24, flAimOrigin)
	VectorAdd(flAimOrigin, flOrigin, flAimOrigin)
	flAimOrigin[2] = float(iAiming[2])
	
	#if defined DEBUG_WITH_MODEL
	new ent = create_entity("info_target") // -.- fuck
	if (pev_valid(ent))
	{
		register_think("Light_Model", "CacheCvars")
		
		engfunc(EngFunc_SetOrigin, ent, flAimOrigin)
		engfunc(EngFunc_SetModel, ent, "models/rpgrocket.mdl")
		set_pev(ent, pev_classname, "Light_Model")
		fm_set_rendering(ent, kRenderFxGlowShell, 255, 255, 255, kRenderNormal, 8);
		set_pev(ent, pev_nextthink, get_gametime() + 1.0)
	}
	#endif // DEBUG_WITH_MODEL
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_ELIGHT) // TE id
	write_short(0) // let this 0 !
	engfunc(EngFunc_WriteCoord, flAimOrigin[0]) // x light origin
	engfunc(EngFunc_WriteCoord, flAimOrigin[1]) // y done
	engfunc(EngFunc_WriteCoord, flAimOrigin[2]) // z
	write_coord(9) // radius (35)
	write_byte(255) // r
	write_byte(255) // g
	write_byte(255) // b
	write_byte(2) // life
	write_coord(0) // decay rate
	message_end()
}
#endif // ACCURACY_80_PERCENT

/* LightTarget 30% */
#if defined ACCURACY_30_PERCENT
public LightTarget(id)
{
	static Float:flOrigin[3], Float:flAimOrigin[3]
	pev(id, pev_origin, flOrigin)
	
	velocity_by_aim(id, 1500, flAimOrigin) // distance
	VectorAdd(flAimOrigin, flOrigin, flAimOrigin)
	
	engfunc(EngFunc_TraceLine, flOrigin, flAimOrigin, DONT_IGNORE_MONSTERS, id, 0)
	
	new Float:flFraction
	get_tr2(0, TR_flFraction, flFraction)
	if (flFraction < 1.0)
	{
		get_tr2(0, TR_vecEndPos, flOrigin)
		get_tr2(0, TR_vecPlaneNormal, flAimOrigin)
	}
	else return;
	
	if (!flAimOrigin[0] || !flAimOrigin[1] || !flAimOrigin[2]) // fix (on a crappy angle this light spot is really far away that show the pictures)
		return;
	
	VectorMS(flAimOrigin, 24.0, flAimOrigin) // units outside (away!!!)
	VectorAdd(flOrigin, flAimOrigin, flOrigin)
	
	#if defined DEBUG_WITH_MODEL
	new ent = create_entity("info_target") // -.- fuck
	if (pev_valid(ent))
	{
		register_think("Light_Model", "CacheCvars")
		
		engfunc(EngFunc_SetOrigin, ent, flOrigin)
		engfunc(EngFunc_SetModel, ent, "models/rpgrocket.mdl")
		set_pev(ent, pev_classname, "Light_Model")
		fm_set_rendering(ent, kRenderFxGlowShell, 255, 255, 255, kRenderNormal, 8);
		set_pev(ent, pev_nextthink, get_gametime() + 1.0)
	}
	#endif // DEBUG_WITH_MODEL
	
	//new iRGB = 255 - floatround(255.0 * flFraction); // friction can only be 0.0 - 1.0!
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_ELIGHT) // TE id
	write_short(0) // let this 0 !
	engfunc(EngFunc_WriteCoord, flOrigin[0]) // x light origin
	engfunc(EngFunc_WriteCoord, flOrigin[1]) // y done
	engfunc(EngFunc_WriteCoord, flOrigin[2]) // z
	write_coord(9) // radius
	write_byte(255) // r
	write_byte(255) // g
	write_byte(255) // b
	write_byte(2) // life
	write_coord(0) // decay rate
	message_end()
}
#endif // ACCURACY_30_PERCENT

#if defined DEBUG_WITH_MODEL
public CacheCvars(ent)
	remove_entity(ent)

stock fm_set_rendering(entity, fx = kRenderFxNone, r = 255, g = 255, b = 255, render = kRenderNormal, amount = 16)
{
	static Float:color[3];
	color[0] = float(r);
	color[1] = float(g);
	color[2] = float(b);
	
	set_pev(entity, pev_renderfx, fx);
	set_pev(entity, pev_rendercolor, color);
	set_pev(entity, pev_rendermode, render);
	set_pev(entity, pev_renderamt, float(amount));
}
#endif // DEBUG_WITH_MODEL