#include <amxmodx>
#include <engine>
#include <fakemeta>
//#include <hamsandwich>
#include <xs>

new g_bitPlayerFlashlight, g_iMaxPlayers;

#define MarkPlayerFlashLight(%0)	g_bitPlayerFlashlight |= 1<<(%0&31)
#define ClearPlayerFlashLight(%0)	g_bitPlayerFlashlight &= ~(1<<(%0&31))
#define HasPlayerFlashLightOn(%0)	(g_bitPlayerFlashlight & 1<<(%0&31))

public plugin_init()
{
	register_plugin("[ZPNM] Flashlight Fix", "1.2.0", "schmurgel1983, ConnorMcLeod, D i 5 7 i n c T")
	
	register_event("Flashlight", "Event_Flashlight", "b") // is b thats ok
	register_event("StatusValue", "ShowStatus", "be", "1=2", "2!0")
	register_event("StatusValue", "HideStatus", "be", "1=1", "2=0")
	
//	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn_Post", 1)
//	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled_Post", 1)
//	
	g_iMaxPlayers = get_maxplayers()
}

public plugin_precache()
{
	engfunc(EngFunc_PrecacheModel, "models/rpgrocket.mdl")
}

public client_disconnect(id)
{
	remove_task(id)
	ClearPlayerFlashLight(id)
}

public zpnm_user_spawn_post(id) //fw_PlayerSpawn_Post
{
/*	if (!is_user_alive(id))
		return;
	
//	engfunc(EngFunc_LightStyle, 0, "b")
//	set_cvar_num("sv_skycolor_r", 0)
//	set_cvar_num("sv_skycolor_g", 0)
//	set_cvar_num("sv_skycolor_b", 0)
//	*/
	remove_task(id)
	ClearPlayerFlashLight(id)
}

public zpnm_user_killed_post(id) //fw_PlayerKilled_Post
{
	remove_task(id)
	ClearPlayerFlashLight(id)
}

public Event_Flashlight(id)
{
	if (read_data(1))
	{
		MarkPlayerFlashLight(id)
		
		new iAim, iBodyPart;
		get_user_aiming(id, iAim, iBodyPart)
		
		if (iAim < 1 || iAim > g_iMaxPlayers || !is_user_alive(iAim)) // || HasPlayerFlashLightOn(iAim)
			return;
		
		LightTarget(id)
		set_task(0.1, "LightTarget", id, _, _, "b")
	}
	else
	{
		remove_task(id)
		ClearPlayerFlashLight(id)
	}
}

public ShowStatus(id)
{
	if (!HasPlayerFlashLightOn(id))
		return;
	
	new iAim = read_data(2);
    
	if (iAim < 1 || iAim > g_iMaxPlayers || !is_user_alive(iAim)) // || HasPlayerFlashLightOn(iAim)
		return;
	
	LightTarget(id)
	set_task(0.1, "LightTarget", id, _, _, "b")
}

public HideStatus(id)
	remove_task(id)

public LightTarget(id)
{
	static Float:flOrigin[3], Float:flAimOrigin[3];
	pev(id, pev_origin, flOrigin)
	
	velocity_by_aim(id, 1500, flAimOrigin) // distance
	xs_vec_add(flAimOrigin, flOrigin, flAimOrigin)
	
	engfunc(EngFunc_TraceLine, flOrigin, flAimOrigin, DONT_IGNORE_MONSTERS, id, 0)
	
	new Float:flFraction;
	get_tr2(0, TR_flFraction, flFraction)
	if (flFraction < 1.0)
	{
		get_tr2(0, TR_vecEndPos, flOrigin)
		get_tr2(0, TR_vecPlaneNormal, flAimOrigin)
	}
	
	xs_vec_mul_scalar(flAimOrigin, 33.0, flAimOrigin) // units outside (away!!!)
	xs_vec_add(flOrigin, flAimOrigin, flOrigin)
	
/*# debug	
	new ent = create_entity("info_target") // -.- fuck
	if (pev_valid(ent))
	{
		register_think("Light_Model", "CacheCvars")
		
		engfunc(EngFunc_SetOrigin, ent, flOrigin)
		engfunc(EngFunc_SetModel, ent, "models/rpgrocket.mdl")
		set_pev(ent, pev_classname, "Light_Model")
		fm_set_rendering(ent, kRenderFxGlowShell, 255, 255, 255, kRenderNormal, 8);
		set_pev(ent, pev_nextthink, get_gametime() + 1.0)
	}
	*/
//	new iRGB = 255 - floatround(255.0 * flFraction); // friction can only be 0.0 - 1.0!
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_ELIGHT) // TE id
	write_short(0) // let this 0 !
	engfunc(EngFunc_WriteCoord, flOrigin[0]) // x light origin
	engfunc(EngFunc_WriteCoord, flOrigin[1]) // y done
	engfunc(EngFunc_WriteCoord, flOrigin[2]) // z
	write_coord(35) // radius
	write_byte(255) // r
	write_byte(255) // g
	write_byte(255) // b
	write_byte(2) // life
	write_coord(0) // decay rate
	message_end()
	
	
	/*static iOrigin[3]
	get_user_origin(id, iOrigin, 3)
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_ELIGHT) // TE id
	write_short(szInfo[0])
	write_coord(iOrigin[0]) // x light origin
	write_coord(iOrigin[1]) // y
	write_coord(iOrigin[2]) // z
	write_coord(15) // radius
	write_byte(255) // r
	write_byte(255) // g
	write_byte(255) // b
	write_byte(2) // life
	write_coord(0) // decay rate
	message_end()*/
}
/*
public CacheCvars(ent)
	remove_entity(ent)

stock fm_set_rendering(entity, fx = kRenderFxNone, r = 255, g = 255, b = 255, render = kRenderNormal, amount = 16)
{
	static Float:color[3];
	color[0] = float(r);
	color[1] = float(g);
	color[2] = float(b);
	
	set_pev(entity, pev_renderfx, fx);
	set_pev(entity, pev_rendercolor, color);
	set_pev(entity, pev_rendermode, render);
	set_pev(entity, pev_renderamt, float(amount));
}
*/