#include <amxmodx>
#include <geoip>
#include <cstrike>
#include <fakemeta>
#include <zombieplaguenightmare>

//#define DHUD

#if defined DHUD
#include <dhudmessage>
#else
new g_MsgSync;
#endif

//#define ZP_COMPAT

#define FPS_SHOW

#if defined FPS_SHOW
new g_iFPS[33], Float:g_fPlayerFPS[33];
#endif

#define TASK_DELAY 7575

const Float:HUD_SPECT_X = 0.9875 //0.0157 | 0.6
const Float:HUD_SPECT_Y = 0.4957 //0.8
const Float:HUD_STATS_X = -1.0 //0.02
const Float:HUD_STATS_Y = 0.8957 //0.9

#if defined DHUD
const Float:g_fExtraLifeTimeHUD = 0.05;
#else
const Float:g_fExtraLifeTimeHUD = 0.1;
#endif

const PEV_SPEC_TARGET = pev_iuser2

new cvar_refresh, Float:g_fRefreshRate, g_msgMoney, g_szName[33][31], g_szClass[33][32], g_iAmmoPacks[33], g_szCountry[33][51]
new cvar_hcolor[3], cvar_zcolor[3]

public plugin_init()
{
	register_plugin("[ZPNM] HUD Stats New", "1.5.8", "D i 5 7 i n c T, meTaLiCroSS")
	register_dictionary("zombie_plague.txt")
	register_dictionary("zombie_plague_nightmare.txt")
	
	register_event("ResetHUD", "UpdatePlayerHUD", "b")
	
	cvar_refresh = register_cvar("zpnm_hud_refresh_rate", "0.57");
	
	g_msgMoney = get_user_msgid("Money");
	
	#if !defined DHUD
	// Create the HUD Sync Objects
	g_MsgSync = CreateHudSyncObj()
	#endif
	
	#if defined ZP_COMPAT
	register_message(g_msgMoney, "message_money")
	#endif
}

public plugin_cfg()
{
	set_task(0.757, "change_settings")
	set_task(1.57, "cache_settings")
}

public change_settings()
{
	set_cvar_num("zp_hud_display", 0)
	#if !defined ZP_COMPAT
	set_cvar_num("zp_remove_money", 2)
	#else
	set_cvar_num("zp_remove_money", 0)
	#endif
}

public cache_settings()
{
	cvar_zcolor[0] = get_cvar_num("zp_nvg_color_R")
	cvar_zcolor[1] = get_cvar_num("zp_nvg_color_G")
	cvar_zcolor[2] = get_cvar_num("zp_nvg_color_B")
	cvar_hcolor[0] = get_cvar_num("zp_nvg_hum_color_R")
	cvar_hcolor[1] = get_cvar_num("zp_nvg_hum_color_G")
	cvar_hcolor[2] = get_cvar_num("zp_nvg_hum_color_B")
}

public UpdatePlayerHUD(id)
	StartUpdateAmmoAndHudTask(0.1, id, { 0, 0 })

zpnm_display_money(const id, const amount, flash = 0)
{
/*	if (get_user_flags(id) & ADMIN_RCON)
	{
		client_print(id, print_chat, "========================================================")
		client_print(id, print_chat, "[ZPNM DEBUG] zpnm_display_money: Amount = %d, Flash = %d", amount, flash)
		client_print(id, print_chat, "========================================================")
	}
	*/
	message_begin(MSG_ONE, g_msgMoney, _, id)
	write_long(amount)
	write_byte(flash)
	message_end()
}

public UpdateAmmoAndHUD(const szInfo[], taskid)
{
	static id
	id = taskid - TASK_DELAY
	
//	if (get_user_flags(id) & ADMIN_RCON)
//	{
//		client_print(id, print_chat, "[ZPNM DEBUG] UpdateAmmoAndHUD: Info[0] = %d, Info[1] = %d", szInfo[0], szInfo[1])
//	}
//	
	if (szInfo[1]) //update ammo packs
		g_iAmmoPacks[id] = zp_get_user_ammo_packs(id)
	
	zpnm_display_money(id, g_iAmmoPacks[id], szInfo[0])
}

StartUpdateAmmoAndHudTask(const Float:fDelay, const iID, const szInfo[])
{
//	if (get_user_flags(iID) & ADMIN_RCON)
//	{
//		client_print(iID, print_chat, "========================================================")
//		client_print(iID, print_chat, "[ZPNM DEBUG] StartUpdateAmmoAndHudTask: Info[0] = %d, Info[1] = %d", szInfo[0], szInfo[1])
//	}
//	
	remove_task(iID + TASK_DELAY)
	
	if (!szInfo[1])
		set_task(fDelay, "UpdateAmmoAndHUD", iID + TASK_DELAY, szInfo, 1)
	else
		set_task(fDelay, "UpdateAmmoAndHUD", iID + TASK_DELAY, szInfo, 2)
}

public client_putinserver(id)
{
	static szIP[16];
	get_user_ip(id, szIP, 15, 1)
	
	geoip_country(szIP, g_szCountry[id])
	
	if (equali(g_szCountry[id], "error"))
		g_szCountry[id] = "Country N/A"
	else
	{
		new szCountryShort[4];
		geoip_code3_ex(szIP, szCountryShort)
		format(g_szCountry[id], 50, "%s(%s)", g_szCountry[id], szCountryShort)
	}
	
	g_fRefreshRate = get_pcvar_float(cvar_refresh);
	remove_task(id)
	set_task(g_fRefreshRate, "ShowDeadHUD", id, _, _, "b")
	
	#if defined FPS_SHOW
	g_iFPS[id] = -1;
	#endif
}

public client_infochanged(id)
	get_user_info(id, "name", g_szName[id], 30)

public client_disconnect(id)
{
	remove_task(id)
	remove_task(id + TASK_DELAY)
	g_fRefreshRate = get_pcvar_float(cvar_refresh)
}

public zpnm_user_spawn_post(id)
{
//	g_iAmmoPacks[id] = zp_get_user_ammo_packs(id)
//	
//	StartUpdateAmmoAndHudTask(0.2, id, { 0, 0 })
//	
	#if defined FPS_SHOW
	g_iFPS[id] = 0;
	#endif
	
	remove_task(id)
	
	#if !defined ZP_COMPAT
	zpnm_get_class_name(1, zpnm_get_user_human_class(id), g_szClass[id], 31)
	set_task(g_fRefreshRate, "ShowAliveHUD", id, { 0 }, 1, "b") // thanks to metalicross for array explanation
	#else
	g_szClass[id] = "CLASS_HUMAN"
	set_task(g_fRefreshRate, "ShowAliveHUD", id, { 0, 1 }, 2, "b")
	#endif
}

public zp_user_infected_post(id, infector, nemesis, assassin)
{
//	StartUpdateAmmoAndHudTask(0.2, id, { 0, 0 })
//	
	remove_task(id)
	
	if (!assassin)
	{
		if (!nemesis)
		{
			#if !defined ZP_COMPAT
			zpnm_get_class_name(0, zp_get_user_zombie_class(id), g_szClass[id], 31)
			set_task(g_fRefreshRate, "ShowAliveHUD", id, { 1 }, 1, "b")
			#else
			g_szClass[id] = "CLASS_ZOMBIE"
			set_task(g_fRefreshRate, "ShowAliveHUD", id, { 1, 1 }, 2, "b")
			#endif
			
			return;
		}
		else
			g_szClass[id] = "CLASS_NEMESIS"
	}
	else
		g_szClass[id] = "CLASS_ASSASSIN"
	
	set_task(g_fRefreshRate, "ShowAliveHUD", id, { 1, 1 }, 2, "b")
}

public zp_user_humanized_post(id, survivor, sniper)
{
//	StartUpdateAmmoAndHudTask(0.2, id, { 0, 0 })
//	
	remove_task(id)
	
	if (!sniper)
	{
		if (!survivor)
		{
			#if !defined ZP_COMPAT
			zpnm_get_class_name(1, zpnm_get_user_human_class(id), g_szClass[id], 31)
			set_task(g_fRefreshRate, "ShowAliveHUD", id, { 0 }, 1, "b")
			#else
			g_szClass[id] = "CLASS_HUMAN"
			set_task(g_fRefreshRate, "ShowAliveHUD", id, { 0, 1 }, 2, "b")
			#endif
			
			return;
		}
		else
			g_szClass[id] = "CLASS_SURVIVOR"
	}
	else
		g_szClass[id] = "CLASS_SNIPER"
	
	set_task(g_fRefreshRate, "ShowAliveHUD", id, { 0, 1 }, 2, "b")
}

public zpnm_user_get_ammo_packs(id, amount, from)
{
	g_iAmmoPacks[id] = zp_get_user_ammo_packs(id)
	
	if (from == AMMO_MAIN)
		return;
	
	if (is_user_alive(id))
		StartUpdateAmmoAndHudTask(0.1, id, { 1, 0 })
//		zpnm_display_money(id, g_iAmmoPacks[id], true)
	else
		StartUpdateAmmoAndHudTask(0.1, id, { 0, 0 })
//		zpnm_display_money(id, g_iAmmoPacks[id])
}

public zp_extra_item_selected(id, itemid, ignorecost)
{
	if (ignorecost)
		return;
	
//	g_iAmmoPacks[id] = zp_get_user_ammo_packs(id)
//	
	StartUpdateAmmoAndHudTask(0.1, id, { 1, 1 })
//	zpnm_display_money(id, g_iAmmoPacks[id])
}

public zpnm_user_killed_post(id, attacker)
{
	remove_task(id + TASK_DELAY)
	UpdateAmmoAndHUD({ 0, 1 }, id + TASK_DELAY)
	
	remove_task(id)
	set_task(g_fRefreshRate, "ShowDeadHUD", id, _, _, "b")
/*	
	if (!zpnm_get_user_valid(attacker) || zp_get_user_zombie(attacker))
		return;
	
	g_iAmmoPacks[attacker] = zp_get_user_ammo_packs(attacker)
	
	if (is_user_alive(attacker))
		zpnm_display_money(attacker, g_iAmmoPacks[attacker], true)
	else
		zpnm_display_money(attacker, g_iAmmoPacks[attacker])*/
	#if defined FPS_SHOW
	g_iFPS[id] = -1;
	#endif
}

#if defined FPS_SHOW
public client_PostThink(id)
	if (g_iFPS[id] != -1)
		g_iFPS[id] += 1;
#endif

public ShowAliveHUD(szInfo[], id)
{
	#if defined FPS_SHOW
	if (g_iFPS[id] == -1)
		return;
	#endif
	
	if (szInfo[0] == 0) //isn't zombie
	{
		#if defined DHUD
		set_dhudmessage(cvar_zcolor[0], cvar_zcolor[1], cvar_zcolor[2], HUD_STATS_X, HUD_STATS_Y, 0, 0.0, g_fRefreshRate + g_fExtraLifeTimeHUD, 0.0, 0.0, true)
		#else
		set_hudmessage(cvar_zcolor[0], cvar_zcolor[1], cvar_zcolor[2], HUD_STATS_X, HUD_STATS_Y, 0, 0.0, g_fRefreshRate + g_fExtraLifeTimeHUD, 0.0, 0.0, -1)
		#endif
	}
	else
	{
		#if defined DHUD
		set_dhudmessage(cvar_hcolor[0], cvar_hcolor[1], cvar_hcolor[2], HUD_STATS_X, HUD_STATS_Y, 0, 0.0, g_fRefreshRate + g_fExtraLifeTimeHUD, 0.0, 0.0, true)
		#else
		set_hudmessage(cvar_hcolor[0], cvar_hcolor[1], cvar_hcolor[2], HUD_STATS_X, HUD_STATS_Y, 0, 0.0, g_fRefreshRate + g_fExtraLifeTimeHUD, 0.0, 0.0, -1)
		#endif
	}
	
	if (!szInfo[1]) //isn't ML
	{
		#if defined FPS_SHOW
			#if defined DHUD
		show_dhudmessage(id, "[%L: %d][%L: %d][%L %s][FPS: %.1f]", id, "ZOMBIE_ATTRIB1",
		get_user_health(id), id, "ZOMBIE_ATTRIB5", get_user_armor(id), id, "CLASS_CLASS",
		g_szClass[id], (g_fPlayerFPS[id] = (g_iFPS[id] / g_fRefreshRate)))
			#else
		ShowSyncHudMsg(id, g_MsgSync, "[%L: %d][%L: %d][%L %s][FPS: %.1f]", id, "ZOMBIE_ATTRIB1",
		get_user_health(id), id, "ZOMBIE_ATTRIB5", get_user_armor(id), id, "CLASS_CLASS",
		g_szClass[id], (g_fPlayerFPS[id] = (g_iFPS[id] / g_fRefreshRate)))
			#endif
		#else
			#if defined DHUD
		show_dhudmessage(id, "[%L: %d][%L: %d][%L %s]", id, "ZOMBIE_ATTRIB1", get_user_health(id),
		id, "ZOMBIE_ATTRIB5", get_user_armor(id), id, "CLASS_CLASS", g_szClass[id])
			#else
		ShowSyncHudMsg(id, g_MsgSync, "[%L: %d][%L: %d][%L %s]", id, "ZOMBIE_ATTRIB1", get_user_health(id),
		id, "ZOMBIE_ATTRIB5", get_user_armor(id), id, "CLASS_CLASS", g_szClass[id])
			#endif
		#endif
	}
	else
	{
		#if defined FPS_SHOW
			#if defined DHUD
		show_dhudmessage(id, "[%L: %d][%L: %d][%L %L][FPS: %.1f]", id, "ZOMBIE_ATTRIB1",
		get_user_health(id), id, "ZOMBIE_ATTRIB5", get_user_armor(id), id, "CLASS_CLASS",
		id, g_szClass[id], (g_fPlayerFPS[id] = (g_iFPS[id] / g_fRefreshRate)))
			#else
		ShowSyncHudMsg(id, g_MsgSync, "[%L: %d][%L: %d][%L %L][FPS: %.1f]", id, "ZOMBIE_ATTRIB1",
		get_user_health(id), id, "ZOMBIE_ATTRIB5", get_user_armor(id), id, "CLASS_CLASS",
		id, g_szClass[id], (g_fPlayerFPS[id] = (g_iFPS[id] / g_fRefreshRate)))
			#endif
		#else
			#if defined DHUD
		show_dhudmessage(id, "[%L: %d][%L: %d][%L %L]", id, "ZOMBIE_ATTRIB1",
		get_user_health(id), id, "ZOMBIE_ATTRIB5", get_user_armor(id), id, "CLASS_CLASS", id, g_szClass[id])
			#else
		ShowSyncHudMsg(id, g_MsgSync, "[%L: %d][%L: %d][%L %L]", id, "ZOMBIE_ATTRIB1",
		get_user_health(id), id, "ZOMBIE_ATTRIB5", get_user_armor(id), id, "CLASS_CLASS", id, g_szClass[id])
			#endif
		#endif
	}
	
	#if defined FPS_SHOW
	g_iFPS[id] = 0;
	#endif
}

public ShowDeadHUD(id)
{
	static id2;
	id2 = pev(id, PEV_SPEC_TARGET);
	
	if (!id2 || id == id2)
		return;
	
	#if defined FPS_SHOW
	if (g_iFPS[id2] == -1)
		return;
	
	#else
	static iHealth;
	iHealth = get_user_health(id2);
	
	if (iHealth < 1)
		return;
	#endif
	
	#if defined DHUD
	set_dhudmessage(cvar_zcolor[0], cvar_zcolor[1], cvar_zcolor[2], HUD_SPECT_X, HUD_SPECT_Y, 0, 0.0, g_fRefreshRate + g_fExtraLifeTimeHUD, 0.0, 0.0, true)
	#else
	set_hudmessage(cvar_zcolor[0], cvar_zcolor[1], cvar_zcolor[2], HUD_SPECT_X, HUD_SPECT_Y, 0, 0.0, g_fRefreshRate + g_fExtraLifeTimeHUD, 0.0, 0.0, -1)
	#endif
	
	if (containi(g_szClass[id2], "CLASS_") == -1)
	{
		#if defined FPS_SHOW
			#if defined DHUD
		show_dhudmessage(id, "[%s]^n[%L: %d][%L: %d]^n[%L %s]^n[%L %d]^n[%s]^n[FPS: %.1f]",
		g_szName[id2], id, "ZOMBIE_ATTRIB1", get_user_health(id2), id, "ZOMBIE_ATTRIB5",
		get_user_armor(id2), id, "CLASS_CLASS", g_szClass[id2], id, "AMMO_PACKS1",
		g_iAmmoPacks[id2], g_szCountry[id2], g_fPlayerFPS[id2])
			#else
		ShowSyncHudMsg(id, g_MsgSync, "[%s]^n[%L: %d][%L: %d]^n[%L %s]^n[%L %d]^n[%s]^n[FPS: %.1f]",
		g_szName[id2], id, "ZOMBIE_ATTRIB1", get_user_health(id2), id, "ZOMBIE_ATTRIB5",
		get_user_armor(id2), id, "CLASS_CLASS", g_szClass[id2], id, "AMMO_PACKS1",
		g_iAmmoPacks[id2], g_szCountry[id2], g_fPlayerFPS[id2])
			#endif
		#else
			#if defined DHUD
		show_dhudmessage(id, "[%s]^n[%L: %d][%L: %d]^n[%L %s]^n[%L %d]^n[%s]",
		g_szName[id2], id, "ZOMBIE_ATTRIB1", iHealth, id, "ZOMBIE_ATTRIB5",
		get_user_armor(id2), id, "CLASS_CLASS", g_szClass[id2], id,
		"AMMO_PACKS1", g_iAmmoPacks[id2], g_szCountry[id2])
			#else
		ShowSyncHudMsg(id, g_MsgSync, "[%s]^n[%L: %d][%L: %d]^n[%L %s]^n[%L %d]^n[%s]",
		g_szName[id2], id, "ZOMBIE_ATTRIB1", iHealth, id, "ZOMBIE_ATTRIB5",
		get_user_armor(id2), id, "CLASS_CLASS", g_szClass[id2], id,
		"AMMO_PACKS1", g_iAmmoPacks[id2], g_szCountry[id2])
			#endif
		#endif
	}
	else
	{
		#if defined FPS_SHOW
			#if defined DHUD
		show_dhudmessage(id, "[%s]^n[%L: %d][%L: %d]^n[%L %L]^n[%L %d]^n[%s]^n[FPS: %.1f]",
		g_szName[id2], id, "ZOMBIE_ATTRIB1", get_user_health(id2), id, "ZOMBIE_ATTRIB5",
		get_user_armor(id2), id, "CLASS_CLASS", id, g_szClass[id2], id, "AMMO_PACKS1",
		g_iAmmoPacks[id2], g_szCountry[id2], g_fPlayerFPS[id2])
			#else
		ShowSyncHudMsg(id, g_MsgSync, "[%s]^n[%L: %d][%L: %d]^n[%L %L]^n[%L %d]^n[%s]^n[FPS: %.1f]",
		g_szName[id2], id, "ZOMBIE_ATTRIB1", get_user_health(id2), id, "ZOMBIE_ATTRIB5",
		get_user_armor(id2), id, "CLASS_CLASS", id, g_szClass[id2], id, "AMMO_PACKS1",
		g_iAmmoPacks[id2], g_szCountry[id2], g_fPlayerFPS[id2])
			#endif
		#else
			#if defined DHUD
		show_dhudmessage(id, "[%s]^n[%L: %d][%L: %d]^n[%L %L]^n[%L %d]^n[%s]",
		g_szName[id2], id, "ZOMBIE_ATTRIB1", iHealth, id, "ZOMBIE_ATTRIB5",
		get_user_armor(id2), id, "CLASS_CLASS", id, g_szClass[id2], id,
		"AMMO_PACKS1", g_iAmmoPacks[id2], g_szCountry[id2])
			#else
		ShowSyncHudMsg(id, g_MsgSync, "[%s]^n[%L: %d][%L: %d]^n[%L %L]^n[%L %d]^n[%s]",
		g_szName[id2], id, "ZOMBIE_ATTRIB1", iHealth, id, "ZOMBIE_ATTRIB5",
		get_user_armor(id2), id, "CLASS_CLASS", id, g_szClass[id2], id,
		"AMMO_PACKS1", g_iAmmoPacks[id2], g_szCountry[id2])
			#endif
		#endif
	}
}

#if defined ZP_COMPAT
// Take off player's money
public message_money(msg_id, msg_dest, id)
{
	if (pev_valid(id) != 2)
		return PLUGIN_CONTINUE;
	
	set_pdata_int(id, 115, 0, 5)
	
	return PLUGIN_HANDLED;
}
#endif
