#include <amxmodx>
#include <bitsums>
#include <hamsandwich>
#include <zombieplaguenightmare>

new const g_szSoundFirstBlood[] = "D7_Announcer/Announcer_1stblood_01.mp3";
new const g_szSoundOwnage[] = "D7_Announcer/Announcer_ownage_01.mp3";

new const g_szSoundsCount[][] =
{
	"D7_Announcer/Announcer_kill_spree_01.mp3",
	"D7_Announcer/Announcer_kill_dominate_01.mp3",
	"D7_Announcer/Announcer_kill_mega_01.mp3",
	"D7_Announcer/Announcer_kill_unstop_01.mp3",
	"D7_Announcer/Announcer_kill_wicked_01.mp3",
	"D7_Announcer/Announcer_kill_monster_01.mp3",
	"D7_Announcer/Announcer_kill_godlike_01.mp3",
	"D7_Announcer/Announcer_kill_holy_01.mp3"
}

const Float:g_fTaskMultiDelay = 10.0;

new const g_szSoundsMulti[][] =
{
	"D7_Announcer/Announcer_kill_double_01.mp3",
	"D7_Announcer/Announcer_kill_triple_01.mp3",
	"D7_Announcer/Announcer_kill_ultra_01.mp3",
	"D7_Announcer/Announcer_kill_rampage_01.mp3"
}

new const g_szTextMulti[][] =
{
	"just got a ^4double kill^1!",
	"just got a ^4triple kill^1!",
	"just got an ^4ULTRA KILL^1!",
	"is on a ^4RAMPAGE^1!"
}

new g_fDelayGlobal;
const g_iTaskDelayID = 8000;

new g_bitConnected, g_bitAlive, g_bitZombie;

stock colored_chat(const iTarget = 0, const iSender = 0, const szMessage[], any:...)
{
	if (iTarget && !bitsum_get(g_bitConnected, iTarget))
		return;
	
	static szBuffer[192];
	vformat(szBuffer, 191, szMessage, 4)
	
	new const D7_CHAT_TAG[] = "^1[^4D7^1] "
	format(szBuffer, 191, "%s%s", D7_CHAT_TAG, szBuffer)
	
	static msgSayText;
	if (!msgSayText)
		msgSayText = get_user_msgid("SayText");
	
	if (iTarget)
		message_begin(MSG_ONE, msgSayText, _, iTarget)
	else
		message_begin(MSG_ALL, msgSayText)
	
	write_byte(iSender ? iSender : iTarget)
	write_string(szBuffer)
	message_end()
}

new g_iMaxPlayers, g_bFirstBlood;
new g_szName[33][31], g_iKills[33], g_iMulti[33], Float:g_fDelay[33];

#define is_user_valid_connected(%1) ((1 <= %1 <= g_iMaxPlayers) && bitsum_get(g_bitConnected, %1))

public plugin_precache()
{
	precache_generic(g_szSoundFirstBlood)
	precache_generic(g_szSoundOwnage)
	
	new i;
	
	for (i = 0; i < sizeof g_szSoundsCount; i++)
		precache_generic(g_szSoundsCount[i])
	
	for (i = 0; i < sizeof g_szSoundsMulti; i++)
		precache_generic(g_szSoundsMulti[i])
}

public plugin_init()
{
	register_plugin("[ZPNM] Kill announcer", "0.0.1", "D i 5 7 i n c T")
	
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn_Post", 1)
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled_Post", 1)
	
	g_iMaxPlayers = get_maxplayers();
}

public zpnm_register_ham_czbots(id)
{
	RegisterHamFromEntity(Ham_Spawn, id, "fw_PlayerSpawn_Post", 1)
	RegisterHamFromEntity(Ham_Killed, id, "fw_PlayerKilled_Post", 1)
}

public client_putinserver(id)
	bitsum_add(g_bitConnected, id)

public client_infochanged(id)
{
	if (!bitsum_get(g_bitConnected, id))
		return;
	
	get_user_info(id, "name", g_szName[id], 30)
}

public client_disconnect(id)
{
	bitsum_del(g_bitAlive, id)
	bitsum_del(g_bitZombie, id)
	bitsum_del(g_bitConnected, id)
	
	g_iKills[id] = 0;
	g_iMulti[id] = 0;
	g_fDelay[id] = 0.0;
}

public fw_PlayerSpawn_Post(id)
{
	bitsum_del(g_bitZombie, id)
	
	if (!is_user_alive(id))
		return;
	
	if (!bitsum_get(g_bitAlive, id))
		bitsum_add(g_bitAlive, id)
}

public zp_round_started()
{
	g_bFirstBlood = false;
	
	for (new i = 1; i <= g_iMaxPlayers; i++)
	{
		g_iKills[i] = 0;
		g_iMulti[id] = 0;
		g_fDelay[id] = 0.0;
	}
}

public zp_round_ended(win)
{
/*	if (win == WIN_NO_ONE)
		return;
	
	client_cmd(0, "mp3 play ^"%s^"", g_szSoundOwnage)
	
	colored_chat(_, _, "Team ^4%s^1 owned team ^3%s^1!",
	(win == WIN_HUMANS) ? "HUMANS" : "ZOMBIES",
	(win == WIN_HUMANS) ? "ZOMBIES" : "HUMANS")
	*/
	new i, iID;
	
	for (i = 1; i <= g_iMaxPlayers; i++)
	{
		if (!bitsum_get(g_bitConnected, i))
			continue;
		
		if (g_iKills[i] > g_iKills[iID])
			iID = i;
	}
	
	if (!is_user_valid_connected(iID))
		return;
	
	// Better 1 loop than 2
	for (i = 1; i <= g_iMaxPlayers; i++)
	{
		if (bitsum_get(g_bitConnected, i))
			client_cmd(i, "mp3 play ^"%s^"", g_szSoundOwnage)
		
		// The stock already checks for user connected
		colored_chat(i, iID, "^4%s^1 owned this round with ^3%d kills^1!", g_szName[iID], g_iKills[iID])
	}
}

public zp_user_infected_post(id, infector)
{
	bitsum_add(g_bitZombie, id)
	
	fw_PlayerKilled_Post(id, infector)
	bitsum_add(g_bitAlive, id)
}

public fw_PlayerKilled_Post(victim, attacker)
{
	bitsum_del(g_bitAlive, victim)
	
	g_iKills[victim] = 0;
	g_iMulti[victim] = 0;
	g_fDelay[victim] = 0.0;
	
	if (!attacker || !is_user_valid_connected(attacker))
		return;
	
	g_iKills[attacker]++;
	g_iMulti[attacker]++;
	
	set_task(g_fTaskMultiDelay, "d7_decrease_multi_count", attacker)
	
	if (!g_bFirstBlood)
	{
		g_bFirstBlood = true;
		
		client_cmd(0, "mp3 play ^"%s^"", g_szSoundFirstBlood)
		colored_chat(_, attacker, "^3%s^1 just got first blood by killing^4 %s^1!", g_szName[attacker], g_szName[id])
	}
	else if (g_iKills[attacker] > 3)
	{
		
	}
	
	if (g_fDelayGlobal)
		g_fDelayGlobal += 3.0;
	else
	{
		g_fDelayGlobal += 4.0;
		
		set_task(0.1, "DecreaseGlobalDelay", g_iTaskDelayID, _, _, "b")
	}
	
	if (g_iMulti[attacker] < 2)
		return;
	
	remove_task(attacker + g_iTaskDelayID)
	set_task(g_fDelayGlobal + g_fDelay[attacker], "AnnounceMulti", attacker + g_iTaskDelayID)
	
	if (g_fDelay[attacker])
		g_fDelay[attacker] += 3.0;
	else
		g_fDelay[attacker] += 4.0;
}

public d7_decrease_multi_count(id)
	g_iMulti[id]--;

public DecreaseGlobalDelay(iTaskID)
{
	g_fDelayGlobal -= 0.1;
	
	if (g_fDelayGlobal <= 0.0)
	{
		remove_task(g_iTaskDelayID)
		
		g_fDelayGlobal = 0.0;
	}
}

public AnnounceMulti(iTaskID)
{
	new id = iTaskID - g_iTaskDelayID, i;
	
	for (i = 1; i <= g_iMaxPlayers; i++)
	{
		if (!bitsum_get(g_bitConnected, i))
			continue;
		
		client_cmd(i, "mp3 play ^"%s^"", (g_iMulti[attacker] < 5) ? g_szSoundsMulti[g_iMulti[id - 2]] : g_szSoundsMulti[3])
		colored_chat(i, id, "^3%s^1 %s", (g_iMulti[attacker] < 5) ? g_szTextMulti[g_iMulti[id - 2]] : g_szTextMulti[3])
	}
}
