
/*================================================================================
 [Plugin Customization]
=================================================================================*/

const MAX_ENT_ARRAY = 		128	/* Is for max 4096 entities (128*32=4096)  128 */
//const Float:SPEC_INTERVAL = 0.5	/*  0.2 */

/*	Uncomment the line below to have csbots support.
	*/
#define CSBOTS

/*================================================================================
 Customization ends here! Yes, that's it. Editing anything beyond
 here is not officially supported. Proceed at your own risk...
=================================================================================*/

#include <amxmodx>
#include <bitsums>
#include <engine>
#include <fakemeta>
#include <hamsandwich>
#include <zombieplaguenightmare>

/*================================================================================
 [Constants, Offsets and Defines]
=================================================================================*/

#define GROUP_ESP_T		1
#define GROUP_ESP_CT	2
#define GROUP_PLAYER 	4
#define GROUP_SEE_T		5
#define GROUP_SEE_CT	6
#define GROUP_SEE_BOTH	7
#define GROUP_ESP_HIDE	8

new const g_szSpriteHuman[]  = "sprites/D7_ESP_PARALLEL_80x88_64x72.spr"
new const g_szSpriteZombie[] = "sprites/ballsmoke.spr" //ballsmoke

enum 
{
	TEAM_HUMAN = 0,
	TEAM_ZOMBIE = 1,
	TEAM_NONE = 2
};

new const g_szColorsHuman[][] =
{
	{ 0, 255, 0 },
	{ 255, 0, 0 },
	{ 0, 0, 0 }
}

new const g_szColorsZombie[][] =
{
	{ 255, 0, 0 },
	{ 255, 255, 0 },
	{ 0, 0, 0 }
}

const pev_spec_mode     = pev_iuser1;
const pev_spec_target   = pev_iuser2;

/*================================================================================
 [Global Variables]
=================================================================================*/

/* Cvar Global */

/* Server Global */
new g_iMaxPlayers,
	g_iSpriteHuman,
	g_iSpriteZombie,
	g_iItemID

/* Client Global */
new g_iSpriteIndex[33],
	g_iTeam[33]; //= {TEAM_NONE, ...}

/* Bitsum client */
new bs_IsConnected,
	bs_IsAlive

/* Bitsum entity */
new bs_IsEspSprite[MAX_ENT_ARRAY]

#if defined CSBOTS
/*================================================================================
 [CSBOTS]
=================================================================================*/

#define TASK_CSBOTS 11823

new cvar_iBotQuota,
	g_iHamCsBots

#endif // CSBOTS
/*================================================================================
 [Macros]
=================================================================================*/

#define is_user_valid(%1)			(1 <= (%1) <= g_iMaxPlayers)
#define is_user_valid_alive(%1)		(1 <= (%1) <= g_iMaxPlayers && get_bitsum(bs_IsAlive, %1))
//#define is_same_team(%1,%2)		(g_iTeam[%1] == g_iTeam[%2])


/*================================================================================
 [Natives, Init and Cfg]
=================================================================================*/

public plugin_precache()
{
	g_iSpriteHuman = precache_model(g_szSpriteHuman)
	g_iSpriteZombie = precache_model(g_szSpriteZombie)
}

public plugin_init()
{
	register_plugin("[ZPNM] Item: ESP", "1.1.5", "DarkGL, schmurgel1983, D i 5 7 i n c T")
	
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn_Post", true)
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled", false)
	
	//register_forward(FM_AddToFullPack, "fw_AddToFullPack_Post", true)
	
	register_clcmd("say /esp", "clcmd_esp")
	
//	register_message(get_user_msgid("TeamInfo"), "MessageTeamInfo")
//	
	#if defined CSBOTS
	cvar_iBotQuota = get_cvar_pointer("bot_quota")
	#endif // CSBOTS
	
	g_iMaxPlayers = get_maxplayers()
	
	g_iItemID = zp_register_extra_item("Zombie detector", 25, ZP_TEAM_HUMAN | ZP_TEAM_SURVIVOR | ZP_TEAM_SNIPER)
}

public plugin_cfg()
{
	/* Create Sprites */
	new iAllocString = engfunc(EngFunc_AllocString, "info_target")
	for (new id = 1; id <= g_iMaxPlayers; id++)
	{
		new iEntity = engfunc(EngFunc_CreateNamedEntity, iAllocString)
		
		if (!pev_valid(iEntity))
			continue
		
		engfunc(EngFunc_SetModel, iEntity, g_szSpriteZombie)
		
//		set_pev(iEntity, pev_scale, 0.9) //1.20
		set_pev(iEntity, pev_owner, id)
		set_pev(iEntity, pev_solid, SOLID_NOT)
		set_pev(iEntity, pev_movetype, MOVETYPE_FOLLOW)
		set_pev(iEntity, pev_aiment, id);
		set_pev(iEntity, pev_rendermode, kRenderTransAlpha)
		set_pev(iEntity, pev_renderfx, kRenderFxNone)
		set_pev(iEntity, pev_renderamt, 255.0)
		set_pev(iEntity, pev_animtime, 1.0)
		set_pev(iEntity, pev_framerate, 1.0)
		dllfunc(DLLFunc_Spawn, iEntity)
		
		add_bitsum_array(bs_IsEspSprite, iEntity)
		g_iSpriteIndex[id] = iEntity;
	}
}


/*================================================================================
 [Put in, Disconnect]
=================================================================================*/

public client_putinserver(id)
{
	add_bitsum(bs_IsConnected, id)
//	del_bitsum(bs_IsAlive, id)
	g_iTeam[id] = TEAM_NONE;
//	set_task(SPEC_INTERVAL, "SpectatorCheck", id, _, _, "b")
}

public client_disconnect(id)
{
	del_bitsum(bs_IsConnected, id)
	del_bitsum(bs_IsAlive, id)
	g_iTeam[id] = TEAM_NONE;
//	remove_task(id)
}

#if defined CSBOTS
/*================================================================================
 [CSBOTS]
=================================================================================*/

/* Register csbots */
public client_authorized(id)
{
	if (is_user_bot(id) && !g_iHamCsBots && cvar_iBotQuota && get_pcvar_num(cvar_iBotQuota))
	{
		set_task(0.1, "StopCsBotForward", TASK_CSBOTS) /* Fake Bot? */
		g_iHamCsBots = register_forward(FM_SetClientKeyValue, "fw_SetClientKeyValue", false)
	}
}

public fw_SetClientKeyValue(id, infobuffer[], key[], value[])
{
	if (value[0] == '1' && equal(key, "*bot"))
	{
		unregister_forward(FM_SetClientKeyValue, g_iHamCsBots, false)
		remove_task(TASK_CSBOTS)
		
		RegisterHamFromEntity(Ham_Spawn, id, "fw_PlayerSpawn_Post", true)
		RegisterHamFromEntity(Ham_Killed, id, "fw_PlayerKilled", false)
	}
}

public StopCsBotForward()
{
	unregister_forward(FM_SetClientKeyValue, g_iHamCsBots, false)
	g_iHamCsBots = 0
}

#endif // CSBOTS
/*================================================================================
 [Main Forwards]
=================================================================================*/

public fw_PlayerSpawn_Post(id)
{
	if (!is_user_alive(id)/* || !g_iTeam[id]*/)
		return
	
	add_bitsum(bs_IsAlive, id)
	set_pev(id, pev_groupinfo, GROUP_PLAYER);
	
//	remove_task(id)
	
	g_iTeam[id] = TEAM_HUMAN;
	set_pev(g_iSpriteIndex[id], pev_groupinfo, GROUP_ESP_CT);
}

public clcmd_esp(const id)
{
	if(pev(id, pev_groupinfo) > GROUP_PLAYER)
		set_pev(id, pev_groupinfo, GROUP_PLAYER)
	else
		set_pev(id, pev_groupinfo, GROUP_SEE_BOTH);
}

public zp_extra_item_selected(id, item)
{
	if (item != g_iItemID)
		return PLUGIN_CONTINUE;
	
	if (pev(id, pev_groupinfo) > GROUP_PLAYER)
	{
		client_print(id, print_center, "Your zombie detector is already working!")
		
		return ZP_PLUGIN_HANDLED;
	}
	
	// We will make cvar for customization later, 
	set_pev(id, pev_groupinfo, GROUP_SEE_BOTH);
	client_print(id, print_center, "Your zombie detector is now ON.")
	
	return PLUGIN_CONTINUE;
}

public zp_user_infected_post(id)
{
	g_iTeam[id] = TEAM_ZOMBIE;
	set_pev(g_iSpriteIndex[id], pev_groupinfo, GROUP_ESP_T);
}

public zp_user_humanized_post(id)
{
	g_iTeam[id] = TEAM_HUMAN;
	set_pev(g_iSpriteIndex[id], pev_groupinfo, GROUP_ESP_CT);
}

public fw_PlayerKilled(id)
{
	del_bitsum(bs_IsAlive, id)
	g_iTeam[id] = TEAM_NONE;
	set_pev(id, pev_groupinfo, GROUP_PLAYER);
	set_pev(g_iSpriteIndex[id], pev_groupinfo, GROUP_ESP_HIDE);
}

public fw_AddToFullPack_Post(es_handle, e, ent, host, flags, player, pSet)
{
	if (player || !is_user_valid(host) || !get_bitsum_array(bs_IsEspSprite, ent))
		return;
	
	static iOwner;
	iOwner = get_es(es_handle, ES_Owner);
	
	if (host == iOwner || g_iTeam[host] == TEAM_NONE || !is_user_valid_alive(iOwner))
		return;
	
//	set_es(es_handle, ES_Origin, g_flOrigins[g_iTarget[host]][iOwner])
	set_es(es_handle, ES_ModelIndex, (g_iTeam[host] == TEAM_ZOMBIE) ? g_iSpriteZombie : g_iSpriteHuman)
//	set_es(es_handle, ES_Scale, g_flScale[g_iTarget[host]][iOwner])
	set_es(es_handle, ES_RenderColor, (g_iTeam[host] == TEAM_ZOMBIE) ? g_szColorsZombie[g_iTeam[iOwner]] : g_szColorsHuman[g_iTeam[iOwner]])
}

/*================================================================================
 [Other Functions and Tasks]
=================================================================================*/
/*
public plugin_pause()
{
	for (new i = 1; i <= g_iMaxPlayers; i++)
		set_pev(i, pev_groupinfo, 0);
}

public plugin_unpause()
{
	for (new i = 1; i <= g_iMaxPlayers; i++)
	{
		if (get_bitsum(bs_IsAlive, i))
			set_pev(i, pev_groupinfo, GROUP_PLAYER)
	}
}
*/
/*================================================================================
 [Message Hooks]
=================================================================================*/
/*
public MessageTeamInfo(msg_id, msg_dest)
{
	if (msg_dest != MSG_ALL && msg_dest != MSG_BROADCAST)
		return
	
	static id, szTeam[2]
	id = get_msg_arg_int(1)
	get_msg_arg_string(2, szTeam, charsmax(szTeam))
	
	switch (szTeam[0])
	{
		case 'T': g_iTeam[id] = CS_TEAM_T
		case 'C': g_iTeam[id] = CS_TEAM_CT
		case 'S': g_iTeam[id] = CS_TEAM_SPECTATOR
		default: g_iTeam[id] = CS_TEAM_UNASSIGNED
	}
}*/
