//#pragma dynamic 16384

/*================================================================================
 [Plugin Customization]
=================================================================================*/

const MAX_PLAYERS = 		32	/* Server slots  32 */
const MAX_ENT_ARRAY = 		128	/* Is for max 4096 entities (128*32=4096)  128 */
const Float:SPEC_INTERVAL = 0.5	/*  0.2 */

/*================================================================================
 Customization ends here! Yes, that's it. Editing anything beyond
 here is not officially supported. Proceed at your own risk...
=================================================================================*/

#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <hamsandwich>

#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

#include <bitsums>
#include <bitsums_array>

/*================================================================================
 [Constants, Offsets and Defines]
=================================================================================*/

new const g_szSpriteHuman[]  = "sprites/D7ESP8Bit_32x72_42x82AdditiveParallelUpright.spr"

new const g_szSpriteZombie[] = "sprites/D7ESP8Bit_32x72_42x82AdditiveParallelUpright.spr" //ballsmoke

enum
{
	CS_TEAM_CT,
	CS_TEAM_T,
	CS_TEAM_CT_SEE_T,
	CS_TEAM_SPECTATOR/*,
	CS_TEAM_UNASSIGNED*/
}

new const g_szColorsHuman[][3] =
{
	{ 0, 255, 0 },
	{ 255, 0, 0 },
	{ 0, 255, 0 },
	{ 0, 0, 0 }
}

new const g_szColorsZombie[][3] =
{
	{ 255, 0, 0 },
	{ 255, 255, 0 },
	{ 255, 0, 0 },
	{ 0, 0, 0 }
}

const pev_spec_mode     = pev_iuser1;
const pev_spec_target   = pev_iuser2;

/*================================================================================
 [Global Variables]
=================================================================================*/

/* Cvar Global */

/* Server Global */
new g_iMaxPlayers,
	g_iSpriteHuman,
	g_iSpriteZombie,
	g_iItemID

/* Client Global */
new g_iIDEntSprite[MAX_PLAYERS+1],
	g_iTeam[MAX_PLAYERS+1],
	g_iTarget[MAX_PLAYERS+1],
	Float:g_flOrigins[MAX_PLAYERS+1][MAX_PLAYERS+1][3],
	Float:g_flScale[MAX_PLAYERS+1][MAX_PLAYERS+1]

/* Bitsum client */
new g_iBsConnected,
	g_iBsAlive,
	bs_SpriteVisible[MAX_PLAYERS+1]

/* Bitsum entity */
new bs_IsEspSprite[MAX_ENT_ARRAY]

/*================================================================================
 [Macros]
=================================================================================*/

#define UTIL_Vector_Add(%1,%2,%3)		(%3[0] = %1[0] + %2[0], %3[1] = %1[1] + %2[1], %3[2] = %1[2] + %2[2]);
#define UTIL_Vector_Sub(%1,%2,%3)		(%3[0] = %1[0] - %2[0], %3[1] = %1[1] - %2[1], %3[2] = %1[2] - %2[2]);
#define UTIL_Vector_MA(%1,%2,%3,%4)		(%4[0] = %2[0] * %3 + %1[0], %4[1] = %2[1] * %3 + %1[1], %4[2] = %2[2] * %3 + %1[2]);

#define is_user_valid(%1)			(1 <= (%1) <= g_iMaxPlayers)
#define is_user_valid_alive(%1)		(1 <= (%1) <= g_iMaxPlayers && get_bitsum(g_iBsAlive, %1))
//#define is_same_team(%1,%2)			(g_iTeam[%1] == g_iTeam[%2])

/*================================================================================
 [Natives, Init and Cfg]
=================================================================================*/

public plugin_precache()
{
	g_iSpriteHuman = precache_model(g_szSpriteHuman)
	g_iSpriteZombie = precache_model(g_szSpriteZombie)
}

public plugin_init()
{
	register_plugin("[ZPNM] Item: ESP", "1.1.6", "DarkGL, schmurgel1983, D i 5 7 i n c T")
	
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn_Post", true)
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled", false)
	RegisterHam(Ham_Player_UpdateClientData, "player", "fw_PlayerUpdateClientData", false)
	RegisterHamBots(Ham_Spawn, "fw_PlayerSpawn_Post", true)
	RegisterHamBots(Ham_Killed, "fw_PlayerKilled", false)
	//RegisterHamBots(Ham_Player_UpdateClientData, "fw_PlayerUpdateClientData", false)
	
	register_forward(FM_AddToFullPack, "fw_AddToFullPack_Post", true)
	register_forward(FM_CheckVisibility, "fw_CheckVisibility", false)
	
	register_clcmd("say /esp", "clcmd_esp")
	
//	register_message(get_user_msgid("TeamInfo"), "MessageTeamInfo")
//	
	
	g_iMaxPlayers = get_maxplayers()
	
	g_iItemID = zp_register_extra_item("Zombie detector", 25, ZP_TEAM_HUMAN | ZP_TEAM_SURVIVOR | ZP_TEAM_SNIPER)
}

public plugin_cfg()
{
	//Create Sprites
	new iAllocString = engfunc(EngFunc_AllocString, "env_sprite")
	for (new id = 1; id <= g_iMaxPlayers; id++)
	{
		new iEntity = engfunc(EngFunc_CreateNamedEntity, iAllocString)
		
		if (!pev_valid(iEntity))
			continue
		
		engfunc(EngFunc_SetModel, iEntity, g_szSpriteHuman)
		
//		set_pev(iEntity, pev_scale, 0.9) //1.20
		set_pev(iEntity, pev_owner, id)
		set_pev(iEntity, pev_solid, SOLID_NOT)
		set_pev(iEntity, pev_movetype, MOVETYPE_NONE)
		set_pev(iEntity, pev_rendermode, kRenderGlow)
		set_pev(iEntity, pev_renderfx, kRenderFxNoDissipation)
		set_pev(iEntity, pev_renderamt, 255.0)
		set_pev(iEntity, pev_animtime, get_gametime())
		set_pev(iEntity, pev_framerate, random_float(10.0, 15.0))
		set_pev(iEntity, pev_spawnflags, SF_SPRITE_STARTON)
		dllfunc(DLLFunc_Spawn, iEntity)
		engfunc(EngFunc_SetOrigin, iEntity, Float:{ 8192.0, 8192.0, 8192.0 })
		
		set_pev(iEntity, pev_effects, pev(iEntity, pev_effects) | EF_NODRAW)
		
		add_bitsum_array(bs_IsEspSprite, iEntity)
		g_iIDEntSprite[id] = iEntity;
	}
}

/*================================================================================
 [Put in, Disconnect]
=================================================================================*/

public client_putinserver(id)
{
	add_bitsum(g_iBsConnected, id)
//	del_bitsum(g_iBsAlive, id)
//	ShowSprite(id, 0)
	g_iTeam[id] = CS_TEAM_SPECTATOR;
	set_task(SPEC_INTERVAL, "SpectatorCheck", id, _, _, "b")
}

public client_disconnect(id)
{
	del_bitsum(g_iBsConnected, id)
	del_bitsum(g_iBsAlive, id)
	ShowSprite(id, 0)
//	g_iTeam[id] = CS_TEAM_SPECTATOR;
	remove_task(id)
}

/*================================================================================
 [Main Forwards]
=================================================================================*/

public fw_PlayerSpawn_Post(id)
{
	if (!is_user_alive(id)/* || !g_iTeam[id]*/)
		return
	
	add_bitsum(g_iBsAlive, id)
	
	remove_task(id)
	
	g_iTarget[id] = id;
	
	if (g_iTeam[id] != CS_TEAM_CT_SEE_T)
		g_iTeam[id] = CS_TEAM_CT;
	
	ShowSprite(id, 1)
}

public clcmd_esp(const id)
{
	if (!(get_user_flags(id) & ADMIN_BAN))
	{
/*		if (g_iTeam[id] != CS_TEAM_SPECTATOR)
		{
			g_iTeam[id] = CS_TEAM_SPECTATOR;
			
			client_print(id, print_chat, "[D7] Your ESP is now OFF!")
			client_print(id, print_chat, "[D7] Note: ESP WILL REACTIVATE ON TEAM OR SPECTATOR FIRST PERSON CHANGE!")
		}
		else
		{
			if (!get_bitsum(g_iBsAlive, id))
				client_print(id, print_chat, "[D7] You must be alive to turn your ESP back on!")
			else
			{
				if (zp_get_user_zombie(id))
					g_iTeam[id] = CS_TEAM_T;
				else
					g_iTeam[id] = CS_TEAM_CT;
				
				client_print(id, print_chat, "[D7] Your ESP is now back ON!")
			}
		}*/
		
		client_print(id, print_chat, "[D7] Your have no access to this command!")
		
		return PLUGIN_HANDLED;
	}
	
	if (g_iTeam[id] != CS_TEAM_SPECTATOR)
		g_iTeam[id]++
	else
		g_iTeam[id] = CS_TEAM_CT;
	
	client_print(id, print_chat, "[D7] Your ESP type is now %d", g_iTeam[id])
	
	return PLUGIN_HANDLED;
}

public zp_extra_item_selected(id, item)
{
	if (item != g_iItemID)
		return PLUGIN_CONTINUE;
	
	if (g_iTeam[id] == CS_TEAM_CT_SEE_T)
	{
		client_print(id, print_center, "Your zombie detector is already working!")
		
		return ZP_PLUGIN_HANDLED;
	}
	
	g_iTeam[id] = CS_TEAM_CT_SEE_T;
	client_print(id, print_center, "Your zombie detector is now ON.")
	
	return PLUGIN_CONTINUE;
}

public zp_user_infected_post(id)
	g_iTeam[id] = CS_TEAM_T;

public zp_user_humanized_post(id)
{
	if (g_iTeam[id] == CS_TEAM_CT_SEE_T)
		return;
	
	g_iTeam[id] = CS_TEAM_CT;
}

public fw_PlayerKilled(id)
{
	del_bitsum(g_iBsAlive, id)
	ShowSprite(id, 0)
	g_iTeam[id] = CS_TEAM_SPECTATOR;
	
	SpectatorCheck(id)
	set_task(SPEC_INTERVAL, "SpectatorCheck", id, _, _, "b")
}

public fw_PlayerUpdateClientData(id)
{
	if (!get_bitsum(g_iBsConnected, id) || g_iTarget[id] != id)
		return
	
	static Float:flOrigins[3], Float:flOrigins2[3], Float:flViewOfs[3], Float:vTraceEnd[3], Float:vNormal[3]
	
	pev(id, pev_origin, flOrigins)
	pev(id, pev_view_ofs, flViewOfs)
	UTIL_Vector_Add(flOrigins, flViewOfs, flViewOfs)
	
	static i, Float:flFraction;
	
	for (i = 1; i <= g_iMaxPlayers; i++)
	{
		if (!get_bitsum(g_iBsAlive, i) || id == i)
		{
			del_bitsum(bs_SpriteVisible[id], i)
			continue;
		}
		
		pev(i, pev_origin, flOrigins2)
		if (is_in_viewcone(id, flOrigins2, 0)) //can see player
		{
			engfunc(EngFunc_TraceLine, flViewOfs, flOrigins2, IGNORE_MONSTERS, id, 0)
			get_tr2(0, TR_flFraction, flFraction)
			
			if (flFraction < 1.0) //something is between
			{
				add_bitsum(bs_SpriteVisible[id], i);
				
				UTIL_Vector_Sub(flViewOfs, flOrigins2, flOrigins)
				
				get_tr2(0, TR_vecEndPos, vTraceEnd)
				get_tr2(0, TR_vecPlaneNormal, vNormal)
				UTIL_Vector_Add(vTraceEnd, vNormal, g_flOrigins[id][i])
				//UTIL_Vector_MA(vTraceEnd, vNormal, 10.0, g_flOrigins[id][i])
				
				UTIL_Vector_Sub(g_flOrigins[id][i], flViewOfs, flOrigins2)
				
				g_flScale[id][i] =  vector_length(flOrigins2) / vector_length(flOrigins)
			}
			else del_bitsum(bs_SpriteVisible[id], i);
		}
		else del_bitsum(bs_SpriteVisible[id], i);
	}
}

public fw_AddToFullPack_Post(es_handle, e, ent, host, flags, player, pSet)
{
	if (player || !is_user_valid(host) || !get_bitsum_array(bs_IsEspSprite, ent))
		return
	
	static iOwner;
	iOwner = get_es(es_handle, ES_Owner);
	
	if (g_iTarget[host] == iOwner || g_iTeam[host] == CS_TEAM_SPECTATOR || !is_user_valid_alive(iOwner)
	|| g_iTeam[host] == CS_TEAM_CT || g_iTeam[host] == CS_TEAM_CT_SEE_T && g_iTeam[iOwner] == CS_TEAM_CT || !get_bitsum(bs_SpriteVisible[g_iTarget[host]], iOwner)
	|| g_iTeam[host] == g_iTeam[iOwner])
		return;
	
	set_es(es_handle, ES_Origin, g_flOrigins[g_iTarget[host]][iOwner])
	set_es(es_handle, ES_ModelIndex, (g_iTeam[host] == CS_TEAM_T) ? g_iSpriteZombie : g_iSpriteHuman)
	set_es(es_handle, ES_Scale, g_flScale[g_iTarget[host]][iOwner])
	set_es(es_handle, ES_RenderColor, (g_iTeam[host] == CS_TEAM_T) ? g_szColorsZombie[g_iTeam[iOwner]] : g_szColorsHuman[g_iTeam[iOwner]])
}

public fw_CheckVisibility(entity, pSet)
{
	if (!pev_valid(entity) || !get_bitsum_array(bs_IsEspSprite, entity))
		return FMRES_IGNORED
	
	forward_return(FMV_CELL, 1)
	return FMRES_SUPERCEDE
}

/*================================================================================
 [Other Functions and Tasks]
=================================================================================*/

ShowSprite(id, set)
{
	new iEntity = g_iIDEntSprite[id]
	if (!pev_valid(iEntity))
	{
		del_bitsum_array(bs_IsEspSprite, iEntity)
		return
	}
	
	if (set) set_pev(iEntity, pev_effects, pev(iEntity, pev_effects) & ~EF_NODRAW)
	else set_pev(iEntity, pev_effects, pev(iEntity, pev_effects) | EF_NODRAW)
}

public SpectatorCheck(const id)
{
	if (pev(id, pev_spec_mode) != 4)
	{
		g_iTarget[id] = id;
		g_iTeam[id] = CS_TEAM_SPECTATOR;
		
		return;
	}
	
	static iTarget;
	iTarget = pev(id, pev_spec_target);
	
	if (!is_user_valid(iTarget))
		return;
	
	g_iTarget[id] = iTarget;
	g_iTeam[id] = g_iTeam[iTarget];
}

public plugin_pause()
{
	for (new i = 1; i <= g_iMaxPlayers; i++)
		ShowSprite(i, 0)
}

public plugin_unpause()
{
	for (new i = 1; i <= g_iMaxPlayers; i++)
		if (get_bitsum(g_iBsAlive, i))
			ShowSprite(i, 1)
}

/*================================================================================
 [Message Hooks]
=================================================================================*/
/*
public MessageTeamInfo(msg_id, msg_dest)
{
	if (msg_dest != MSG_ALL && msg_dest != MSG_BROADCAST)
		return
	
	static id, szTeam[2]
	id = get_msg_arg_int(1)
	get_msg_arg_string(2, szTeam, charsmax(szTeam))
	
	switch (szTeam[0])
	{
		case 'T': g_iTeam[id] = CS_TEAM_T
		case 'C': g_iTeam[id] = CS_TEAM_CT
		case 'S': g_iTeam[id] = CS_TEAM_SPECTATOR
		default: g_iTeam[id] = CS_TEAM_UNASSIGNED
	}
}*/
