#include <amxmodx>
#include <colorchat>
#include <zombieplaguenightmare>

enum
{
	health = 0,
	armor
}

new g_amount[33][2], Float:g_interval[33][2], g_limit[33][2], g_stop[33][2], Float:g_delay[33][2]

#define TASK_HEALTH 57
#define ID_HEALTH (taskid - TASK_HEALTH)
#define TASK_ARMOR 75
#define ID_ARMOR (taskid - TASK_ARMOR)

public plugin_init()
{
	register_plugin("[ZPNM] System: Regeneration", "1.0", "D i 5 7 i n c T")
	
	register_dictionary_colored("zpnm_system_regeneration.txt")
	register_dictionary("zombie_plague.txt")
	register_dictionary("zombie_plague_nightmare.txt")
}

public plugin_natives()
{
	register_native("zpnm_get_user_regeneration", "native_get_user_regeneration", 1)
	register_native("zpnm_set_user_regeneration", "native_set_user_regeneration", 1)
}

public native_get_user_regeneration(id, type, info[], lenght)
{
	if (!zpnm_get_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ZPNM] Invalid Player (%d)", id)
		return -1;
	}
	
	if (type < health || type > armor)
	{
		log_error(AMX_ERR_NATIVE, "[ZPNM] Invalid type of regeneration (%d)", type)
		log_error(AMX_ERR_NATIVE, "[ZPNM] Regeneration type can either be %d(health) or %d(armor)", health, armor)
		return -1;
	}
	
	param_convert(3)
	
	formatex(info, lenght, "%d %f %d %d %f", g_amount[id][type], g_interval[id][type], g_limit[id][type], g_stop[id][type], g_delay[id][type])
	
	return true;
}

public native_set_user_regeneration(id, type, amount, Float:interval, limit, stop, Float:delay)
{
	if (!zpnm_get_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ZPNM] Invalid Player (%d)", id)
		return -1;
	}
	
	if (!zpnm_get_user_alive(id))
	{
		log_error(AMX_ERR_NATIVE, "[ZPNM] Player must be alive to regenerate (%d)", id)
		return -1;
	}
	
/*	if (type < health || type > armor)
	{
		log_error(AMX_ERR_NATIVE, "[ZPNM] Invalid type of regeneration (%d)", type)
		log_error(AMX_ERR_NATIVE, "[ZPNM] Regeneration type can either be %d(health) or %d(armor)", health, armor)
		return -1;
	}
	*/
	
	if (type < health)
		type = health
	else if (type > armor)
		type = armor
	
	if (!amount)
	{
		if (type == health)
			remove_task(id + TASK_HEALTH)
		else if (type == armor)
			remove_task(id + TASK_ARMOR)
		
		return true;
	}
	
	g_amount[id][type] = amount
	g_interval[id][type] = interval < 0.1 ? 0.1 : interval
	g_limit[id][type] = limit < 2 ? 2 : limit
	g_stop[id][type] = stop > 3 ? 3 : stop
	g_delay[id][type] = delay < 0.1 ? 0.1 : delay
	
	if (type == health)
	{
		if (get_user_health(id) < limit && !task_exists(id + TASK_HEALTH))
			zpnm_regenerate_health(id + TASK_HEALTH)
		
		client_print_color(id, id, "^1[^4ZPNM^1] %L^3 %d^4 %L^1.", id, "ZPNM_REGENERATION_LIMIT_TYPE", limit, id, "ZOMBIE_ATTRIB1")
	}
	else if (type == armor)
	{
		if (get_user_armor(id) < limit && !task_exists(id + TASK_ARMOR))
			zpnm_regenerate_armor(id + TASK_ARMOR)
		
		client_print_color(id, id, "^1[^4ZPNM^1] %L^3 %d^4 %L^1.", id, "ZPNM_REGENERATION_LIMIT_TYPE", limit, id, "ZOMBIE_ATTRIB5")
	}
	
	client_print_color(id, id, "^1[^4ZPNM^1] %L", id, "ZPNM_REGENERATION_AMOUNT_INTERVAL", amount, interval)
	
	if (stop == 1)
		client_print_color(id, id, "^1[^4ZPNM^1] %L %L", id, "ZPNM_REGENERATION_DELAY_STOP", delay, id, "ZPNM_REGENERATION_NORMAL")
	else if (stop == 2)
		client_print_color(id, id, "^1[^4ZPNM^1] %L %L", id, "ZPNM_REGENERATION_DELAY_STOP", delay, id, "ZPNM_REGENERATION_FIRE")
	else if (stop == 3)
		client_print_color(id, id, "^1[^4ZPNM^1] %L %L, %L", id, "ZPNM_REGENERATION_DELAY_STOP", delay, id, "ZPNM_REGENERATION_FIRE", id, "ZPNM_REGENERATION_NORMAL")
	
	return true;
}

public zpnm_regenerate_health(taskid)
{
	static newhealth
	newhealth = get_user_health(ID_HEALTH) + g_amount[ID_HEALTH][health]
	
	zpnm_set_user_health(ID_HEALTH, newhealth)
	
	if (newhealth >= g_limit[ID_HEALTH][health])
		return;
	
	set_task(Float:g_interval[ID_HEALTH][health], "zpnm_regenerate_health", taskid)
}

public zpnm_regenerate_armor(taskid)
{
	static newarmor
	newarmor = get_user_armor(ID_ARMOR) + g_amount[ID_ARMOR][armor]
	
	zpnm_set_user_armor(ID_ARMOR, newarmor)
	
	if (newarmor >= g_limit[ID_ARMOR][armor])
		return;
	
	set_task(Float:g_interval[ID_ARMOR][armor], "zpnm_regenerate_armor", taskid)
}

public client_disconnect(id)
{
	remove_task(id + TASK_HEALTH)
	remove_task(id + TASK_ARMOR)
	
	g_amount[id][health] = 0
	g_amount[id][armor] = 0
}

public zpnm_user_take_damage_post(id)
{
	if (g_amount[id][health] && get_user_health(id) < g_limit[id][health])
	{
		if (task_exists(id + TASK_HEALTH))
		{
			if (!g_stop[id][health] || g_stop[id][health] == 2)
				return;
			
			remove_task(id + TASK_HEALTH)
			set_task(Float:g_delay[id][health], "zpnm_regenerate_health", id + TASK_HEALTH)
		}
		else
			set_task(Float:g_delay[id][health], "zpnm_regenerate_health", id + TASK_HEALTH)
	}
	
	if (g_amount[id][armor] && get_user_armor(id) < g_limit[id][armor])
	{
		if (task_exists(id + TASK_ARMOR))
		{
			if (!g_stop[id][armor] || g_stop[id][armor] == 2)
				return;
			
			remove_task(id + TASK_ARMOR)
			set_task(Float:g_delay[id][armor], "zpnm_regenerate_armor", id + TASK_ARMOR)
		}
		else
			set_task(Float:g_delay[id][armor], "zpnm_regenerate_armor", id + TASK_ARMOR)
	}
}

public zpnm_user_burn(id, atc, dmg, post)
{
	if (!post)
		return;
	
	if (g_amount[id][health] && get_user_health(id) < g_limit[id][health])
	{
		if (task_exists(id + TASK_HEALTH))
		{
			if (g_stop[id][health] < 2)
				return;
			
			remove_task(id + TASK_HEALTH)
			set_task(Float:g_delay[id][health], "zpnm_regenerate_health", id + TASK_HEALTH)
		}
		else
			set_task(Float:g_delay[id][health], "zpnm_regenerate_health", id + TASK_HEALTH)
	}
	
	if (g_amount[id][armor] && get_user_armor(id) < g_limit[id][armor])
	{
		if (task_exists(id + TASK_ARMOR))
		{
			if (g_stop[id][armor] < 2)
				return;
			
			remove_task(id + TASK_ARMOR)
			set_task(Float:g_delay[id][armor], "zpnm_regenerate_armor", id + TASK_ARMOR)
		}
		else
			set_task(Float:g_delay[id][armor], "zpnm_regenerate_armor", id + TASK_ARMOR)
	}
}

public zpnm_user_killed_post(id)
{
	remove_task(id + TASK_HEALTH)
	remove_task(id + TASK_ARMOR)
}
