#include <amxmodx>
#include <zpnm_sys_regeneration>
#include <zombieplaguenightmare>

// Regenerator Zombie Attributes
new const zclass_regen_name[] = "Regenerator Zombie" // name
new const zclass_regen_info[] = "Health regeneration" // description
new const zclass_regen_model[] = "zombie_source" // model
new const zclass_regen_clawmodel[] = "zombie_plague/v_knife_zombie.mdl" // claw model
const zclass_regen_health = 1800 // health
const zclass_regen_speed = 199 // speed
const Float:zclass_regen_gravity = 1.0 // gravity
const Float:zclass_regen_knockback = 1.0 // knockback

new cvar_health, cvar_delay, cvar_interval, cvar_damage
new g_zclass_regen, g_regeneration[33]

public plugin_init()
{
	register_plugin("[ZPNM] Regenerator Zombie", "1.1", "D i 5 7 i n c T")
	
	cvar_health = register_cvar("zpnm_regen_zclass_health", "5")
	cvar_delay = register_cvar("zpnm_regen_zclass_delay", "1.57")
	cvar_interval = register_cvar("zpnm_regen_zclass_interval", "0.1")
	cvar_damage = register_cvar("zpnm_regen_zclass_damage_stop", "3")
}

public plugin_precache()
	g_zclass_regen = zp_register_zombie_class(zclass_regen_name, zclass_regen_info, zclass_regen_model, zclass_regen_clawmodel, zclass_regen_health, zclass_regen_speed, zclass_regen_gravity, zclass_regen_knockback)

public client_disconnect(id)
{
	remove_task(id)
	g_regeneration[id] = false
}

public zpnm_user_spawn_post(id)
	if (g_regeneration[id])
	{
		remove_task(id)
		g_regeneration[id] = false
		zpnm_set_user_regeneration(id, TYPE_HEALTH, REGEN_REMOVE)
	}

public zp_user_infected_post(id, infector, nemesis, assassin, bomb)
{
	if (zp_get_user_zombie_class(id) != g_zclass_regen)
		return;
	
	if (nemesis || assassin)
	{
		if (!g_regeneration[id])
			return;
		
		remove_task(id)
		g_regeneration[id] = false
		zpnm_set_user_regeneration(id, TYPE_HEALTH, REGEN_REMOVE)
		
		return;
	}
	
	g_regeneration[id] = true
	
	if (!bomb && zp_has_round_started() == 1 || zp_get_user_first_zombie(id))
		zpnm_start_regeneration(id)
	else
		set_task(0.11, "zpnm_start_regeneration", id)
}

public zpnm_start_regeneration(id)
{
	static health, maxhealth
	health = get_user_health(id)
	maxhealth = zp_get_zombie_maxhealth(id)
	
	if (health > maxhealth)
		maxhealth = health
	
	zpnm_set_user_regeneration(id, TYPE_HEALTH, get_pcvar_num(cvar_health), get_pcvar_float(cvar_interval), maxhealth, get_pcvar_num(cvar_damage), get_pcvar_float(cvar_delay))
}

public zp_user_humanized_post(id)
{
	if (!g_regeneration[id])
		return;
	
	remove_task(id)
	g_regeneration[id] = false
	zpnm_set_user_regeneration(id, TYPE_HEALTH, REGEN_REMOVE)
}
