/*================================================================================
 [Plugin Customization]
=================================================================================*/

/*================================================================================
================================================================================
================================================================================
================================================================================
					:)
================================================================================
================================================================================
================================================================================
================================================================================*/

// All customization settings have been moved
// to external files to allow easier editing
new const ZP_CUSTOMIZATION_FILE[] = "zombieplaguenightmare.ini"
new const ZP_EXTRAITEMS_FILE[] = "zpnm_extraitems.ini"
new const ZP_ZOMBIECLASSES_FILE[] = "zpnm_zombieclasses.ini"
new const ZP_HUMANCLASSES_FILE[] = "zpnm_humanclasses.ini"

// Limiters for stuff not worth making dynamic arrays out of (increase if needed)
const MAX_CSDM_SPAWNS = 128
const MAX_STATS_SAVED = 64

/*================================================================================
 Customization ends here! Yes, that's it. Editing anything beyond
 here is not officially supported. Proceed at your own risk...
=================================================================================*/

#include < amxmodx >
#include < amxmisc >
#include < cstrike >
#include < engine >
#include < fakemeta >
#include < hamsandwich >
#include < xs >
#include < fun >
#include < dhudmessage >
#include < nexon >
#include < zp50_log >

/*================================================================================
 [Constants, Offsets, Macros]
=================================================================================*/

// Plugin Version
new const PLUGIN_VERSION[] = "Nightmare 2.3.8"

native OpenWeaponMenu(id)
native get_user_lvl(id)
native get_num_lvls(id)
native get_user_xp(id)
native get_lvl_xp(id)

// Trail color
new g_colorfire
new g_colorfrost
new g_colorflare
new g_colorinfect

// Frost, Fire Explosion Effects
new g_talrasha_frost
new g_talrasha_frost2
new g_talrasha_fire
new g_talrasha_fire2
new g_talrasha_flare
new g_talrasha_flare2
new g_talrasha_infection
new g_talrasha_infection2

// Trail
new trail_grenade_fire[64], 
trail_grenade_frost[64], 
trail_grenade_flare[64],
trail_grenade_infect[64]

// Check Damage
new Float:user_damage[33]

// Informer hud
new g_informer[33], g_position[33]
enum
{
	INFORMER_STYLE1,
	INFORMER_STYLE2,
	INFORMER_STYLE3,
	INFORMER_STYLE4
}
enum
{
	POSITION_LEFT,
	POSITION_CENTER,
	POSITION_RIGHT
}
#define INF_DHUD	"Большой информер"
#define INF_HUD		"Маленький информер"
#define INF_TEXT	"Текст"
#define INF_OFF		"Выключен"

#define POST_LEFT	"Слева"
#define POST_CENTER "По середине"
#define POST_RIGHT	"Справа"

// Zombie sounds
new Array:class_sound_infect, 
Array:class_sound_pain,
Array:class_sound_idle, 
Array:class_sound_idle_last, 
Array:class_sound_die, 
Array:class_sound_fall, 
Array:class_sound_madness, 
Array:class_sound_burn, 
Array:class_sound_miss_slash, 
Array:class_sound_miss_wall, 
Array:class_sound_hit_normal, 
Array:class_sound_hit_stab

// Pointers
new Array:pointer_class_sound_infect, 
Array:pointer_class_sound_pain, 
Array:pointer_class_sound_idle, 
Array:pointer_class_sound_idle_last, 
Array:pointer_class_sound_die, 
Array:pointer_class_sound_fall, 
Array:pointer_class_sound_madness, 
Array:pointer_class_sound_burn, 
Array:pointer_class_sound_miss_slash, 
Array:pointer_class_sound_miss_wall, 
Array:pointer_class_sound_hit_normal, 
Array:pointer_class_sound_hit_stab 

// Nemesis sounds
new Array:nemesis_pain, 
Array:nemesis_idle, 
Array:nemesis_die, 
Array:nemesis_fall, 
Array:nemesis_miss_slash, 
Array:nemesis_miss_wall, 
Array:nemesis_hit_normal, 
Array:nemesis_hit_stab 

// assassin sounds
new Array:assassin_pain, 
Array:assassin_idle, 
Array:assassin_die, 
Array:assassin_fall, 
Array:assassin_miss_slash, 
Array:assassin_miss_wall, 
Array:assassin_hit_normal, 
Array:assassin_hit_stab 

// Customization file sections
enum
{
	SECTION_NONE = 0,
	SECTION_ACCESS_FLAGS,
	SECTION_PLAYER_MODELS,
	SECTION_WEAPON_MODELS,
	SECTION_GRENADE_SPRITES,
	SECTION_SOUNDS,
	SECTION_AMBIENCE_SOUNDS,
	SECTION_BUY_MENU_WEAPONS,
	SECTION_EXTRA_ITEMS_WEAPONS,
	SECTION_HARD_CODED_ITEMS_COSTS,
	SECTION_WEATHER_EFFECTS,
	SECTION_SKY,
	SECTION_LIGHTNING,
	SECTION_ZOMBIE_DECALS,
	SECTION_KNOCKBACK,
	SECTION_OBJECTIVE_ENTS,
	SECTION_SVC_BAD
}

// Access flags
enum
{
	ACCESS_ENABLE_MOD = 0,
	ACCESS_ADMIN_MENU,
	ACCESS_MODE_INFECTION,
	ACCESS_MODE_NEMESIS,
	ACCESS_MODE_SURVIVOR,
	ACCESS_MODE_SWARM,
	ACCESS_MODE_MULTI,
	ACCESS_MODE_PLAGUE,
	ACCESS_MAKE_ZOMBIE,
	ACCESS_MAKE_HUMAN,
	ACCESS_MAKE_NEMESIS,
	ACCESS_MAKE_SURVIVOR,
	ACCESS_RESPAWN_PLAYERS,
	ACCESS_ADMIN_MODELS,
	ACCESS_MODE_SNIPER,
	ACCESS_MAKE_SNIPER,
	ACCESS_MODE_ASSASSIN,
	ACCESS_MAKE_ASSASSIN,
	MAX_ACCESS_FLAGS
}

// Task offsets
enum (+= 100)
{
	TASK_MODEL = 2000,
	TASK_TEAM,
	TASK_SPAWN,
	TASK_BLOOD,
	TASK_AURA,
	TASK_BURN,
	TASK_NVISION,
	TASK_FLASH,
	TASK_CHARGE,
	TASK_SHOWHUD,
	TASK_MAKEZOMBIE,
	TASK_WELCOMEMSG,
	TASK_THUNDER_PRE,
	TASK_THUNDER,
	TASK_AMBIENCESOUNDS,
	TASK_UNFREEZE
}

// IDs inside tasks
#define ID_MODEL (taskid - TASK_MODEL)
#define ID_TEAM (taskid - TASK_TEAM)
#define ID_SPAWN (taskid - TASK_SPAWN)
#define ID_BLOOD (taskid - TASK_BLOOD)
#define ID_AURA (taskid - TASK_AURA)
#define ID_BURN (taskid - TASK_BURN)
#define ID_NVISION (taskid - TASK_NVISION)
#define ID_FLASH (taskid - TASK_FLASH)
#define ID_CHARGE (taskid - TASK_CHARGE)
#define ID_SHOWHUD (taskid - TASK_SHOWHUD)
#define ID_UNFREEZE (taskid - TASK_UNFREEZE)

// BP Ammo Refill task
#define REFILL_WEAPONID args[0]

// For weapon buy menu handlers
#define WPN_STARTID g_menu_data[id][1]
#define WPN_MAXIDS ArraySize(g_primary_items)
#define WPN_SELECTION (g_menu_data[id][1]+key)
#define WPN_AUTO_ON g_menu_data[id][2]
#define WPN_AUTO_PRI g_menu_data[id][3]
#define WPN_AUTO_SEC g_menu_data[id][4]

// For player list menu handlers
#define PL_ACTION g_menu_data[id][0]

// For remembering menu pages
#define MENU_PAGE_ZCLASS g_menu_data[id][5]
#define MENU_PAGE_EXTRAS g_menu_data[id][6]
#define MENU_PAGE_PLAYERS g_menu_data[id][7]
#define MENU_PAGE_HCLASS g_menu_data[id][8]

// For extra items menu handlers
#define EXTRAS_CUSTOM_STARTID (EXTRA_WEAPONS_STARTID + ArraySize(g_extraweapon_names))

// Menu selections
const MENU_KEY_AUTOSELECT = 7
const MENU_KEY_BACK = 7
const MENU_KEY_NEXT = 8
const MENU_KEY_EXIT = 9

// Hard coded extra items
enum
{
	EXTRA_NVISION = 0,
	EXTRA_ANTIDOTE,
	EXTRA_MADNESS,
	EXTRA_INFBOMB,
	EXTRA_WEAPONS_STARTID
}

// Game modes
enum
{
	MODE_NONE = 0,
	MODE_INFECTION,
	MODE_NEMESIS,
	MODE_SURVIVOR,
	MODE_SWARM,
	MODE_MULTI,
	MODE_PLAGUE,
	MODE_SNIPER,
	MODE_ASSASSIN
}

// ZP Teams
const ZP_TEAM_NO_ONE = 0
const ZP_TEAM_ANY = 0
const ZP_TEAM_ZOMBIE = (1<<0)
const ZP_TEAM_HUMAN = (1<<1)
const ZP_TEAM_NEMESIS = (1<<2)
const ZP_TEAM_SURVIVOR = (1<<3)
const ZP_TEAM_SNIPER = (1<<4)
const ZP_TEAM_ASSASSIN = (1<<5)
new const ZP_TEAM_NAMES[][] = { "ZOMBIE , HUMAN", "ZOMBIE", "HUMAN", "ZOMBIE , HUMAN", "NEMESIS",
			"ZOMBIE , NEMESIS", "HUMAN , NEMESIS", "ZOMBIE , HUMAN , NEMESIS",
			"SURVIVOR", "ZOMBIE , SURVIVOR", "HUMAN , SURVIVOR", "ZOMBIE , HUMAN , SURVIVOR",
			"NEMESIS , SURVIVOR", "ZOMBIE , NEMESIS , SURVIVOR", "HUMAN, NEMESIS, SURVIVOR",
			"ZOMBIE , HUMAN , NEMESIS , SURVIVOR", "SNIPER", "ZOMBIE , SNIPER", "HUMAN , SNIPER",
			"ZOMBIE , HUMAN , SNIPER", "NEMESIS , SNIPER", "SURVIVOR , SNIPER",
			"ZOMBIE , NEMESIS , SNIPER", "ZOMBIE , SURVIVOR , SNIPER", "HUMAN , NEMESIS , SNIPER",
			"HUMAN , SURVIVOR , SNIPER", "NEMESIS , SURVIVOR , SNIPER",
			"ZOMBIE , HUMAN , NEMESIS , SNIPER", "ZOMBIE , HUMAN , SURVIVOR , SNIPER",
			"ZOMBIE , NEMESIS , SURVIVOR , SNIPER", "HUMAN , NEMESIS , SURVIVOR , SNIPER",
			"ZOMBIE , HUMAN , NEMESIS , SURVIVOR , SNIPER", "ASSASSIN", "ZOMBIE , ASSASSIN",
			"HUMAN , ASSASSIN", "ZOMBIE , HUMAN , ASSASSIN", "NEMESIS , ASSASSIN",
			"SURVIVOR , ASSASSIN", "ZOMBIE , NEMESIS , ASSASSIN", "ZOMBIE , SURVIVOR , ASSASSIN",
			"HUMAN , NEMESIS , ASSASSIN", "HUMAN , SURVIVOR , ASSASSIN",
			"NEMESIS , SURVIVOR , ASSASSIN", "ZOMBIE , HUMAN , NEMESIS , ASSASSIN",
			"ZOMBIE , HUMAN , SURVIVOR , ASSASSIN", "ZOMBIE , NEMESIS , SURVIVOR , ASSASSIN",
			"HUMAN , NEMESIS , SURVIVOR , ASSASSIN",
			"ZOMBIE , HUMAN , NEMESIS , SURVIVOR , ASSASSIN", "SNIPER , ASSASSIN",
			"ZOMBIE , SNIPER , ASSASSIN", "HUMAN , SNIPER , ASSASSIN",
			"NEMESIS , SNIPER , ASSASSIN", "SURVIVOR , SNIPER , ASSASSIN",
			"ZOMBIE , HUMAN , SNIPER , ASSASSIN", "ZOMBIE , NEMESIS , SNIPER , ASSASSIN",
			"ZOMBIE , SURVIVOR , SNIPER , ASSASSIN", "HUMAN , NEMESIS , SNIPER , ASSASSIN",
			"HUMAN , SURVIVOR , SNIPER , ASSASSIN", "NEMESIS , SURVIVOR , SNIPER , ASSASSIN",
			"ZOMBIE , HUMAN , NEMESIS , SURVIVOR , SNIPER , ASSASSIN" }

// Zombie classes
const HZCLASS_NONE = -1

// HUD messages
const Float:HUD_EVENT_X = -1.0
const Float:HUD_EVENT_Y = 0.17
const Float:HUD_INFECT_X = 0.05
const Float:HUD_INFECT_Y = 0.45
const Float:HUD_STATS_X = -1.0 //0.02
const Float:HUD_STATS_Y = 0.8957 //0.9

// Hack to be able to use Ham_Player_ResetMaxSpeed (by joaquimandrade)
new Ham:Ham_Player_ResetMaxSpeed = Ham_Item_PreFrame

// CS Player PData Offsets (win32)
const PDATA_SAFE = 2
const OFFSET_PAINSHOCK = 108 // ConnorMcLeod
const OFFSET_CSTEAMS = 114
const OFFSET_CSMONEY = 115
const OFFSET_CSMENUCODE = 205
const OFFSET_FLASHLIGHT_BATTERY = 244
const OFFSET_CSDEATHS = 444
const OFFSET_MODELINDEX = 491 // Orangutanz

// CS Player CBase Offsets (win32)
const OFFSET_ACTIVE_ITEM = 373

// CS Weapon CBase Offsets (win32)
const OFFSET_WEAPONOWNER = 41

// Linux diff's
const OFFSET_LINUX = 5 // offsets 5 higher in Linux builds
const OFFSET_LINUX_WEAPONS = 4 // weapon offsets are only 4 steps higher on Linux

// CS Teams
enum
{
	FM_CS_TEAM_UNASSIGNED = 0,
	FM_CS_TEAM_T,
	FM_CS_TEAM_CT,
	FM_CS_TEAM_SPECTATOR
}
new const CS_TEAM_NAMES[][] = { "UNASSIGNED", "TERRORIST", "CT", "SPECTATOR" }

// Some constants
const HIDE_MONEY = (1<<5)
const UNIT_SECOND = (1<<12)
const DMG_HEGRENADE = (1<<24)
const IMPULSE_FLASHLIGHT = 100
const USE_USING = 2
const USE_STOPPED = 0
const STEPTIME_SILENT = 999
const BREAK_GLASS = 0x01
const FFADE_IN = 0x0000
const FFADE_STAYOUT = 0x0004
const PEV_SPEC_TARGET = pev_iuser2

// Max BP ammo for weapons
new const MAXBPAMMO[] = { -1, 254, -1, 254, 1, 254, 1, 254, 254, 1, 254, 254, 254, 254, 254, 254, 254, 254,
			254, 254, 254, 254, 254, 254, 254, 2, 254, 254, 254, -1, 254 }
/*
DEFAULT: { -1, 52, -1, 90, 1, 32, 1, 100, 90, 1, 120, 100, 100, 90, 90, 90, 100, 120,
			30, 120, 200, 32, 90, 120, 90, 2, 35, 90, 90, -1, 100 }*/

// Max Clip for weapons
new const MAXCLIP[] = { -1, 13, -1, 10, -1, 7, -1, 30, 30, -1, 30, 20, 25, 30, 35, 25, 12, 20,
			10, 30, 100, 8, 30, 30, 20, -1, 7, 30, 30, -1, 50 }

// Amount of ammo to give when buying additional clips for weapons
new const BUYAMMO[] = { -1, 13, -1, 30, -1, 8, -1, 12, 30, -1, 30, 50, 12, 30, 30, 30, 12, 30,
			10, 30, 30, 8, 30, 30, 30, -1, 7, 30, 30, -1, 50 }

// Ammo IDs for weapons
new const AMMOID[] = { -1, 9, -1, 2, 12, 5, 14, 6, 4, 13, 10, 7, 6, 4, 4, 4, 6, 10,
			1, 10, 3, 5, 4, 10, 2, 11, 8, 4, 2, -1, 7 }

// Ammo Type Names for weapons
new const AMMOTYPE[][] = { "", "357sig", "", "762nato", "", "buckshot", "", "45acp", "556nato", "", "9mm", "57mm", "45acp",
			"556nato", "556nato", "556nato", "45acp", "9mm", "338magnum", "9mm", "556natobox", "buckshot",
			"556nato", "9mm", "762nato", "", "50ae", "556nato", "762nato", "", "57mm" }

// Weapon IDs for ammo types
new const AMMOWEAPON[] = { 0, CSW_AWP, CSW_SCOUT, CSW_M249, CSW_AUG, CSW_XM1014, CSW_MAC10, CSW_FIVESEVEN, CSW_DEAGLE,
			CSW_P228, CSW_ELITE, CSW_FLASHBANG, CSW_HEGRENADE, CSW_SMOKEGRENADE, CSW_C4 }

// Primary and Secondary Weapon Names
new const WEAPONNAMES[][] = { "", "P228 Compact", "", "Schmidt Scout", "", "XM1014 M4", "", "Ingram MAC-10", "Steyr AUG A1",
			"", "Dual Elite Berettas", "FiveseveN", "UMP 45", "SG-550 Auto-Sniper", "IMI Galil", "Famas",
			"USP .45 ACP Tactical", "Glock 18C", "AWP Magnum Sniper", "MP5 Navy", "M249 Para Machinegun",
			"M3 Super 90", "M4A1 Carbine", "Schmidt TMP", "G3SG1 Auto-Sniper", "", "Desert Eagle .50 AE",
			"SG-552 Commando", "AK-47 Kalashnikov", "", "ES P90" }

// Weapon entity names
new const WEAPONENTNAMES[][] = { "", "weapon_p228", "", "weapon_scout", "weapon_hegrenade", "weapon_xm1014", "weapon_c4", "weapon_mac10",
			"weapon_aug", "weapon_smokegrenade", "weapon_elite", "weapon_fiveseven", "weapon_ump45", "weapon_sg550",
			"weapon_galil", "weapon_famas", "weapon_usp", "weapon_glock18", "weapon_awp", "weapon_mp5navy", "weapon_m249",
			"weapon_m3", "weapon_m4a1", "weapon_tmp", "weapon_g3sg1", "weapon_flashbang", "weapon_deagle", "weapon_sg552",
			"weapon_ak47", "weapon_knife", "weapon_p90" }

// CS sounds
new const sound_flashlight[] = "items/flashlight1.wav"
new const sound_buyammo[] = "items/9mmclip1.wav"
new const sound_armorhit[] = "player/bhit_helmet-1.wav"

// Explosion radius for custom grenades
const Float:NADE_EXPLOSION_RADIUS = 240.0

// HACK: pev_ field used to store additional ammo on weapons
const PEV_ADDITIONAL_AMMO = pev_iuser1

// HACK: pev_ field used to store custom nade types and their values
const PEV_NADE_TYPE = pev_flTimeStepSound
const NADE_TYPE_INFECTION = 1111
const NADE_TYPE_NAPALM = 2222
const NADE_TYPE_FROST = 3333
const NADE_TYPE_FLARE = 4444
const PEV_FLARE_COLOR = pev_punchangle
const PEV_FLARE_DURATION = pev_flSwimTime

// Weapon bitsums
const PRIMARY_WEAPONS_BIT_SUM = (1<<CSW_SCOUT)|(1<<CSW_XM1014)|(1<<CSW_MAC10)|(1<<CSW_AUG)|(1<<CSW_UMP45)|(1<<CSW_SG550)|(1<<CSW_GALIL)|(1<<CSW_FAMAS)|(1<<CSW_AWP)|(1<<CSW_MP5NAVY)|(1<<CSW_M249)|(1<<CSW_M3)|(1<<CSW_M4A1)|(1<<CSW_TMP)|(1<<CSW_G3SG1)|(1<<CSW_SG552)|(1<<CSW_AK47)|(1<<CSW_P90)
const SECONDARY_WEAPONS_BIT_SUM = (1<<CSW_P228)|(1<<CSW_ELITE)|(1<<CSW_FIVESEVEN)|(1<<CSW_USP)|(1<<CSW_GLOCK18)|(1<<CSW_DEAGLE)

// Allowed weapons for zombies (added grenades/bomb for sub-plugin support, since they shouldn't be getting them anyway)
const ZOMBIE_ALLOWED_WEAPONS_BITSUM = (1<<CSW_KNIFE)|(1<<CSW_HEGRENADE)|(1<<CSW_FLASHBANG)|(1<<CSW_SMOKEGRENADE)|(1<<CSW_C4)

// Classnames for separate model entities
new const MODEL_ENT_CLASSNAME[] = "player_model"
new const WEAPON_ENT_CLASSNAME[] = "weapon_model"

// Menu keys
const KEYSMENU = MENU_KEY_1|MENU_KEY_2|MENU_KEY_3|MENU_KEY_4|MENU_KEY_5|MENU_KEY_6|MENU_KEY_7|MENU_KEY_8|MENU_KEY_9|MENU_KEY_0

// Ambience Sounds
enum
{
	AMBIENCE_SOUNDS_INFECTION = 0,
	AMBIENCE_SOUNDS_NEMESIS,
	AMBIENCE_SOUNDS_SURVIVOR,
	AMBIENCE_SOUNDS_SWARM,
	AMBIENCE_SOUNDS_PLAGUE,
	AMBIENCE_SOUNDS_SNIPER,
	AMBIENCE_SOUNDS_ASSASSIN,
	MAX_AMBIENCE_SOUNDS
}

// Admin menu actions
enum
{
	ACTION_ZOMBIEFY_HUMANIZE = 0,
	ACTION_MAKE_NEMESIS,
	ACTION_MAKE_SURVIVOR,
	ACTION_RESPAWN_PLAYER,
	ACTION_MODE_SWARM,
	ACTION_MODE_MULTI,
	ACTION_MODE_PLAGUE,
	ACTION_MAKE_SNIPER,
	ACTION_MAKE_ASSASSIN
}

// Custom forward return values
const ZP_PLUGIN_HANDLED = 97

/*================================================================================
 [Global Variables]
=================================================================================*/

// Player vars
new g_zombie[33] // is zombie
new g_nemesis[33] // is nemesis
new g_survivor[33] // is survivor
new g_firstzombie[33] // is first zombie
new g_lastzombie[33] // is last zombie
new g_lasthuman[33] // is last human
new g_frozen[33] // is frozen (can't move)
new Float:g_frozen_gravity[33] // store previous gravity when frozen
new g_nodamage[33] // has spawn protection/zombie madness
new g_respawn_as_zombie[33] // should respawn as zombie
new g_nvision[33] // has night vision
new g_nvisionenabled[33] // has night vision turned on
new g_zombieclass[33] // zombie class
new g_zombieclassnext[33] // zombie class for next infection
new g_flashlight[33] // has custom flashlight turned on
new g_flashbattery[33] = { 100, ... } // custom flashlight battery
new g_canbuy[33] // is allowed to buy a new weapon through the menu
new g_ammopacks[33] // ammo pack count
new g_damagedealt_human[33] // damage dealt as human (used to calculate ammo packs reward)
new g_damagedealt_zombie[33] // damage dealt as zombie (used to calculate ammo packs reward)
new Float:g_lastleaptime[33] // time leap was last used
new Float:g_lastflashtime[33] // time flashlight was last toggled
new g_playermodel[33][32] // current model's short name [player][model]
new g_menu_data[33][9] // data for some menu handlers
new g_ent_playermodel[33] // player model entity
new g_ent_weaponmodel[33] // weapon model entity
new g_burning_duration[33] // burning task duration
new Float:g_buytime[33] // used to calculate custom buytime
new g_humanclass[33] // human class
new g_humanclassnext[33] // human class for next spawn or disinfection
new g_sniper[33] // is sniper
new g_assassin[33] // is assassin
new g_infammo[33] // has infinite ammo

// Game vars
new g_pluginenabled // ZP enabled
new g_newround // new round starting
new g_endround // round ended
new g_nemround // nemesis round
new g_survround // survivor round
new g_swarmround // swarm round
new g_plagueround // plague round
new g_modestarted // mode fully started
new g_lastmode // last played mode
new g_scorezombies, g_scorehumans, g_gamecommencing // team scores
new g_spawnCount, g_spawnCount2 // available spawn points counter
new Float:g_spawns[MAX_CSDM_SPAWNS][3], Float:g_spawns2[MAX_CSDM_SPAWNS][3] // spawn points data
new g_lights_i // lightning current lights counter
new g_lights_cycle[32] // current lightning cycle
new g_lights_cycle_len // lightning cycle length
new Float:g_models_targettime // for adding delays between Model Change messages
new Float:g_teams_targettime // for adding delays between Team Change messages
new g_MsgSync, g_MsgSync2 // message sync objects
new g_exploSpr, g_flameSpr, g_smokeSpr, g_glassSpr // grenade sprites
new g_modname[32] // for formatting the mod name
new g_freezetime // whether CS's freeze time is on
new g_maxplayers // max players counter
new g_czero // whether we are running on a CZ server
new g_hamczbots // whether ham forwards are registered for CZ bots
new g_fwSpawn, g_fwPrecacheSound // spawn and precache sound forward handles
new g_infbombcounter, g_antidotecounter, g_madnesscounter // to limit buying some items
new g_arrays_created // to prevent stuff from being registered before initializing arrays
new g_lastplayerleaving // flag for whenever a player leaves and another takes his place
new g_switchingteam // flag for whenever a player's team change emessage is sent
new g_buyzone_ent // custom buyzone entity
new g_snipround // sniper round
new g_assround // assassin round

// Message IDs vars
new g_msgScoreInfo, g_msgNVGToggle, g_msgScoreAttrib, g_msgAmmoPickup, g_msgScreenFade,
g_msgDeathMsg, g_msgSetFOV, g_msgFlashlight, g_msgFlashBat, g_msgTeamInfo, g_msgDamage,
g_msgHideWeapon, g_msgCrosshair, g_msgScreenShake, g_msgCurWeapon

// Some forward handlers
new g_fwRoundStart, g_fwRoundEnd, g_fwUserInfected_pre, g_fwUserInfected_post,
g_fwUserHumanized_pre, g_fwUserHumanized_post, g_fwUserInfect_attempt,
g_fwUserHumanize_attempt, g_fwExtraItemSelected, g_fwUserUnfrozen,
g_fwUserLastZombie, g_fwUserLastHuman, g_fwDummyResult, g_fwUserSpawn_pre,
g_fwUserSpawn_post, g_fwUserKilled_pre, g_fwUserKilled_post, g_fwUserTakeDamage_attempt,
g_fwUserTakeDamage_post, g_fwUserBurn, g_fwUserFrozen, g_fwUserGetWeapons,
g_fwUserGetAmmoPacks, g_fwCzBotsRegisterHam, g_fwExtraItemBuyAttempt

// Temporary Database vars (used to restore players stats in case they get disconnected)
//new db_name[MAX_STATS_SAVED][32] // player name
new db_address[MAX_STATS_SAVED][26] // player ip
new db_ammopacks[MAX_STATS_SAVED] // ammo pack count
new db_zombieclass[MAX_STATS_SAVED] // zombie class
new db_slot_i // additional saved slots counter (should start on maxplayers+1)
new db_humanclass[MAX_STATS_SAVED] // human class

// Extra Items vars
new Array:g_extraitem_name // caption
new Array:g_extraitem_cost // cost
new Array:g_extraitem_team // team
new g_extraitem_i // loaded extra items counter

// For extra items file parsing
new Array:g_extraitem2_realname, Array:g_extraitem2_name, Array:g_extraitem2_cost,
Array:g_extraitem2_team, Array:g_extraitem_new

// Zombie Classes vars
new Array:g_zclass_name // caption
new Array:g_zclass_info // description
new Array:g_zclass_modelsstart // start position in models array
new Array:g_zclass_modelsend // end position in models array
new Array:g_zclass_playermodel // player models array
new Array:g_zclass_modelindex // model indices array
new Array:g_zclass_clawmodel // claw model
new Array:g_zclass_hp // health
new Array:g_zclass_spd // speed
new Array:g_zclass_grav // gravity
new Array:g_zclass_kb // knockback
new g_zclass_i // loaded zombie classes counter

// For zombie classes file parsing
new Array:g_zclass2_realname, Array:g_zclass2_name, Array:g_zclass2_info,
Array:g_zclass2_modelsstart, Array:g_zclass2_modelsend, Array:g_zclass2_playermodel,
Array:g_zclass2_modelindex, Array:g_zclass2_clawmodel, Array:g_zclass2_hp,
Array:g_zclass2_spd, Array:g_zclass2_grav, Array:g_zclass2_kb, Array:g_zclass_new

// Human Classes vars
new Array:g_hclass_name // caption
new Array:g_hclass_info // description
new Array:g_hclass_modelsstart // start position in models array
new Array:g_hclass_modelsend // end position in models array
new Array:g_hclass_playermodel // player models array
new Array:g_hclass_modelindex // model indices array
new Array:g_hclass_handmodel // hand model
new Array:g_hclass_hp // health
new Array:g_hclass_spd // speed
new Array:g_hclass_grav // gravity
new g_hclass_i // loaded human classes counter

// For human classes file parsing
new Array:g_hclass2_realname, Array:g_hclass2_name, Array:g_hclass2_info,
Array:g_hclass2_modelsstart, Array:g_hclass2_modelsend, Array:g_hclass2_playermodel,
Array:g_hclass2_modelindex, Array:g_hclass2_handmodel, Array:g_hclass2_hp,
Array:g_hclass2_spd, Array:g_hclass2_grav, Array:g_hclass_new

// Customization vars
new g_access_flag[MAX_ACCESS_FLAGS], Array:model_nemesis, Array:model_survivor,
Array:model_admin_zombie, Array:model_admin_human,
Array:g_modelindex_nemesis, Array:g_modelindex_survivor, g_same_models_for_all,
Array:g_modelindex_admin_zombie, Array:g_modelindex_admin_human,
model_vknife_nemesis[64], model_vweapon_survivor[64],
model_vknife_admin_human[64], model_vknife_admin_zombie[64], 
sprite_grenade_fire[64], sprite_grenade_ring[64],
sprite_grenade_smoke[64], sprite_grenade_glass[64], Array:sound_win_zombies,
Array:sound_win_humans, Array:sound_win_no_one,/* Array:sound_win_zombies_ismp3,
Array:sound_win_humans_ismp3, Array:sound_win_no_one_ismp3, */ g_ambience_rain,
Array:sound_nemesis, Array:sound_survivor,
Array:sound_swarm, Array:sound_multi, Array:sound_plague, Array:grenade_infect,
Array:grenade_infect_player, Array:grenade_fire,
Array:grenade_frost, Array:grenade_frost_player, Array:grenade_frost_break,
Array:grenade_flare, Array:sound_antidote, Array:sound_thunder, g_ambience_sounds[MAX_AMBIENCE_SOUNDS],
Array:sound_ambience1, Array:sound_ambience2, Array:sound_ambience3, Array:sound_ambience4,
Array:sound_ambience5, Array:sound_ambience1_duration, Array:sound_ambience2_duration,
Array:sound_ambience3_duration, Array:sound_ambience4_duration,
Array:sound_ambience5_duration,/* Array:sound_ambience1_ismp3, Array:sound_ambience2_ismp3,
Array:sound_ambience3_ismp3, Array:sound_ambience4_ismp3, Array:sound_ambience5_ismp3,*/
Array:g_primary_items, Array:g_secondary_items, Array:g_additional_items,
Array:g_primary_weaponids, Array:g_secondary_weaponids, Array:g_extraweapon_names,
Array:g_extraweapon_items, Array:g_extraweapon_costs, g_extra_costs2[EXTRA_WEAPONS_STARTID],
g_ambience_snow, g_ambience_fog, g_fog_density[10], g_fog_color[12], g_sky_enable,
Array:g_sky_names, Array:lights_thunder, Array:zombie_decals, Array:g_objective_ents,
Float:g_modelchange_delay, g_set_modelindex_offset, g_handle_models_on_separate_ent,
Float:kb_weapon_power[31] = { -1.0, ... }, g_force_consistency,
Array:model_sniper, Array:g_modelindex_sniper, model_vweapon_sniper[64], Array:sound_sniper,
Array:model_assassin, Array:g_modelindex_assassin, model_vknife_assassin[64],
model_v_grenade_fire[64], 
model_v_grenade_frost[64], 
model_v_grenade_flare[64], 
model_v_grenade_infection[64],
model_p_grenade_fire[64], 
model_p_grenade_frost[64], 
model_p_grenade_flare[64], 
model_p_grenade_infection[64],
model_w_grenade_fire[64], 
model_w_grenade_frost[64], 
model_w_grenade_flare[64],
model_w_grenade_infection[64],
Array:sound_assassin, Array:sound_ambience6, Array:sound_ambience6_duration,
/*Array:sound_ambience6_ismp3, */Array:sound_ambience7, Array:sound_ambience7_duration,
/*Array:sound_ambience7_ismp3, */g_sky_name[32]

// CVAR pointers
new cvar_lighting, cvar_zombiefov, cvar_plague, cvar_plaguechance, cvar_zombiefirsthp,
cvar_removemoney, cvar_thunder, cvar_zombiebonushp, cvar_nemhp, cvar_nem, cvar_surv,
cvar_nemchance, cvar_deathmatch, cvar_nemglow, cvar_customnvg, cvar_hitzones,
cvar_nemgravity, cvar_flashsize, cvar_ammodamage_human, cvar_ammodamage_zombie,
cvar_zombiearmor, cvar_survpainfree, cvar_nempainfree, cvar_nemspd, cvar_survchance,
cvar_survhp, cvar_survspd, cvar_swarmchance, cvar_flashdrain,
cvar_zombiebleeding, cvar_removedoors, cvar_customflash, cvar_randspawn, cvar_multi,
cvar_multichance, cvar_infammo, cvar_swarm, cvar_ammoinfect, cvar_toggle,
cvar_knockbackpower, cvar_freezeduration, cvar_triggered, cvar_flashcharge,
cvar_firegrenades, cvar_frostgrenades, cvar_survgravity, cvar_logcommands, cvar_survglow,
cvar_spawnprotection, cvar_nvgsize, cvar_flareduration, cvar_zclasses,
cvar_extraitems, cvar_showactivity, cvar_humanlasthp, cvar_nemignorefrags, cvar_warmup,
cvar_flashdist, cvar_flarecolor, cvar_survignorefrags, cvar_fireduration, cvar_firedamage,
cvar_flaregrenades, cvar_knockbackducking, cvar_knockbackdamage, cvar_knockbackzvel,
cvar_multiratio, cvar_flaresize, cvar_spawndelay, cvar_extraantidote, cvar_extramadness,
cvar_extraweapons, cvar_extranvision, cvar_nvggive, cvar_preventconsecutive, cvar_botquota,
cvar_buycustom, cvar_zombiepainfree, cvar_fireslowdown, cvar_survbasehp, cvar_survaura,
cvar_nemignoreammo, cvar_survignoreammo, cvar_nemaura, cvar_extrainfbomb, cvar_knockback,
cvar_fragsinfect, cvar_fragskill, cvar_humanarmor, cvar_zombiesilent, cvar_removedropped,
cvar_plagueratio, cvar_blocksuicide, cvar_knockbackdist, cvar_nemdamage, cvar_leapzombies,
cvar_leapzombiesforce, cvar_leapzombiesheight, cvar_leapzombiescooldown, cvar_leapnemesis,
cvar_leapnemesisforce, cvar_leapnemesisheight, cvar_leapnemesiscooldown, cvar_leapsurvivor,
cvar_leapsurvivorforce, cvar_leapsurvivorheight, cvar_nemminplayers, cvar_survminplayers,
cvar_respawnonsuicide, cvar_respawnafterlast, cvar_leapsurvivorcooldown, cvar_statssave,
cvar_swarmminplayers, cvar_multiminplayers, cvar_plagueminplayers, cvar_adminmodelshuman,
cvar_adminmodelszombie, cvar_nembasehp, cvar_blockpushables, cvar_respawnworldspawnkill,
cvar_madnessduration, cvar_plaguenemnum, cvar_plaguenemhpmulti, cvar_plaguesurvhpmulti,
cvar_survweapon, cvar_plaguesurvnum, cvar_infectionscreenfade, cvar_infectionscreenshake,
cvar_infectionsparkle, cvar_infectiontracers, cvar_infectionparticles, cvar_infbomblimit,
cvar_allowrespawnsurv, cvar_flashshowall, cvar_allowrespawninfection, cvar_allowrespawnnem,
cvar_allowrespawnswarm, cvar_allowrespawnplague, cvar_survinfammo, cvar_nemknockback,
cvar_nvgcolor[3], cvar_nemnvgcolor[3], cvar_humnvgcolor[3], cvar_flashcolor[3],
cvar_hudicons, cvar_respawnzomb, cvar_respawnhum, cvar_respawnnem, cvar_respawnsurv,
cvar_startammopacks, cvar_randweapons, cvar_antidotelimit, cvar_madnesslimit,
cvar_adminknifemodelshuman, cvar_adminknifemodelszombie, cvar_keephealthondisconnect,
cvar_buyzonetime, cvar_huddisplay, cvar_hclasses, cvar_snip, cvar_snippainfree,
cvar_snipchance, cvar_sniphp, cvar_snipspd, cvar_snipgravity, cvar_snipglow,
cvar_snipignorefrags, cvar_snipbasehp, cvar_snipaura, cvar_snipignoreammo, cvar_leapsniper,
cvar_leapsniperforce, cvar_leapsniperheight, cvar_snipminplayers, cvar_leapsnipercooldown,
cvar_allowrespawnsnip, cvar_snipinfammo, cvar_snipdamage, cvar_respawnsnip, cvar_asshp,
cvar_ass, cvar_asschance, cvar_assglow, cvar_assgravity, cvar_asspainfree, cvar_assspd,
cvar_assignorefrags, cvar_assignoreammo, cvar_assaura, cvar_assdamage, cvar_leapassassin,
cvar_leapassassinforce, cvar_leapassassinheight, cvar_leapassassincooldown,
cvar_assminplayers, cvar_assbasehp, cvar_allowrespawnass, cvar_assknockback,
cvar_assnvgcolor[3], cvar_respawnass, cvar_inf, cvar_respawnlimit,
cvar_win_no_one_action, cvar_infchance, cvar_infminplayers, cvar_infpreventconsecutive,
Float:cvar_gravity, cvar_unstuck

// Cached stuff for players
new g_isconnected[33] // whether player is connected
new g_isalive[33] // whether player is alive
new g_isbot[33] // whether player is a bot
new g_currentweapon[33] // player's current weapon id
new g_playername[33][31] // player's name
new Float:g_zombie_spd[33] // zombie class speed
new Float:g_cached_zmknockback[33] // zombie class knockback
new g_zombie_classname[33][32] // zombie class name
#define is_user_valid_connected(%1) (1 <= %1 <= g_maxplayers && g_isconnected[%1])
#define is_user_valid_alive(%1) (1 <= %1 <= g_maxplayers && g_isalive[%1])
#define is_user_valid(%1) (1 <= %1 <= g_maxplayers)
new Float:g_human_spd[33] // human class speed
new g_human_classname[33][32] // human class name
new g_playerauthid[33][32] // player's SteamID
new g_szPlayerAddress[33][26] // player's IP
new g_respawn_count[33] // number of times the player respawns

// Cached CVARs
/*new g_cached_customflash, g_cached_zombiesilent, g_cached_leapzombies, g_cached_leapnemesis,
g_cached_leapsurvivor, */
new Float:g_cached_leapzombiescooldown, Float:g_cached_leapnemesiscooldown,
Float:g_cached_leapsurvivorcooldown, Float:g_cached_buytime, Float:g_cached_nemkb[33],
/*g_cached_leapsniper, */Float:g_cached_leapsnipercooldown,/* g_cached_leapassassin,*/
Float:g_cached_leapassassincooldown, Float:g_cached_asskb[33]

/*================================================================================
 [Natives, Precache and Init]
=================================================================================*/

public plugin_natives()
{
	// Player specific natives
	register_native("zp_get_user_zombie", "native_get_user_zombie", 1)
	register_native("zp_get_user_nemesis", "native_get_user_nemesis", 1)
	register_native("zp_get_user_survivor", "native_get_user_survivor", 1)
	register_native("zp_get_user_first_zombie", "native_get_user_first_zombie", 1)
	register_native("zp_get_user_last_zombie", "native_get_user_last_zombie", 1)
	register_native("zp_get_user_last_human", "native_get_user_last_human", 1)
	register_native("zp_get_user_zombie_class", "native_get_user_zombie_class", 1)
	register_native("zp_get_user_next_class", "native_get_user_next_class", 1)
	register_native("zp_set_user_zombie_class", "native_set_user_zombie_class", 1)
	register_native("zp_get_user_ammo_packs", "native_get_user_ammo_packs", 1)
	register_native("zp_set_user_ammo_packs", "native_set_user_ammo_packs", 1)
	register_native("zp_get_zombie_maxhealth", "native_get_zombie_maxhealth", 1)
	register_native("zp_get_user_batteries", "native_get_user_batteries", 1)
	register_native("zp_set_user_batteries", "native_set_user_batteries", 1)
	register_native("zp_get_user_nightvision", "native_get_user_nightvision", 1)
	register_native("zp_set_user_nightvision", "native_set_user_nightvision", 1)
	register_native("zp_infect_user", "native_infect_user", 1)
	register_native("zp_disinfect_user", "native_disinfect_user", 1)
	register_native("zp_make_user_nemesis", "native_make_user_nemesis", 1)
	register_native("zp_make_user_survivor", "native_make_user_survivor", 1)
	register_native("zp_respawn_user", "native_respawn_user", 1)
	register_native("zp_force_buy_extra_item", "native_force_buy_extra_item", 1)
	register_native("zp_override_user_model", "native_override_user_model", 1)
	register_native("zpnm_get_user_human_class", "native_get_user_human_class", 1)
	register_native("zpnm_get_user_next_hclass", "native_get_user_next_hclass", 1)
	register_native("zpnm_set_user_human_class", "native_set_user_human_class", 1)
	register_native("zpnm_get_human_maxhealth", "native_get_human_maxhealth", 1)
	register_native("zpnm_set_user_health", "native_set_user_health", 1)
	register_native("zpnm_set_user_armor", "native_set_user_armor", 1)
	register_native("zpnm_get_user_burning", "native_get_user_burning", 1)
	register_native("zpnm_set_user_burning", "native_set_user_burning", 1)
	register_native("zpnm_get_user_frozen", "native_get_user_frozen", 1)
	register_native("zpnm_set_user_frozen", "native_set_user_frozen", 1)
	register_native("zpnm_get_user_no_damage", "native_get_user_no_damage", 1)
	register_native("zpnm_set_user_no_damage", "native_set_user_no_damage", 1)
	register_native("zpnm_get_user_model", "native_get_user_model", 1)
	register_native("zpnm_get_user_maxspeed", "native_get_user_maxspeed", 1)
	register_native("zpnm_set_user_maxspeed", "native_set_user_maxspeed", 1)
	register_native("zpnm_reset_user_maxspeed", "native_reset_user_maxspeed", 1)
	register_native("zpnm_get_user_gravity", "native_get_user_gravity", 1)
	register_native("zpnm_set_user_gravity", "native_set_user_gravity", 1)
	register_native("zpnm_get_user_knockback", "native_get_user_knockback", 1)
	register_native("zpnm_set_user_knockback", "native_set_user_knockback", 1)
	register_native("zpnm_strip_user_weapons", "native_strip_user_weapons", 1)
	register_native("zpnm_give_user_item", "native_give_user_item", 1)
	register_native("zpnm_get_user_valid", "native_get_user_valid", 1)
	register_native("zpnm_get_user_connected", "native_get_user_connected", 1)
	register_native("zpnm_get_user_alive", "native_get_user_alive", 1)
	register_native("zpnm_drop_user_weapons", "native_drop_user_weapons", 1)
	register_native("zpnm_get_user_sniper", "native_get_user_sniper", 1)
	register_native("zpnm_make_user_sniper", "native_make_user_sniper", 1)
	register_native("zpnm_get_user_assassin", "native_get_user_assassin", 1)
	register_native("zpnm_make_user_assassin", "native_make_user_assassin", 1)
	register_native("zpnm_get_class_name", "native_get_class_name", 1)
	register_native("zpnm_teleport_user", "native_teleport_user", 1)
	register_native("zpnm_get_user_unlimited_ammo", "native_get_user_unlimited_ammo", 1)
	register_native("zpnm_set_user_unlimited_ammo", "native_set_user_unlimited_ammo", 1)
	
	// Round natives
	register_native("zp_has_round_started", "native_has_round_started", 1)
	register_native("zp_is_nemesis_round", "native_is_nemesis_round", 1)
	register_native("zp_is_survivor_round", "native_is_survivor_round", 1)
	register_native("zp_is_swarm_round", "native_is_swarm_round", 1)
	register_native("zp_is_plague_round", "native_is_plague_round", 1)
	register_native("zp_get_zombie_count", "native_get_zombie_count", 1)
	register_native("zp_get_human_count", "native_get_human_count", 1)
	register_native("zp_get_nemesis_count", "native_get_nemesis_count", 1)
	register_native("zp_get_survivor_count", "native_get_survivor_count", 1)
	register_native("zpnm_is_sniper_round", "native_is_sniper_round", 1)
	register_native("zpnm_get_sniper_count", "native_get_sniper_count", 1)
	register_native("zpnm_is_assassin_round", "native_is_assassin_round", 1)
	register_native("zpnm_get_assassin_count", "native_get_assassin_count", 1)
	register_native("zpnm_set_game_mode", "native_set_game_mode", 1)
	
	// External additions natives
	register_native("zp_register_extra_item", "native_register_extra_item", 1)
	register_native("zp_register_zombie_class", "native_register_zombie_class", 1)
	register_native("zp_get_extra_item_id", "native_get_extra_item_id", 1)
	register_native("zp_get_zombie_class_id", "native_get_zombie_class_id", 1)
	register_native("zp_get_zombie_class_info", "native_get_zombie_class_info", 1)
	register_native("zpnm_register_human_class", "native_register_human_class", 1)
	register_native("zpnm_get_human_class_id", "native_get_human_class_id", 1)
	register_native("zpnm_get_human_class_info", "native_get_human_class_info", 1)
}

public plugin_precache()
{
	// Register earlier to show up in plugins list properly after plugin disable/error at loading
	register_plugin("Zombie Plague", PLUGIN_VERSION, "MeRcyLeZZ, D i 5 7 i n c T, TalRasha")
	
	// To switch plugin on/off
	register_concmd("zp_toggle", "cmd_toggle", _, "<1/0> - Enable/Disable Zombie Plague (will restart the current map)", 0)
	cvar_toggle = register_cvar("zp_on", "1")
	
	// Plugin disabled?
	if (!get_pcvar_num(cvar_toggle)) return;
	g_pluginenabled = true
	
	// Initialize a few dynamically sized arrays (alright, maybe more than just a few...)
	precache_sound("TalRasha/emotion/male_joy.wav")
	precache_sound("TalRasha/emotion/female_joy.wav")
	
	precache_sound("TalRasha/knives/lightsaber/draw2.wav")
	
	precache_sound("TalRasha/grenade/frost/pinpull.wav")
	precache_sound("TalRasha/grenade/frost/deploy.wav")
	
	precache_sound("TalRasha/grenade/flare/charge.wav")
	precache_sound("TalRasha/grenade/flare/draw.wav")
	precache_sound("TalRasha/grenade/flare/ready.wav")
	precache_sound("TalRasha/grenade/flare/throw.wav")
	
	precache_sound("TalRasha/weapon/ak47long/boltpull.wav")
	precache_sound("TalRasha/weapon/ak47long/clipin.wav")
	precache_sound("TalRasha/weapon/ak47long/clipout.wav")
	
	precache_sound("TalRasha/weapon/dmp7a1/draw.wav")
	precache_sound("TalRasha/weapon/dmp7a1/drop.wav")
	precache_sound("TalRasha/weapon/dmp7a1/foley.wav")
	precache_sound("TalRasha/weapon/dmp7a1/foley2.wav")
	
	precache_sound("TalRasha/weapon/tar21/boltpull.wav")
	precache_sound("TalRasha/weapon/tar21/clipin.wav")
	precache_sound("TalRasha/weapon/tar21/clipout.wav")
	
	precache_sound("TalRasha/weapon/skull1/clipin.wav")
	precache_sound("TalRasha/weapon/skull1/clipout.wav")
	precache_sound("TalRasha/weapon/skull1/draw.wav")
	
	precache_sound("TalRasha/weapon/skull4/clipin.wav")
	precache_sound("TalRasha/weapon/skull4/clipout.wav")
	precache_sound("TalRasha/weapon/skull4/draw.wav")
	
	precache_sound("TalRasha/weapon/skull5/boltpull.wav")
	precache_sound("TalRasha/weapon/skull5/clipin.wav")
	precache_sound("TalRasha/weapon/skull5/clipout.wav")
	precache_sound("TalRasha/weapon/skull5/draw.wav")
	
	precache_sound("TalRasha/weapon/skull3/boltpull.wav")
	precache_sound("TalRasha/weapon/skull3/clipin.wav")
	precache_sound("TalRasha/weapon/skull3/clipout.wav")
	precache_sound("TalRasha/weapon/skull3/drop.wav")
	precache_sound("TalRasha/weapon/skull3/idle.wav")
	
	precache_sound("TalRasha/weapon/unicorn/boltpull.wav")
	precache_sound("TalRasha/weapon/unicorn/clipin.wav")
	precache_sound("TalRasha/weapon/unicorn/clipout.wav")
	precache_sound("TalRasha/weapon/unicorn/draw.wav")
	precache_sound("TalRasha/weapon/unicorn/idle.wav")
	
	precache_sound("TalRasha/weapon/m400/clipin.wav")
	precache_sound("TalRasha/weapon/m400/clipout.wav")
	precache_sound("TalRasha/weapon/m400/foley.wav")
	precache_sound("TalRasha/weapon/m400/foley2.wav")
	
	precache_sound("TalRasha/weapon/scar/change.wav")
	precache_sound("TalRasha/weapon/scar/change2.wav")
	precache_sound("TalRasha/weapon/scar/change3.wav")
	precache_sound("TalRasha/weapon/scar/clipin.wav")
	precache_sound("TalRasha/weapon/scar/clipout.wav")
	precache_sound("TalRasha/weapon/scar/draw.wav")
	precache_sound("TalRasha/weapon/scar/scar.wav")
	precache_sound("TalRasha/weapon/scar/scar2.wav")
	
	precache_sound("TalRasha/weapon/cartblue/clipin.wav")
	precache_sound("TalRasha/weapon/cartblue/clipout.wav")
	precache_sound("TalRasha/weapon/cartblue/draw.wav")
	precache_sound("TalRasha/weapon/cartblue/foley1.wav")
	precache_sound("TalRasha/weapon/cartblue/foley2.wav")
	precache_sound("TalRasha/weapon/cartblue/foley3.wav")
	precache_sound("TalRasha/weapon/cartblue/foley4.wav")
	precache_sound("TalRasha/weapon/cartblue/jump.wav")
	precache_sound("TalRasha/weapon/cartblue/lclipin.wav")
	precache_sound("TalRasha/weapon/cartblue/second_clipout.wav")
	precache_sound("TalRasha/weapon/cartblue/second_draw.wav")
	precache_sound("TalRasha/weapon/cartblue/second_hit.wav")
	precache_sound("TalRasha/weapon/cartblue/spindown.wav")
	precache_sound("TalRasha/weapon/cartblue/turn.wav")
	precache_sound("TalRasha/weapon/cartblue/yahoo.wav")
	
	precache_sound("TalRasha/weapon/m4a1tfk/boltcatch.wav")
	precache_sound("TalRasha/weapon/m4a1tfk/clipin.wav")
	precache_sound("TalRasha/weapon/m4a1tfk/clipout.wav")
	precache_sound("TalRasha/weapon/m4a1tfk/deploy.wav")
	
	nemesis_pain = ArrayCreate(64, 1) 
	nemesis_idle = ArrayCreate(64, 1)
	nemesis_die = ArrayCreate(64, 1)
	nemesis_fall = ArrayCreate(64, 1)
	nemesis_miss_slash = ArrayCreate(64, 1) 
	nemesis_miss_wall = ArrayCreate(64, 1)
	nemesis_hit_normal = ArrayCreate(64, 1)
	nemesis_hit_stab = ArrayCreate(64, 1)
	
	assassin_pain = ArrayCreate(64, 1) 
	assassin_idle = ArrayCreate(64, 1)
	assassin_die = ArrayCreate(64, 1)
	assassin_fall = ArrayCreate(64, 1)
	assassin_miss_slash = ArrayCreate(64, 1) 
	assassin_miss_wall = ArrayCreate(64, 1)
	assassin_hit_normal = ArrayCreate(64, 1)
	assassin_hit_stab = ArrayCreate(64, 1)
	
	class_sound_infect = ArrayCreate(64, 1)
	class_sound_pain = ArrayCreate(64, 1)
	class_sound_idle = ArrayCreate(64, 1)
	class_sound_idle_last = ArrayCreate(64, 1)
	class_sound_die = ArrayCreate(64, 1)
	class_sound_fall = ArrayCreate(64, 1)
	class_sound_madness = ArrayCreate(64, 1)
	class_sound_burn = ArrayCreate(64, 1)
	class_sound_miss_slash = ArrayCreate(64, 1)
	class_sound_miss_wall = ArrayCreate(64, 1)
	class_sound_hit_normal = ArrayCreate(64, 1)
	class_sound_hit_stab = ArrayCreate(64, 1)
	
	pointer_class_sound_infect = ArrayCreate(10, 1)
	pointer_class_sound_pain = ArrayCreate(10, 1)
	pointer_class_sound_idle = ArrayCreate(10, 1)
	pointer_class_sound_idle_last = ArrayCreate(10, 1)
	pointer_class_sound_die = ArrayCreate(10, 1)
	pointer_class_sound_fall = ArrayCreate(64, 1)
	pointer_class_sound_madness = ArrayCreate(10, 1)
	pointer_class_sound_burn = ArrayCreate(10, 1)
	pointer_class_sound_miss_slash = ArrayCreate(64, 1)
	pointer_class_sound_miss_wall = ArrayCreate(64, 1)
	pointer_class_sound_hit_normal = ArrayCreate(64, 1)
	pointer_class_sound_hit_stab = ArrayCreate(64, 1)
	
	model_nemesis = ArrayCreate(32, 1)
	model_survivor = ArrayCreate(32, 1)
	model_admin_human = ArrayCreate(32, 1)
	model_admin_zombie = ArrayCreate(32, 1)
	g_modelindex_nemesis = ArrayCreate(1, 1)
	g_modelindex_survivor = ArrayCreate(1, 1)
	g_modelindex_admin_human = ArrayCreate(1, 1)
	g_modelindex_admin_zombie = ArrayCreate(1, 1)
	sound_win_zombies = ArrayCreate(64, 1)
//	sound_win_zombies_ismp3 = ArrayCreate(1, 1)
	sound_win_humans = ArrayCreate(64, 1)
//	sound_win_humans_ismp3 = ArrayCreate(1, 1)
	sound_win_no_one = ArrayCreate(64, 1)
//	sound_win_no_one_ismp3 = ArrayCreate(1, 1)
	sound_nemesis = ArrayCreate(64, 1)
	sound_survivor = ArrayCreate(64, 1)
	sound_swarm = ArrayCreate(64, 1)
	sound_multi = ArrayCreate(64, 1)
	sound_plague = ArrayCreate(64, 1)
	grenade_infect = ArrayCreate(64, 1)
	grenade_infect_player = ArrayCreate(64, 1)
	grenade_fire = ArrayCreate(64, 1)
	grenade_frost = ArrayCreate(64, 1)
	grenade_frost_player = ArrayCreate(64, 1)
	grenade_frost_break = ArrayCreate(64, 1)
	grenade_flare = ArrayCreate(64, 1)
	sound_antidote = ArrayCreate(64, 1)
	sound_thunder = ArrayCreate(64, 1)
	sound_ambience1 = ArrayCreate(64, 1)
	sound_ambience2 = ArrayCreate(64, 1)
	sound_ambience3 = ArrayCreate(64, 1)
	sound_ambience4 = ArrayCreate(64, 1)
	sound_ambience5 = ArrayCreate(64, 1)
	sound_ambience1_duration = ArrayCreate(1, 1)
	sound_ambience2_duration = ArrayCreate(1, 1)
	sound_ambience3_duration = ArrayCreate(1, 1)
	sound_ambience4_duration = ArrayCreate(1, 1)
	sound_ambience5_duration = ArrayCreate(1, 1)
/*	sound_ambience1_ismp3 = ArrayCreate(1, 1)
	sound_ambience2_ismp3 = ArrayCreate(1, 1)
	sound_ambience3_ismp3 = ArrayCreate(1, 1)
	sound_ambience4_ismp3 = ArrayCreate(1, 1)
	sound_ambience5_ismp3 = ArrayCreate(1, 1)*/
	g_primary_items = ArrayCreate(32, 1)
	g_secondary_items = ArrayCreate(32, 1)
	g_additional_items = ArrayCreate(32, 1)
	g_primary_weaponids = ArrayCreate(1, 1)
	g_secondary_weaponids = ArrayCreate(1, 1)
	g_extraweapon_names = ArrayCreate(32, 1)
	g_extraweapon_items = ArrayCreate(32, 1)
	g_extraweapon_costs = ArrayCreate(1, 1)
	g_sky_names = ArrayCreate(32, 1)
	lights_thunder = ArrayCreate(32, 1)
	zombie_decals = ArrayCreate(1, 1)
	g_objective_ents = ArrayCreate(32, 1)
	g_extraitem_name = ArrayCreate(32, 1)
	g_extraitem_cost = ArrayCreate(1, 1)
	g_extraitem_team = ArrayCreate(1, 1)
	g_extraitem2_realname = ArrayCreate(32, 1)
	g_extraitem2_name = ArrayCreate(32, 1)
	g_extraitem2_cost = ArrayCreate(1, 1)
	g_extraitem2_team = ArrayCreate(1, 1)
	g_extraitem_new = ArrayCreate(1, 1)
	g_zclass_name = ArrayCreate(32, 1)
	g_zclass_info = ArrayCreate(32, 1)
	g_zclass_modelsstart = ArrayCreate(1, 1)
	g_zclass_modelsend = ArrayCreate(1, 1)
	g_zclass_playermodel = ArrayCreate(32, 1)
	g_zclass_modelindex = ArrayCreate(1, 1)
	g_zclass_clawmodel = ArrayCreate(64, 1) //32
	g_zclass_hp = ArrayCreate(1, 1)
	g_zclass_spd = ArrayCreate(1, 1)
	g_zclass_grav = ArrayCreate(1, 1)
	g_zclass_kb = ArrayCreate(1, 1)
	g_zclass2_realname = ArrayCreate(32, 1)
	g_zclass2_name = ArrayCreate(32, 1)
	g_zclass2_info = ArrayCreate(32, 1)
	g_zclass2_modelsstart = ArrayCreate(1, 1)
	g_zclass2_modelsend = ArrayCreate(1, 1)
	g_zclass2_playermodel = ArrayCreate(32, 1)
	g_zclass2_modelindex = ArrayCreate(1, 1)
	g_zclass2_clawmodel = ArrayCreate(64, 1) //32
	g_zclass2_hp = ArrayCreate(1, 1)
	g_zclass2_spd = ArrayCreate(1, 1)
	g_zclass2_grav = ArrayCreate(1, 1)
	g_zclass2_kb = ArrayCreate(1, 1)
	g_zclass_new = ArrayCreate(1, 1)
	g_hclass_name = ArrayCreate(32, 1)
	g_hclass_info = ArrayCreate(32, 1)
	g_hclass_modelsstart = ArrayCreate(1, 1)
	g_hclass_modelsend = ArrayCreate(1, 1)
	g_hclass_playermodel = ArrayCreate(32, 1)
	g_hclass_modelindex = ArrayCreate(1, 1)
	g_hclass_handmodel = ArrayCreate(64, 1) //32
	g_hclass_hp = ArrayCreate(1, 1)
	g_hclass_spd = ArrayCreate(1, 1)
	g_hclass_grav = ArrayCreate(1, 1)
	g_hclass2_realname = ArrayCreate(32, 1)
	g_hclass2_name = ArrayCreate(32, 1)
	g_hclass2_info = ArrayCreate(32, 1)
	g_hclass2_modelsstart = ArrayCreate(1, 1)
	g_hclass2_modelsend = ArrayCreate(1, 1)
	g_hclass2_playermodel = ArrayCreate(32, 1)
	g_hclass2_modelindex = ArrayCreate(1, 1)
	g_hclass2_handmodel = ArrayCreate(64, 1) //32
	g_hclass2_hp = ArrayCreate(1, 1)
	g_hclass2_spd = ArrayCreate(1, 1)
	g_hclass2_grav = ArrayCreate(1, 1)
	g_hclass_new = ArrayCreate(1, 1)
	model_sniper = ArrayCreate(32, 1)
	g_modelindex_sniper = ArrayCreate(1, 1)
	sound_sniper = ArrayCreate(64, 1)
	model_assassin = ArrayCreate(32, 1)
	g_modelindex_assassin = ArrayCreate(1, 1)
	sound_assassin = ArrayCreate(64, 1)
	sound_ambience6 = ArrayCreate(64, 1)
	sound_ambience7 = ArrayCreate(64, 1)
	sound_ambience6_duration = ArrayCreate(1, 1)
	sound_ambience7_duration = ArrayCreate(1, 1)
/*	sound_ambience6_ismp3 = ArrayCreate(1, 1)
	sound_ambience7_ismp3 = ArrayCreate(1, 1)*/
	
	// Allow registering stuff now
	g_arrays_created = true
	
	// Load customization data
	load_customization_from_files()
	
	new i, buffer[100]
	
	// Load up the hard coded extra items
	native_register_extra_item2("NightVision", g_extra_costs2[EXTRA_NVISION], ZP_TEAM_HUMAN)
	native_register_extra_item2("T-Virus Antidote", g_extra_costs2[EXTRA_ANTIDOTE], ZP_TEAM_ZOMBIE)
	native_register_extra_item2("Zombie Madness", g_extra_costs2[EXTRA_MADNESS], ZP_TEAM_ZOMBIE)
	native_register_extra_item2("Infection Bomb", g_extra_costs2[EXTRA_INFBOMB], ZP_TEAM_ZOMBIE)
	
	// Extra weapons
	for (i = 0; i < ArraySize(g_extraweapon_names); i++)
	{
		ArrayGetString(g_extraweapon_names, i, buffer, 99)
		native_register_extra_item2(buffer, ArrayGetCell(g_extraweapon_costs, i), ZP_TEAM_HUMAN)
	}
	
	// Custom player models
	for (i = 0; i < ArraySize(model_nemesis); i++)
	{
		ArrayGetString(model_nemesis, i, buffer, 99)
		format(buffer, 99, "models/player/%s/%s.mdl", buffer, buffer)
		ArrayPushCell(g_modelindex_nemesis, engfunc(EngFunc_PrecacheModel, buffer))
		if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, buffer)
		if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, buffer)
		// Precache modelT.mdl files too
		copy(buffer[strlen(buffer)-4], 99 - (strlen(buffer)-4), "T.mdl")
		if (file_exists(buffer)) engfunc(EngFunc_PrecacheModel, buffer)
	}
	for (i = 0; i < ArraySize(model_survivor); i++)
	{
		ArrayGetString(model_survivor, i, buffer, 99)
		format(buffer, 99, "models/player/%s/%s.mdl", buffer, buffer)
		ArrayPushCell(g_modelindex_survivor, engfunc(EngFunc_PrecacheModel, buffer))
		if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, buffer)
		if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, buffer)
		// Precache modelT.mdl files too
		copy(buffer[strlen(buffer)-4], 99 - (strlen(buffer)-4), "T.mdl")
		if (file_exists(buffer)) engfunc(EngFunc_PrecacheModel, buffer)
	}
	for (i = 0; i < ArraySize(model_admin_zombie); i++)
	{
		ArrayGetString(model_admin_zombie, i, buffer, 99)
		format(buffer, 99, "models/player/%s/%s.mdl", buffer, buffer)
		ArrayPushCell(g_modelindex_admin_zombie, engfunc(EngFunc_PrecacheModel, buffer))
		if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, buffer)
		if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, buffer)
		// Precache modelT.mdl files too
		copy(buffer[strlen(buffer)-4], 99 - (strlen(buffer)-4), "T.mdl")
		if (file_exists(buffer)) engfunc(EngFunc_PrecacheModel, buffer)
	}
	for (i = 0; i < ArraySize(model_admin_human); i++)
	{
		ArrayGetString(model_admin_human, i, buffer, 99)
		format(buffer, 99, "models/player/%s/%s.mdl", buffer, buffer)
		ArrayPushCell(g_modelindex_admin_human, engfunc(EngFunc_PrecacheModel, buffer))
		if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, buffer)
		if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, buffer)
		// Precache modelT.mdl files too
		copy(buffer[strlen(buffer)-4], 99 - (strlen(buffer)-4), "T.mdl")
		if (file_exists(buffer)) engfunc(EngFunc_PrecacheModel, buffer)
	}
	for (i = 0; i < ArraySize(model_sniper); i++)
	{
		ArrayGetString(model_sniper, i, buffer, 99)
		format(buffer, 99, "models/player/%s/%s.mdl", buffer, buffer)
		ArrayPushCell(g_modelindex_sniper, engfunc(EngFunc_PrecacheModel, buffer))
		if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, buffer)
		if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, buffer)
		// Precache modelT.mdl files too
		copy(buffer[strlen(buffer)-4], 99 - (strlen(buffer)-4), "T.mdl")
		if (file_exists(buffer)) engfunc(EngFunc_PrecacheModel, buffer)
	}
	for (i = 0; i < ArraySize(model_assassin); i++)
	{
		ArrayGetString(model_assassin, i, buffer, 99)
		format(buffer, 99, "models/player/%s/%s.mdl", buffer, buffer)
		ArrayPushCell(g_modelindex_assassin, engfunc(EngFunc_PrecacheModel, buffer))
		if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, buffer)
		if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, buffer)
		// Precache modelT.mdl files too
		copy(buffer[strlen(buffer)-4], 99 - (strlen(buffer)-4), "T.mdl")
		if (file_exists(buffer)) engfunc(EngFunc_PrecacheModel, buffer)
	}
	
	// Custom weapon models
	engfunc(EngFunc_PrecacheModel, model_vknife_nemesis)
	engfunc(EngFunc_PrecacheModel, model_vweapon_survivor)
	engfunc(EngFunc_PrecacheModel, model_v_grenade_infection)
	engfunc(EngFunc_PrecacheModel, model_p_grenade_infection)
	engfunc(EngFunc_PrecacheModel, model_w_grenade_infection)
	engfunc(EngFunc_PrecacheModel, model_v_grenade_fire)
	engfunc(EngFunc_PrecacheModel, model_p_grenade_fire)
	engfunc(EngFunc_PrecacheModel, model_w_grenade_fire)
	engfunc(EngFunc_PrecacheModel, model_v_grenade_frost)
	engfunc(EngFunc_PrecacheModel, model_p_grenade_frost)
	engfunc(EngFunc_PrecacheModel, model_w_grenade_frost)
	engfunc(EngFunc_PrecacheModel, model_v_grenade_flare)
	engfunc(EngFunc_PrecacheModel, model_p_grenade_flare)
	engfunc(EngFunc_PrecacheModel, model_w_grenade_flare)
	engfunc(EngFunc_PrecacheModel, model_vknife_admin_human)
	engfunc(EngFunc_PrecacheModel, model_vknife_admin_zombie)
	engfunc(EngFunc_PrecacheModel, model_vweapon_sniper)
	engfunc(EngFunc_PrecacheModel, model_vknife_assassin)
	
	// Custom sprites for grenades
	g_colorfire = engfunc(EngFunc_PrecacheModel, trail_grenade_fire)
	g_colorfrost = engfunc(EngFunc_PrecacheModel, trail_grenade_frost)
	g_colorflare = engfunc(EngFunc_PrecacheModel, trail_grenade_flare)
	g_colorinfect = engfunc(EngFunc_PrecacheModel, trail_grenade_infect)
	g_exploSpr = engfunc(EngFunc_PrecacheModel, sprite_grenade_ring)
	g_flameSpr = engfunc(EngFunc_PrecacheModel, sprite_grenade_fire)
	g_smokeSpr = engfunc(EngFunc_PrecacheModel, sprite_grenade_smoke)
	g_glassSpr = engfunc(EngFunc_PrecacheModel, sprite_grenade_glass)
	g_talrasha_frost = precache_model("sprites/TalRasha/grenade/frost/frost.spr")
	g_talrasha_frost2 = precache_model("sprites/TalRasha/grenade/frost/frost2.spr")
	g_talrasha_fire = precache_model("sprites/TalRasha/grenade/fire/fire.spr")
	g_talrasha_fire2 = precache_model("sprites/TalRasha/grenade/fire/fire2.spr")
	g_talrasha_flare = precache_model("sprites/TalRasha/grenade/flare/flare.spr")
	g_talrasha_flare2 = precache_model("sprites/TalRasha/grenade/flare/flare2.spr")
	g_talrasha_infection = precache_model("sprites/TalRasha/grenade/infection/infection.spr")
	g_talrasha_infection2 = precache_model("sprites/TalRasha/grenade/infection/infection2.spr")
	
	// Custom sounds
	for (i = 0; i < ArraySize(nemesis_pain); i++)
	{
		ArrayGetString(nemesis_pain, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(nemesis_idle); i++)
	{
		ArrayGetString(nemesis_idle, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(nemesis_die); i++)
	{
		ArrayGetString(nemesis_die, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(nemesis_fall); i++)
	{
		ArrayGetString(nemesis_fall, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(nemesis_miss_slash); i++)
	{
		ArrayGetString(nemesis_miss_slash, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(nemesis_miss_wall); i++)
	{
		ArrayGetString(nemesis_miss_wall, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(nemesis_hit_normal); i++)
	{
		ArrayGetString(nemesis_hit_normal, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(nemesis_hit_stab); i++)
	{
		ArrayGetString(nemesis_hit_stab, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(assassin_pain); i++)
	{
		ArrayGetString(assassin_pain, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(assassin_idle); i++)
	{
		ArrayGetString(assassin_idle, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(assassin_die); i++)
	{
		ArrayGetString(assassin_die, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(assassin_fall); i++)
	{
		ArrayGetString(assassin_fall, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(assassin_miss_slash); i++)
	{
		ArrayGetString(assassin_miss_slash, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(assassin_miss_wall); i++)
	{
		ArrayGetString(assassin_miss_wall, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(assassin_hit_normal); i++)
	{
		ArrayGetString(assassin_hit_normal, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(assassin_hit_stab); i++)
	{
		ArrayGetString(assassin_hit_stab, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(class_sound_infect); i++)
	{
		ArrayGetString(class_sound_infect, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(class_sound_pain); i++)
	{
		ArrayGetString(class_sound_pain, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(class_sound_idle); i++)
	{
		ArrayGetString(class_sound_idle, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(class_sound_idle_last); i++)
	{
		ArrayGetString(class_sound_idle_last, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(class_sound_die); i++)
	{
		ArrayGetString(class_sound_die, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(class_sound_fall); i++)
	{
		ArrayGetString(class_sound_fall, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(class_sound_madness); i++)
	{
		ArrayGetString(class_sound_madness, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(class_sound_burn); i++)
	{
		ArrayGetString(class_sound_burn, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(class_sound_miss_slash); i++)
	{
		ArrayGetString(class_sound_miss_slash, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(class_sound_miss_wall); i++)
	{
		ArrayGetString(class_sound_miss_wall, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(class_sound_hit_normal); i++)
	{
		ArrayGetString(class_sound_hit_normal, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(class_sound_hit_stab); i++)
	{
		ArrayGetString(class_sound_hit_stab, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(sound_win_zombies); i++)
	{
		ArrayGetString(sound_win_zombies, i, buffer, 99)
		if (is_mp3(buffer)) //ArrayGetCell(sound_win_zombies_ismp3, i)
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(sound_win_humans); i++)
	{
		ArrayGetString(sound_win_humans, i, buffer, 99)
		if (is_mp3(buffer)) //ArrayGetCell(sound_win_humans_ismp3, i)
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(sound_win_no_one); i++)
	{
		ArrayGetString(sound_win_no_one, i, buffer, 99)
		if (is_mp3(buffer)) //ArrayGetCell(sound_win_no_one_ismp3, i)
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(sound_nemesis); i++)
	{
		ArrayGetString(sound_nemesis, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(sound_survivor); i++)
	{
		ArrayGetString(sound_survivor, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(sound_swarm); i++)
	{
		ArrayGetString(sound_swarm, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(sound_multi); i++)
	{
		ArrayGetString(sound_multi, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(sound_plague); i++)
	{
		ArrayGetString(sound_plague, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(grenade_infect); i++)
	{
		ArrayGetString(grenade_infect, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(grenade_infect_player); i++)
	{
		ArrayGetString(grenade_infect_player, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(grenade_fire); i++)
	{
		ArrayGetString(grenade_fire, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(grenade_frost); i++)
	{
		ArrayGetString(grenade_frost, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(grenade_frost_player); i++)
	{
		ArrayGetString(grenade_frost_player, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(grenade_frost_break); i++)
	{
		ArrayGetString(grenade_frost_break, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(grenade_flare); i++)
	{
		ArrayGetString(grenade_flare, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(sound_antidote); i++)
	{
		ArrayGetString(sound_antidote, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(sound_thunder); i++)
	{
		ArrayGetString(sound_thunder, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(sound_sniper); i++)
	{
		ArrayGetString(sound_sniper, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	for (i = 0; i < ArraySize(sound_assassin); i++)
	{
		ArrayGetString(sound_assassin, i, buffer, 99)
		if (is_mp3(buffer))
		{
			format(buffer, 99, "sound/%s", buffer)
			engfunc(EngFunc_PrecacheGeneric, buffer)
		}
		else
		{
			engfunc(EngFunc_PrecacheSound, buffer)
		}
	}
	
	// Ambience Sounds
	if (g_ambience_sounds[AMBIENCE_SOUNDS_INFECTION])
	{
		for (i = 0; i < ArraySize(sound_ambience1); i++)
		{
			ArrayGetString(sound_ambience1, i, buffer, 99)
			
			if (is_mp3(buffer)) //ArrayGetCell(sound_ambience1_ismp3, i)
			{
				format(buffer, 99, "sound/%s", buffer)
				engfunc(EngFunc_PrecacheGeneric, buffer)
			}
			else
			{
				engfunc(EngFunc_PrecacheSound, buffer)
			}
		}
	}
	if (g_ambience_sounds[AMBIENCE_SOUNDS_NEMESIS])
	{
		for (i = 0; i < ArraySize(sound_ambience2); i++)
		{
			ArrayGetString(sound_ambience2, i, buffer, 99)
			
			if (is_mp3(buffer)) //ArrayGetCell(sound_ambience2_ismp3, i)
			{
				format(buffer, 99, "sound/%s", buffer)
				engfunc(EngFunc_PrecacheGeneric, buffer)
			}
			else
			{
				engfunc(EngFunc_PrecacheSound, buffer)
			}
		}
	}
	if (g_ambience_sounds[AMBIENCE_SOUNDS_SURVIVOR])
	{
		for (i = 0; i < ArraySize(sound_ambience3); i++)
		{
			ArrayGetString(sound_ambience3, i, buffer, 99)
			
			if (is_mp3(buffer)) //ArrayGetCell(sound_ambience3_ismp3, i)
			{
				format(buffer, 99, "sound/%s", buffer)
				engfunc(EngFunc_PrecacheGeneric, buffer)
			}
			else
			{
				engfunc(EngFunc_PrecacheSound, buffer)
			}
		}
	}
	if (g_ambience_sounds[AMBIENCE_SOUNDS_SWARM])
	{
		for (i = 0; i < ArraySize(sound_ambience4); i++)
		{
			ArrayGetString(sound_ambience4, i, buffer, 99)
			
			if (is_mp3(buffer)) //ArrayGetCell(sound_ambience4_ismp3, i)
			{
				format(buffer, 99, "sound/%s", buffer)
				engfunc(EngFunc_PrecacheGeneric, buffer)
			}
			else
			{
				engfunc(EngFunc_PrecacheSound, buffer)
			}
		}
	}
	if (g_ambience_sounds[AMBIENCE_SOUNDS_PLAGUE])
	{
		for (i = 0; i < ArraySize(sound_ambience5); i++)
		{
			ArrayGetString(sound_ambience5, i, buffer, 99)
			
			if (is_mp3(buffer)) //ArrayGetCell(sound_ambience5_ismp3, i)
			{
				format(buffer, 99, "sound/%s", buffer)
				engfunc(EngFunc_PrecacheGeneric, buffer)
			}
			else
			{
				engfunc(EngFunc_PrecacheSound, buffer)
			}
		}
	}
	if (g_ambience_sounds[AMBIENCE_SOUNDS_SNIPER])
	{
		for (i = 0; i < ArraySize(sound_ambience6); i++)
		{
			ArrayGetString(sound_ambience6, i, buffer, 99)
			
			if (is_mp3(buffer)) //ArrayGetCell(sound_ambience6_ismp3, i)
			{
				format(buffer, 99, "sound/%s", buffer)
				engfunc(EngFunc_PrecacheGeneric, buffer)
			}
			else
			{
				engfunc(EngFunc_PrecacheSound, buffer)
			}
		}
	}
	if (g_ambience_sounds[AMBIENCE_SOUNDS_ASSASSIN])
	{
		for (i = 0; i < ArraySize(sound_ambience7); i++)
		{
			ArrayGetString(sound_ambience7, i, buffer, 99)
			
			if (is_mp3(buffer)) //ArrayGetCell(sound_ambience7_ismp3, i)
			{
				format(buffer, 99, "sound/%s", buffer)
				engfunc(EngFunc_PrecacheGeneric, buffer)
			}
			else
			{
				engfunc(EngFunc_PrecacheSound, buffer)
			}
		}
	}
	
	// CS sounds (just in case)
	engfunc(EngFunc_PrecacheSound, sound_flashlight)
	engfunc(EngFunc_PrecacheSound, sound_buyammo)
	engfunc(EngFunc_PrecacheSound, sound_armorhit)
	
	new ent
	
	// Fake Hostage (to force round ending)
	ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "hostage_entity"))
	if (pev_valid(ent))
	{
		engfunc(EngFunc_SetOrigin, ent, Float:{8192.0,8192.0,8192.0})
		dllfunc(DLLFunc_Spawn, ent)
	}
	
	// Weather/ambience effects
	if (g_ambience_fog)
	{
		ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "env_fog"))
		if (pev_valid(ent))
		{
			fm_set_kvd(ent, "density", g_fog_density, "env_fog")
			fm_set_kvd(ent, "rendercolor", g_fog_color, "env_fog")
		}
	}
	if (g_ambience_rain) engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "env_rain"))
	if (g_ambience_snow) engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "env_snow"))
	
	// Custom buyzone for all players
	g_buyzone_ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "func_buyzone"))
	if (pev_valid(g_buyzone_ent))
	{
		dllfunc(DLLFunc_Spawn, g_buyzone_ent)
		set_pev(g_buyzone_ent, pev_solid, SOLID_NOT)
	}
	
	// Prevent some entities from spawning
	g_fwSpawn = register_forward(FM_Spawn, "fw_Spawn")
	
	// Prevent hostage sounds from being precached
	g_fwPrecacheSound = register_forward(FM_PrecacheSound, "fw_PrecacheSound")
}

public plugin_init()
{
	// Plugin disabled?
	if (!g_pluginenabled) return;
	
	// No zombie classes?
	if (!g_zclass_i) set_fail_state("No zombie classes loaded!")
	
	// No human classes?
	if (!g_hclass_i) set_fail_state("No human classes loaded!")
	
	// Language files
	register_dictionary("zombie_plague.txt")
	register_dictionary("zombie_plague_nightmare.txt")
	
	// Events
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0")
	register_logevent("logevent_round_start", 2, "1=Round_Start")
	register_logevent("logevent_round_end", 2, "1=Round_End")
	register_event("AmmoX", "event_ammo_x", "be")
	if (g_ambience_sounds[AMBIENCE_SOUNDS_INFECTION] || g_ambience_sounds[AMBIENCE_SOUNDS_NEMESIS] || g_ambience_sounds[AMBIENCE_SOUNDS_SURVIVOR] || g_ambience_sounds[AMBIENCE_SOUNDS_SWARM] || g_ambience_sounds[AMBIENCE_SOUNDS_PLAGUE] || g_ambience_sounds[AMBIENCE_SOUNDS_SNIPER] || g_ambience_sounds[AMBIENCE_SOUNDS_ASSASSIN])
		register_event("30", "event_intermission", "a")
	
	// HAM Forwards
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn")
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn_Post", 1)
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled")
	RegisterHam(Ham_Killed, "player", "fw_PlayerKilled_Post", 1)
	RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage")
	RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage_Post", 1)
	RegisterHam ( Ham_TakeDamage, "player", "TalRasha_Check_Damage")
	RegisterHam(Ham_TraceAttack, "player", "fw_TraceAttack")
	RegisterHam(Ham_Player_ResetMaxSpeed, "player", "fw_ResetMaxSpeed_Post", 1)
	RegisterHam(Ham_Use, "func_tank", "fw_UseStationary")
	RegisterHam(Ham_Use, "func_tankmortar", "fw_UseStationary")
	RegisterHam(Ham_Use, "func_tankrocket", "fw_UseStationary")
	RegisterHam(Ham_Use, "func_tanklaser", "fw_UseStationary")
	RegisterHam(Ham_Use, "func_tank", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tankmortar", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tankrocket", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tanklaser", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_pushable", "fw_UsePushable")
	RegisterHam(Ham_Touch, "weaponbox", "fw_TouchWeapon")
	RegisterHam(Ham_Touch, "armoury_entity", "fw_TouchWeapon")
	RegisterHam(Ham_Touch, "weapon_shield", "fw_TouchWeapon")
	RegisterHam(Ham_AddPlayerItem, "player", "fw_AddPlayerItem")
	for (new i = 1; i < sizeof WEAPONENTNAMES; i++)
		if (WEAPONENTNAMES[i][0]) RegisterHam(Ham_Item_Deploy, WEAPONENTNAMES[i], "fw_Item_Deploy_Post", 1)
	
	// FM Forwards
	register_forward(FM_ClientDisconnect, "fw_ClientDisconnect")
	register_forward(FM_ClientDisconnect, "fw_ClientDisconnect_Post", 1)
	register_forward(FM_ClientKill, "fw_ClientKill")
	register_forward(FM_EmitSound, "fw_EmitSound")
	if (!g_handle_models_on_separate_ent) register_forward(FM_SetClientKeyValue, "fw_SetClientKeyValue")
	register_forward(FM_ClientUserInfoChanged, "fw_ClientUserInfoChanged")
	register_forward(FM_GetGameDescription, "fw_GetGameDescription")
	register_forward(FM_SetModel, "fw_SetModel")
	RegisterHam(Ham_Think, "grenade", "fw_ThinkGrenade")
	register_forward(FM_CmdStart, "fw_CmdStart")
	register_forward(FM_PlayerPreThink, "fw_PlayerPreThink")
	unregister_forward(FM_Spawn, g_fwSpawn)
	unregister_forward(FM_PrecacheSound, g_fwPrecacheSound)
	
	// Client commands
	register_clcmd("say zpmenu", "clcmd_saymenu")
	register_clcmd("say /zpmenu", "clcmd_saymenu")
	register_clcmd("say unstuck", "clcmd_sayunstuck")
	register_clcmd("say /unstuck", "clcmd_sayunstuck")
	register_clcmd("nightvision", "clcmd_nightvision")
	register_clcmd("drop", "clcmd_drop")
	register_clcmd("buyammo1", "clcmd_buyammo")
	register_clcmd("buyammo2", "clcmd_buyammo")
	register_clcmd("chooseteam", "clcmd_changeteam")
	register_clcmd("jointeam", "clcmd_changeteam")
	register_clcmd("cheer", "show_menu_game")
	register_clcmd("client_buy_open", "show_menu_extras") //buy
	register_clcmd("buyequip", "show_menu_extras")
	register_clcmd("say /hud", "show_menu_settings")
	
	// Menus
	register_menu("Game Menu", KEYSMENU, "menu_game")
	register_menu("Buy Menu 1", KEYSMENU, "menu_buy1")
	register_menu("Buy Menu 2", KEYSMENU, "menu_buy2")
	register_menu("Admin Menu", KEYSMENU, "menu_admin")
	register_menu("Classes Menu", KEYSMENU, "menu_classes")
	
	// CS Buy Menus (to prevent zombies/survivor from buying)
	register_menucmd(register_menuid("#Buy", 1), 511, "menu_cs_buy")
	register_menucmd(register_menuid("BuyPistol", 1), 511, "menu_cs_buy")
	register_menucmd(register_menuid("BuyShotgun", 1), 511, "menu_cs_buy")
	register_menucmd(register_menuid("BuySub", 1), 511, "menu_cs_buy")
	register_menucmd(register_menuid("BuyRifle", 1), 511, "menu_cs_buy")
	register_menucmd(register_menuid("BuyMachine", 1), 511, "menu_cs_buy")
	register_menucmd(register_menuid("BuyItem", 1), 511, "menu_cs_buy")
	register_menucmd(register_menuid("Settings"), 1023, "menu_settings")
	register_menucmd(-28, 511, "menu_cs_buy")
	register_menucmd(-29, 511, "menu_cs_buy")
	register_menucmd(-30, 511, "menu_cs_buy")
	register_menucmd(-32, 511, "menu_cs_buy")
	register_menucmd(-31, 511, "menu_cs_buy")
	register_menucmd(-33, 511, "menu_cs_buy")
	register_menucmd(-34, 511, "menu_cs_buy")
	
	// Admin commands
	register_concmd("zp_zombie", "cmd_zombie", _, "<target> - Turn someone into a Zombie", 0)
	register_concmd("zp_human", "cmd_human", _, "<target> - Turn someone back to Human", 0)
	register_concmd("zp_nemesis", "cmd_nemesis", _, "<target> - Turn someone into a Nemesis", 0)
	register_concmd("zp_survivor", "cmd_survivor", _, "<target> - Turn someone into a Survivor", 0)
	register_concmd("zp_respawn", "cmd_respawn", _, "<target> - Respawn someone", 0)
	register_concmd("zp_swarm", "cmd_swarm", _, " - Start Swarm Mode", 0)
	register_concmd("zp_multi", "cmd_multi", _, " - Start Multi Infection", 0)
	register_concmd("zp_plague", "cmd_plague", _, " - Start Plague Mode", 0)
	register_concmd("zpnm_sniper", "cmd_sniper", _, "<target> - Turn someone into a Sniper", 0)
	register_concmd("zpnm_assassin", "cmd_assassin", _, "<target> - Turn someone into an Assassin", 0)
	
	// Message IDs
	g_msgScoreInfo = get_user_msgid("ScoreInfo")
	g_msgTeamInfo = get_user_msgid("TeamInfo")
	g_msgDeathMsg = get_user_msgid("DeathMsg")
	g_msgScoreAttrib = get_user_msgid("ScoreAttrib")
	g_msgSetFOV = get_user_msgid("SetFOV")
	g_msgScreenFade = get_user_msgid("ScreenFade")
	g_msgScreenShake = get_user_msgid("ScreenShake")
	g_msgNVGToggle = get_user_msgid("NVGToggle")
	g_msgFlashlight = get_user_msgid("Flashlight")
	g_msgFlashBat = get_user_msgid("FlashBat")
	g_msgAmmoPickup = get_user_msgid("AmmoPickup")
	g_msgDamage = get_user_msgid("Damage")
	g_msgHideWeapon = get_user_msgid("HideWeapon")
	g_msgCrosshair = get_user_msgid("Crosshair")
	g_msgCurWeapon = get_user_msgid("CurWeapon")
	
	// Message hooks
	register_message(g_msgCurWeapon, "message_cur_weapon")
	register_message(get_user_msgid("Money"), "message_money")
	register_message(get_user_msgid("Health"), "message_health")
	register_message(g_msgFlashBat, "message_flashbat")
	register_message(g_msgScreenFade, "message_screenfade")
	register_message(g_msgNVGToggle, "message_nvgtoggle")
	if (g_handle_models_on_separate_ent) register_message(get_user_msgid("ClCorpse"), "message_clcorpse")
	register_message(get_user_msgid("WeapPickup"), "message_weappickup")
	register_message(g_msgAmmoPickup, "message_ammopickup")
	register_message(get_user_msgid("Scenario"), "message_scenario")
	register_message(get_user_msgid("HostagePos"), "message_hostagepos")
	register_message(get_user_msgid("TextMsg"), "message_textmsg")
	register_message(get_user_msgid("SendAudio"), "message_sendaudio")
	register_message(get_user_msgid("TeamScore"), "message_teamscore")
	register_message(g_msgTeamInfo, "message_teaminfo")
	
	// CVARS - General Purpose
	cvar_warmup = register_cvar("zp_delay", "10")
	cvar_lighting = register_cvar("zp_lighting", "a")
	cvar_thunder = register_cvar("zp_thunderclap", "90")
	cvar_triggered = register_cvar("zp_triggered_lights", "1")
	cvar_removedoors = register_cvar("zp_remove_doors", "0")
	cvar_blockpushables = register_cvar("zp_blockuse_pushables", "1")
	cvar_blocksuicide = register_cvar("zp_block_suicide", "1")
	cvar_randspawn = register_cvar("zp_random_spawn", "1")
	cvar_respawnworldspawnkill = register_cvar("zp_respawn_on_worldspawn_kill", "1")
	cvar_removedropped = register_cvar("zp_remove_dropped", "0")
	cvar_removemoney = register_cvar("zp_remove_money", "1")
	cvar_buycustom = register_cvar("zp_buy_custom", "1")
	cvar_buyzonetime = register_cvar("zp_buyzone_time", "0.0")
	cvar_randweapons = register_cvar("zp_random_weapons", "0")
	cvar_adminmodelshuman = register_cvar("zp_admin_models_human", "1")
	cvar_adminknifemodelshuman = register_cvar("zp_admin_knife_models_human", "0")
	cvar_adminmodelszombie = register_cvar("zp_admin_models_zombie", "1")
	cvar_adminknifemodelszombie = register_cvar("zp_admin_knife_models_zombie", "0")
	cvar_zclasses = register_cvar("zp_zombie_classes", "1")
	cvar_statssave = register_cvar("zp_stats_save", "1")
	cvar_startammopacks = register_cvar("zp_starting_ammo_packs", "5")
	cvar_preventconsecutive = register_cvar("zp_prevent_consecutive_modes", "1")
	cvar_keephealthondisconnect = register_cvar("zp_keep_health_on_disconnect", "1")
	cvar_huddisplay = register_cvar("zp_hud_display", "1")
	cvar_hclasses = register_cvar("zpnm_human_classes", "1")
	cvar_win_no_one_action = register_cvar("zpnm_win_no_one_action", "0")
	cvar_unstuck = register_cvar("zpnm_unstuck_allow", "3")
	
	// CVARS - Deathmatch
	cvar_deathmatch = register_cvar("zp_deathmatch", "0")
	cvar_spawndelay = register_cvar("zp_spawn_delay", "5")
	cvar_spawnprotection = register_cvar("zp_spawn_protection", "5")
	cvar_respawnonsuicide = register_cvar("zp_respawn_on_suicide", "0")
	cvar_respawnafterlast = register_cvar("zp_respawn_after_last_human", "1")
	cvar_allowrespawninfection = register_cvar("zp_infection_allow_respawn", "1")
	cvar_allowrespawnnem = register_cvar("zp_nem_allow_respawn", "0")
	cvar_allowrespawnsurv = register_cvar("zp_surv_allow_respawn", "0")
	cvar_allowrespawnswarm = register_cvar("zp_swarm_allow_respawn", "0")
	cvar_allowrespawnplague = register_cvar("zp_plague_allow_respawn", "0")
	cvar_respawnzomb = register_cvar("zp_respawn_zombies", "1")
	cvar_respawnhum = register_cvar("zp_respawn_humans", "1")
	cvar_respawnnem = register_cvar("zp_respawn_nemesis", "1")
	cvar_respawnsurv = register_cvar("zp_respawn_survivors", "1")
	cvar_allowrespawnsnip = register_cvar("zpnm_snip_allow_respawn", "0")
	cvar_respawnsnip = register_cvar("zpnm_respawn_snipers", "1")
	cvar_allowrespawnass = register_cvar("zpnm_ass_allow_respawn", "0")
	cvar_respawnass = register_cvar("zpnm_respawn_assassins", "1")
	cvar_respawnlimit = register_cvar("zpnm_respawn_limit", "0")
	
	// CVARS - Extra Items
	cvar_extraitems = register_cvar("zp_extra_items", "1")
	cvar_extraweapons = register_cvar("zp_extra_weapons", "1")
	cvar_extranvision = register_cvar("zp_extra_nvision", "1")
	cvar_extraantidote = register_cvar("zp_extra_antidote", "1")
	cvar_antidotelimit = register_cvar("zp_extra_antidote_limit", "999")
	cvar_extramadness = register_cvar("zp_extra_madness", "1")
	cvar_madnesslimit = register_cvar("zp_extra_madness_limit", "999")
	cvar_madnessduration = register_cvar("zp_extra_madness_duration", "5.0")
	cvar_extrainfbomb = register_cvar("zp_extra_infbomb", "1")
	cvar_infbomblimit = register_cvar("zp_extra_infbomb_limit", "999")
	
	// CVARS - Flashlight and Nightvision
	cvar_nvggive = register_cvar("zp_nvg_give", "1")
	cvar_customnvg = register_cvar("zp_nvg_custom", "1")
	cvar_nvgsize = register_cvar("zp_nvg_size", "80")
	cvar_nvgcolor[0] = register_cvar("zp_nvg_color_R", "0")
	cvar_nvgcolor[1] = register_cvar("zp_nvg_color_G", "150")
	cvar_nvgcolor[2] = register_cvar("zp_nvg_color_B", "0")
	cvar_humnvgcolor[0] = register_cvar("zp_nvg_hum_color_R", "0")
	cvar_humnvgcolor[1] = register_cvar("zp_nvg_hum_color_G", "150")
	cvar_humnvgcolor[2] = register_cvar("zp_nvg_hum_color_B", "0")
	cvar_nemnvgcolor[0] = register_cvar("zp_nvg_nem_color_R", "150")
	cvar_nemnvgcolor[1] = register_cvar("zp_nvg_nem_color_G", "0")
	cvar_nemnvgcolor[2] = register_cvar("zp_nvg_nem_color_B", "0")
	cvar_customflash = register_cvar("zp_flash_custom", "0")
	cvar_flashsize = register_cvar("zp_flash_size", "10")
	cvar_flashdrain = register_cvar("zp_flash_drain", "1")
	cvar_flashcharge = register_cvar("zp_flash_charge", "5")
	cvar_flashdist = register_cvar("zp_flash_distance", "1000")
	cvar_flashcolor[0] = register_cvar("zp_flash_color_R", "100")
	cvar_flashcolor[1] = register_cvar("zp_flash_color_G", "100")
	cvar_flashcolor[2] = register_cvar("zp_flash_color_B", "100")
	cvar_flashshowall = register_cvar("zp_flash_show_all", "1")
	cvar_assnvgcolor[0] = register_cvar("zpnm_nvg_ass_color_R", "150")
	cvar_assnvgcolor[1] = register_cvar("zpnm_nvg_ass_color_G", "0")
	cvar_assnvgcolor[2] = register_cvar("zpnm_nvg_ass_color_B", "0")
	
	// CVARS - Knockback
	cvar_knockback = register_cvar("zp_knockback", "0")
	cvar_knockbackdamage = register_cvar("zp_knockback_damage", "1")
	cvar_knockbackpower = register_cvar("zp_knockback_power", "1")
	cvar_knockbackzvel = register_cvar("zp_knockback_zvel", "0")
	cvar_knockbackducking = register_cvar("zp_knockback_ducking", "0.25")
	cvar_knockbackdist = register_cvar("zp_knockback_distance", "500")
	cvar_nemknockback = register_cvar("zp_knockback_nemesis", "0.25")
	cvar_assknockback = register_cvar("zpnm_knockback_assassin", "0.15")
	
	// CVARS - Leap
	cvar_leapzombies = register_cvar("zp_leap_zombies", "0")
	cvar_leapzombiesforce = register_cvar("zp_leap_zombies_force", "500")
	cvar_leapzombiesheight = register_cvar("zp_leap_zombies_height", "300")
	cvar_leapzombiescooldown = register_cvar("zp_leap_zombies_cooldown", "5.0")
	cvar_leapnemesis = register_cvar("zp_leap_nemesis", "1")
	cvar_leapnemesisforce = register_cvar("zp_leap_nemesis_force", "500")
	cvar_leapnemesisheight = register_cvar("zp_leap_nemesis_height", "300")
	cvar_leapnemesiscooldown = register_cvar("zp_leap_nemesis_cooldown", "5.0")
	cvar_leapsurvivor = register_cvar("zp_leap_survivor", "0")
	cvar_leapsurvivorforce = register_cvar("zp_leap_survivor_force", "500")
	cvar_leapsurvivorheight = register_cvar("zp_leap_survivor_height", "300")
	cvar_leapsurvivorcooldown = register_cvar("zp_leap_survivor_cooldown", "5.0")
	cvar_leapsniper = register_cvar("zpnm_leap_sniper", "0")
	cvar_leapsniperforce = register_cvar("zpnm_leap_sniper_force", "500")
	cvar_leapsniperheight = register_cvar("zpnm_leap_sniper_height", "300")
	cvar_leapsnipercooldown = register_cvar("zpnm_leap_sniper_cooldown", "5.0")
	cvar_leapassassin = register_cvar("zpnm_leap_assassin", "0")
	cvar_leapassassinforce = register_cvar("zpnm_leap_assassin_force", "500")
	cvar_leapassassinheight = register_cvar("zpnm_leap_assassin_height", "300")
	cvar_leapassassincooldown = register_cvar("zpnm_leap_assassin_cooldown", "5.0")
	
	// CVARS - Humans
	cvar_humanlasthp = register_cvar("zp_human_last_extrahp", "0")
	cvar_humanarmor = register_cvar("zp_human_armor_protect", "1")
	cvar_infammo = register_cvar("zp_human_unlimited_ammo", "0")
	cvar_ammodamage_human = register_cvar("zp_human_damage_reward", "500")
	cvar_fragskill = register_cvar("zp_human_frags_for_kill", "1")
	
	// CVARS - Custom Grenades
	cvar_firegrenades = register_cvar("zp_fire_grenades", "1")
	cvar_fireduration = register_cvar("zp_fire_duration", "10")
	cvar_firedamage = register_cvar("zp_fire_damage", "5")
	cvar_fireslowdown = register_cvar("zp_fire_slowdown", "0.5")
	cvar_frostgrenades = register_cvar("zp_frost_grenades", "1")
	cvar_freezeduration = register_cvar("zp_frost_duration", "3")
	cvar_flaregrenades = register_cvar("zp_flare_grenades","1")
	cvar_flareduration = register_cvar("zp_flare_duration", "60")
	cvar_flaresize = register_cvar("zp_flare_size", "25")
	cvar_flarecolor = register_cvar("zp_flare_color", "0")
	
	// CVARS - Zombies
	cvar_zombiefirsthp = register_cvar("zp_zombie_first_hp", "2.0")
	cvar_zombiearmor = register_cvar("zp_zombie_armor", "0.75")
	cvar_hitzones = register_cvar("zp_zombie_hitzones", "0")
	cvar_zombiebonushp = register_cvar("zp_zombie_infect_health", "100")
	cvar_zombiefov = register_cvar("zp_zombie_fov", "110")
	cvar_zombiesilent = register_cvar("zp_zombie_silent", "1")
	cvar_zombiepainfree = register_cvar("zp_zombie_painfree", "2")
	cvar_zombiebleeding = register_cvar("zp_zombie_bleeding", "1")
	cvar_ammoinfect = register_cvar("zp_zombie_infect_reward", "1")
	cvar_ammodamage_zombie = register_cvar("zp_zombie_damage_reward", "0")
	cvar_fragsinfect = register_cvar("zp_zombie_frags_for_infect", "1")
	
	// CVARS - Special Effects
	cvar_infectionscreenfade = register_cvar("zp_infection_screenfade", "1")
	cvar_infectionscreenshake = register_cvar("zp_infection_screenshake", "1")
	cvar_infectionsparkle = register_cvar("zp_infection_sparkle", "1")
	cvar_infectiontracers = register_cvar("zp_infection_tracers", "1")
	cvar_infectionparticles = register_cvar("zp_infection_particles", "1")
	cvar_hudicons = register_cvar("zp_hud_icons", "1")
	
	// CVARS - Single Infection
	cvar_inf = register_cvar("zpnm_inf_enabled", "1")
	cvar_infchance = register_cvar("zpnm_inf_chance", "1")
	cvar_infminplayers = register_cvar("zpnm_inf_min_players", "0")
	cvar_infpreventconsecutive = register_cvar("zpnm_inf_prevent_consecutive", "0")
	
	// CVARS - Nemesis
	cvar_nem = register_cvar("zp_nem_enabled", "1")
	cvar_nemchance = register_cvar("zp_nem_chance", "20")
	cvar_nemminplayers = register_cvar("zp_nem_min_players", "0")
	cvar_nemhp = register_cvar("zp_nem_health", "0")
	cvar_nembasehp = register_cvar("zp_nem_base_health", "0")
	cvar_nemspd = register_cvar("zp_nem_speed", "250")
	cvar_nemgravity = register_cvar("zp_nem_gravity", "0.5")
	cvar_nemdamage = register_cvar("zp_nem_damage", "250")
	cvar_nemglow = register_cvar("zp_nem_glow", "1")
	cvar_nemaura = register_cvar("zp_nem_aura", "1")	
	cvar_nempainfree = register_cvar("zp_nem_painfree", "0")
	cvar_nemignorefrags = register_cvar("zp_nem_ignore_frags", "1")
	cvar_nemignoreammo = register_cvar("zp_nem_ignore_rewards", "1")
	
	// CVARS - Survivor
	cvar_surv = register_cvar("zp_surv_enabled", "1")
	cvar_survchance = register_cvar("zp_surv_chance", "20")
	cvar_survminplayers = register_cvar("zp_surv_min_players", "0")
	cvar_survhp = register_cvar("zp_surv_health", "0")
	cvar_survbasehp = register_cvar("zp_surv_base_health", "0")
	cvar_survspd = register_cvar("zp_surv_speed", "230")
	cvar_survgravity = register_cvar("zp_surv_gravity", "1.25")
	cvar_survglow = register_cvar("zp_surv_glow", "1")
	cvar_survaura = register_cvar("zp_surv_aura", "1")
	cvar_survpainfree = register_cvar("zp_surv_painfree", "1")
	cvar_survignorefrags = register_cvar("zp_surv_ignore_frags", "1")
	cvar_survignoreammo = register_cvar("zp_surv_ignore_rewards", "1")
	cvar_survweapon = register_cvar("zp_surv_weapon", "weapon_m249")
	cvar_survinfammo = register_cvar("zp_surv_unlimited_ammo", "2")
	
	// CVARS - Swarm Mode
	cvar_swarm = register_cvar("zp_swarm_enabled", "1")
	cvar_swarmchance = register_cvar("zp_swarm_chance", "20")
	cvar_swarmminplayers = register_cvar("zp_swarm_min_players", "0")
	
	// CVARS - Multi Infection
	cvar_multi = register_cvar("zp_multi_enabled", "1")
	cvar_multichance = register_cvar("zp_multi_chance", "20")
	cvar_multiminplayers = register_cvar("zp_multi_min_players", "0")
	cvar_multiratio = register_cvar("zp_multi_ratio", "0.15")
	
	// CVARS - Plague Mode
	cvar_plague = register_cvar("zp_plague_enabled", "1")
	cvar_plaguechance = register_cvar("zp_plague_chance", "30")
	cvar_plagueminplayers = register_cvar("zp_plague_min_players", "0")
	cvar_plagueratio = register_cvar("zp_plague_ratio", "0.5")
	cvar_plaguenemnum = register_cvar("zp_plague_nem_number", "1")
	cvar_plaguenemhpmulti = register_cvar("zp_plague_nem_hp_multi", "0.5")
	cvar_plaguesurvnum = register_cvar("zp_plague_surv_number", "1")
	cvar_plaguesurvhpmulti = register_cvar("zp_plague_surv_hp_multi", "0.5")
	
	// CVARS - Sniper
	cvar_snip = register_cvar("zpnm_snip_enabled", "1")
	cvar_snipchance = register_cvar("zpnm_snip_chance", "20")
	cvar_snipminplayers = register_cvar("zpnm_snip_min_players", "0")
	cvar_sniphp = register_cvar("zpnm_snip_health", "0")
	cvar_snipbasehp = register_cvar("zpnm_snip_base_health", "0")
	cvar_snipspd = register_cvar("zpnm_snip_speed", "217")
	cvar_snipgravity = register_cvar("zpnm_snip_gravity", "0.757")
	cvar_snipglow = register_cvar("zpnm_snip_glow", "1")
	cvar_snipaura = register_cvar("zpnm_snip_aura", "1")
	cvar_snippainfree = register_cvar("zpnm_snip_painfree", "0")
	cvar_snipignorefrags = register_cvar("zpnm_snip_ignore_frags", "1")
	cvar_snipignoreammo = register_cvar("zpnm_snip_ignore_rewards", "1")
	cvar_snipinfammo = register_cvar("zpnm_snip_unlimited_ammo", "1")
	cvar_snipdamage = register_cvar("zpnm_snip_damage", "7575")
	
	// CVARS - Assassin
	cvar_ass = register_cvar("zpnm_ass_enabled", "1")
	cvar_asschance = register_cvar("zpnm_ass_chance", "35")
	cvar_assminplayers = register_cvar("zpnm_ass_min_players", "0")
	cvar_asshp = register_cvar("zpnm_ass_health", "0")
	cvar_assbasehp = register_cvar("zpnm_ass_base_health", "175")
	cvar_assspd = register_cvar("zpnm_ass_speed", "577")
	cvar_assgravity = register_cvar("zpnm_ass_gravity", "0.357")
	cvar_assdamage = register_cvar("zpnm_ass_damage", "357")
	cvar_assglow = register_cvar("zpnm_ass_glow", "0")
	cvar_assaura = register_cvar("zpnm_ass_aura", "0")	
	cvar_asspainfree = register_cvar("zpnm_ass_painfree", "1")
	cvar_assignorefrags = register_cvar("zpnm_ass_ignore_frags", "1")
	cvar_assignoreammo = register_cvar("zpnm_ass_ignore_rewards", "1")
	
	// CVARS - Others
	cvar_logcommands = register_cvar("zp_logcommands", "1")
	cvar_showactivity = get_cvar_pointer("amx_show_activity")
	cvar_botquota = get_cvar_pointer("bot_quota")
	register_cvar("zp_version", PLUGIN_VERSION, FCVAR_SERVER|FCVAR_SPONLY)
	set_cvar_string("zp_version", PLUGIN_VERSION)
	
	// Custom Forwards
	g_fwRoundStart = CreateMultiForward("zp_round_started", ET_IGNORE, FP_CELL, FP_CELL)
	g_fwRoundEnd = CreateMultiForward("zp_round_ended", ET_IGNORE, FP_CELL)
	g_fwUserInfected_pre = CreateMultiForward("zp_user_infected_pre", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL, FP_CELL, FP_CELL)
	g_fwUserInfected_post = CreateMultiForward("zp_user_infected_post", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL, FP_CELL, FP_CELL)
	g_fwUserHumanized_pre = CreateMultiForward("zp_user_humanized_pre", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL)
	g_fwUserHumanized_post = CreateMultiForward("zp_user_humanized_post", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL)
	g_fwUserInfect_attempt = CreateMultiForward("zp_user_infect_attempt", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL, FP_CELL, FP_CELL)
	g_fwUserHumanize_attempt = CreateMultiForward("zp_user_humanize_attempt", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL)
	g_fwExtraItemSelected = CreateMultiForward("zp_extra_item_selected", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL, FP_CELL)
	g_fwUserUnfrozen = CreateMultiForward("zp_user_unfrozen", ET_IGNORE, FP_CELL, FP_CELL)
	g_fwUserLastZombie = CreateMultiForward("zp_user_last_zombie", ET_IGNORE, FP_CELL)
	g_fwUserLastHuman = CreateMultiForward("zp_user_last_human", ET_IGNORE, FP_CELL)
	g_fwUserSpawn_pre = CreateMultiForward("zpnm_user_spawn_pre", ET_IGNORE, FP_CELL)
	g_fwUserSpawn_post = CreateMultiForward("zpnm_user_spawn_post", ET_IGNORE, FP_CELL)
	g_fwUserKilled_pre = CreateMultiForward("zpnm_user_killed_pre", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL)
	g_fwUserKilled_post = CreateMultiForward("zpnm_user_killed_post", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL)
	g_fwUserTakeDamage_attempt = CreateMultiForward("zpnm_user_take_damage_attempt", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL, FP_CELL, FP_CELL)
	g_fwUserTakeDamage_post = CreateMultiForward("zpnm_user_take_damage_post", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL, FP_CELL, FP_CELL)
	g_fwUserBurn = CreateMultiForward("zpnm_user_burn", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL, FP_CELL)
	g_fwUserFrozen = CreateMultiForward("zpnm_user_frozen", ET_IGNORE, FP_CELL, FP_CELL)
	g_fwUserGetWeapons = CreateMultiForward("zpnm_user_get_weapons", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL)
	g_fwUserGetAmmoPacks = CreateMultiForward("zpnm_user_get_ammo_packs", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL)
	g_fwCzBotsRegisterHam = CreateMultiForward("zpnm_register_ham_czbots", ET_IGNORE, FP_CELL)
	g_fwExtraItemBuyAttempt = CreateMultiForward("zpnm_extra_item_buy_attempt", ET_CONTINUE, FP_CELL, FP_CELL, FP_CELL, FP_CELL)
	
	// Collect random spawn points
	load_spawns()
	
	// Set a random skybox?
	if (g_sky_enable)
	{
//		new sky[32]
//		ArrayGetString(g_sky_names, random_num(0, ArraySize(g_sky_names) - 1), sky, charsmax(sky))
		set_pcvar_string(get_cvar_pointer("sv_skyname"), g_sky_name)
	}
	
	// Disable sky lighting so it doesn't mess with our custom lighting
	set_pcvar_num(get_cvar_pointer("sv_skycolor_r"), 0)
	set_pcvar_num(get_cvar_pointer("sv_skycolor_g"), 0)
	set_pcvar_num(get_cvar_pointer("sv_skycolor_b"), 0)
	
	// Create the HUD Sync Objects
	g_MsgSync = CreateHudSyncObj()
	g_MsgSync2 = CreateHudSyncObj()
	
	// Format mod name
	formatex(g_modname, 31, "Zombie Plague %s", PLUGIN_VERSION)
	
	// Get Max Players
	g_maxplayers = get_maxplayers()
	
	// Reserved saving slots starts on maxplayers+1
	db_slot_i = g_maxplayers+1
	
	// Check if it's a CZ server
	new mymod[6]
	get_modname(mymod, 5)
	if (equali(mymod, "czero")) g_czero = 1
}

public plugin_cfg()
{
	// Plugin disabled?
	if (!g_pluginenabled) return;
	
	// Get configs dir
	new cfgdir[32]
	get_configsdir(cfgdir, 31)
	
	// Execute config file (zombieplaguenightmare.cfg)
	server_cmd("exec %s/zombieplaguenightmare.cfg", cfgdir)
	
	// Prevent any more stuff from registering
	g_arrays_created = false
	
	// Save customization data
	save_customization()
	
	// Lighting task
	set_task(5.0, "lighting_effects", _, _, _, "b")
	
	// Cache CVARs after configs are loaded / call roundstart manually
	set_task(0.5, "cache_cvars")
	set_task(0.5, "event_round_start")
	set_task(0.5, "logevent_round_start")
	set_task(0.5, "cache_settings")
}

/*================================================================================
 [Main Events]
=================================================================================*/

// Event Round Start
public event_round_start()
{
	// Remove doors/lights?
	set_task(0.1, "remove_stuff")
	
/*	new i;
	
	if (g_assround)
	{
		static szLighting[2];
		get_pcvar_string(cvar_lighting, szLighting, 1)
		
		if (!equali(szLighting, "0"))
			for (i = 1; i <= g_maxplayers; i++)
			{
				if (g_isconnected[i])
					engfunc(EngFunc_LightStyle, i, szLighting)
			}
		else
			for (i = 1; i <= g_maxplayers; i++)
			{
				if (g_isconnected[i])
					engfunc(EngFunc_LightStyle, i, "m")
			}
	}
	*/
	// New round starting
	g_newround = true
	g_endround = false
	g_survround = false
	g_nemround = false
	g_swarmround = false
	g_plagueround = false
	g_snipround = false
	g_assround = false
	g_modestarted = false
	
	// Reset bought infection bombs counter
	g_infbombcounter = 0
	g_antidotecounter = 0
	g_madnesscounter = 0
	
	// Freezetime begins
	g_freezetime = true
	
	if (get_pcvar_num(cvar_deathmatch) && get_pcvar_num(cvar_respawnlimit))
	{
		for (new i = 1; i <= g_maxplayers; i++)
		{
			if (!g_isconnected[i])
				continue;
			
			g_respawn_count[i] = 0
		}
	}
	
	// Show welcome message and T-Virus notice
	remove_task(TASK_WELCOMEMSG)
	set_task(2.0, "welcome_msg", TASK_WELCOMEMSG)
	
	// Set a new "Make Zombie Task"
	remove_task(TASK_MAKEZOMBIE)
	set_task(2.0 + get_pcvar_float(cvar_warmup), "make_zombie_task", TASK_MAKEZOMBIE)
}

public TalRasha_Check_Damage(victim, weapon, attacker, Float:damage, damagebits)
{
	new NameVictim[32],NameAttacker[32]
	get_user_name(victim,NameVictim,31)
	get_user_name(attacker,NameAttacker,31)
  
	if (get_user_team ( attacker ) != get_user_team ( victim ) && attacker != victim)
	{
		user_damage[attacker] += damage
	}
}

public show_menu_settings(id)
{
	new menu[512], len, keys = MENU_KEY_0
	len += formatex(menu[len], charsmax(menu) - len, "\wМеню настроек худа^n^n")

	len += formatex(menu[len], charsmax(menu) - len, "\r1. \wИнформер \d[ \y%s \d]^n", g_informer[id] == INFORMER_STYLE1 ? INF_DHUD : g_informer[id] ==  INFORMER_STYLE2 ? INF_HUD : g_informer[id] == INFORMER_STYLE3 ? INF_TEXT : INF_OFF)
	keys += MENU_KEY_1
	if(g_informer[id] == INFORMER_STYLE1 || g_informer[id] == INFORMER_STYLE2)
	len += formatex(menu[len], charsmax(menu) - len, "\r2. \wПоложение \d[ \y%s \d]^n", g_position[id] == POSITION_LEFT ? POST_LEFT : g_position[id] == POSITION_CENTER ? POST_CENTER : POST_RIGHT)
	keys += MENU_KEY_2
	
	len += formatex(menu[len], charsmax(menu) - len, "^n\r0. \wВыход")
	
	if (pev_valid(id) == 2) set_pdata_int(id, 205, 0, 5)
	show_menu(id, keys, menu, -1, "Settings")
	return PLUGIN_HANDLED
}

public menu_settings(id, key) 
{
	new szName[32]
	get_user_name(id, szName, 31)
	
	switch(key) 
	{
		case 0: 
		{
			if(g_informer[id] == INFORMER_STYLE1) 
			{
				g_informer[id] = INFORMER_STYLE2
				show_menu_settings(id)
			}
			else if(g_informer[id] == INFORMER_STYLE2) 
			{
				g_informer[id] = INFORMER_STYLE3
				show_menu_settings(id)
			}
			else if(g_informer[id] == INFORMER_STYLE3) 
			{
				g_informer[id] = INFORMER_STYLE4
				show_menu_settings(id)
			}
			else if(g_informer[id] == INFORMER_STYLE4) 
			{
				g_informer[id] = INFORMER_STYLE1
				show_menu_settings(id)
			}
		}
		case 1: 
		{
			if(g_position[id] == POSITION_LEFT) 
			{
				g_position[id] = POSITION_CENTER
				show_menu_settings(id)
			}
			else if(g_position[id] == POSITION_CENTER) 
			{
				g_position[id] = POSITION_RIGHT
				show_menu_settings(id)
			}
			else if(g_position[id] == POSITION_RIGHT) 
			{
				g_position[id] = POSITION_LEFT
				show_menu_settings(id)
			}
		}
	}
	return PLUGIN_HANDLED
}

// Log Event Round Start
public logevent_round_start()
{
	// Freezetime ends
	g_freezetime = false
}

// Log Event Round End
public logevent_round_end()
{
	// Prevent this from getting called twice when restarting (bugfix)
	static Float:lastendtime
	new Float:current_time = get_gametime()
	if (current_time - lastendtime < 0.5) return;
	lastendtime = current_time
	
	// Temporarily save player stats?
	if (get_pcvar_num(cvar_statssave))
	{
		new id, team;
		for (id = 1; id <= g_maxplayers; id++)
		{
			// Not connected
			if (!g_isconnected[id])
				continue;
			
			team = fm_cs_get_user_team(id)
			
			// Not playing
			if (team == FM_CS_TEAM_SPECTATOR || team == FM_CS_TEAM_UNASSIGNED)
				continue;
			
			save_stats(id)
		}
	}
	
	// Round ended
	//g_endround = true
	
	// Stop old tasks (if any)
	remove_task(TASK_WELCOMEMSG)
	remove_task(TASK_MAKEZOMBIE)
	
	// Stop ambience sounds
	if ((g_ambience_sounds[AMBIENCE_SOUNDS_NEMESIS] && g_nemround) || (g_ambience_sounds[AMBIENCE_SOUNDS_SURVIVOR] && g_survround) || (g_ambience_sounds[AMBIENCE_SOUNDS_SWARM] && g_swarmround) || (g_ambience_sounds[AMBIENCE_SOUNDS_PLAGUE] && g_plagueround)
	|| (g_ambience_sounds[AMBIENCE_SOUNDS_SNIPER] && g_snipround) || (g_ambience_sounds[AMBIENCE_SOUNDS_ASSASSIN] && g_assround) || (g_ambience_sounds[AMBIENCE_SOUNDS_INFECTION] && !g_nemround && !g_assround && !g_survround && !g_snipround && !g_swarmround && !g_plagueround))
	{
		remove_task(TASK_AMBIENCESOUNDS)
		client_cmd(0, "mp3 stop; stopsound") //ambience_sound_stop()
	}
	
	// Show HUD notice, play win sound, update team scores...
	if (g_newround)
		win_round(0)
	else if (!fnGetZombies())
		win_round(1)
	else if (!fnGetHumans())
		win_round(2)
	else
		win_round(get_pcvar_num(cvar_win_no_one_action))
	
	// Game commencing triggers round end
	g_gamecommencing = false
	
	// Balance the teams
	balance_teams()
}

win_round(team)
{
	static sound[64]
	
	switch (team)
	{
		case 1:
		{
			// Human team wins
			set_dhudmessage(cvar_humnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], HUD_EVENT_X, HUD_EVENT_Y, 1, 6.0, 1.1, 0.0, 2.0) //0, 0, 200 | , -1)
//			ShowSyncHudMsg(0, g_MsgSync, "%L", LANG_PLAYER, "WIN_HUMAN")
			show_dhudmessage(0, "%L", LANG_PLAYER, "WIN_HUMAN")
			
			// Play win sound and increase score, unless game commencing
			ArrayGetString(sound_win_humans, random_num(0, ArraySize(sound_win_humans) - 1), sound, 63)
			PlaySound(sound)
			if (!g_gamecommencing) g_scorehumans++
			
			// Round end forward
			ExecuteForward(g_fwRoundEnd, g_fwDummyResult, ZP_TEAM_HUMAN);
		}
		case 2:
		{
			// Zombie team wins
			set_dhudmessage(cvar_nvgcolor[0], cvar_nemnvgcolor[1], cvar_assnvgcolor[2], HUD_EVENT_X, HUD_EVENT_Y, 0, 6.0, 1.1, 0.0, 2.0) //200, 0, 0 | , -1)
//			show_dhudmessage(0, "%L", LANG_PLAYER, "WIN_ZOMBIE")
			show_dhudmessage(0, "%L", LANG_PLAYER, "WIN_ZOMBIE")
			
			// Play win sound and increase score, unless game commencing
			ArrayGetString(sound_win_zombies, random_num(0, ArraySize(sound_win_zombies) - 1), sound, 63)
			PlaySound(sound)
			if (!g_gamecommencing) g_scorezombies++
			
			// Round end forward
			ExecuteForward(g_fwRoundEnd, g_fwDummyResult, ZP_TEAM_ZOMBIE);
		}
		case 0:
		{
			// No one wins
			set_dhudmessage(cvar_nvgcolor[0], cvar_humnvgcolor[1], cvar_nvgcolor[2], HUD_EVENT_X, HUD_EVENT_Y, 1, 6.0, 1.1, 0.0, 2.0) //0, 200, 0 | , -1)
//			ShowSyncHudMsg(0, g_MsgSync, "%L", LANG_PLAYER, "WIN_NO_ONE")
			show_dhudmessage(0, "%L", LANG_PLAYER, "WIN_NO_ONE")
			
			// Play win sound
			ArrayGetString(sound_win_no_one, random_num(0, ArraySize(sound_win_no_one) - 1), sound, 63)
			PlaySound(sound)
			
			// Round end forward
			ExecuteForward(g_fwRoundEnd, g_fwDummyResult, ZP_TEAM_NO_ONE);
		}
	}
}

// Event Map Ended
public event_intermission()
{
	// Remove ambience sounds task
	remove_task(TASK_AMBIENCESOUNDS)
}

// BP Ammo update
public event_ammo_x(id)
{
	// Humans only
	if (g_zombie[id])
		return;
	
	// Get ammo type
	new type = read_data(1)
	
	// Unknown ammo type
	if (type >= sizeof AMMOWEAPON)
		return;
	
	// Get weapon's id
	new weapon = AMMOWEAPON[type]
	
	// Primary and secondary only
	if (MAXBPAMMO[weapon] <= 2)
		return;
	
	// Get ammo amount
	new amount = read_data(2)
	
	// Unlimited BP Ammo?
	if (g_infammo[id]) //g_survivor[id] ? cvar_survinfammo : g_sniper[id] ? cvar_snipinfammo : cvar_infammo
	{
		if (amount < MAXBPAMMO[weapon])
		{
			// The BP Ammo refill code causes the engine to send a message, but we
			// can't have that in this forward or we risk getting some recursion bugs.
			// For more info see: https://bugs.alliedmods.net/show_bug.cgi?id=3664
			new args[2]
			args[0] = weapon
			set_task(0.1, "refill_bpammo", id, args, 2)
		}
	}
	// Bots automatically buy ammo when needed
	else if (g_isbot[id] && amount <= BUYAMMO[weapon])
	{
		// Task needed for the same reason as above
		set_task(0.1, "clcmd_buyammo", id)
	}
}

/*================================================================================
 [Main Forwards]
=================================================================================*/

// Entity Spawn Forward
public fw_Spawn(entity)
{
	// Invalid entity
	if (!pev_valid(entity)) return FMRES_IGNORED;
	
	// Get classname
	new classname[32], objective[32], size = ArraySize(g_objective_ents)
	pev(entity, pev_classname, classname, 31)
	
	// Check whether it needs to be removed
	for (new i = 0; i < size; i++)
	{
		ArrayGetString(g_objective_ents, i, objective, 31)
		
		if (equali(classname, objective))
		{
			engfunc(EngFunc_RemoveEntity, entity)
			return FMRES_SUPERCEDE;
		}
	}
	
	return FMRES_IGNORED;
}

// Sound Precache Forward
public fw_PrecacheSound(const sound[])
{
	// Block all those unneeeded hostage sounds
	if (equali(sound, "hostage", 7))
		return FMRES_SUPERCEDE;
	
	return FMRES_IGNORED;
}

// Ham Player Spawn Forward
public fw_PlayerSpawn(id)
	ExecuteForward(g_fwUserSpawn_pre, g_fwDummyResult, id);

// Ham Player Spawn Post Forward
public fw_PlayerSpawn_Post(id)
{
	// Not alive or didn't join a team yet
	if (!is_user_alive(id) || !fm_cs_get_user_team(id))
		return;
	
	// Player spawned
	g_isalive[id] = true
	
	// Remove previous tasks
	remove_task(id+TASK_SPAWN)
	remove_task(id+TASK_MODEL)
	remove_task(id+TASK_BLOOD)
	remove_task(id+TASK_AURA)
	remove_task(id+TASK_BURN)
	remove_task(id+TASK_CHARGE)
	remove_task(id+TASK_FLASH)
	remove_task(id+TASK_NVISION)
	
	// Spawn at a random location?
	if (get_pcvar_num(cvar_randspawn)) do_random_spawn(id)
	
	// Hide money?
	new removemoney = get_pcvar_num(cvar_removemoney)
	if (removemoney == 1 || removemoney == 3)
		set_task(0.4, "task_hide_money", id+TASK_SPAWN)
	
	// Reset player vars
	reset_vars(id, 0)
	
	if (get_pcvar_num(cvar_hclasses) && g_humanclassnext[id] != HZCLASS_NONE)
		// Set selected human class
		g_humanclass[id] = g_humanclassnext[id]
	
	// Cache speed and name for player's class
	g_human_spd[id] = float(ArrayGetCell(g_hclass_spd, g_humanclass[id]))
	ArrayGetString(g_hclass_name, g_humanclass[id], g_human_classname[id], 31)
	
	// Set health and gravity
	fm_set_user_health(id, ArrayGetCell(g_hclass_hp, g_humanclass[id]))
	set_pev(id, pev_gravity, Float:ArrayGetCell(g_hclass_grav, g_humanclass[id]))
	
	// Set human maxspeed
	ExecuteHamB(Ham_Player_ResetMaxSpeed, id)
	
	g_infammo[id] = get_pcvar_num(cvar_infammo)
	
	ExecuteForward(g_fwUserSpawn_post, g_fwDummyResult, id);
	
	// Respawn player if he dies because of a worldspawn kill?
	if (get_pcvar_num(cvar_respawnworldspawnkill))
		set_task(1.757, "respawn_player_check_task", id+TASK_SPAWN)
	
	// Spawn as zombie?
	if (g_respawn_as_zombie[id] && !g_newround)
	{
		zombieme(id, 0, 0, 0, 0) // make him zombie right away
		g_respawn_as_zombie[id] = false
		
		return;
	}
	
	g_buytime[id] = get_gametime()
	
	// Show custom buy menu?
	if (get_pcvar_num(cvar_buycustom))
		set_task(0.2, "show_menu_buy1", id+TASK_SPAWN)
	
	// Switch to CT if spawning mid-round
	if (!g_newround && fm_cs_get_user_team(id) != FM_CS_TEAM_CT) // need to change team?
	{
		remove_task(id+TASK_TEAM)
		fm_cs_set_user_team(id, FM_CS_TEAM_CT)
		fm_user_team_update(id)
	}
	
	// Custom models stuff
	static currentmodel[32], tempmodel[32]
	new already_has_model = false, i, iRand, size
	
	if (g_handle_models_on_separate_ent)
	{
		// Set the right model
		if (get_pcvar_num(cvar_adminmodelshuman) && (get_user_flags(id) & g_access_flag[ACCESS_ADMIN_MODELS]))
		{
			iRand = random_num(0, ArraySize(model_admin_human) - 1)
			ArrayGetString(model_admin_human, iRand, g_playermodel[id], 31)
			if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_modelindex_admin_human, iRand))
		}
		else
		{
			iRand = random_num(ArrayGetCell(g_hclass_modelsstart, g_humanclass[id]), ArrayGetCell(g_hclass_modelsend, g_humanclass[id]) - 1)
			ArrayGetString(g_hclass_playermodel, iRand, g_playermodel[id], 31)
			if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_hclass_modelindex, iRand))
		}
		
		// Set model on player model entity
		fm_set_playermodel_ent(id)
		
		// Remove glow on player model entity
		fm_set_rendering(g_ent_playermodel[id])
	}
	else
	{
		// Get current model for comparing it with the current one
		fm_cs_get_user_model(id, currentmodel, 31)
		
		// Set the right model, after checking that we don't already have it
		if (get_pcvar_num(cvar_adminmodelshuman) && (get_user_flags(id) & g_access_flag[ACCESS_ADMIN_MODELS]))
		{
			size = ArraySize(model_admin_human)
			for (i = 0; i < size; i++)
			{
				ArrayGetString(model_admin_human, i, tempmodel, 31)
				if (equali(currentmodel, tempmodel)) already_has_model = true
			}
			
			if (!already_has_model)
			{
				iRand = random_num(0, size - 1)
				ArrayGetString(model_admin_human, iRand, g_playermodel[id], 31)
				if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_modelindex_admin_human, iRand))
			}
		}
		else
		{
			for (i = ArrayGetCell(g_hclass_modelsstart, g_humanclass[id]); i < ArrayGetCell(g_hclass_modelsend, g_humanclass[id]); i++)
			{
				ArrayGetString(g_hclass_playermodel, i, tempmodel, 31)
				if (equali(currentmodel, tempmodel)) already_has_model = true
			}
			
			if (!already_has_model)
			{
				iRand = random_num(ArrayGetCell(g_hclass_modelsstart, g_humanclass[id]), ArrayGetCell(g_hclass_modelsend, g_humanclass[id]) - 1)
				ArrayGetString(g_hclass_playermodel, iRand, g_playermodel[id], 31)
				if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_hclass_modelindex, iRand))
			}
		}
		
		// Need to change the model?
		if (!already_has_model)
		{
			// An additional delay is offset at round start
			// since SVC_BAD is more likely to be triggered there
			if (g_newround)
				set_task(5.0 * g_modelchange_delay, "fm_user_model_update", id+TASK_MODEL)
			else
				fm_user_model_update(id+TASK_MODEL)
		}
		
		// Remove glow
		fm_set_rendering(id)
	}
	
	// Bots stuff
	if (g_isbot[id])
	{
		// Turn off NVG for bots
		cs_set_user_nvg(id, 0)
		
		// Automatically buy extra items/weapons after first zombie is chosen
		if (get_pcvar_num(cvar_extraitems))
		{
			if (g_newround) set_task(10.0 + get_pcvar_float(cvar_warmup), "bot_buy_extras", id+TASK_SPAWN)
			else set_task(10.0, "bot_buy_extras", id+TASK_SPAWN)
		}
	}
	
	// Enable spawn protection for humans spawning mid-round
	if (!g_newround && get_pcvar_float(cvar_spawnprotection) > 0.0)
	{
		// Do not take damage
		g_nodamage[id] = true
		
		// Make temporarily invisible
		set_pev(id, pev_effects, pev(id, pev_effects) | EF_NODRAW)
		
		// Set task to remove it
		set_task(get_pcvar_float(cvar_spawnprotection), "remove_spawn_protection", id+TASK_SPAWN)
	}
	
	// Turn off his flashlight (prevents double flashlight bug/exploit)
	turn_off_flashlight(id)
	
	// Set the flashlight charge task to update battery status
	if (cvar_customflash)
		set_task(1.0, "flashlight_charge", id+TASK_CHARGE, _, _, "b")
	
	// Replace weapon models (bugfix)
	new weapon_ent = fm_cs_get_current_weapon_ent(id)
	if (pev_valid(weapon_ent)) replace_weapon_models(id, cs_get_weapon_id(weapon_ent))
	
	// Last Zombie Check
	if (!g_newround && !g_endround) fnCheckLastZombie()
}

// Ham Player Killed Forward
public fw_PlayerKilled(victim, attacker, shouldgib)
{
	// Unfreeze the player if he dies frozen
	if (g_frozen[victim])
	{
		new atk[2]
		atk[0] = attacker
		
		remove_task(victim+TASK_UNFREEZE)
		remove_freeze(atk, victim+TASK_UNFREEZE)
	}
	
	// Player killed
	g_isalive[victim] = false
	
	// Disable nodamage mode after we die to prevent spectator nightvision using zombie madness colors bug
	g_nodamage[victim] = false
	
	ExecuteForward(g_fwUserKilled_pre, g_fwDummyResult, victim, attacker, shouldgib);
	
	// Enable dead players nightvision
	set_task(0.1, "spec_nvision", victim)
	
	new nvggive = get_pcvar_num(cvar_nvggive)
	// Disable nightvision when killed (bugfix)
	if (nvggive == 0 && g_nvision[victim])
	{
		if (get_pcvar_num(cvar_customnvg)) remove_task(victim+TASK_NVISION)
		else if (g_nvisionenabled[victim]) set_user_gnvision(victim, 0)
		g_nvision[victim] = false
		g_nvisionenabled[victim] = false
	}
	// Turn off nightvision when killed (bugfix)
	else if (nvggive == 2 && g_nvision[victim] && g_nvisionenabled[victim])
	{
		if (get_pcvar_num(cvar_customnvg)) remove_task(victim+TASK_NVISION)
		else set_user_gnvision(victim, 0)
		g_nvisionenabled[victim] = false
	}
	
	// Turn off custom flashlight when killed
	if (cvar_customflash)
	{
		// Turn it off
		g_flashlight[victim] = false
		g_flashbattery[victim] = 100
		
		// Remove previous tasks
		remove_task(victim+TASK_CHARGE)
		remove_task(victim+TASK_FLASH)
	}
	
	// Stop bleeding/burning/aura when killed
	if (g_zombie[victim])
	{
		remove_task(victim+TASK_BLOOD)
		remove_task(victim+TASK_AURA)
		remove_task(victim+TASK_BURN)
	}
	
	// Nemesis explodes!
	if (g_nemesis[victim] || g_assassin[victim] || is_user_valid_alive(attacker) &&
	(g_sniper[attacker] && g_currentweapon[attacker] == CSW_AWP || g_assassin[attacker]))
		SetHamParamInteger(3, 2)
	
	// Determine whether the player killed himself
	new selfkill = (victim == attacker || !is_user_valid_connected(attacker)) ? true : false
	
	// Killed by a non-player entity or self killed
	if (selfkill) return;
	
	// Ignore Nemesis/Survivor Frags?
	if ((g_nemesis[attacker] && get_pcvar_num(cvar_nemignorefrags)) || (g_survivor[attacker] && get_pcvar_num(cvar_survignorefrags))
	|| (g_sniper[attacker] && get_pcvar_num(cvar_snipignorefrags)) || (g_assassin[attacker] && get_pcvar_num(cvar_assignorefrags)))
		RemoveFrags(attacker, victim)
	
	// Zombie/nemesis killed human, reward ammo packs
	if (g_zombie[attacker] && ((!g_nemesis[attacker] || !get_pcvar_num(cvar_nemignoreammo)) || (!g_assassin[attacker] || !get_pcvar_num(cvar_assignoreammo))))
	{
		new reward = get_pcvar_num(cvar_ammoinfect)
		
		g_ammopacks[attacker] += reward
		
		ExecuteForward(g_fwUserGetAmmoPacks, g_fwDummyResult, attacker, reward, 1);
	}
	
	// Human killed zombie, add up the extra frags for kill
	new fragskill = get_pcvar_num(cvar_fragskill)
	if (!g_zombie[attacker] && fragskill > 1)
		UpdateFrags(attacker, victim, fragskill - 1, 0, 0)
	if (fnGetZombies() == 0)
		RoundEndForceControl(WINSTATUS_CT, 15.0)
	
	// Zombie killed human, add up the extra frags for kill
	new fragsinfect = get_pcvar_num(cvar_fragsinfect)
	if (g_zombie[attacker] && fragsinfect > 1)
		UpdateFrags(attacker, victim, fragsinfect - 1, 0, 0)
	if(fnGetHumans() == 0)
		RoundEndForceControl(WINSTATUS_TERRORIST, 15.0)
}

// Ham Player Killed Post Forward
public fw_PlayerKilled_Post(victim, attacker, shouldgib)
{
	ExecuteForward(g_fwUserKilled_post, g_fwDummyResult, victim, attacker, shouldgib);
	
	// Last Zombie Check
	if (!g_newround && !g_endround) fnCheckLastZombie()
	
	// Determine whether the player killed himself
	new selfkill = (victim == attacker || !is_user_valid_connected(attacker)) ? true : false
	
	// Respawn if deathmatch is enabled
	if (get_pcvar_num(cvar_deathmatch))
	{
		// Respawn on suicide?
		if (selfkill && !get_pcvar_num(cvar_respawnonsuicide))
			return;
		
		new limit = get_pcvar_num(cvar_respawnlimit)
		if (limit && g_respawn_count[victim] >= limit)
			return;
		
		// Respawn if human/zombie/nemesis/survivor?
		if ((g_zombie[victim] && !g_nemesis[victim] && !g_assassin[victim] && !get_pcvar_num(cvar_respawnzomb))
		|| (!g_zombie[victim] && !g_survivor[victim] && !g_sniper[victim] && !get_pcvar_num(cvar_respawnhum))
		|| (g_nemesis[victim] && !get_pcvar_num(cvar_respawnnem)) || (g_survivor[victim] && !get_pcvar_num(cvar_respawnsurv))
		|| (g_sniper[victim] && !get_pcvar_num(cvar_respawnsnip))  || (g_assassin[victim] && !get_pcvar_num(cvar_respawnass)))
			return;
		
		// Set the respawn task
		set_task(get_pcvar_float(cvar_spawndelay), "respawn_player_task", victim+TASK_SPAWN)
	}
	
	if (is_user_valid_connected(attacker) && g_sniper[attacker] && g_zombie[victim] && g_currentweapon[attacker] == CSW_AWP)
	{
		new origin[3]
		get_user_origin(victim, origin)
		
		message_begin(MSG_PVS, SVC_TEMPENTITY, origin, 0)
		write_byte(TE_LAVASPLASH)
		write_coord(origin[0])
		write_coord(origin[1])
		write_coord(origin[2] - 26)
		message_end()
	}
	
	g_infammo[victim] = 0
//	
//	reset_vars(victim, 0)
}


// Ham Take Damage Forward
public fw_TakeDamage(victim, inflictor, attacker, Float:damage, damage_type)
{
	ExecuteForward(g_fwUserTakeDamage_attempt, g_fwDummyResult, victim, inflictor, attacker, Float:damage, damage_type);
	
	if (g_fwDummyResult >= ZP_PLUGIN_HANDLED)
		return HAM_SUPERCEDE;
	
	// Non-player damage or self damage
	if (victim == attacker || !is_user_valid_connected(attacker))
		return HAM_IGNORED;
	
	// New round starting or round ended
	if (g_newround || g_endround)
		return HAM_SUPERCEDE;
	
	// Victim shouldn't take damage or victim is frozen
	if (attacker && g_nodamage[victim]) // || g_frozen[victim]
		return HAM_SUPERCEDE;
	
	// Prevent friendly fire
	if (g_zombie[attacker] == g_zombie[victim])
		return HAM_SUPERCEDE;
	
	// Attacker is human...
	if (!g_zombie[attacker])
	{
		// Armor multiplier for the final damage on normal zombies
		if (!g_nemesis[victim] && !g_assassin[victim])
		{
			damage *= get_pcvar_float(cvar_zombiearmor)
			SetHamParamFloat(4, damage)
		}
		
		// Reward ammo packs to humans for damaging zombies?
		if ((cvar_ammodamage_human > 0) && ((!g_survivor[attacker] || !cvar_survignoreammo) || (!g_sniper[attacker] || !cvar_snipignoreammo)))
		{
			// Store damage dealt
			g_damagedealt_human[attacker] += floatround(damage)
			
			new oldammo = g_ammopacks[attacker]
			
			// Reward ammo packs for every [ammo damage] dealt
			while (g_damagedealt_human[attacker] > cvar_ammodamage_human)
			{
				g_ammopacks[attacker]++
				g_damagedealt_human[attacker] -= cvar_ammodamage_human
			}
			
			if (oldammo != g_ammopacks[attacker])
				ExecuteForward(g_fwUserGetAmmoPacks, g_fwDummyResult, attacker, g_ammopacks[attacker] - oldammo, 0);
		}
		
		if (g_sniper[attacker] && inflictor == attacker && g_currentweapon[attacker] == CSW_AWP)
			SetHamParamFloat(4, get_pcvar_float(cvar_snipdamage))
		
		return HAM_IGNORED;
	}
	
	// Attacker is zombie...
	
	// Prevent infection/damage by HE grenade (bugfix)
	if (damage_type & DMG_HEGRENADE)
		return HAM_SUPERCEDE;
	
	// Ignore nemesis damage override if damage comes from a 3rd party entity
	// (to prevent this from affecting a sub-plugin's rockets e.g.)
	if (inflictor == attacker)
	{
		// Nemesis?
		if (g_nemesis[attacker])
			// Set nemesis damage
			SetHamParamFloat(4, get_pcvar_float(cvar_nemdamage))
		else if (g_assassin[attacker])
			SetHamParamFloat(4, get_pcvar_float(cvar_assdamage))
	}
	
	// Reward ammo packs to zombies for damaging humans?
	if (cvar_ammodamage_zombie > 0)
	{
		// Store damage dealt
		g_damagedealt_zombie[attacker] += floatround(damage)
		
		new oldammo = g_ammopacks[attacker]
		
		// Reward ammo packs for every [ammo damage] dealt
		while (g_damagedealt_zombie[attacker] > cvar_ammodamage_zombie)
		{
			g_ammopacks[attacker]++
			g_damagedealt_zombie[attacker] -= cvar_ammodamage_zombie
		}
		
		if (oldammo != g_ammopacks[attacker])
			ExecuteForward(g_fwUserGetAmmoPacks, g_fwDummyResult, attacker, g_ammopacks[attacker] - oldammo, 0);
	}
	
	// Last human or not an infection round
	if (g_survround || g_snipround || g_nemround || g_assround || g_swarmround || g_plagueround
	|| g_survivor[victim] || g_sniper[victim] || g_nemesis[attacker] || g_assassin[attacker])
		return HAM_IGNORED; // human is killed
	
	// Does human armor need to be reduced before infecting?
	if (cvar_humanarmor && !g_nodamage[victim])
	{
		// Get victim armor
		new Float:armor
		pev(victim, pev_armorvalue, armor)
		
		// If he has some, block the infection and reduce armor instead
		if (armor > 0.0)
		{
			new iNewArmor = floatround(armor - damage)
			if (iNewArmor < 0) iNewArmor = 0
			
			if (iNewArmor < 100)
				cs_set_user_armor(victim, iNewArmor, CS_ARMOR_NONE)
			else
				cs_set_user_armor(victim, iNewArmor, CS_ARMOR_VESTHELM)
			
			emit_sound(victim, CHAN_BODY, sound_armorhit, 1.0, ATTN_NORM, 0, PITCH_NORM)
			
			return HAM_SUPERCEDE;
		}
	}
	
	// Infection allowed
	zombieme(victim, attacker, 0, 0, 1) // turn into zombie
	return HAM_SUPERCEDE;
}

// Ham Take Damage Post Forward
public fw_TakeDamage_Post(victim, inflictor, attacker, Float:damage, damage_type)
{
	ExecuteForward(g_fwUserTakeDamage_post, g_fwDummyResult, victim, inflictor, attacker, Float:damage, damage_type);
	
	// --- Check if victim should be Pain Shock Free ---
	
	// Check if proper CVARs are enabled
	if (g_zombie[victim])
	{
		if (g_nemesis[victim])
		{
			if (!cvar_nempainfree) return;
		}
		else if (g_assassin[victim])
		{
			if (!cvar_asspainfree) return;
		}
		else
		{
			switch (cvar_zombiepainfree)
			{
				case 0: return;
				case 2: if (!g_lastzombie[victim]) return;
				case 3: if (!g_firstzombie[victim]) return;
			}
		}
	}
	else
	{
		if (g_survivor[victim])
		{
			if (!cvar_survpainfree) return;
		}
		else if (g_sniper[victim])
		{
			if (!cvar_snippainfree) return;
		}
		else return;
	}
	
	// Prevent server crash if entity's private data not initalized
	if (pev_valid(victim) != PDATA_SAFE)
		return;
	
	// Set pain shock free offset
	set_pdata_float(victim, OFFSET_PAINSHOCK, 1.0, OFFSET_LINUX)
}

// Ham Trace Attack Forward
public fw_TraceAttack(victim, attacker, Float:damage, Float:direction[3], tracehandle, damage_type)
{
	// Non-player damage or self damage
	if (victim == attacker || !is_user_valid_connected(attacker))
		return HAM_IGNORED;
	
	// New round starting or round ended
	if (g_newround || g_endround)
		return HAM_SUPERCEDE;
	
	// Victim shouldn't take damage or victim is frozen
	if (g_nodamage[victim]) // || g_frozen[victim]
		return HAM_SUPERCEDE;
	
	// Prevent friendly fire
	if (g_zombie[attacker] == g_zombie[victim])
		return HAM_SUPERCEDE;
	
	// Victim isn't a zombie or not bullet damage, nothing else to do here
	if (!g_zombie[victim] || !(damage_type & DMG_BULLET))
		return HAM_IGNORED;
	
	// If zombie hitzones are enabled, check whether we hit an allowed one
	if (cvar_hitzones && !g_nemesis[victim] && !g_assassin[victim] && !(cvar_hitzones & (1<<get_tr2(tracehandle, TR_iHitgroup))))
		return HAM_SUPERCEDE;
	
	// Knockback disabled, nothing else to do here
	if (!cvar_knockback)
		return HAM_IGNORED;
	
	// Nemesis knockback disabled, nothing else to do here
	if (g_nemesis[victim] && g_cached_nemkb[victim] == 0.0 || g_assassin[victim] && g_cached_asskb[victim] == 0.0)
		return HAM_IGNORED;
	
	// Get whether the victim is in a crouch state
	new ducking = pev(victim, pev_flags) & (FL_DUCKING | FL_ONGROUND) == (FL_DUCKING | FL_ONGROUND)
	
	// Zombie knockback when ducking disabled
	if (ducking && get_pcvar_float(cvar_knockbackducking) == 0.0)
		return HAM_IGNORED;
	
	// Get distance between players
	static origin1[3], origin2[3]
	get_user_origin(victim, origin1)
	get_user_origin(attacker, origin2)
	
	// Max distance exceeded
	if (get_distance(origin1, origin2) > cvar_knockbackdist)
		return HAM_IGNORED;
	
	// Get victim's velocity
	static Float:velocity[3]
	pev(victim, pev_velocity, velocity)
	
	// Use damage on knockback calculation
	if (cvar_knockbackdamage)
		xs_vec_mul_scalar(direction, damage, direction)
	
	// Use weapon power on knockback calculation
	if (cvar_knockbackpower && kb_weapon_power[g_currentweapon[attacker]] > 0.0)
		xs_vec_mul_scalar(direction, kb_weapon_power[g_currentweapon[attacker]], direction)
	
	// Apply ducking knockback multiplier
	if (ducking)
		xs_vec_mul_scalar(direction, get_pcvar_float(cvar_knockbackducking), direction)
	
	// Apply zombie class/nemesis knockback multiplier
	if (g_nemesis[victim])
		xs_vec_mul_scalar(direction, g_cached_nemkb[victim], direction)
	else if (g_assassin[victim])
		xs_vec_mul_scalar(direction, g_cached_asskb[victim], direction)
	else
		xs_vec_mul_scalar(direction, g_cached_zmknockback[victim], direction)
	
	// Add up the new vector
	xs_vec_add(velocity, direction, direction)
	
	// Should knockback also affect vertical velocity?
	if (!cvar_knockbackzvel)
		direction[2] = velocity[2]
	
	// Set the knockback'd victim's velocity
	set_pev(victim, pev_velocity, direction)
	
	return HAM_IGNORED;
}

// Ham Reset MaxSpeed Post Forward
public fw_ResetMaxSpeed_Post(id)
{
	// Freezetime active or player not alive
	if (g_freezetime || !g_isalive[id])
		return;
	
	set_player_maxspeed(id)
}

// Ham Use Stationary Gun Forward
public fw_UseStationary(entity, caller, activator, use_type)
{
	// Prevent zombies from using stationary guns
	if (use_type == USE_USING && is_user_valid_connected(caller) && g_zombie[caller])
		return HAM_SUPERCEDE;
	
	return HAM_IGNORED;
}

// Ham Use Stationary Gun Post Forward
public fw_UseStationary_Post(entity, caller, activator, use_type)
{
	// Someone stopped using a stationary gun
	if (use_type == USE_STOPPED && is_user_valid_connected(caller))
		replace_weapon_models(caller, g_currentweapon[caller]) // replace weapon models (bugfix)
}

// Ham Use Pushable Forward
public fw_UsePushable()
{
	// Prevent speed bug with pushables?
	if (get_pcvar_num(cvar_blockpushables))
		return HAM_SUPERCEDE;
	
	return HAM_IGNORED;
}

// Ham Weapon Touch Forward
public fw_TouchWeapon(weapon, id)
{
	// Not a player
	if (!is_user_valid_connected(id))
		return HAM_IGNORED;
	
	// Dont pickup weapons if zombie or survivor (+PODBot MM fix)
	if (g_zombie[id] || g_survivor[id] || g_sniper[id]) //!g_isbot[id]
		return HAM_SUPERCEDE;
	
	return HAM_IGNORED;
}

// Ham Weapon Pickup Forward
public fw_AddPlayerItem(id, weapon_ent)
{
	// HACK: Retrieve our custom extra ammo from the weapon
	new extra_ammo = pev(weapon_ent, PEV_ADDITIONAL_AMMO)
	
	// If present
	if (extra_ammo)
	{
		// Get weapon's id
		new weaponid = cs_get_weapon_id(weapon_ent)
		
		// Add to player's bpammo
		ExecuteHamB(Ham_GiveAmmo, id, extra_ammo, AMMOTYPE[weaponid], MAXBPAMMO[weaponid])
		set_pev(weapon_ent, PEV_ADDITIONAL_AMMO, 0)
	}
}

// Ham Weapon Deploy Forward
public fw_Item_Deploy_Post(weapon_ent)
{
	// Get weapon's owner
	new owner = fm_cs_get_weapon_ent_owner(weapon_ent)
	
	// Valid owner?
	if (!pev_valid(owner))
		return;
	
	// Get weapon's id
	new weaponid = cs_get_weapon_id(weapon_ent)
	
	// Store current weapon's id for reference
	g_currentweapon[owner] = weaponid
	
	// Replace weapon models with custom ones
	replace_weapon_models(owner, weaponid)
	
	// Zombie not holding an allowed weapon for some reason
	if (g_zombie[owner] && !((1<<weaponid) & ZOMBIE_ALLOWED_WEAPONS_BITSUM))
	{
		// Switch to knife
		g_currentweapon[owner] = CSW_KNIFE
		engclient_cmd(owner, "weapon_knife")
	}
}

// WeaponMod bugfix
//forward wpn_gi_reset_weapon(id);
public wpn_gi_reset_weapon(id)
{
	// Replace knife model
	replace_weapon_models(id, CSW_KNIFE)
}

// Client joins the game
public client_putinserver(id)
{
	// Plugin disabled?
	if (!g_pluginenabled) return;
	
	// Player joined
	g_isconnected[id] = true
	
	// Reset Nemesis and Assassin knockback
	g_cached_nemkb[id] = get_pcvar_float(cvar_nemknockback)
	g_cached_asskb[id] = get_pcvar_float(cvar_assknockback)
	
	// Cache player's data
	get_user_name(id, g_playername[id], 30)
	get_user_authid(id, g_playerauthid[id], 31)
	get_user_ip(id, g_szPlayerAddress[id], 25)
	
	// Initialize player vars
	reset_vars(id, 1)
	
	// Load player stats?
	if (get_pcvar_num(cvar_statssave)) load_stats(id)
	
	// Set some tasks for humans only
	if (!is_user_bot(id))
	{
		// Set the custom HUD display task if enabled
		if (get_pcvar_num(cvar_huddisplay))
			set_task(1.0, "ShowHUD", id+TASK_SHOWHUD, _, _, "b")
		
		// Disable minmodels for clients to see zombies properly
		set_task(5.0, "disable_minmodels", id)
	}
	else
	{
		// Set bot flag
		g_isbot[id] = true
		
		// CZ bots seem to use a different "classtype" for player entities
		// (or something like that) which needs to be hooked separately
		if (!g_hamczbots && cvar_botquota)
		{
			// Set a task to let the private data initialize
			set_task(0.1, "register_ham_czbots", id)
		}
	}
	
	if (g_newround || g_endround)
		return;
	
	set_task(2.0, "ambience_sound_effects", id+TASK_AMBIENCESOUNDS)
}

// Client leaving
public fw_ClientDisconnect(id)
{
	// Check that we still have both humans and zombies to keep the round going
	if (g_isalive[id]) check_round(id)
	
	// Temporarily save player stats?
	if (get_pcvar_num(cvar_statssave)) save_stats(id)
	
	// Remove previous tasks
	remove_task(id+TASK_TEAM)
	remove_task(id+TASK_MODEL)
	remove_task(id+TASK_FLASH)
	remove_task(id+TASK_CHARGE)
	remove_task(id+TASK_SPAWN)
	remove_task(id+TASK_BLOOD)
	remove_task(id+TASK_AURA)
	remove_task(id+TASK_BURN)
	remove_task(id+TASK_NVISION)
	remove_task(id+TASK_SHOWHUD)
	remove_task(id+TASK_AMBIENCESOUNDS)
	
	if (g_handle_models_on_separate_ent)
	{
		// Remove custom model entities
		fm_remove_model_ents(id)
	}
	
	// Player left, clear cached flags
	g_isconnected[id] = false
	g_isbot[id] = false
	g_isalive[id] = false
	g_ammopacks[id] = 0
	g_infammo[id] = 0
}

// Client left
public fw_ClientDisconnect_Post()
{
	// Last Zombie Check
	if (!g_newround && !g_endround) fnCheckLastZombie()
}

// Client Kill Forward
public fw_ClientKill()
{
	// Prevent players from killing themselves?
	if (cvar_blocksuicide)
		return FMRES_SUPERCEDE;
	
	return FMRES_IGNORED;
}

// Emit Sound Forward
public fw_EmitSound(id, channel, const sample[], Float:volume, Float:attn, flags, pitch)
{
	// Block all those unneeeded hostage sounds
	if (sample[0] == 'h' && sample[1] == 'o' && sample[2] == 's' && sample[3] == 't' && sample[4] == 'a' && sample[5] == 'g' && sample[6] == 'e')
		return FMRES_SUPERCEDE;
	
	// Replace these next sounds for zombies only
	if (!is_user_valid_connected(id) || !g_zombie[id])
		return FMRES_IGNORED;
	
	static sound[64]
	
	// Zombie being hit
	if (sample[7] == 'b' && sample[8] == 'h' && sample[9] == 'i' && sample[10] == 't')
	{
		if (g_nemesis[id])
		{
			ArrayGetString(nemesis_pain, random_num(0, ArraySize(nemesis_pain) - 1), sound, 63)
			emit_sound(id, channel, sound, volume, attn, flags, pitch)
		}
		else if (g_assassin[id])
		{
			ArrayGetString(assassin_pain, random_num(0, ArraySize(assassin_pain) - 1), sound, 63)
			emit_sound(id, channel, sound, volume, attn, flags, pitch)
		}
		else
		{
			static pointers[10], end
			ArrayGetArray(pointer_class_sound_pain, g_zombieclass[id], pointers)
			
			for (new i; i < 10; i++)
			{
				if (pointers[i] != -1)
				end = i
			}
			ArrayGetString(class_sound_pain, random_num(pointers[0], pointers[end]), sound, 63)
			emit_sound(id, channel, sound, volume, attn, flags, pitch)
		}
		return FMRES_SUPERCEDE;
	}
	
	// Zombie attacks with knife
	if (sample[8] == 'k' && sample[9] == 'n' && sample[10] == 'i')
	{
		if (sample[14] == 's' && sample[15] == 'l' && sample[16] == 'a') // slash
		{
			if(g_nemesis[id])
			{
				ArrayGetString(nemesis_miss_slash, random_num(0, ArraySize(nemesis_miss_slash) - 1), sound, 63)
			}
			else if (g_assassin[id])
			{
				ArrayGetString(assassin_miss_slash, random_num(0, ArraySize(assassin_miss_slash) - 1), sound, 63)
			}
			else 
			{
				static pointers[10], end
				ArrayGetArray(pointer_class_sound_miss_slash, g_zombieclass[id], pointers)
	
				for (new i; i < 10; i++)
				{
					if (pointers[i] != -1)
						end = i
				}
				ArrayGetString(class_sound_miss_slash, random_num(pointers[0], pointers[end]), sound, 63)
			}
			emit_sound(id, channel, sound, volume, attn, flags, pitch)
			return FMRES_SUPERCEDE;
		}
		if (sample[14] == 'h' && sample[15] == 'i' && sample[16] == 't') // hit
		{
			if (sample[17] == 'w') // wall
			{
				if(g_nemesis[id])
				{
					ArrayGetString(nemesis_miss_wall, random_num(0, ArraySize(nemesis_miss_wall) - 1), sound, 63)
				}
				else if (g_assassin[id])
				{
					ArrayGetString(assassin_miss_wall, random_num(0, ArraySize(assassin_miss_wall) - 1), sound, 63)
				}
				else 
				{
					static pointers[10], end
					ArrayGetArray(pointer_class_sound_miss_wall, g_zombieclass[id], pointers)
			
					for (new i; i < 10; i++)
					{
						if (pointers[i] != -1)
							end = i
					}
					ArrayGetString(class_sound_miss_wall, random_num(pointers[0], pointers[end]), sound, 63)
				}
				emit_sound(id, channel, sound, volume, attn, flags, pitch)
				return FMRES_SUPERCEDE;
			}
			else
			{
				if(g_nemesis[id])
				{
					ArrayGetString(nemesis_hit_normal, random_num(0, ArraySize(nemesis_hit_normal) - 1), sound, 63)
				}
				else if (g_assassin[id])
				{
					ArrayGetString(assassin_hit_normal, random_num(0, ArraySize(assassin_hit_normal) - 1), sound, 63)
				}
				else 
				{				
					static pointers[10], end
					ArrayGetArray(pointer_class_sound_hit_normal, g_zombieclass[id], pointers)
			
					for (new i; i < 10; i++)
					{
						if (pointers[i] != -1)
							end = i
					}
					ArrayGetString(class_sound_hit_normal, random_num(pointers[0], pointers[end]), sound, 63)
				}
				emit_sound(id, channel, sound, volume, attn, flags, pitch)
				return FMRES_SUPERCEDE;
			}
		}
		if (sample[14] == 's' && sample[15] == 't' && sample[16] == 'a') // stab
		{
			if(g_nemesis[id])
			{
				ArrayGetString(nemesis_hit_stab, random_num(0, ArraySize(nemesis_hit_stab) - 1), sound, 63)
			}
			else if (g_assassin[id])
			{
				ArrayGetString(assassin_hit_stab, random_num(0, ArraySize(assassin_hit_stab) - 1), sound, 63)
			}
			else 
			{	
				static pointers[10], end
				ArrayGetArray(pointer_class_sound_hit_stab, g_zombieclass[id], pointers)
			
				for (new i; i < 10; i++)
				{
					if (pointers[i] != -1)
						end = i
				}
				ArrayGetString(class_sound_hit_stab, random_num(pointers[0], pointers[end]), sound, 63)
			}
			emit_sound(id, channel, sound, volume, attn, flags, pitch)
			return FMRES_SUPERCEDE;
		}
	}
	
	// Zombie dies
	if (sample[7] == 'd' && ((sample[8] == 'i' && sample[9] == 'e') || (sample[8] == 'e' && sample[9] == 'a')))
	{
		if(g_nemesis[id])
		{
			ArrayGetString(nemesis_die, random_num(0, ArraySize(nemesis_die) - 1), sound, 63)
		}
		else if(g_assassin[id])
		{
			ArrayGetString(assassin_die, random_num(0, ArraySize(assassin_die) - 1), sound, 63)
		}
		else 
		{	
			static pointers[10], end
			ArrayGetArray(pointer_class_sound_die, g_zombieclass[id], pointers)
			
			for (new i; i < 10; i++)
			{
				if (pointers[i] != -1)
					end = i
			}
			ArrayGetString(class_sound_die, random_num(pointers[0], pointers[end]), sound, 63)
		}
		emit_sound(id, channel, sound, volume, attn, flags, pitch)
		return FMRES_SUPERCEDE;
	}

	// Zombie falls off
	if (sample[10] == 'f' && sample[11] == 'a' && sample[12] == 'l' && sample[13] == 'l')
	{
		if(g_nemesis[id])
		{
			ArrayGetString(nemesis_fall, random_num(0, ArraySize(nemesis_fall) - 1), sound, 63)
		}
		else if(g_assassin[id])
		{
			ArrayGetString(assassin_fall, random_num(0, ArraySize(assassin_fall) - 1), sound, 63)
		}
		else 
		{
			static pointers[10], end
			ArrayGetArray(pointer_class_sound_fall, g_zombieclass[id], pointers)
			
			for (new i; i < 10; i++)
			{
				if (pointers[i] != -1)
				end = i
			}
			ArrayGetString(class_sound_fall, random_num(pointers[0], pointers[end]), sound, 63)
		}
		emit_sound(id, channel, sound, volume, attn, flags, pitch)
	}
	return FMRES_SUPERCEDE;
}

// Forward Set ClientKey Value -prevent CS from changing player models-
public fw_SetClientKeyValue(id, const infobuffer[], const key[])
{
	// Block CS model changes
	if (key[0] == 'm' && key[1] == 'o' && key[2] == 'd' && key[3] == 'e' && key[4] == 'l')
		return FMRES_SUPERCEDE;
	
	return FMRES_IGNORED;
}

// Forward Client User Info Changed -prevent players from changing models-
public fw_ClientUserInfoChanged(id)
{
	// Cache player's name
	get_user_info(id, "name", g_playername[id], 30)
	
	if (!g_handle_models_on_separate_ent)
	{
		// Get current model
		static currentmodel[32]
		fm_cs_get_user_model(id, currentmodel, 31)
		
		// If they're different, set model again
		if (!equali(currentmodel, g_playermodel[id]) && !task_exists(id+TASK_MODEL))
			fm_cs_set_user_model(id+TASK_MODEL)
	}
}

// Forward Get Game Description
public fw_GetGameDescription()
{
	// Return the mod name so it can be easily identified
	forward_return(FMV_STRING, g_modname)
	
	return FMRES_SUPERCEDE;
}

// Forward Set Model
public fw_SetModel(entity, const model[])
{	
	// We don't care
	if (strlen(model) < 8)
		return FMRES_IGNORED
	
	// Remove weapons?
	if (get_pcvar_float(cvar_removedropped) > 0.0)
	{
		// Get entity's classname
		static classname[10]
		pev(entity, pev_classname, classname, 9)
		
		// Check if it's a weapon box
		if (equali(classname, "weaponbox"))
		{
			// They get automatically removed when thinking
			set_pev(entity, pev_nextthink, get_gametime() + get_pcvar_float(cvar_removedropped))
			return FMRES_IGNORED
		}
	}
	
	// Narrow down our matches a bit
	if (model[7] != 'w' || model[8] != '_')
		return FMRES_IGNORED
	
	// Get damage time of grenade
	new Float:dmgtime
	pev(entity, pev_dmgtime, dmgtime)
	
	// Grenade not yet thrown
	if (dmgtime == 0.0)
		return FMRES_IGNORED
	
	// Get whether grenade's owner is a zombie
	if (g_zombie[pev(entity, pev_owner)])
	{
		if (model[9] == 'h' && model[10] == 'e' && get_pcvar_num(cvar_extrainfbomb)) // Infection Bomb
		{
			// Give it a glow
			fm_set_rendering(entity, kRenderFxGlowShell, cvar_nvgcolor[0], cvar_nvgcolor[1], cvar_nvgcolor[2], kRenderNormal); //0, 200, 0
			
			// And a colored trail
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
			write_byte(TE_BEAMFOLLOW) // TE id
			write_short(entity) // entity
			write_short(g_colorinfect) // sprite
			write_byte(40) // life
			write_byte(30) // width
			write_byte(cvar_nvgcolor[0]) // r-0
			write_byte(cvar_nvgcolor[1]) // g-200
			write_byte(cvar_nvgcolor[2]) // b-0
			write_byte(200) // brightness
			message_end()
			
			// Set grenade type on the thrown grenade entity
			engfunc(EngFunc_SetModel, entity, model_w_grenade_infection)
			set_pev(entity, PEV_NADE_TYPE, NADE_TYPE_INFECTION)
			return FMRES_SUPERCEDE
		}
	}
	else if (model[9] == 'h' && model[10] == 'e' && cvar_firegrenades) // Napalm Grenade
	{
		// Give it a glow
		fm_set_rendering(entity, kRenderFxGlowShell, 200, 0, 0, kRenderNormal);
		
		// And a colored trail
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_BEAMFOLLOW) // TE id
		write_short(entity) // entity
		write_short(g_colorfire) // sprite
		write_byte(40) // life
		write_byte(30) // width
		write_byte(200) // r
		write_byte(0) // g
		write_byte(0) // b
		write_byte(200) // brightness
		message_end()	
		
		// Set grenade type on the thrown grenade entity
		engfunc(EngFunc_SetModel, entity, model_w_grenade_fire)
		set_pev(entity, PEV_NADE_TYPE, NADE_TYPE_NAPALM)
		return FMRES_SUPERCEDE
	}
	else if (model[9] == 'f' && model[10] == 'l' && cvar_frostgrenades) // Frost Grenade
	{
		// Give it a glow
		fm_set_rendering(entity, kRenderFxGlowShell, 0, 100, 200, kRenderNormal, 16);
		
		// And a colored trail
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_BEAMFOLLOW) // TE id
		write_short(entity) // entity
		write_short(g_colorfrost) // sprite
		write_byte(40) // life
		write_byte(30) // width
		write_byte(0) // r
		write_byte(100) // g
		write_byte(200) // b
		write_byte(200) // brightness
		message_end()
		
		// Set grenade type on the thrown grenade entity
		engfunc(EngFunc_SetModel, entity, model_w_grenade_frost)
		set_pev(entity, PEV_NADE_TYPE, NADE_TYPE_FROST)
		return FMRES_SUPERCEDE
	}
	else if (model[9] == 's' && model[10] == 'm' && cvar_flaregrenades) // Flare
	{
		// Build flare's color
		static rgb[11]
		
		if (g_assround)
		{
			rgb[0] = cvar_assnvgcolor[0]
			rgb[1] = cvar_assnvgcolor[1]
			rgb[2] = cvar_assnvgcolor[2]
		}
		else
		{
			get_pcvar_string(cvar_flarecolor, rgb, 10)
			new red[4], green[4], blue[4]
			parse(rgb, red, 3, green, 3, blue, 3)
			
			if (!green[0])
				switch (get_pcvar_num(cvar_flarecolor))
				{
					case 0: // white
					{
						rgb[0] = 255 // r
						rgb[1] = 255 // g
						rgb[2] = 255 // b
					}
					case 1: // red
					{
						rgb[0] = random_num(175,255) // r
						rgb[1] = 0 // g
						rgb[2] = 0 // b
					}
					case 2: // green
					{
						rgb[0] = 0 // r
						rgb[1] = random_num(175,255) // g
						rgb[2] = 0 // b
					}
					case 3: // blue
					{
						rgb[0] = 0 // r
						rgb[1] = 0 // g
						rgb[2] = random_num(175,255) // b
					}
					case 4: // random (all colors)
					{
						rgb[0] = random_num(75,255) // r 217
						rgb[1] = random_num(0,255) // g
						rgb[2] = random_num(0,255) // b
					}
					case 5: // random (r,g,b)
					{
						switch (random_num(1, 3))
						{
							case 1: // red
							{
								rgb[0] = random_num(175,255) // r
								rgb[1] = 0 // g
								rgb[2] = 0 // b
							}
							case 2: // green
							{
								rgb[0] = 0 // r
								rgb[1] = random_num(175,255) // g
								rgb[2] = 0 // b
							}
							case 3: // blue
							{
								rgb[0] = 0 // r
								rgb[1] = 0 // g
								rgb[2] = random_num(175,255) // b
							}
						}
					}
				}
			else
			{
				rgb[0] = clamp(str_to_num(red), 0, 255)
				rgb[1] = clamp(str_to_num(green), 0, 255)
				rgb[2] = clamp(str_to_num(blue), 0, 255)
			}
		}
		
		// Give it a glow
		fm_set_rendering(entity, kRenderFxGlowShell, rgb[0], rgb[1], rgb[2], kRenderNormal);
		
		// And a colored trail
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_BEAMFOLLOW) // TE id
		write_short(entity) // entity
		write_short(g_colorflare) // sprite
		write_byte(40) // life
		write_byte(30) // width
		write_byte(rgb[0]) // r
		write_byte(rgb[1]) // g
		write_byte(rgb[2]) // b
		write_byte(200) // brightness
		message_end()
		
		// Set grenade type on the thrown grenade entity
		set_pev(entity, PEV_NADE_TYPE, NADE_TYPE_FLARE)
		
		set_pev(entity, pev_effects, EF_LIGHT)
		
		// Set flare color on the thrown grenade entity
		set_pev(entity, PEV_FLARE_COLOR, rgb)
		
		engfunc( EngFunc_SetModel, entity, model_w_grenade_flare)
		return FMRES_SUPERCEDE
	}
	return FMRES_IGNORED
}

// Ham Grenade Think Forward
public fw_ThinkGrenade(entity)
{
	// Invalid entity
	if (!pev_valid(entity)) return HAM_IGNORED;
	
	// Get damage time of grenade
	new Float:dmgtime, Float:current_time
	pev(entity, pev_dmgtime, dmgtime)
	current_time = get_gametime()
	
	// Check if it's time to go off
	if (dmgtime > current_time)
		return HAM_IGNORED;
	
	// Check if it's one of our custom nades
	switch (pev(entity, PEV_NADE_TYPE))
	{
		case NADE_TYPE_INFECTION: // Infection Bomb
		{
			infection_explode(entity)
			return HAM_SUPERCEDE;
		}
		case NADE_TYPE_NAPALM: // Napalm Grenade
		{
			fire_explode(entity)
			return HAM_SUPERCEDE;
		}
		case NADE_TYPE_FROST: // Frost Grenade
		{
			frost_explode(entity)
			return HAM_SUPERCEDE;
		}
		case NADE_TYPE_FLARE: // Flare
		{
			flare_explode(entity)
			// Get its duration
			new duration = pev(entity, PEV_FLARE_DURATION)
			
			// Already went off, do lighting loop for the duration of PEV_FLARE_DURATION
			if (duration > 0)
			{
				// Check whether this is the last loop
				if (duration == 1)
				{
					// Get rid of the flare entity
					engfunc(EngFunc_RemoveEntity, entity)
					return HAM_SUPERCEDE;
				}
				
				// Light it up!
				flare_lighting(entity, duration)
				
				// Set time for next loop
				set_pev(entity, PEV_FLARE_DURATION, --duration)
				set_pev(entity, pev_dmgtime, current_time + 2.0)
			}
			// Light up when it's stopped on ground
			else if ((pev(entity, pev_flags) & FL_ONGROUND) && fm_get_speed(entity) < 10)
			{
				// Flare sound
				static sound[64]
				ArrayGetString(grenade_flare, random_num(0, ArraySize(grenade_flare) - 1), sound, 63)
				emit_sound(entity, CHAN_WEAPON, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
				
				// Set duration and start lightning loop on next think
				set_pev(entity, PEV_FLARE_DURATION, 1 + get_pcvar_num(cvar_flareduration)/2)
				set_pev(entity, pev_dmgtime, current_time + 0.1)
			}
			else
			{
				// Delay explosion until we hit ground
				set_pev(entity, pev_dmgtime, current_time + 0.5)
			}
		}
	}
	
	return HAM_IGNORED;
}

// Forward CmdStart
public fw_CmdStart(id, handle)
{
	// Not alive
	if (!g_isalive[id])
		return;
	
	// This logic looks kinda weird, but it should work in theory...
	// p = g_zombie[id], q = g_survivor[id], r = g_cached_customflash
	// �(p v q v (�p ^ r)) <==> �p ^ �q ^ (p v �r)
	if (!g_zombie[id] && !g_survivor[id] && !g_sniper[id] && (g_zombie[id] || !cvar_customflash))
		return;
	
	// Check if it's a flashlight impulse
	if (get_uc(handle, UC_Impulse) != IMPULSE_FLASHLIGHT)
		return;
	
	// Block it I say!
	set_uc(handle, UC_Impulse, 0)
	
	// Should human's custom flashlight be turned on?
	if (!g_zombie[id] && !g_survivor[id] && !g_sniper[id] && g_flashbattery[id] > 2 && get_gametime() - g_lastflashtime[id] > 1.2)
	{
		// Prevent calling flashlight too quickly (bugfix)
		g_lastflashtime[id] = get_gametime()
		
		// Toggle custom flashlight
		g_flashlight[id] = !(g_flashlight[id])
		
		// Play flashlight toggle sound
		emit_sound(id, CHAN_ITEM, sound_flashlight, 1.0, ATTN_NORM, 0, PITCH_NORM)
		
		// Update flashlight status on the HUD
		message_begin(MSG_ONE, g_msgFlashlight, _, id)
		write_byte(g_flashlight[id]) // toggle
		write_byte(g_flashbattery[id]) // battery
		message_end()
		
		// Remove previous tasks
		remove_task(id+TASK_CHARGE)
		remove_task(id+TASK_FLASH)
		
		// Set the flashlight charge task
		set_task(1.0, "flashlight_charge", id+TASK_CHARGE, _, _, "b")
		
		// Call our custom flashlight task if enabled
		if (g_flashlight[id]) set_task(0.1, "set_user_flashlight", id+TASK_FLASH, _, _, "b")
	}
}

// Forward Player PreThink
public fw_PlayerPreThink(id)
{
	// Not alive
	if (!g_isalive[id])
		return;
	
	// Enable custom buyzone for player during buytime, unless zombie or survivor or time expired
	if (g_cached_buytime > 0.0 && !g_zombie[id] && !g_survivor[id] && !g_sniper[id] && (get_gametime() < g_buytime[id] + g_cached_buytime))
	{
		if (pev_valid(g_buyzone_ent))
			dllfunc(DLLFunc_Touch, g_buyzone_ent, id)
	}
	
	// Silent footsteps for zombies?
	if (cvar_zombiesilent && g_zombie[id] && !g_nemesis[id])
		set_pev(id, pev_flTimeStepSound, STEPTIME_SILENT)
	
	// Player frozen?
	if (g_frozen[id])
	{
		set_pev(id, pev_velocity, Float:{0.0,0.0,0.0}) // stop motion
		return; // shouldn't leap while frozen
	}
	
	// --- Check if player should leap ---
	
	// Don't allow leap during freezetime
	if (g_freezetime)
		return;
	
	// Check if proper CVARs are enabled and retrieve leap settings
	new Float:cooldown, Float:current_time
	if (g_zombie[id])
	{
		if (g_nemesis[id])
		{
			if (!cvar_leapnemesis) return;
			cooldown = g_cached_leapnemesiscooldown
		}
		else if (g_assassin[id])
		{
			if (!cvar_leapassassin) return;
			cooldown = g_cached_leapassassincooldown
		}
		else
		{
			switch (cvar_leapzombies)
			{
				case 0: return;
				case 2: if (!g_firstzombie[id]) return;
				case 3: if (!g_lastzombie[id]) return;
			}
			cooldown = g_cached_leapzombiescooldown
		}
	}
	else
	{
		if (g_survivor[id])
		{
			if (!cvar_leapsurvivor) return;
			cooldown = g_cached_leapsurvivorcooldown
		}
		else if (g_sniper[id])
		{
			if (!cvar_leapsniper) return;
			cooldown = g_cached_leapsnipercooldown
		}
		else return;
	}
	
	current_time = get_gametime()
	
	// Cooldown not over yet
	if (current_time - g_lastleaptime[id] < cooldown)
		return;
	
	// Not doing a longjump (don't perform check for bots, they leap automatically)
	if (!g_isbot[id] && !(pev(id, pev_button) & (IN_JUMP | IN_DUCK) == (IN_JUMP | IN_DUCK)))
		return;
	
	// Not on ground or not enough speed
	if (!(pev(id, pev_flags) & FL_ONGROUND) || fm_get_speed(id) < 80)
		return;
	
	static Float:velocity[3]
	
	// Make velocity vector
	velocity_by_aim(id, g_survivor[id] ? get_pcvar_num(cvar_leapsurvivorforce) : g_sniper[id] ? get_pcvar_num(cvar_leapsniperforce) : g_nemesis[id] ? get_pcvar_num(cvar_leapnemesisforce) : g_assassin[id] ? get_pcvar_num(cvar_leapassassinforce) : get_pcvar_num(cvar_leapzombiesforce), velocity)
	
	// Set custom height
	velocity[2] = g_survivor[id] ? get_pcvar_float(cvar_leapsurvivorheight) : g_sniper[id] ? get_pcvar_float(cvar_leapsniperheight) : g_nemesis[id] ? get_pcvar_float(cvar_leapnemesisheight) : g_assassin[id] ? get_pcvar_float(cvar_leapassassinheight) : get_pcvar_float(cvar_leapzombiesheight)
	
	// Apply the new velocity
	set_pev(id, pev_velocity, velocity)
	
	// Update last leap time
	g_lastleaptime[id] = current_time
}

/*================================================================================
 [Client Commands]
=================================================================================*/

// Say "/zpmenu"
public clcmd_saymenu(id)
{
	show_menu_game(id) // show game menu
}

// Say "/unstuck"
public clcmd_sayunstuck(id)
{
	menu_game(id, 3) // try to get unstuck
}

// Nightvision toggle
public clcmd_nightvision(id)
{
	// Nightvision available to player?
	if (g_nvision[id] || (g_isalive[id] && cs_get_user_nvg(id)))
	{
		// Enable-disable
		g_nvisionenabled[id] = !(g_nvisionenabled[id])
		
		// Custom nvg?
		if (get_pcvar_num(cvar_customnvg))
		{
			remove_task(id+TASK_NVISION)
			if (g_nvisionenabled[id]) set_task(0.1, "set_user_nvision", id+TASK_NVISION, _, _, "b")
		}
		else
			set_user_gnvision(id, g_nvisionenabled[id])
	}
	
	if((g_zombie[id] || g_assassin[id] || g_nemesis[id]) && g_nvisionenabled[id])
	{	
		remove_task(id+TASK_NVISION)
		message_begin( MSG_ONE_UNRELIABLE, g_msgScreenFade, { 0,0,0 }, id); 
		write_short( 1<<0 ); 
		write_short( 1<<0 ); 
		write_short( 0x0004 ); 
		write_byte( 175 );
		write_byte( 50 );
		write_byte( 25 ); 
		write_byte( 50 ); 
		message_end( );
		
		message_begin(MSG_ONE, g_msgSetFOV, _, id)
		write_byte(110) // fov angle
		message_end()
		
		client_cmd(id, "spk items/nvg_on.wav")
	}
	else if(g_zombie[id] || g_assassin[id] || g_nemesis[id])
	{
		remove_task(id+TASK_NVISION)
		message_begin( MSG_ONE_UNRELIABLE, g_msgScreenFade, { 0,0,0 }, id); 
		write_short( 0 ); 
		write_short( 0 ); 
		write_short( 0x0000 ); 
		write_byte( 0 );
		write_byte( 0 );
		write_byte( 0 ); 
		write_byte( 0 ); 
		message_end( );
			
		message_begin(MSG_ONE, g_msgSetFOV, _, id)
		write_byte(90) // fov angle
		message_end()
		
		client_cmd(id, "spk items/nvg_off.wav")
	}
	
	return PLUGIN_HANDLED;
}

// Weapon Drop
public clcmd_drop(id)
{
	// Survivor should stick with its weapon
	if ((g_survivor[id] || g_sniper[id]) && ((1<<g_currentweapon[id]) & PRIMARY_WEAPONS_BIT_SUM))
	{
		client_print(id, print_center, "%L", id, "CMD_NOT_DROP")
		
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_CONTINUE;
}

// Buy BP Ammo
public clcmd_buyammo(id)
{
	ExecuteForward(g_fwExtraItemBuyAttempt, g_fwDummyResult, id, -1, 0, 1);
	
	// Item purchase blocked
	if (g_fwDummyResult >= ZP_PLUGIN_HANDLED)
		return PLUGIN_HANDLED;
	
	// Not alive or infinite ammo setting enabled
	if (!g_isalive[id] || get_pcvar_num(cvar_infammo))
		return PLUGIN_HANDLED;
	
	// Not human
	if (g_zombie[id])
	{
		zp_colored_print(id, "^3%L", id, "CMD_HUMAN_ONLY")
		return PLUGIN_HANDLED;
	}
	
	// Custom buytime enabled and human player standing in buyzone, allow buying weapon's ammo normally instead
	if (g_cached_buytime > 0.0 && !g_survivor[id] && !g_sniper[id] && (get_gametime() < g_buytime[id] + g_cached_buytime) && cs_get_user_buyzone(id))
		return PLUGIN_CONTINUE;
	
	// Not enough ammo packs
	if (g_ammopacks[id] < 1)
	{
		zp_colored_print(id, "^3%L^1(^3%d^1/^4%d^1)", id, "NOT_ENOUGH_AMMO", g_ammopacks[id], 1)
		return PLUGIN_HANDLED;
	}
	
	// Get user weapons
	static weapons[32]
	new num, i, currentammo, weaponid, refilled = false
//	num = 0 // reset passed weapons count (bugfix)
//	refilled = false
	get_user_weapons(id, weapons, num)
	
	// Loop through them and give the right ammo type
	for (i = 0; i < num; i++)
	{
		// Prevents re-indexing the array
		weaponid = weapons[i]
		
		// Primary and secondary only
		if (MAXBPAMMO[weaponid] > 2)
		{
			// Get current ammo of the weapon
			currentammo = cs_get_user_bpammo(id, weaponid)
			
			// Give additional ammo
			ExecuteHamB(Ham_GiveAmmo, id, BUYAMMO[weaponid], AMMOTYPE[weaponid], MAXBPAMMO[weaponid])
			
			// Check whether we actually refilled the weapon's ammo
			if (cs_get_user_bpammo(id, weaponid) - currentammo > 0) refilled = true
		}
	}
	
	// Weapons already have full ammo
	if (!refilled) return PLUGIN_HANDLED;
	
	// Deduce ammo packs, play clip purchase sound, and notify player
	g_ammopacks[id]--
	emit_sound(id, CHAN_ITEM, sound_buyammo, 1.0, ATTN_NORM, 0, PITCH_NORM)
	zp_colored_print(id, "^4%L", id, "AMMO_BOUGHT")
	
	ExecuteForward(g_fwExtraItemSelected, g_fwDummyResult, id, -1, 0, 1);
	
	return PLUGIN_HANDLED;
}

// Block Team Change
public clcmd_changeteam(id)
{
	new team = fm_cs_get_user_team(id);
	
	// Unless it's a spectator joining the game
	if (team == FM_CS_TEAM_SPECTATOR || team == FM_CS_TEAM_UNASSIGNED)
		return PLUGIN_CONTINUE;
	
	// Pressing 'M' (chooseteam) ingame should show the main menu instead
	show_menu_game(id)
	return PLUGIN_HANDLED;
}

/*================================================================================
 [Menus]
=================================================================================*/

// Game Menu
public show_menu_game(id)
{
	// Player disconnected?
	if (!g_isconnected[id])
		return;
	
	static menu[512]
	new len, userflags = get_user_flags(id)
	
	new player_name[32], MapName[32] 

	get_user_name(id, player_name, 31)
	get_mapname(MapName,31)
	
	// Title
	len += formatex(menu[len], 249 - len, "\r%s^n\yHello \r%s!^n\yCurrent Map is \r%s^n^n", g_modname, player_name, MapName)
	
	// 1. Buy weapons
	if (get_pcvar_num(cvar_buycustom) && !g_zombie[id])
		len += formatex(menu[len], 512 - len, "\y[1] - \w%L^n", id, "MENU_BUY")
	else
		len += formatex(menu[len], 512 - len, "\d[1] - %L^n", id, "MENU_BUY")
	
	// 2. Extra items
	if (get_pcvar_num(cvar_extraitems) && g_isalive[id])
		len += formatex(menu[len], 512 - len, "\y[2] - \w%L^n", id, "MENU_EXTRABUY")
	else
		len += formatex(menu[len], 512 - len, "\d[2] - %L^n", id, "MENU_EXTRABUY")
		
	// 3. Weapon items
	if (get_pcvar_num(cvar_extraitems) && g_isalive[id] && !g_zombie[id])
		len += formatex(menu[len], 512 - len, "\y[3] - \w%L^n^n", id, "MENU_WEAPONBUY")
	else
		len += formatex(menu[len], 512 - len, "\d[3] - %L^n^n", id, "MENU_WEAPONBUY")
	
	// 4. Choose class
	if (get_pcvar_num(cvar_zclasses) || get_pcvar_num(cvar_hclasses))
		len += formatex(menu[len], 512 - len, "\y[4] - \w%L^n^n", id, "MENU_CLASSES")
	else
		len += formatex(menu[len], 512 - len, "\d[4] - %L^n^n", id, "MENU_CLASSES")
	
	new unstuck = get_pcvar_num(cvar_unstuck)
	
	// 5. Menu ZP
	len += formatex(menu[len], 512 - len, "\y[5] - \w%L^n", id, "MENU_ZPCENTR")
	
	// 6. Menu Emotion
	if(!g_zombie[id])
		len += formatex(menu[len], 512 - len, "\y[6] - \w%L^n^n", id, "MENU_EMOTION")
	else
		len += formatex(menu[len], 512 - len, "\d[6] - %L^n^n", id, "MENU_EMOTION")
	
	// 6. Join spec
	if (!g_isalive[id] || !cvar_blocksuicide || (userflags & g_access_flag[ACCESS_ADMIN_MENU]))
		len += formatex(menu[len], 512 - len, "\y[7] - \w%L^n", id, "MENU_SPECTATOR")
	else
		len += formatex(menu[len], 512 - len, "\d[7] - %L^n", id, "MENU_SPECTATOR")
		
	// 7. Unstuck
	if (g_isalive[id] && unstuck && (!g_zombie[id] && (unstuck == 1 || unstuck > 2) || g_zombie[id] && unstuck > 1))
		len += formatex(menu[len], 512 - len, "\y[8] - \w%L^n^n", id, "MENU_UNSTUCK")
	else
		len += formatex(menu[len], 512 - len, "\d[8] - %L^n^n", id, "MENU_UNSTUCK")
	
	// 9. Admin menu
	if (userflags & g_access_flag[ACCESS_ADMIN_MENU])
		len += formatex(menu[len], 512 - len, "\y[9] - \w%L", id, "MENU_ADMIN")
	else
		len += formatex(menu[len], 512 - len, "\d[9] - %L", id, "MENU_ADMIN")
	
	// 0. Exit
	len += formatex(menu[len], 512 - len, "^n^n\y[0] - \w%L", id, "MENU_EXIT")
	
	// Fix for AMXX custom menus
	if (pev_valid(id) == PDATA_SAFE)
		set_pdata_int(id, OFFSET_CSMENUCODE, 0, OFFSET_LINUX)
	
	show_menu(id, KEYSMENU, menu, -1, "Game Menu")
}

// Game Menu
show_menu_classes(id)
{
	// Player disconnected?
	if (!g_isconnected[id])
		return;
	
	static menu[512]
	new len
	
	// Title
	len += formatex(menu[len], 512 - len, "\r%L^n^n", id, "MENU_CLASSES")
	
	// 1. Zombie class
	if (get_pcvar_num(cvar_zclasses))
		len += formatex(menu[len], 512 - len, "\y[1] - \w%L^n", id, "MENU_ZCLASS")
	else
		len += formatex(menu[len], 512 - len, "\d[1] - %L^n", id, "MENU_ZCLASS")
	
	// 2. Human class
	if (get_pcvar_num(cvar_hclasses))
		len += formatex(menu[len], 512 - len, "\y[2] - \w%L^n", id, "MENU_HCLASS")
	else
		len += formatex(menu[len], 512 - len, "\d[2] - %L^n", id, "MENU_HCLASS")
	
	// 0. Exit
	len += formatex(menu[len], 512 - len, "^n^n\y[0] - \w%L", id, "MENU_EXIT")
	
	// Fix for AMXX custom menus
	if (pev_valid(id) == PDATA_SAFE)
		set_pdata_int(id, OFFSET_CSMENUCODE, 0, OFFSET_LINUX)
	
	show_menu(id, KEYSMENU, menu, -1, "Classes Menu")
}

// Buy Menu 1
public show_menu_buy1(taskid)
{
	// Get player's id
	new id = (taskid > g_maxplayers) ? ID_SPAWN : taskid;
	
	// Player dead?
	if (!g_isalive[id])
		return;
	
	// Zombies or survivors get no guns
	if (g_zombie[id] || g_survivor[id] || g_sniper[id])
		return;
	
	// Bots pick their weapons randomly / Random weapons setting enabled
	if (get_pcvar_num(cvar_randweapons) || g_isbot[id])
	{
		buy_primary_weapon(id, random_num(0, ArraySize(g_primary_items) - 1))
		menu_buy2(id, random_num(0, ArraySize(g_secondary_items) - 1))
		return;
	}
	
	// Automatic selection enabled for player and menu called on spawn event
	if (WPN_AUTO_ON && taskid > g_maxplayers)
	{
		buy_primary_weapon(id, WPN_AUTO_PRI)
		menu_buy2(id, WPN_AUTO_SEC)
		return;
	}
	
	static menu[512]
	new len, weap, maxloops = min(WPN_STARTID+7, WPN_MAXIDS)
	
	// Title
	len += formatex(menu[len], 512 - len, "\r%L \y[\w%d\y-\w%d\y]^n^n", id, "MENU_BUY1_TITLE", WPN_STARTID+1, min(WPN_STARTID+7, WPN_MAXIDS))
	
	// 1-7. Weapon List
	for (weap = WPN_STARTID; weap < maxloops; weap++)
		len += formatex(menu[len], 512 - len, "\y[%d] - \w%s^n", weap-WPN_STARTID+1, WEAPONNAMES[ArrayGetCell(g_primary_weaponids, weap)])
	
	// 8. Auto Select
	len += formatex(menu[len], 512 - len, "^n\y[8] - \w%L \y[\w%L\y]", id, "MENU_AUTOSELECT", id, (WPN_AUTO_ON) ? "MOTD_ENABLED" : "MOTD_DISABLED")
	
	// 0. Exit
	len += formatex(menu[len], 512 - len, "^n\y[0] - \w%L^n^n\w%L: ^n^n\y- %L^n- %L^n- %L", id, "MENU_EXIT", id, "INFO_BUY", id, "INFO_BUY_PRIMARY", id, "INFO_BUY_INFORMATION", id, "INFO_BUY_INFORMATION2")
	
	// Fix for AMXX custom menus
	if (pev_valid(id) == PDATA_SAFE)
		set_pdata_int(id, OFFSET_CSMENUCODE, 0, OFFSET_LINUX)
	
	show_menu(id, KEYSMENU, menu, -1, "Buy Menu 1")
}

// Buy Menu 2
show_menu_buy2(id)
{
	// Player dead?
	if (!g_isalive[id])
		return;
	
	static menu[512]
	new len, weap, maxloops = ArraySize(g_secondary_items)
	
	// Title
	len += formatex(menu[len], 512 - len, "\r%L^n", id, "MENU_BUY2_TITLE")
	
	// 1-6. Weapon List
	for (weap = 0; weap < maxloops; weap++)
		len += formatex(menu[len], 512 - len, "^n\y[%d] - \w%s", weap+1, WEAPONNAMES[ArrayGetCell(g_secondary_weaponids, weap)])
	
	// 8. Auto Select
	len += formatex(menu[len], 512 - len, "^n^n\y[8] - \w%L \y[\w%L\y]", id, "MENU_AUTOSELECT", id, (WPN_AUTO_ON) ? "MOTD_ENABLED" : "MOTD_DISABLED")
	
	// 0. Exit
	len += formatex(menu[len], 512 - len, "^n\y[0] - \w%L^n^n\w%L: ^n^n\y- %L^n- %L^n- %L", id, "MENU_EXIT", id, "INFO_BUY", id, "INFO_BUY_SECONDARY", id, "INFO_BUY_INFORMATION", id, "INFO_BUY_INFORMATION2")
	
	// Fix for AMXX custom menus
	if (pev_valid(id) == PDATA_SAFE)
		set_pdata_int(id, OFFSET_CSMENUCODE, 0, OFFSET_LINUX)
	
	show_menu(id, KEYSMENU, menu, -1, "Buy Menu 2")
}

// Extra Items Menu
public show_menu_extras(id)
{
	// Player dead?
	if (!g_isalive[id])
		return;
	
	static menu[512], buffer[32]
	new menuid, item, team
	
	// Title
	formatex(menu, 127, "\r%L\y [\w%L\y]\w", id, "MENU_EXTRA_TITLE", id, g_zombie[id] ? g_nemesis[id] ? "CLASS_NEMESIS" : g_assassin[id] ? "CLASS_ASSASSIN" : "CLASS_ZOMBIE" : g_survivor[id] ? "CLASS_SURVIVOR" : g_sniper[id] ? "CLASS_SNIPER" : "CLASS_HUMAN")
	menuid = menu_create(menu, "menu_extras")
	
	// Item List
	for (item = 0; item < g_extraitem_i; item++)
	{
		// Retrieve item's team
		team = ArrayGetCell(g_extraitem_team, item)
		
		// Item not available to player's team/class
		if ((g_zombie[id] && !g_nemesis[id] && !g_assassin[id] && !(team & ZP_TEAM_ZOMBIE)) || (!g_zombie[id] && !g_survivor[id] && !g_sniper[id] && !(team & ZP_TEAM_HUMAN)) || (g_nemesis[id] && !(team & ZP_TEAM_NEMESIS)) || (g_assassin[id] && !(team & ZP_TEAM_ASSASSIN)) || (g_survivor[id] && !(team & ZP_TEAM_SURVIVOR)) || (g_sniper[id] && !(team & ZP_TEAM_SNIPER)))
			continue;
		
		// Check if it's one of the hardcoded items, check availability, set translated caption
		switch (item)
		{
			case EXTRA_NVISION:
			{
				if (!get_pcvar_num(cvar_extranvision)) continue;
				formatex(buffer, 31, "%L", id, "MENU_EXTRA1")
			}
			case EXTRA_ANTIDOTE:
			{
				if (!get_pcvar_num(cvar_extraantidote) || g_antidotecounter >= get_pcvar_num(cvar_antidotelimit)) continue;
				formatex(buffer, 31, "%L", id, "MENU_EXTRA2")
			}
			case EXTRA_MADNESS:
			{
				if (!get_pcvar_num(cvar_extramadness) || g_madnesscounter >= get_pcvar_num(cvar_madnesslimit)) continue;
				formatex(buffer, 31, "%L", id, "MENU_EXTRA3")
			}
			case EXTRA_INFBOMB:
			{
				if (!get_pcvar_num(cvar_extrainfbomb) || g_infbombcounter >= get_pcvar_num(cvar_infbomblimit)) continue;
				formatex(buffer, 31, "%L", id, "MENU_EXTRA4")
			}
			default:
			{
				if (item >= EXTRA_WEAPONS_STARTID && item < EXTRAS_CUSTOM_STARTID && !get_pcvar_num(cvar_extraweapons)) continue;
				ArrayGetString(g_extraitem_name, item, buffer, 31)
			}
		}
		
		// Add Item Name and Cost
//		formatex(menu, charsmax(menu), "%s \y%d %L", buffer, ArrayGetCell(g_extraitem_cost, item), id, "AMMO_PACKS2")
		formatex(menu, 127, "\y%s \w(\r$%d\w)", buffer, ArrayGetCell(g_extraitem_cost, item))
		buffer[0] = item
		buffer[1] = 0
		menu_additem(menuid, menu, buffer)
	}
	
	// No items to display?
	if (menu_items(menuid) <= 0)
	{
		zp_colored_print(id, "^3%L", id, "CMD_NOT_EXTRAS")
		menu_destroy(menuid)
		return;
	}
	
	// Back - Next - Exit
	formatex(menu, 127, "%L", id, "MENU_BACK")
	menu_setprop(menuid, MPROP_BACKNAME, menu)
	formatex(menu, 127, "%L", id, "MENU_NEXT")
	menu_setprop(menuid, MPROP_NEXTNAME, menu)
	formatex(menu, 127, "%L", id, "MENU_EXIT")
	menu_setprop(menuid, MPROP_EXITNAME, menu)
		
	// If remembered page is greater than number of pages, clamp down the value
	MENU_PAGE_EXTRAS = min(MENU_PAGE_EXTRAS, menu_pages(menuid)-1)
	
	// Fix for AMXX custom menus
	if (pev_valid(id) == PDATA_SAFE)
		set_pdata_int(id, OFFSET_CSMENUCODE, 0, OFFSET_LINUX)
	
	menu_display(id, menuid, MENU_PAGE_EXTRAS)
}

// Zombie Class Menu
/*public */show_menu_zclass(id)
{
	// Player disconnected
	if (!g_isconnected[id])
		return;
	
	// Bots pick their zombie class randomly
	if (g_isbot[id])
	{
		g_zombieclassnext[id] = random_num(0, g_zclass_i - 1)
		return;
	}
	
	static menu[512], buffer[32], buffer2[32]
	new menuid, class
	
	// Title
	formatex(menu, 127, "\r%L\w", id, "MENU_ZCLASS_TITLE")
	menuid = menu_create(menu, "menu_zclass")
	
	// Class List
	for (class = 0; class < g_zclass_i; class++)
	{
		// Retrieve name and info
		ArrayGetString(g_zclass_name, class, buffer, 31)
		ArrayGetString(g_zclass_info, class, buffer2, 31)
		
		// Add to menu
		if (class == g_zombieclassnext[id])
			formatex(menu, 127, "\d%s %s", buffer, buffer2)
		else
			formatex(menu, 127, "\y%s \r%s", buffer, buffer2)
		
		buffer[0] = class
		buffer[1] = 0
		menu_additem(menuid, menu, buffer)
	}
	
	// Back - Next - Exit
	formatex(menu, 127, "%L", id, "MENU_BACK")
	menu_setprop(menuid, MPROP_BACKNAME, menu)
	formatex(menu, 127, "%L", id, "MENU_NEXT")
	menu_setprop(menuid, MPROP_NEXTNAME, menu)
	formatex(menu, 127, "%L", id, "MENU_EXIT")
	menu_setprop(menuid, MPROP_EXITNAME, menu)
	
	// If remembered page is greater than number of pages, clamp down the value
	MENU_PAGE_ZCLASS = min(MENU_PAGE_ZCLASS, menu_pages(menuid)-1)
	
	// Fix for AMXX custom menus
	if (pev_valid(id) == PDATA_SAFE)
		set_pdata_int(id, OFFSET_CSMENUCODE, 0, OFFSET_LINUX)
	
	menu_display(id, menuid, MENU_PAGE_ZCLASS)
}

// Human Class Menu
/*public */show_menu_hclass(id)
{
	// Player disconnected
	if (!g_isconnected[id])
		return;
	
	// Bots pick their human class randomly
	if (g_isbot[id])
	{
		g_humanclassnext[id] = random_num(0, g_hclass_i - 1)
		return;
	}
	
	static menu[512], buffer[32], buffer2[32]
	new menuid, class
	
	// Title
	formatex(menu, 127, "\r%L\w", id, "MENU_HCLASS_TITLE")
	menuid = menu_create(menu, "menu_hclass")
	
	// Class List
	for (class = 0; class < g_hclass_i; class++)
	{
		// Retrieve name and info
		ArrayGetString(g_hclass_name, class, buffer, 31)
		ArrayGetString(g_hclass_info, class, buffer2, 31)
		
		// Add to menu
		if (class == g_humanclassnext[id])
			formatex(menu, 127, "\d%s %s", buffer, buffer2)
		else
			formatex(menu, 127, "\y%s \r%s", buffer, buffer2)
		
		buffer[0] = class
		buffer[1] = 0
		menu_additem(menuid, menu, buffer)
	}
	
	// Back - Next - Exit
	formatex(menu, 127, "%L", id, "MENU_BACK")
	menu_setprop(menuid, MPROP_BACKNAME, menu)
	formatex(menu, 127, "%L", id, "MENU_NEXT")
	menu_setprop(menuid, MPROP_NEXTNAME, menu)
	formatex(menu, 127, "%L", id, "MENU_EXIT")
	menu_setprop(menuid, MPROP_EXITNAME, menu)
	
	// If remembered page is greater than number of pages, clamp down the value
	MENU_PAGE_HCLASS = min(MENU_PAGE_HCLASS, menu_pages(menuid)-1)
	
	// Fix for AMXX custom menus
	if (pev_valid(id) == PDATA_SAFE)
		set_pdata_int(id, OFFSET_CSMENUCODE, 0, OFFSET_LINUX)
	
	menu_display(id, menuid, MENU_PAGE_HCLASS)
}

// Admin Menu
show_menu_admin(id)
{
	// Player disconnected?
	if (!g_isconnected[id])
		return;
	
	static menu[512]
	new len, userflags = get_user_flags(id)
	
	// Title
	len += formatex(menu[len], 512 - len, "\r%L^n^n", id, "MENU_ADMIN_TITLE")
	
	// 1. Zombiefy/Humanize command
	if (userflags & (g_access_flag[ACCESS_MODE_INFECTION] | g_access_flag[ACCESS_MAKE_ZOMBIE] | g_access_flag[ACCESS_MAKE_HUMAN]))
		len += formatex(menu[len], 512 - len, "\y[1] - \w%L^n", id, "MENU_ADMIN1")
	else
		len += formatex(menu[len], 512 - len, "\d[1] - %L^n", id, "MENU_ADMIN1")
	
	// 2. Nemesis command
	if (userflags & (g_access_flag[ACCESS_MODE_NEMESIS] | g_access_flag[ACCESS_MAKE_NEMESIS]))
		len += formatex(menu[len], 512 - len, "\y[2] - \w%L^n", id, "MENU_ADMIN2")
	else
		len += formatex(menu[len], 512 - len, "\d[2] - %L^n", id, "MENU_ADMIN2")
	
	// 3. Survivor command
	if (userflags & (g_access_flag[ACCESS_MODE_SURVIVOR] | g_access_flag[ACCESS_MAKE_SURVIVOR]))
		len += formatex(menu[len], 512 - len, "\y[3] - \w%L^n", id, "MENU_ADMIN3")
	else
		len += formatex(menu[len], 512 - len, "\d[3] - %L^n", id, "MENU_ADMIN3")
	
	// 4. Respawn command
	if (userflags & g_access_flag[ACCESS_RESPAWN_PLAYERS])
		len += formatex(menu[len], 512 - len, "\y[4] - \w%L^n", id, "MENU_ADMIN4")
	else
		len += formatex(menu[len], 512 - len, "\d[4] - %L^n", id, "MENU_ADMIN4")
	
	// 5. Swarm mode command
	if ((userflags & g_access_flag[ACCESS_MODE_SWARM]) && allowed_swarm())
		len += formatex(menu[len], 512 - len, "\y[5] - \w%L^n", id, "MENU_ADMIN5")
	else
		len += formatex(menu[len], 512 - len, "\d[5] - %L^n", id, "MENU_ADMIN5")
	
	// 6. Multi infection command
	if ((userflags & g_access_flag[ACCESS_MODE_MULTI]) && allowed_multi())
		len += formatex(menu[len], 512 - len, "\y[6] - \w%L^n", id, "MENU_ADMIN6")
	else
		len += formatex(menu[len], 512 - len, "\d[6] - %L^n", id, "MENU_ADMIN6")
	
	// 7. Plague mode command
	if ((userflags & g_access_flag[ACCESS_MODE_PLAGUE]) && allowed_plague())
		len += formatex(menu[len], 512 - len, "\y[7] - \w%L^n", id, "MENU_ADMIN7")
	else
		len += formatex(menu[len], 512 - len, "\d[7] - %L^n", id, "MENU_ADMIN7")
	
	// 8. Sniper command
	if (userflags & (g_access_flag[ACCESS_MODE_SNIPER] | g_access_flag[ACCESS_MAKE_SNIPER]))
		len += formatex(menu[len], 512 - len, "\y[8] - \w%L^n", id, "MENU_ADMIN8")
	else
		len += formatex(menu[len], 512 - len, "\d[8] - %L^n", id, "MENU_ADMIN8")
	
	// 9. Assassin command
	if (userflags & (g_access_flag[ACCESS_MODE_ASSASSIN] | g_access_flag[ACCESS_MAKE_ASSASSIN]))
		len += formatex(menu[len], 512 - len, "\y[9] - \w%L^n", id, "MENU_ADMIN9")
	else
		len += formatex(menu[len], 512 - len, "\d[9] - %L^n", id, "MENU_ADMIN9")
	
	// 0. Exit
	len += formatex(menu[len], 512 - len, "^n\y[0] - \w%L", id, "MENU_EXIT")
	
	// Fix for AMXX custom menus
	if (pev_valid(id) == PDATA_SAFE)
		set_pdata_int(id, OFFSET_CSMENUCODE, 0, OFFSET_LINUX)
	
	show_menu(id, KEYSMENU, menu, -1, "Admin Menu")
}

// Player List Menu
show_menu_player_list(id)
{
	// Player disconnected?
	if (!g_isconnected[id])
		return;
	
	static menu[512]
	new buffer[2], menuid, player, userflags = get_user_flags(id)
	
	// Title
	switch (PL_ACTION)
	{
		case ACTION_ZOMBIEFY_HUMANIZE: formatex(menu, charsmax(menu), "%L\r", id, "MENU_ADMIN1")
		case ACTION_MAKE_NEMESIS: formatex(menu, charsmax(menu), "%L\r", id, "MENU_ADMIN2")
		case ACTION_MAKE_SURVIVOR: formatex(menu, charsmax(menu), "%L\r", id, "MENU_ADMIN3")
		case ACTION_RESPAWN_PLAYER: formatex(menu, charsmax(menu), "%L\r", id, "MENU_ADMIN4")
		case ACTION_MAKE_SNIPER: formatex(menu, charsmax(menu), "%L\r", id, "MENU_ADMIN8")
		case ACTION_MAKE_ASSASSIN: formatex(menu, charsmax(menu), "%L\r", id, "MENU_ADMIN9")
	}
	menuid = menu_create(menu, "menu_player_list")
	
	// Player List
	for (player = 0; player <= g_maxplayers; player++)
	{
		// Skip if not connected
		if (!g_isconnected[player])
			continue;
		
		// Format text depending on the action to take
		switch (PL_ACTION)
		{
			case ACTION_ZOMBIEFY_HUMANIZE: // Zombiefy/Humanize command
			{
				if (g_zombie[player])
				{
					if (allowed_human(player) && (userflags & g_access_flag[ACCESS_MAKE_HUMAN]))
						formatex(menu, charsmax(menu), "%s \r[%L]", g_playername[player], id, g_nemesis[player] ? "CLASS_NEMESIS" : g_assassin[player] ? "CLASS_ASSASSIN" : "CLASS_ZOMBIE")
					else
						formatex(menu, charsmax(menu), "\d%s [%L]", g_playername[player], id, g_nemesis[player] ? "CLASS_NEMESIS" : g_assassin[player] ? "CLASS_ASSASSIN" : "CLASS_ZOMBIE")
				}
				else
				{
					if (allowed_zombie(player) && (g_newround ? (userflags & g_access_flag[ACCESS_MODE_INFECTION]) : (userflags & g_access_flag[ACCESS_MAKE_ZOMBIE])))
						formatex(menu, charsmax(menu), "%s \y[%L]", g_playername[player], id, g_survivor[player] ? "CLASS_SURVIVOR" : g_sniper[player] ? "CLASS_SNIPER" : "CLASS_HUMAN")
					else
						formatex(menu, charsmax(menu), "\d%s [%L]", g_playername[player], id, g_survivor[player] ? "CLASS_SURVIVOR" : g_sniper[player] ? "CLASS_SNIPER" : "CLASS_HUMAN")
				}
			}
			case ACTION_MAKE_NEMESIS: // Nemesis command
			{
				if (allowed_nemesis(player) && (g_newround ? (userflags & g_access_flag[ACCESS_MODE_NEMESIS]) : (userflags & g_access_flag[ACCESS_MAKE_NEMESIS])))
				{
					if (g_zombie[player])
						formatex(menu, charsmax(menu), "%s \r[%L]", g_playername[player], id, g_nemesis[player] ? "CLASS_NEMESIS" : g_assassin[player] ? "CLASS_ASSASSIN" : "CLASS_ZOMBIE")
					else
						formatex(menu, charsmax(menu), "%s \y[%L]", g_playername[player], id, g_survivor[player] ? "CLASS_SURVIVOR" : g_sniper[player] ? "CLASS_SNIPER" : "CLASS_HUMAN")
				}
				else
					formatex(menu, charsmax(menu), "\d%s [%L]", g_playername[player], id, g_zombie[player] ? g_nemesis[player] ? "CLASS_NEMESIS" : g_assassin[player] ? "CLASS_ASSASSIN" : "CLASS_ZOMBIE" : g_survivor[player] ? "CLASS_SURVIVOR" : g_sniper[player] ? "CLASS_SNIPER" : "CLASS_HUMAN")
			}
			case ACTION_MAKE_SURVIVOR: // Survivor command
			{
				if (allowed_survivor(player) && (g_newround ? (userflags & g_access_flag[ACCESS_MODE_SURVIVOR]) : (userflags & g_access_flag[ACCESS_MAKE_SURVIVOR])))
				{
					if (g_zombie[player])
						formatex(menu, charsmax(menu), "%s \r[%L]", g_playername[player], id, g_nemesis[player] ? "CLASS_NEMESIS" : g_assassin[player] ? "CLASS_ASSASSIN" : "CLASS_ZOMBIE")
					else
						formatex(menu, charsmax(menu), "%s \y[%L]", g_playername[player], id, g_survivor[player] ? "CLASS_SURVIVOR" : g_sniper[player] ? "CLASS_SNIPER" : "CLASS_HUMAN")
				}
				else
					formatex(menu, charsmax(menu), "\d%s [%L]", g_playername[player], id, g_zombie[player] ? g_nemesis[player] ? "CLASS_NEMESIS" : g_assassin[player] ? "CLASS_ASSASSIN" : "CLASS_ZOMBIE" : g_survivor[player] ? "CLASS_SURVIVOR" : g_sniper[player] ? "CLASS_SNIPER" : "CLASS_HUMAN")
			}
			case ACTION_RESPAWN_PLAYER: // Respawn command
			{
				if (allowed_respawn(player) && (userflags & g_access_flag[ACCESS_RESPAWN_PLAYERS]))
					formatex(menu, charsmax(menu), "%s", g_playername[player])
				else
					formatex(menu, charsmax(menu), "\d%s", g_playername[player])
			}
			case ACTION_MAKE_SNIPER: // Sniper command
			{
				if (allowed_sniper(player) && (g_newround ? (userflags & g_access_flag[ACCESS_MODE_SNIPER]) : (userflags & g_access_flag[ACCESS_MAKE_SNIPER])))
				{
					if (g_zombie[player])
						formatex(menu, charsmax(menu), "%s \r[%L]", g_playername[player], id, g_nemesis[player] ? "CLASS_NEMESIS" : g_assassin[player] ? "CLASS_ASSASSIN" : "CLASS_ZOMBIE")
					else
						formatex(menu, charsmax(menu), "%s \y[%L]", g_playername[player], id, g_survivor[player] ? "CLASS_SURVIVOR" : g_sniper[player] ? "CLASS_SNIPER" : "CLASS_HUMAN")
				}
				else
					formatex(menu, charsmax(menu), "\d%s [%L]", g_playername[player], id, g_zombie[player] ? g_nemesis[player] ? "CLASS_NEMESIS" : g_assassin[player] ? "CLASS_ASSASSIN" : "CLASS_ZOMBIE" : g_survivor[player] ? "CLASS_SURVIVOR" : g_sniper[player] ? "CLASS_SNIPER" : "CLASS_HUMAN")
			}
			case ACTION_MAKE_ASSASSIN: // Assassin command
			{
				if (allowed_assassin(player) && (g_newround ? (userflags & g_access_flag[ACCESS_MODE_ASSASSIN]) : (userflags & g_access_flag[ACCESS_MAKE_ASSASSIN])))
				{
					if (g_zombie[player])
						formatex(menu, charsmax(menu), "%s \r[%L]", g_playername[player], id, g_nemesis[player] ? "CLASS_NEMESIS" : g_assassin[player] ? "CLASS_ASSASSIN" : "CLASS_ZOMBIE")
					else
						formatex(menu, charsmax(menu), "%s \y[%L]", g_playername[player], id, g_survivor[player] ? "CLASS_SURVIVOR" : g_sniper[player] ? "CLASS_SNIPER" : "CLASS_HUMAN")
				}
				else
					formatex(menu, charsmax(menu), "\d%s [%L]", g_playername[player], id, g_zombie[player] ? g_nemesis[player] ? "CLASS_NEMESIS" : g_assassin[player] ? "CLASS_ASSASSIN" : "CLASS_ZOMBIE" : g_survivor[player] ? "CLASS_SURVIVOR" : g_sniper[player] ? "CLASS_SNIPER" : "CLASS_HUMAN")
			}
		}
		
		// Add player
		buffer[0] = player
		buffer[1] = 0
		menu_additem(menuid, menu, buffer)
	}
	
	// Back - Next - Exit
	formatex(menu, charsmax(menu), "%L", id, "MENU_BACK")
	menu_setprop(menuid, MPROP_BACKNAME, menu)
	formatex(menu, charsmax(menu), "%L", id, "MENU_NEXT")
	menu_setprop(menuid, MPROP_NEXTNAME, menu)
	formatex(menu, charsmax(menu), "%L", id, "MENU_EXIT")
	menu_setprop(menuid, MPROP_EXITNAME, menu)
	
	// If remembered page is greater than number of pages, clamp down the value
	MENU_PAGE_PLAYERS = min(MENU_PAGE_PLAYERS, menu_pages(menuid)-1)
	
	// Fix for AMXX custom menus
	if (pev_valid(id) == PDATA_SAFE)
		set_pdata_int(id, OFFSET_CSMENUCODE, 0, OFFSET_LINUX)
	
	menu_display(id, menuid, MENU_PAGE_PLAYERS)
}

/*================================================================================
 [Menu Handlers]
=================================================================================*/

// Game Menu
public menu_game(id, key)
{
	// Player disconnected?
	if (!g_isconnected[id])
		return PLUGIN_HANDLED;
	
	switch (key)
	{
		case 0: // Buy Weapons
		{
			if(g_zombie[id])
			ChatColor(id, "%L", id, "MENU_WEAPON")
			// Custom buy menus enabled?
			if (get_pcvar_num(cvar_buycustom) && !g_zombie[id])
				// Disable the remember selection setting
				WPN_AUTO_ON = 0
					
			// Show menu if player hasn't yet bought anything
			if (g_canbuy[id]) show_menu_buy1(id)
		}
		case 1: // Extra Items
		{
			// Extra items enabled?
			ChatColor(id, "%L", id, "MENU_EXTRAITEM")
			if (get_pcvar_num(cvar_extraitems))
				// Check whether the player is able to buy anything
				if (g_isalive[id])
					show_menu_extras(id)
				else
					zp_colored_print(id, "^3%L", id, "CMD_NOT")
		}
		case 2: // Weapon Items
		{
			// Extra items enabled?
			if(!g_zombie[id])
			{
				ChatColor(id, "%L", id, "MENU_EXTRAWEAPON")
			}
			if (get_pcvar_num(cvar_extraitems))
			{
				// Check whether the player is able to buy anything
				if (g_isalive[id] && !g_zombie[id])
					OpenWeaponMenu(id)
				else
					ChatColor(id, "%L", id, "MENU_NOTZMBRO")
			}
			else
				zp_colored_print(id, "^3%L", id, "CMD_NOT_EXTRAS")
		}
		case 3: // Zombie Classes
		{
			// Zombie classes enabled?
			ChatColor(id, "%L", id, "MENU_CLASSES_HI")
			if (get_pcvar_num(cvar_zclasses) || get_pcvar_num(cvar_hclasses))
				show_menu_classes(id)
			else
				zp_colored_print(id, "^3%L", id, "CMD_NOT")
		}
		case 4: // Menu
		{
			ChatColor(id, "%L", id, "MENU_ZPCENTER_HI")
			client_cmd(id, "say /zpcentr")
		}
		case 5: // Menu Emotion
		{
			if(g_zombie[id])
			{
				ChatColor(id, "%L", id, "MENU_NOT_ZM_EMOTION")
			}
			client_cmd(id, "emotion")
		}
		case 6: // Join Spectator
		{
			// Player alive?
			if (g_isalive[id])
			{
				ChatColor(id, "%L", id, "MENU_SPECTATOR_HI")
				// Prevent abuse by non-admins if block suicide setting is enabled
				if (cvar_blocksuicide && !(get_user_flags(id) & g_access_flag[ACCESS_ADMIN_MENU]))
				{
					zp_colored_print(id, "^3%L", id, "CMD_NOT")
					return PLUGIN_HANDLED;
				}
				
				// Check that we still have both humans and zombies to keep the round going
				check_round(id)
				
				// Kill him before he switches team
				dllfunc(DLLFunc_ClientKill, id)
			}
			
			// Temporarily save player stats?
			if (get_pcvar_num(cvar_statssave)) save_stats(id)
			
			// Remove previous tasks
			remove_task(id+TASK_TEAM)
			remove_task(id+TASK_MODEL)
			remove_task(id+TASK_FLASH)
			remove_task(id+TASK_CHARGE)
			remove_task(id+TASK_SPAWN)
			remove_task(id+TASK_BLOOD)
			remove_task(id+TASK_AURA)
			remove_task(id+TASK_BURN)
			
			// Then move him to the spectator team
			fm_cs_set_user_team(id, FM_CS_TEAM_SPECTATOR)
			fm_user_team_update(id)
		}
		case 7: // Unstuck
		{
			// Check if player is stuck
			if (g_isalive[id])
			{
				new unstuck = get_pcvar_num(cvar_unstuck)
				
				if (!unstuck || !g_zombie[id] && unstuck == 2 || g_zombie[id] && unstuck < 2)
				{
					zp_colored_print(id, "^3%L", id, "CMD_NOT")
					
					return PLUGIN_HANDLED;
				}
				
				if (is_player_stuck(id))
				{
					// Move to an initial spawn
					if (get_pcvar_num(cvar_randspawn))
						do_random_spawn(id) // random spawn (including CSDM)
					else
						do_random_spawn(id, 1) // regular spawn
				}
				else
					zp_colored_print(id, "^3%L", id, "CMD_NOT_STUCK")
			}
			else
				zp_colored_print(id, "^3%L", id, "CMD_NOT")
		}
		case 8: // Admin Menu
		{
			// Check if player has the required access
			if (get_user_flags(id) & g_access_flag[ACCESS_ADMIN_MENU])
				show_menu_admin(id)
			else
				zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
		}
	}
	
	return PLUGIN_HANDLED;
}

// Buy Menu 1
public menu_buy1(id, key)
{
	// Player dead?
	if (!g_isalive[id])
		return PLUGIN_HANDLED;
	
	// Zombies or survivors get no guns
	if (g_zombie[id] || g_survivor[id] || g_sniper[id])
		return PLUGIN_HANDLED;
	
	// Special keys / weapon list exceeded
	if (key >= MENU_KEY_AUTOSELECT || WPN_SELECTION >= WPN_MAXIDS)
	{
		switch (key)
		{
			case MENU_KEY_AUTOSELECT: // toggle auto select
			{
				WPN_AUTO_ON = 1 - WPN_AUTO_ON
			}
			case MENU_KEY_NEXT: // next/back
			{
				if (WPN_STARTID+7 < WPN_MAXIDS)
					WPN_STARTID += 7
				else
					WPN_STARTID = 0
			}
			case MENU_KEY_EXIT: // exit
			{
				return PLUGIN_HANDLED;
			}
		}
		
		// Show buy menu again
		show_menu_buy1(id)
		return PLUGIN_HANDLED;
	}
	
	// Store selected weapon id
	WPN_AUTO_PRI = WPN_SELECTION
	
	// Buy primary weapon
	buy_primary_weapon(id, WPN_AUTO_PRI)
	
	// Show pistols menu
	show_menu_buy2(id)
	
	return PLUGIN_HANDLED;
}

// Buy Primary Weapon
buy_primary_weapon(id, selection)
{
	// Drop previous weapons
	drop_weapons(id, 1)
	drop_weapons(id, 2)
	
	// Strip off from weapons
	fm_strip_user_weapons(id)
	fm_give_item(id, "weapon_knife")
	
	// Get weapon's id and name
	static wname[32]
	new weaponid = ArrayGetCell(g_primary_weaponids, selection)
	ArrayGetString(g_primary_items, selection, wname, 31)
	
	// Give the new weapon and full ammo
	fm_give_item(id, wname)
	ExecuteHamB(Ham_GiveAmmo, id, MAXBPAMMO[weaponid], AMMOTYPE[weaponid], MAXBPAMMO[weaponid])
	
	// Weapons bought
	g_canbuy[id] = false
	
	// Give additional items
	for (new i = 0; i < ArraySize(g_additional_items); i++)
	{
		ArrayGetString(g_additional_items, i, wname, 31)
		fm_give_item(id, wname)
	}
	
	ExecuteForward(g_fwUserGetWeapons, g_fwDummyResult, id, 1, wname);
}

// Buy Menu 2
public menu_buy2(id, key)
{
	// Player dead?
	if (!g_isalive[id])
		return PLUGIN_HANDLED;
	
	// Zombies or survivors get no guns
	if (g_zombie[id] || g_survivor[id] || g_sniper[id])
		return PLUGIN_HANDLED;
	
	// Special keys / weapon list exceeded
	if (key >= ArraySize(g_secondary_items))
	{
		// Toggle autoselect
		if (key == MENU_KEY_AUTOSELECT)
			WPN_AUTO_ON = 1 - WPN_AUTO_ON
		
		// Reshow menu unless user exited
		if (key != MENU_KEY_EXIT)
			show_menu_buy2(id)
		
		return PLUGIN_HANDLED;
	}
	
	// Store selected weapon
	WPN_AUTO_SEC = key
	
	// Drop secondary gun again, in case we picked another (bugfix)
	drop_weapons(id, 2)
	
	// Get weapon's id
	static wname[32]
	new weaponid = ArrayGetCell(g_secondary_weaponids, key)
	ArrayGetString(g_secondary_items, key, wname, 31)
	
	// Give the new weapon and full ammo
	fm_give_item(id, wname)
	ExecuteHamB(Ham_GiveAmmo, id, MAXBPAMMO[weaponid], AMMOTYPE[weaponid], MAXBPAMMO[weaponid])
	
	ExecuteForward(g_fwUserGetWeapons, g_fwDummyResult, id, 2, wname);
	
	// Show human class menu if they haven't chosen any (e.g. just connected)
	if (get_pcvar_num(cvar_hclasses) && g_humanclassnext[id] == HZCLASS_NONE)
		show_menu_hclass(id) //set_task(0.2, "show_menu_hclass", id)
	else
	{
		client_cmd(id, "knife");
	}
	
	return PLUGIN_HANDLED;
}

// Extra Items Menu
public menu_extras(id, menuid, item)
{
	// Player disconnected?
	if (!is_user_connected(id))
	{
		menu_destroy(menuid)
		return PLUGIN_HANDLED;
	}
	
	// Remember player's menu page
	static menudummy
	player_menu_info(id, menudummy, menudummy, MENU_PAGE_EXTRAS)
	
	// Menu was closed
	if (item == MENU_EXIT)
	{
		menu_destroy(menuid)
		return PLUGIN_HANDLED;
	}
	
	// Dead players are not allowed to buy items
	if (!g_isalive[id])
	{
		zp_colored_print(id, "^3%L", id, "CMD_NOT")
		menu_destroy(menuid)
		return PLUGIN_HANDLED;
	}
	
	// Retrieve extra item id
	new buffer[2], dummy, itemid
	menu_item_getinfo(menuid, item, dummy, buffer, 1, _, _, dummy)
	itemid = buffer[0]
	
	// Attempt to buy the item
	buy_extra_item(id, itemid)
	menu_destroy(menuid)
	return PLUGIN_HANDLED;
}

// Buy Extra Item
buy_extra_item(id, itemid, ignorecost = 0)
{
	new cost = ArrayGetCell(g_extraitem_cost, itemid)
	
	// Item selected forward
	ExecuteForward(g_fwExtraItemBuyAttempt, g_fwDummyResult, id, itemid, ignorecost, cost);
	
	// Item purchase blocked
	if (g_fwDummyResult >= ZP_PLUGIN_HANDLED)
		return;
	
	// Retrieve item's team
	new team = ArrayGetCell(g_extraitem_team, itemid)
	
	// Check for team/class specific items
	if ((g_zombie[id] && !g_nemesis[id] && !g_assassin[id] && !(team & ZP_TEAM_ZOMBIE)) || (!g_zombie[id] && !g_survivor[id] && !g_sniper[id] && !(team & ZP_TEAM_HUMAN)) || (g_nemesis[id] && !(team & ZP_TEAM_NEMESIS)) || (g_assassin[id] && !(team & ZP_TEAM_ASSASSIN)) || (g_survivor[id] && !(team & ZP_TEAM_SURVIVOR)) || (g_sniper[id] && !(team & ZP_TEAM_SNIPER)))
	{
		zp_colored_print(id, "^3%L", id, "CMD_NOT")
		return;
	}
	
	// Check for unavailable items
	if ((itemid == EXTRA_NVISION && !get_pcvar_num(cvar_extranvision))
	|| (itemid == EXTRA_ANTIDOTE && (!get_pcvar_num(cvar_extraantidote) || g_antidotecounter >= get_pcvar_num(cvar_antidotelimit)))
	|| (itemid == EXTRA_MADNESS && (!get_pcvar_num(cvar_extramadness) || g_madnesscounter >= get_pcvar_num(cvar_madnesslimit)))
	|| (itemid == EXTRA_INFBOMB && (!get_pcvar_num(cvar_extrainfbomb) || g_infbombcounter >= get_pcvar_num(cvar_infbomblimit)))
	|| (itemid >= EXTRA_WEAPONS_STARTID && itemid < EXTRAS_CUSTOM_STARTID && !get_pcvar_num(cvar_extraweapons)))
	{
		zp_colored_print(id, "^3%L", id, "CMD_NOT")
		return;
	}
	
	// Check for hard coded items with special conditions
	if ((itemid == EXTRA_ANTIDOTE && (g_endround || g_swarmround || g_nemround || g_assround || g_survround || g_snipround || g_plagueround || fnGetZombies() < 2 || (get_pcvar_num(cvar_deathmatch) && !get_pcvar_num(cvar_respawnafterlast) && fnGetHumans() == 1)))
	|| (itemid == EXTRA_MADNESS && g_nodamage[id]) || (itemid == EXTRA_INFBOMB && (g_endround || g_swarmround || g_nemround || g_assround || g_survround || g_snipround || g_plagueround)))
	{
		zp_colored_print(id, "^3%L", id, "CMD_NOT_CANTUSE")
		return;
	}
	
	// Ignore item's cost?
	if (!ignorecost)
	{
		// Check that we have enough ammo packs
		if (g_ammopacks[id] < cost)
		{
			zp_colored_print(id, "^3%L^1(^3%d^1/^4%d^1)", id, "NOT_ENOUGH_AMMO", g_ammopacks[id], cost)
			return;
		}
		
		// Deduce item cost
		g_ammopacks[id] -= cost
	}
	
	// Check which kind of item we're buying
	switch (itemid)
	{
		case EXTRA_NVISION: // Night Vision
		{
			g_nvision[id] = true
			
			if (!g_isbot[id])
			{
				g_nvisionenabled[id] = true
				
				// Custom nvg?
				if (get_pcvar_num(cvar_customnvg))
				{
					remove_task(id+TASK_NVISION)
					set_task(0.1, "set_user_nvision", id+TASK_NVISION, _, _, "b")
				}
				else
					set_user_gnvision(id, 1)
			}
			else
				cs_set_user_nvg(id, 1)
		}
		case EXTRA_ANTIDOTE: // Antidote
		{
			// Increase antidote purchase count for this round
			g_antidotecounter++
			
			humanme(id, 0, 0)
		}
		case EXTRA_MADNESS: // Zombie Madness
		{
			// Increase madness purchase count for this round
			g_madnesscounter++
			
			g_nodamage[id] = true
			set_task(0.1, "zombie_aura", id+TASK_AURA, _, _, "b")
			set_task(get_pcvar_float(cvar_madnessduration), "madness_over", id+TASK_BLOOD)
			
			static sound[64]
			static pointers[10], end
			ArrayGetArray(pointer_class_sound_madness, g_zombieclass[id], pointers)
			
			for (new i; i < 10; i++)
			{
				if (pointers[i] != -1)
				end = i
			}
			ArrayGetString(class_sound_madness, random_num(pointers[0], pointers[end]), sound, 63)
			emit_sound(id, CHAN_VOICE, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		case EXTRA_INFBOMB: // Infection Bomb
		{
			// Increase infection bomb purchase count for this round
			g_infbombcounter++
			
			// Already own one
			if (user_has_weapon(id, CSW_HEGRENADE))
			{
				// Increase BP ammo on it instead
				cs_set_user_bpammo(id, CSW_HEGRENADE, cs_get_user_bpammo(id, CSW_HEGRENADE) + 1)
				
				// Flash ammo in hud
				message_begin(MSG_ONE_UNRELIABLE, g_msgAmmoPickup, _, id)
				write_byte(AMMOID[CSW_HEGRENADE]) // ammo id
				write_byte(1) // ammo amount
				message_end()
				
				// Play clip purchase sound
				emit_sound(id, CHAN_ITEM, sound_buyammo, 1.0, ATTN_NORM, 0, PITCH_NORM)
			}
			else
				// Give weapon to the player
				fm_give_item(id, "weapon_hegrenade")
		}
		default:
		{
			if (itemid >= EXTRA_WEAPONS_STARTID && itemid < EXTRAS_CUSTOM_STARTID) // Weapons
			{
				// Get weapon's id and name
				static wname[32]
				ArrayGetString(g_extraweapon_items, itemid - EXTRA_WEAPONS_STARTID, wname, 31)
				new weaponid = cs_weapon_name_to_id(wname)
				
				// If we are giving a primary/secondary weapon
				if (MAXBPAMMO[weaponid] > 2)
				{
					// Make user drop the previous one
					if ((1<<weaponid) & PRIMARY_WEAPONS_BIT_SUM)
						drop_weapons(id, 1)
					else
						drop_weapons(id, 2)
					
					// Give weapon to the player
					fm_give_item(id, wname)
					
					// Give full BP ammo for the new one
					ExecuteHamB(Ham_GiveAmmo, id, MAXBPAMMO[weaponid], AMMOTYPE[weaponid], MAXBPAMMO[weaponid])
				}
				// If we are giving a grenade which the user already owns
				else if (user_has_weapon(id, weaponid))
				{
					// Increase BP ammo on it instead
					cs_set_user_bpammo(id, weaponid, cs_get_user_bpammo(id, weaponid) + 1)
					
					// Flash ammo in hud
					message_begin(MSG_ONE_UNRELIABLE, g_msgAmmoPickup, _, id)
					write_byte(AMMOID[weaponid]) // ammo id
					write_byte(1) // ammo amount
					message_end()
					
					// Play clip purchase sound
					emit_sound(id, CHAN_ITEM, sound_buyammo, 1.0, ATTN_NORM, 0, PITCH_NORM)
				}
				else
					// Give weapon to the player
					fm_give_item(id, wname)
			}
/*			else // Custom additions
			{
				// Item selected forward
				ExecuteForward(g_fwExtraItemSelected, g_fwDummyResult, id, itemid, ignorecost, cost);
				
				// Item purchase blocked, restore buyer's ammo packs
				if (g_fwDummyResult >= ZP_PLUGIN_HANDLED && !ignorecost)
					g_ammopacks[id] += cost
			}*/
		}
	}
	
	// Item selected forward
	ExecuteForward(g_fwExtraItemSelected, g_fwDummyResult, id, itemid, ignorecost, cost);
	
	// Item purchase blocked, restore buyer's ammo packs
	if (g_fwDummyResult >= ZP_PLUGIN_HANDLED && !ignorecost)
		g_ammopacks[id] += cost
}

// Classes Menu
public menu_classes(id, key)
{
	// Player disconnected?
	if (!g_isconnected[id])
		return PLUGIN_HANDLED;
	
	switch (key)
	{
		case 0: // Zombie Classes
		{
			// Zombie classes enabled?
			if (get_pcvar_num(cvar_zclasses))
				show_menu_zclass(id)
			else
				zp_colored_print(id, "^3%L", id, "CMD_NOT_ZCLASSES")
		}
		case 1: // Human Classes
		{
			// Human classes enabled?
			if (get_pcvar_num(cvar_hclasses))
				show_menu_hclass(id)
			else
				zp_colored_print(id, "^3%L", id, "CMD_NOT_HCLASSES")
		}
	}
	
	return PLUGIN_HANDLED;
}

// Zombie Class Menu
public menu_zclass(id, menuid, item)
{
	// Player disconnected?
	if (!is_user_connected(id))
	{
		menu_destroy(menuid)
		return PLUGIN_HANDLED;
	}
	
	// Remember player's menu page
	static menudummy
	player_menu_info(id, menudummy, menudummy, MENU_PAGE_ZCLASS)
	
	// Menu was closed
	if (item == MENU_EXIT)
	{
		menu_destroy(menuid)
		return PLUGIN_HANDLED;
	}
	
	// Retrieve zombie class id
	new buffer[2], dummy, classid
	menu_item_getinfo(menuid, item, dummy, buffer, 1, _, _, dummy)
	classid = buffer[0]
	
	// Store selection for the next infection
	g_zombieclassnext[id] = classid
	
	static name[32]
	ArrayGetString(g_zclass_name, g_zombieclassnext[id], name, 31)
	
	// Show selected zombie class info and stats
	zp_colored_print(id, "^4%L^1: ^3%s", id, "ZOMBIE_SELECT", name)
	zp_colored_print(id, "^4%L^1: ^3%d^1 | ^4%L^1: ^3%d^1 | ^4%L^1: ^3%d^1 | ^4%L^1: ^3%d^1%%", id, "ZOMBIE_ATTRIB1", ArrayGetCell(g_zclass_hp, g_zombieclassnext[id]), id, "ZOMBIE_ATTRIB2", ArrayGetCell(g_zclass_spd, g_zombieclassnext[id]),
	id, "ZOMBIE_ATTRIB3", floatround(Float:ArrayGetCell(g_zclass_grav, g_zombieclassnext[id]) * cvar_gravity), id, "ZOMBIE_ATTRIB4", floatround(Float:ArrayGetCell(g_zclass_kb, g_zombieclassnext[id]) * 100.0))
	
	menu_destroy(menuid)
	
	if (get_pcvar_num(cvar_hclasses) && g_humanclassnext[id] == HZCLASS_NONE)
		show_menu_hclass(id) //set_task(0.2, "show_menu_hclass", id)
	
	return PLUGIN_HANDLED;
}

// Human Class Menu
public menu_hclass(id, menuid, item)
{
	// Player disconnected?
	if (!is_user_connected(id))
	{
		menu_destroy(menuid)
		return PLUGIN_HANDLED;
	}
	
	// Remember player's menu page
	static menudummy
	player_menu_info(id, menudummy, menudummy, MENU_PAGE_HCLASS)
	
	// Menu was closed
	if (item == MENU_EXIT)
	{
		menu_destroy(menuid)
		return PLUGIN_HANDLED;
	}
	
	// Retrieve human class id
	new buffer[2], dummy, classid
	menu_item_getinfo(menuid, item, dummy, buffer, 1, _, _, dummy)
	classid = buffer[0]
	
	// Store selection for the next spawn/disinfection
	g_humanclassnext[id] = classid
	
	if(g_humanclassnext[id] == 0)
	{
		show_motd(id , "hclass_david_black.txt")
	}
	if(g_humanclassnext[id] == 1)
	{
		show_motd(id , "hclass_gerrard.txt")
	}
	if(g_humanclassnext[id] == 2)
	{
		show_motd(id , "hclass_spade.txt")
	}
	if(g_humanclassnext[id] == 3)
	{
		show_motd(id , "hclass_dominic.txt")
	}
	if(g_humanclassnext[id] == 4)
	{
		show_motd(id , "hclass_choijiyoon.txt")
	}
	if(g_humanclassnext[id] == 5)
	{
		show_motd(id , "hclass_jennifer.txt")
	}
	if(g_humanclassnext[id] == 6)
	{
		show_motd(id , "hclass_natasha.txt")
	}
	if(g_humanclassnext[id] == 7)
	{
		show_motd(id , "hclass_ritsuka.txt")
	}
	if(g_humanclassnext[id] == 8)
	{
		show_motd(id , "hclass_alice.txt")
	}
			
	static name[32]
	ArrayGetString(g_hclass_name, g_humanclassnext[id], name, 31)
	
	// Show selected human class info and stats
	zp_colored_print(id, "^4%L^1: ^3%s", id, "HUMAN_SELECT", name)
	zp_colored_print(id, "^4%L^1: ^3%d^1 | ^4%L^1: ^3%d^1 | ^4%L^1: ^3%d", id, "ZOMBIE_ATTRIB1", ArrayGetCell(g_hclass_hp, g_humanclassnext[id]), id, "ZOMBIE_ATTRIB2", ArrayGetCell(g_hclass_spd, g_humanclassnext[id]),
	id, "ZOMBIE_ATTRIB3", floatround(Float:ArrayGetCell(g_hclass_grav, g_humanclassnext[id]) * cvar_gravity))
	
	menu_destroy(menuid)
	
	if (get_pcvar_num(cvar_zclasses) && g_zombieclassnext[id] == HZCLASS_NONE)
		show_menu_zclass(id) //set_task(0.2, "show_menu_zclass", id)
	
	return PLUGIN_HANDLED;
}

// Admin Menu
public menu_admin(id, key)
{
	// Player disconnected?
	if (!g_isconnected[id])
		return PLUGIN_HANDLED;
	
	new userflags = get_user_flags(id)
	
	switch (key)
	{
		case ACTION_ZOMBIEFY_HUMANIZE: // Zombiefy/Humanize command
		{
			if (userflags & (g_access_flag[ACCESS_MODE_INFECTION] | g_access_flag[ACCESS_MAKE_ZOMBIE] | g_access_flag[ACCESS_MAKE_HUMAN]))
			{
				// Show player list for admin to pick a target
				PL_ACTION = ACTION_ZOMBIEFY_HUMANIZE
				show_menu_player_list(id)
			}
			else
			{
				zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
				show_menu_admin(id)
			}
		}
		case ACTION_MAKE_NEMESIS: // Nemesis command
		{
			if (userflags & (g_access_flag[ACCESS_MODE_NEMESIS] | g_access_flag[ACCESS_MAKE_NEMESIS]))
			{
				// Show player list for admin to pick a target
				PL_ACTION = ACTION_MAKE_NEMESIS
				show_menu_player_list(id)
			}
			else
			{
				zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
				show_menu_admin(id)
			}
		}
		case ACTION_MAKE_SURVIVOR: // Survivor command
		{
			if (userflags & (g_access_flag[ACCESS_MODE_SURVIVOR] | g_access_flag[ACCESS_MAKE_SURVIVOR]))
			{
				// Show player list for admin to pick a target
				PL_ACTION = ACTION_MAKE_SURVIVOR
				show_menu_player_list(id)
			}
			else
			{
				zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
				show_menu_admin(id)
			}
		}
		case ACTION_RESPAWN_PLAYER: // Respawn command
		{
			if (userflags & g_access_flag[ACCESS_RESPAWN_PLAYERS])
			{
				// Show player list for admin to pick a target
				PL_ACTION = ACTION_RESPAWN_PLAYER
				show_menu_player_list(id)
			}
			else
			{
				zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
				show_menu_admin(id)
			}
		}
		case ACTION_MODE_SWARM: // Swarm Mode command
		{
			if (userflags & g_access_flag[ACCESS_MODE_SWARM])
			{
				if (allowed_swarm())
					command_swarm(id)
				else
					zp_colored_print(id, "^3%L", id, "CMD_NOT")
			}
			else
				zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
			
			show_menu_admin(id)
		}
		case ACTION_MODE_MULTI: // Multiple Infection command
		{
			if (userflags & g_access_flag[ACCESS_MODE_MULTI])
			{
				if (allowed_multi())
					command_multi(id)
				else
					zp_colored_print(id, "^3%L", id, "CMD_NOT")
			}
			else
				zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
			
			show_menu_admin(id)
		}
		case ACTION_MODE_PLAGUE: // Plague Mode command
		{
			if (userflags & g_access_flag[ACCESS_MODE_PLAGUE])
			{
				if (allowed_plague())
					command_plague(id)
				else
					zp_colored_print(id, "^3%L", id, "CMD_NOT")
			}
			else
				zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
			
			show_menu_admin(id)
		}
		case ACTION_MAKE_SNIPER: // Sniper command
		{
			if (userflags & (g_access_flag[ACCESS_MODE_SNIPER] | g_access_flag[ACCESS_MAKE_SNIPER]))
			{
				// Show player list for admin to pick a target
				PL_ACTION = ACTION_MAKE_SNIPER
				show_menu_player_list(id)
			}
			else
			{
				zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
				show_menu_admin(id)
			}
		}
		case ACTION_MAKE_ASSASSIN: // Assassin command
		{
			if (userflags & (g_access_flag[ACCESS_MODE_ASSASSIN] | g_access_flag[ACCESS_MAKE_ASSASSIN]))
			{
				// Show player list for admin to pick a target
				PL_ACTION = ACTION_MAKE_ASSASSIN
				show_menu_player_list(id)
			}
			else
			{
				zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
				show_menu_admin(id)
			}
		}
	}
	
	return PLUGIN_HANDLED;
}

// Player List Menu
public menu_player_list(id, menuid, item)
{
	// Player disconnected?
	if (!is_user_connected(id))
	{
		menu_destroy(menuid)
		return PLUGIN_HANDLED;
	}
	
	// Remember player's menu page
	static menudummy
	player_menu_info(id, menudummy, menudummy, MENU_PAGE_PLAYERS)
	
	// Menu was closed
	if (item == MENU_EXIT)
	{
		menu_destroy(menuid)
		show_menu_admin(id)
		return PLUGIN_HANDLED;
	}
	
	// Retrieve player id
	new buffer[2], dummy, playerid
	menu_item_getinfo(menuid, item, dummy, buffer, 1, _, _, dummy)
	playerid = buffer[0]
	
	// Perform action on player
	
	// Get admin flags
	new userflags = get_user_flags(id)
	
	// Make sure it's still connected
	if (g_isconnected[playerid])
	{
		// Perform the right action if allowed
		switch (PL_ACTION)
		{
			case ACTION_ZOMBIEFY_HUMANIZE: // Zombiefy/Humanize command
			{
				if (g_zombie[playerid])
				{
					if (userflags & g_access_flag[ACCESS_MAKE_HUMAN])
					{
						if (allowed_human(playerid))
							command_human(id, playerid)
						else
							zp_colored_print(id, "^3%L", id, "CMD_NOT")
					}
					else
						zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
				}
				else
				{
					if (g_newround ? (userflags & g_access_flag[ACCESS_MODE_INFECTION]) : (userflags & g_access_flag[ACCESS_MAKE_ZOMBIE]))
					{
						if (allowed_zombie(playerid))
							command_zombie(id, playerid)
						else
							zp_colored_print(id, "^3%L", id, "CMD_NOT")
					}
					else
						zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
				}
			}
			case ACTION_MAKE_NEMESIS: // Nemesis command
			{
				if (g_newround ? (userflags & g_access_flag[ACCESS_MODE_NEMESIS]) : (userflags & g_access_flag[ACCESS_MAKE_NEMESIS]))
				{
					if (allowed_nemesis(playerid))
						command_nemesis(id, playerid)
					else
						zp_colored_print(id, "^3%L", id, "CMD_NOT")
				}
				else
					zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
			}
			case ACTION_MAKE_SURVIVOR: // Survivor command
			{
				if (g_newround ? (userflags & g_access_flag[ACCESS_MODE_SURVIVOR]) : (userflags & g_access_flag[ACCESS_MAKE_SURVIVOR]))
				{
					if (allowed_survivor(playerid))
						command_survivor(id, playerid)
					else
						zp_colored_print(id, "^3%L", id, "CMD_NOT")
				}
				else
					zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
			}
			case ACTION_RESPAWN_PLAYER: // Respawn command
			{
				if (userflags & g_access_flag[ACCESS_RESPAWN_PLAYERS])
				{
					if (allowed_respawn(playerid))
						command_respawn(id, playerid)
					else
						zp_colored_print(id, "^3%L", id, "CMD_NOT")
				}
				else
					zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
			}
			case ACTION_MAKE_SNIPER: // Sniper command
			{
				if (g_newround ? (userflags & g_access_flag[ACCESS_MODE_SNIPER]) : (userflags & g_access_flag[ACCESS_MAKE_SNIPER]))
				{
					if (allowed_sniper(playerid))
						command_sniper(id, playerid)
					else
						zp_colored_print(id, "^3%L", id, "CMD_NOT")
				}
				else
					zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
			}
			case ACTION_MAKE_ASSASSIN: // Assassin command
			{
				if (g_newround ? (userflags & g_access_flag[ACCESS_MODE_ASSASSIN]) : (userflags & g_access_flag[ACCESS_MAKE_ASSASSIN]))
				{
					if (allowed_assassin(playerid))
						command_assassin(id, playerid)
					else
						zp_colored_print(id, "^3%L", id, "CMD_NOT")
				}
				else
					zp_colored_print(id, "^3%L", id, "CMD_NOT_ACCESS")
			}
		}
	}
	else
		zp_colored_print(id, "^3%L", id, "CMD_NOT")
	
	menu_destroy(menuid)
	show_menu_player_list(id)
	return PLUGIN_HANDLED;
}

// CS Buy Menus
public menu_cs_buy(id, key)
{
	// Prevent buying if zombie/survivor (bugfix)
	if (g_zombie[id] || g_survivor[id] || g_sniper[id])
		return PLUGIN_HANDLED;
	
	return PLUGIN_CONTINUE;
}

/*================================================================================
 [Admin Commands]
=================================================================================*/

// zp_toggle [1/0]
public cmd_toggle(id, level, cid)
{
	// Check for access flag - Enable/Disable Mod
	if (!cmd_access(id, g_access_flag[ACCESS_ENABLE_MOD], cid, 2))
		return PLUGIN_HANDLED;
	
	// Retrieve arguments
	new arg[2]
	read_argv(1, arg, 1)
	
	// Mod already enabled/disabled
	if (str_to_num(arg) == g_pluginenabled)
		return PLUGIN_HANDLED;
	
	// Set toggle cvar
	set_pcvar_num(cvar_toggle, str_to_num(arg))
	client_print(id, print_console, "Zombie Plague %L.", id, str_to_num(arg) ? "MOTD_ENABLED" : "MOTD_DISABLED")
	
	// Retrieve map name
	new mapname[32]
	get_mapname(mapname, 31)
	
	// Restart current map
	server_cmd("changelevel %s", mapname)
	
	return PLUGIN_HANDLED;
}

// zp_zombie [target]
public cmd_zombie(id, level, cid)
{
	// Check for access flag depending on the resulting action
	if (g_newround)
	{
		// Start Mode Infection
		if (!cmd_access(id, g_access_flag[ACCESS_MODE_INFECTION], cid, 2))
			return PLUGIN_HANDLED;
	}
	else
	{
		// Make Zombie
		if (!cmd_access(id, g_access_flag[ACCESS_MAKE_ZOMBIE], cid, 2))
			return PLUGIN_HANDLED;
	}
	
	// Retrieve arguments
	static arg[32]
	read_argv(1, arg, 31)
	new player = cmd_target(id, arg, (CMDTARGET_ONLY_ALIVE | CMDTARGET_ALLOW_SELF))
	
	// Invalid target
	if (!player) return PLUGIN_HANDLED;
	
	// Target not allowed to be zombie
	if (!allowed_zombie(player))
	{
		client_print(id, print_console, "[ Zombie Server ] %L", id, "CMD_NOT")
		return PLUGIN_HANDLED
	}
	
	command_zombie(id, player)
	
	return PLUGIN_HANDLED;
}

// zp_human [target]
public cmd_human(id, level, cid)
{
	// Check for access flag - Make Human
	if (!cmd_access(id, g_access_flag[ACCESS_MAKE_HUMAN], cid, 2))
		return PLUGIN_HANDLED;
	
	// Retrieve arguments
	static arg[32]
	read_argv(1, arg, 31)
	new player = cmd_target(id, arg, (CMDTARGET_ONLY_ALIVE | CMDTARGET_ALLOW_SELF))
	
	// Invalid target
	if (!player) return PLUGIN_HANDLED;
	
	// Target not allowed to be human
	if (!allowed_human(player))
	{
		client_print(id, print_console, "[ Zombie Server ] %L", id, "CMD_NOT")
		return PLUGIN_HANDLED;
	}
	
	command_human(id, player)
	
	return PLUGIN_HANDLED;
}

// zp_survivor [target]
public cmd_survivor(id, level, cid)
{
	// Check for access flag depending on the resulting action
	if (g_newround)
	{
		// Start Mode Survivor
		if (!cmd_access(id, g_access_flag[ACCESS_MODE_SURVIVOR], cid, 2))
			return PLUGIN_HANDLED;
	}
	else
	{
		// Make Survivor
		if (!cmd_access(id, g_access_flag[ACCESS_MAKE_SURVIVOR], cid, 2))
			return PLUGIN_HANDLED;
	}
	
	// Retrieve arguments
	static arg[32]
	read_argv(1, arg, 31)
	new player = cmd_target(id, arg, (CMDTARGET_ONLY_ALIVE | CMDTARGET_ALLOW_SELF))
	
	// Invalid target
	if (!player) return PLUGIN_HANDLED;
	
	// Target not allowed to be survivor
	if (!allowed_survivor(player))
	{
		client_print(id, print_console, "[ Zombie Server ] %L", id, "CMD_NOT")
		return PLUGIN_HANDLED;
	}
	
	command_survivor(id, player)
	
	return PLUGIN_HANDLED;
}

// zp_nemesis [target]
public cmd_nemesis(id, level, cid)
{
	// Check for access flag depending on the resulting action
	if (g_newround)
	{
		// Start Mode Nemesis
		if (!cmd_access(id, g_access_flag[ACCESS_MODE_NEMESIS], cid, 2))
			return PLUGIN_HANDLED;
	}
	else
	{
		// Make Nemesis
		if (!cmd_access(id, g_access_flag[ACCESS_MAKE_NEMESIS], cid, 2))
			return PLUGIN_HANDLED;
	}
	
	// Retrieve arguments
	static arg[32]
	read_argv(1, arg, 31)
	new player = cmd_target(id, arg, (CMDTARGET_ONLY_ALIVE | CMDTARGET_ALLOW_SELF))
	
	// Invalid target
	if (!player) return PLUGIN_HANDLED;
	
	// Target not allowed to be nemesis
	if (!allowed_nemesis(player))
	{
		client_print(id, print_console, "[ Zombie Server ] %L", id, "CMD_NOT")
		return PLUGIN_HANDLED;
	}
	
	command_nemesis(id, player)
	
	return PLUGIN_HANDLED;
}

// zp_respawn [target]
public cmd_respawn(id, level, cid)
{
	// Check for access flag - Respawn
	if (!cmd_access(id, g_access_flag[ACCESS_RESPAWN_PLAYERS], cid, 2))
		return PLUGIN_HANDLED;
	
	// Retrieve arguments
	static arg[32]
	read_argv(1, arg, 31)
	new player = cmd_target(id, arg, CMDTARGET_ALLOW_SELF)
	
	// Invalid target
	if (!player) return PLUGIN_HANDLED;
	
	// Target not allowed to be respawned
	if (!allowed_respawn(player))
	{
		client_print(id, print_console, "[ Zombie Server ] %L", id, "CMD_NOT")
		return PLUGIN_HANDLED;
	}
	
	command_respawn(id, player)
	
	return PLUGIN_HANDLED;
}

// zp_swarm
public cmd_swarm(id, level, cid)
{
	// Check for access flag - Mode Swarm
	if (!cmd_access(id, g_access_flag[ACCESS_MODE_SWARM], cid, 1))
		return PLUGIN_HANDLED;
	
	// Swarm mode not allowed
	if (!allowed_swarm())
	{
		client_print(id, print_console, "[ Zombie Server ] %L", id, "CMD_NOT")
		return PLUGIN_HANDLED;
	}
	
	command_swarm(id)
	
	return PLUGIN_HANDLED;
}

// zp_multi
public cmd_multi(id, level, cid)
{
	// Check for access flag - Mode Multi
	if (!cmd_access(id, g_access_flag[ACCESS_MODE_MULTI], cid, 1))
		return PLUGIN_HANDLED;
	
	// Multi infection mode not allowed
	if (!allowed_multi())
	{
		client_print(id, print_console, "[ Zombie Server ] %L", id, "CMD_NOT")
		return PLUGIN_HANDLED;
	}
	
	command_multi(id)
	
	return PLUGIN_HANDLED;
}

// zp_plague
public cmd_plague(id, level, cid)
{
	// Check for access flag - Mode Plague
	if (!cmd_access(id, g_access_flag[ACCESS_MODE_PLAGUE], cid, 1))
		return PLUGIN_HANDLED;
	
	// Plague mode not allowed
	if (!allowed_plague())
	{
		client_print(id, print_console, "[ Zombie Server ] %L", id, "CMD_NOT")
		return PLUGIN_HANDLED;
	}
	
	command_plague(id)
	
	return PLUGIN_HANDLED;
}

// zp_sniper [target]
public cmd_sniper(id, level, cid)
{
	// Check for access flag depending on the resulting action
	if (g_newround)
	{
		// Start Mode Sniper
		if (!cmd_access(id, g_access_flag[ACCESS_MODE_SNIPER], cid, 2))
			return PLUGIN_HANDLED;
	}
	else
	{
		// Make Sniper
		if (!cmd_access(id, g_access_flag[ACCESS_MAKE_SNIPER], cid, 2))
			return PLUGIN_HANDLED;
	}
	
	// Retrieve arguments
	static arg[32]
	read_argv(1, arg, 31)
	new player = cmd_target(id, arg, (CMDTARGET_ONLY_ALIVE | CMDTARGET_ALLOW_SELF))
	
	// Invalid target
	if (!player) return PLUGIN_HANDLED;
	
	// Target not allowed to be sniper
	if (!allowed_sniper(player))
	{
		client_print(id, print_console, "[ Zombie Server ] %L", id, "CMD_NOT")
		return PLUGIN_HANDLED;
	}
	
	command_sniper(id, player)
	
	return PLUGIN_HANDLED;
}

// zp_assassin [target]
public cmd_assassin(id, level, cid)
{
	// Check for access flag depending on the resulting action
	if (g_newround)
	{
		// Start Mode Assassin
		if (!cmd_access(id, g_access_flag[ACCESS_MODE_ASSASSIN], cid, 2))
			return PLUGIN_HANDLED;
	}
	else
	{
		// Make Assassin
		if (!cmd_access(id, g_access_flag[ACCESS_MAKE_ASSASSIN], cid, 2))
			return PLUGIN_HANDLED;
	}
	
	// Retrieve arguments
	static arg[32]
	read_argv(1, arg, 31)
	new player = cmd_target(id, arg, (CMDTARGET_ONLY_ALIVE | CMDTARGET_ALLOW_SELF))
	
	// Invalid target
	if (!player) return PLUGIN_HANDLED;
	
	// Target not allowed to be assassin
	if (!allowed_assassin(player))
	{
		client_print(id, print_console, "[ Zombie Server ] %L", id, "CMD_NOT")
		return PLUGIN_HANDLED;
	}
	
	command_assassin(id, player)
	
	return PLUGIN_HANDLED;
}

/*================================================================================
 [Message Hooks]
=================================================================================*/

// Current Weapon info
public message_cur_weapon(msg_id, msg_dest, msg_entity)
{
	// Not alive or zombie
	if (!g_isalive[msg_entity] || g_zombie[msg_entity])
		return;
	
	// Not an active weapon
	if (get_msg_arg_int(1) != 1)
		return;
	
	// Unlimited clip disabled for class
	if (g_infammo[msg_entity] < 2) //g_survivor[msg_entity] ? cvar_survinfammo < 2 : g_sniper[msg_entity] ? cvar_snipinfammo < 2 : cvar_infammo < 2
		return;
	
	// Get weapon's id
	static weapon
	weapon = get_msg_arg_int(2)
	
	// Unlimited Clip Ammo for this weapon?
	if (MAXBPAMMO[weapon] > 2)
	{
		// Max out clip ammo
		static weapon_ent
		weapon_ent = fm_cs_get_current_weapon_ent(msg_entity)
		if (pev_valid(weapon_ent)) cs_set_weapon_ammo(weapon_ent, MAXCLIP[weapon]) //125
		
		// HUD should show full clip all the time
		set_msg_arg_int(3, get_msg_argtype(3), 125) //MAXCLIP[weapon]
	}
}

// Take off player's money
public message_money(msg_id, msg_dest, msg_entity)
{
	// Remove money setting enabled?
	new removemoney = get_pcvar_num(cvar_removemoney)
	if (!removemoney || removemoney > 2)
		return PLUGIN_CONTINUE;
	
	fm_cs_set_user_money(msg_entity, 0)
	return PLUGIN_HANDLED;
}

// Fix for the HL engine bug when HP is multiples of 256
public message_health(msg_id, msg_dest, msg_entity)
{
	// Get player's health
	static health
	health = get_msg_arg_int(1)
	
	// Don't bother
	if (health < 256) return;
	
	// Check if we need to fix it
	if (health % 256 == 0)
		fm_set_user_health(msg_entity, pev(msg_entity, pev_health) + 1)
	
	// HUD can only show as much as 255 hp
	set_msg_arg_int(1, get_msg_argtype(1), 255)
}

// Block flashlight battery messages if custom flashlight is enabled instead
public message_flashbat()
{
	if (cvar_customflash)
		return PLUGIN_HANDLED;
	
	return PLUGIN_CONTINUE;
}

// Flashbangs should only affect zombies
public message_screenfade(msg_id, msg_dest, msg_entity)
{
	if (get_msg_arg_int(4) != 255 || get_msg_arg_int(5) != 255 || get_msg_arg_int(6) != 255 || get_msg_arg_int(7) < 200)
		return PLUGIN_CONTINUE;
	
	// Nemesis shouldn't be FBed
	if (g_zombie[msg_entity] && !g_nemesis[msg_entity] && !g_assassin[msg_entity])
	{
		// Set flash color to nighvision's
		set_msg_arg_int(4, get_msg_argtype(4), cvar_nvgcolor[0])
		set_msg_arg_int(5, get_msg_argtype(5), cvar_nvgcolor[1])
		set_msg_arg_int(6, get_msg_argtype(6), cvar_nvgcolor[2])
		return PLUGIN_CONTINUE;
	}
	
	return PLUGIN_HANDLED;
}

// Prevent spectators' nightvision from being turned off when switching targets, etc.
public message_nvgtoggle()
{
	return PLUGIN_HANDLED;
}

// Set correct model on player corpses
public message_clcorpse()
{
	set_msg_arg_string(1, g_playermodel[get_msg_arg_int(12)])
}

// Prevent zombies from seeing any weapon pickup icon
public message_weappickup(msg_id, msg_dest, msg_entity)
{
	if (g_zombie[msg_entity])
		return PLUGIN_HANDLED;
	
	return PLUGIN_CONTINUE;
}

// Prevent zombies from seeing any ammo pickup icon
public message_ammopickup(msg_id, msg_dest, msg_entity)
{
	if (g_zombie[msg_entity])
		return PLUGIN_HANDLED;
	
	return PLUGIN_CONTINUE;
}

// Block hostage HUD display
public message_scenario()
{
	if (get_msg_args() > 1)
	{
		static sprite[8]
		get_msg_arg_string(2, sprite, 7)
		
		if (equali(sprite, "hostage"))
			return PLUGIN_HANDLED;
	}
	
	return PLUGIN_CONTINUE;
}

// Block hostages from appearing on radar
public message_hostagepos()
{
	return PLUGIN_HANDLED;
}

// Block some text messages
public message_textmsg()
{
	static textmsg[22]
	get_msg_arg_string(2, textmsg, 21)
	
	// Game restarting, reset scores and call round end to balance the teams
	if (equali(textmsg, "#Game_will_restart_in"))
	{
		logevent_round_end()
		g_scorehumans = 0
		g_scorezombies = 0
	}
	// Game commencing, reset scores only (round end is automatically triggered)
	else if (equali(textmsg, "#Game_Commencing"))
	{
		g_gamecommencing = true
		g_scorehumans = 0
		g_scorezombies = 0
	}
	// Block round end related messages
	else if (equali(textmsg, "#Hostages_Not_Rescued") || equali(textmsg, "#Round_Draw") || equali(textmsg, "#Terrorists_Win") || equali(textmsg, "#CTs_Win"))
	{
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_CONTINUE;
}

// Block CS round win audio messages, since we're playing our own instead
public message_sendaudio()
{
	static audio[17]
	get_msg_arg_string(2, audio, 16)
	
	if(equali(audio[7], "terwin") || equali(audio[7], "ctwin") || equali(audio[7], "rounddraw"))
		return PLUGIN_HANDLED;
	
	return PLUGIN_CONTINUE;
}

// Send actual team scores (T = zombies // CT = humans)
public message_teamscore()
{
	new team[2]
	get_msg_arg_string(1, team, 1)
	
	switch (team[0])
	{
		// CT
		case 'C': set_msg_arg_int(2, get_msg_argtype(2), g_scorehumans)
		// Terrorist
		case 'T': set_msg_arg_int(2, get_msg_argtype(2), g_scorezombies)
	}
}

// Team Switch (or player joining a team for first time)
public message_teaminfo(msg_id, msg_dest)
{
	// Only hook global messages
	if (msg_dest != MSG_ALL && msg_dest != MSG_BROADCAST) return;
	
	// Don't pick up our own TeamInfo messages for this player (bugfix)
	if (g_switchingteam) return;
	
	// Get player's id
	new id = get_msg_arg_int(1)
	
	// Invalid player id? (bugfix)
	if (!(1 <= id <= g_maxplayers)) return;
	
	// Enable spectators' nightvision if not spawning right away
	set_task(0.2, "spec_nvision", id)
	
	// Round didn't start yet, nothing to worry about
	if (g_newround) return;
	
	// Get his new team
	new team[2]
	get_msg_arg_string(2, team, 1)
	
	// Perform some checks to see if they should join a different team instead
	switch (team[0])
	{
		case 'C': // CT
		{
			if (((g_survround || g_snipround) && fnGetHumans()) || !fnGetZombies()) // survivor alive --> switch to T and spawn as zombie
			{
				g_respawn_as_zombie[id] = true;
				remove_task(id+TASK_TEAM)
				fm_cs_set_user_team(id, FM_CS_TEAM_T)
				set_msg_arg_string(2, "TERRORIST")
			}
/*=====			else if (!fnGetZombies()) // no zombies alive --> switch to T and spawn as zombie
			{
				g_respawn_as_zombie[id] = true;
				remove_task(id+TASK_TEAM)
				fm_cs_set_user_team(id, FM_CS_TEAM_T)
				set_msg_arg_string(2, "TERRORIST")
			}*/
		}
		case 'T': // Terrorist
		{
			if ((g_swarmround || g_survround || g_snipround) && fnGetHumans()) // survivor alive or swarm round w/ humans --> spawn as zombie
			{
				g_respawn_as_zombie[id] = true;
			}
			else if (fnGetZombies()) // zombies alive --> switch to CT
			{
				g_respawn_as_zombie[id] = false;
				remove_task(id+TASK_TEAM)
				fm_cs_set_user_team(id, FM_CS_TEAM_CT)
				set_msg_arg_string(2, "CT")
			}
		}
	}
}

/*================================================================================
 [Main Functions]
=================================================================================*/

// Make Zombie Task
public make_zombie_task()
{
	/*if(g_newround)
	{
		set_dhudmessage(150, 150, 150, 0.02, 0.18, 0, 6.0, 1.1, 0.0, 5.0)
		show_dhudmessage(0, "Skype администратора: xxxtalrashaxxx")
	}*/
	
	// Call make a zombie with no specific mode
	make_a_zombie(MODE_NONE, 0)
}

// Make a Zombie Function
make_a_zombie(mode, id)
{
	// Get alive players count
	new iPlayersnum = fnGetAlive()
	
	// Not enough players, come back later!
	if (iPlayersnum < 1)
	{
		set_task(2.0, "make_zombie_task", TASK_MAKEZOMBIE)
		return;
	}
	
	// Round started!
	g_newround = false
	
	// Set up some common vars
	static sound[64]
	new forward_id, iZombies, iMaxZombies
	
	if ((mode == MODE_NONE && (!get_pcvar_num(cvar_preventconsecutive) || g_lastmode != MODE_SURVIVOR) && random_num(1, get_pcvar_num(cvar_survchance)) == get_pcvar_num(cvar_surv) && iPlayersnum >= get_pcvar_num(cvar_survminplayers)) || mode == MODE_SURVIVOR)
	{
		// Survivor Mode
		g_survround = true
		g_lastmode = MODE_SURVIVOR
		
		// Choose player randomly?
		if (mode == MODE_NONE)
			id = fnGetRandomAlive(random_num(1, iPlayersnum))
		
		// Remember id for calling our forward later
		forward_id = id
		
		// Turn player into a survivor
		humanme(id, 1, 0)
		
		// Turn the remaining players into zombies
		for (id = 1; id <= g_maxplayers; id++)
		{
			// Not alive
			if (!g_isalive[id])
				continue;
			
			// Survivor or already a zombie
			if (g_survivor[id] || g_zombie[id])
				continue;
			
			// Turn into a zombie
			zombieme(id, 0, 0, 1, 0)
		}
		
		// Play survivor sound
		ArrayGetString(sound_survivor, random_num(0, ArraySize(sound_survivor) - 1), sound, 63)
		PlaySound(sound);
		
		// Show Survivor HUD notice
		set_dhudmessage(cvar_humnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], HUD_EVENT_X, HUD_EVENT_Y, 1, 6.0, 1.1, 0.0, 2.0) //20, 20, 255 | , -1)
//		ShowSyncHudMsg(0, g_MsgSync, "%L", LANG_PLAYER, "NOTICE_SURVIVOR", g_playername[forward_id])
		show_dhudmessage(0, "%L", LANG_PLAYER, "NOTICE_SURVIVOR", g_playername[forward_id])
		
		// Mode fully started!
		g_modestarted = true
		
		// Round start forward
		ExecuteForward(g_fwRoundStart, g_fwDummyResult, MODE_SURVIVOR, forward_id);
	}
	else if ((mode == MODE_NONE && (!get_pcvar_num(cvar_preventconsecutive) || g_lastmode != MODE_SWARM) && random_num(1, get_pcvar_num(cvar_swarmchance)) == get_pcvar_num(cvar_swarm) && iPlayersnum >= get_pcvar_num(cvar_swarmminplayers)) || mode == MODE_SWARM)
	{
		// Swarm Mode
		g_swarmround = true
		g_lastmode = MODE_SWARM
		
		// Make sure there are alive players on both teams (BUGFIX)
		if (!fnGetAliveTs())
		{
			// Move random player to T team
			id = fnGetRandomAlive(random_num(1, iPlayersnum))
			remove_task(id+TASK_TEAM)
			fm_cs_set_user_team(id, FM_CS_TEAM_T)
			fm_user_team_update(id)
		}
		else if (!fnGetAliveCTs())
		{
			// Move random player to CT team
			id = fnGetRandomAlive(random_num(1, iPlayersnum))
			remove_task(id+TASK_TEAM)
			fm_cs_set_user_team(id, FM_CS_TEAM_CT)
			fm_user_team_update(id)
		}
		
		// Turn every T into a zombie
		for (id = 1; id <= g_maxplayers; id++)
		{
			// Not alive
			if (!g_isalive[id])
				continue;
			
			// Not a Terrorist
			if (fm_cs_get_user_team(id) != FM_CS_TEAM_T)
				continue;
			
			// Turn into a zombie
			zombieme(id, 0, 0, 1, 0)
		}
		
		// Play swarm sound
		ArrayGetString(sound_swarm, random_num(0, ArraySize(sound_swarm) - 1), sound, 63)
		PlaySound(sound);
		
		// Show Swarm HUD notice
		set_dhudmessage(cvar_nvgcolor[0], cvar_assnvgcolor[1], cvar_humnvgcolor[2], HUD_EVENT_X, HUD_EVENT_Y, 1, 6.0, 1.1, 0.0, 2.0) //20, 255, 20 | , -1)
//		ShowSyncHudMsg(0, g_MsgSync, "%L", LANG_PLAYER, "NOTICE_SWARM")
		show_dhudmessage(0, "%L", LANG_PLAYER, "NOTICE_SWARM")
		
		// Mode fully started!
		g_modestarted = true
		
		// Round start forward
		ExecuteForward(g_fwRoundStart, g_fwDummyResult, MODE_SWARM, 0);
	}
	else if ((mode == MODE_NONE && (!get_pcvar_num(cvar_preventconsecutive) || g_lastmode != MODE_MULTI) && random_num(1, get_pcvar_num(cvar_multichance)) == get_pcvar_num(cvar_multi) && floatround(iPlayersnum*get_pcvar_float(cvar_multiratio), floatround_ceil) >= 2 && floatround(iPlayersnum*get_pcvar_float(cvar_multiratio), floatround_ceil) < iPlayersnum && iPlayersnum >= get_pcvar_num(cvar_multiminplayers)) || mode == MODE_MULTI)
	{
		// Multi Infection Mode
		g_lastmode = MODE_MULTI
		
		// iMaxZombies is rounded up, in case there aren't enough players
		iMaxZombies = floatround(iPlayersnum*get_pcvar_float(cvar_multiratio), floatround_ceil)
		iZombies = 0
		
		// Randomly turn iMaxZombies players into zombies
		while (iZombies < iMaxZombies)
		{
			// Keep looping through all players
			if (++id > g_maxplayers) id = 1
			
			// Dead or already a zombie
			if (!g_isalive[id] || g_zombie[id])
				continue;
			
			// Random chance
			if (random_num(0, 1))
			{
				// Turn into a zombie
				zombieme(id, 0, 0, 1, 0)
				iZombies++
			}
		}
		
		// Turn the remaining players into humans
		for (id = 1; id <= g_maxplayers; id++)
		{
			// Only those of them who aren't zombies
			if (!g_isalive[id] || g_zombie[id])
				continue;
			
			// Switch to CT
			if (fm_cs_get_user_team(id) != FM_CS_TEAM_CT) // need to change team?
			{
				remove_task(id+TASK_TEAM)
				fm_cs_set_user_team(id, FM_CS_TEAM_CT)
				fm_user_team_update(id)
			}
		}
		
		// Play multi infection sound
		ArrayGetString(sound_multi, random_num(0, ArraySize(sound_multi) - 1), sound, 63)
		PlaySound(sound);
		
		// Show Multi Infection HUD notice
		set_dhudmessage(cvar_nvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], HUD_EVENT_X, HUD_EVENT_Y, 1, 6.0, 1.1, 0.0, 2.0) //200, 50, 0 | , -1)
//		ShowSyncHudMsg(0, g_MsgSync, "%L", LANG_PLAYER, "NOTICE_MULTI")
		show_dhudmessage(0, "%L", LANG_PLAYER, "NOTICE_MULTI")
		
		// Mode fully started!
		g_modestarted = true
		
		// Round start forward
		ExecuteForward(g_fwRoundStart, g_fwDummyResult, MODE_MULTI, 0);
	}
	else if ((mode == MODE_NONE && (!get_pcvar_num(cvar_preventconsecutive) || g_lastmode != MODE_PLAGUE) && random_num(1, get_pcvar_num(cvar_plaguechance)) == get_pcvar_num(cvar_plague) && floatround((iPlayersnum-(cvar_plaguenemnum+cvar_plaguesurvnum))*get_pcvar_float(cvar_plagueratio), floatround_ceil) >= 1
	&& iPlayersnum-(cvar_plaguesurvnum+cvar_plaguenemnum+floatround((iPlayersnum-(cvar_plaguenemnum+cvar_plaguesurvnum))*get_pcvar_float(cvar_plagueratio), floatround_ceil)) >= 1 && iPlayersnum >= get_pcvar_num(cvar_plagueminplayers)) || mode == MODE_PLAGUE)
	{
		// Plague Mode
		g_plagueround = true
		g_lastmode = MODE_PLAGUE
		
		// Turn specified amount of players into Survivors
		new iSurvivors/*, iMaxSurvivors
		iMaxSurvivors = get_pcvar_num(cvar_plaguesurvnum)
		iSurvivors = 0*/
		
		new iPlayersRemaining = iPlayersnum
		
		while (iPlayersRemaining && iSurvivors < cvar_plaguesurvnum) //iMaxSurvivors
		{
			// Choose random guy
			id = fnGetRandomAlive(random_num(1, iPlayersnum))
			
			// Already a survivor?
			if (g_survivor[id])
				continue;
			
			// If not, turn him into one
			humanme(id, 1, 0)
			iSurvivors++
			iPlayersRemaining--
			
			// Apply survivor health multiplier
			fm_set_user_health(id, floatround(float(pev(id, pev_health)) * get_pcvar_float(cvar_plaguesurvhpmulti)))
		}
		
		// Turn specified amount of players into Nemesis
		new iNemesis/*, iMaxNemesis
		iMaxNemesis = get_pcvar_num(cvar_plaguenemnum)
		iNemesis = 0*/
		
		while (iPlayersRemaining && iNemesis < cvar_plaguenemnum) //iMaxNemesis
		{
			// Choose random guy
			id = fnGetRandomAlive(random_num(1, iPlayersnum))
			
			// Already a survivor or nemesis?
			if (g_survivor[id] || g_nemesis[id])
				continue;
			
			// If not, turn him into one
			zombieme(id, 0, 1, 0, 0)
			iNemesis++
			iPlayersRemaining--
			
			// Apply nemesis health multiplier
			fm_set_user_health(id, floatround(float(pev(id, pev_health)) * get_pcvar_float(cvar_plaguenemhpmulti)))
		}
		
		// iMaxZombies is rounded up, in case there aren't enough players
		iMaxZombies = floatround((iPlayersnum-(cvar_plaguenemnum+cvar_plaguesurvnum))*get_pcvar_float(cvar_plagueratio), floatround_ceil)
		iZombies = 0
		
		// Randomly turn iMaxZombies players into zombies
		while (iPlayersRemaining && iZombies < iMaxZombies)
		{
			// Keep looping through all players
			if (++id > g_maxplayers) id = 1
			
			// Dead or already a zombie or survivor
			if (!g_isalive[id] || g_zombie[id] || g_survivor[id])
				continue;
			
			// Random chance
			if (random_num(0, 1))
			{
				// Turn into a zombie
				zombieme(id, 0, 0, 1, 0)
				iZombies++
				iPlayersRemaining--
			}
		}
		
		// Turn the remaining players into humans
		for (id = 1; id <= g_maxplayers; id++)
		{
			// Only those of them who arent zombies or survivor
			if (!g_isalive[id] || g_zombie[id] || g_survivor[id])
				continue;
			
			// Switch to CT
			if (fm_cs_get_user_team(id) != FM_CS_TEAM_CT) // need to change team?
			{
				remove_task(id+TASK_TEAM)
				fm_cs_set_user_team(id, FM_CS_TEAM_CT)
				fm_user_team_update(id)
			}
			
			iPlayersRemaining--
			
			if (!iPlayersRemaining)
				break;
		}
		
		// Play plague sound
		ArrayGetString(sound_plague, random_num(0, ArraySize(sound_plague) - 1), sound, 63)
		PlaySound(sound);
		
		// Show Plague HUD notice
		set_dhudmessage(cvar_nemnvgcolor[0], cvar_nvgcolor[1], cvar_humnvgcolor[2], HUD_EVENT_X, HUD_EVENT_Y, 1, 6.0, 1.1, 0.0, 2.0) //0, 50, 200 | , -1)
//		ShowSyncHudMsg(0, g_MsgSync, "%L", LANG_PLAYER, "NOTICE_PLAGUE")
		show_dhudmessage(0, "%L", LANG_PLAYER, "NOTICE_PLAGUE")
		
		// Mode fully started!
		g_modestarted = true
		
		// Round start forward
		ExecuteForward(g_fwRoundStart, g_fwDummyResult, MODE_PLAGUE, 0);
	}
	else if ((mode == MODE_NONE && (!get_pcvar_num(cvar_preventconsecutive) || g_lastmode != MODE_SNIPER) && random_num(1, get_pcvar_num(cvar_snipchance)) == get_pcvar_num(cvar_snip) && iPlayersnum >= get_pcvar_num(cvar_snipminplayers)) || mode == MODE_SNIPER)
	{
		// Sniper Mode
		g_snipround = true
		g_lastmode = MODE_SNIPER
		
		// Choose player randomly?
		if (mode == MODE_NONE)
			id = fnGetRandomAlive(random_num(1, iPlayersnum))
		
		// Remember id for calling our forward later
		forward_id = id
		
		// Turn player into a sniper
		humanme(id, 0, 0, 1)
		
		// Turn the remaining players into zombies
		for (id = 1; id <= g_maxplayers; id++)
		{
			// Not alive
			if (!g_isalive[id])
				continue;
			
			// Sniper or already a zombie
			if (g_sniper[id] || g_zombie[id])
				continue;
			
			// Turn into a zombie
			zombieme(id, 0, 0, 1, 0)
		}
		
		// Play sniper sound
		ArrayGetString(sound_sniper, random_num(0, ArraySize(sound_sniper) - 1), sound, 63)
		PlaySound(sound);
		
		// Show Sniper HUD notice
		set_dhudmessage(cvar_humnvgcolor[0], cvar_assnvgcolor[1], cvar_humnvgcolor[2], HUD_EVENT_X, HUD_EVENT_Y, 1, 6.0, 1.1, 0.0, 2.0) //20, 20, 255 | , -1)
//		ShowSyncHudMsg(0, g_MsgSync, "%L", LANG_PLAYER, "NOTICE_SNIPER", g_playername[forward_id])
		show_dhudmessage(0, "%L", LANG_PLAYER, "NOTICE_SNIPER", g_playername[forward_id])
		
		// Mode fully started!
		g_modestarted = true
		
		// Round start forward
		ExecuteForward(g_fwRoundStart, g_fwDummyResult, MODE_SNIPER, forward_id);
	}
	else
	{
		// Single Infection Mode or Nemesis Mode
		
		// Choose player randomly?
		if (mode == MODE_NONE)
			id = fnGetRandomAlive(random_num(1, iPlayersnum))
		
		// Remember id for calling our forward later
		forward_id = id
		
		if ((mode == MODE_NONE && (!get_pcvar_num(cvar_preventconsecutive) || g_lastmode != MODE_NEMESIS) && random_num(1, get_pcvar_num(cvar_nemchance)) == get_pcvar_num(cvar_nem) && iPlayersnum >= get_pcvar_num(cvar_nemminplayers)) || mode == MODE_NEMESIS)
		{
			// Nemesis Mode
			g_nemround = true
			g_lastmode = MODE_NEMESIS
			
			// Turn player into nemesis
			zombieme(id, 0, 1, 0, 0)
		}
		else if ((mode == MODE_NONE && (!get_pcvar_num(cvar_preventconsecutive) || g_lastmode != MODE_ASSASSIN) && random_num(1, get_pcvar_num(cvar_asschance)) == get_pcvar_num(cvar_ass) && iPlayersnum >= get_pcvar_num(cvar_assminplayers)) || mode == MODE_ASSASSIN)
		{
			// Assassin Mode
			g_assround = true
			g_lastmode = MODE_ASSASSIN
			
			// Turn player into assassin
			zombieme(id, 0, 0, 0, 0, 1)
			
			new triggered = get_pcvar_num(cvar_triggered)
			
			set_pcvar_num(cvar_triggered, 0)
			remove_stuff()
			set_pcvar_num(cvar_triggered, triggered)
			
			remove_task(TASK_THUNDER_PRE)
			remove_task(TASK_THUNDER)
			
/*			for (id = 1; id <= g_maxplayers; id++)
				if (g_isconnected[id])*/
			engfunc(EngFunc_LightStyle, 0, "a")
		}
		else if ((mode == MODE_NONE && (!get_pcvar_num(cvar_infpreventconsecutive) || g_lastmode != MODE_INFECTION) && random_num(1, get_pcvar_num(cvar_infchance)) == get_pcvar_num(cvar_inf) && iPlayersnum >= get_pcvar_num(cvar_infminplayers)) || mode == MODE_INFECTION)
		{
			// Single Infection Mode
			g_lastmode = MODE_INFECTION
			
			// Turn player into the first zombie
			zombieme(id, 0, 0, 0, 0)
		}
		else
		{
			make_a_zombie(MODE_NONE, id)
			
			return;
		}
		
		// Remaining players should be humans (CTs)
		for (id = 1; id <= g_maxplayers; id++)
		{
			// Not alive
			if (!g_isalive[id])
				continue;
			
			// First zombie/nemesis
			if (g_zombie[id])
				continue;
			
			// Switch to CT
			if (fm_cs_get_user_team(id) != FM_CS_TEAM_CT) // need to change team?
			{
				remove_task(id+TASK_TEAM)
				fm_cs_set_user_team(id, FM_CS_TEAM_CT)
				fm_user_team_update(id)
			}
			
			if (!g_assround)
				continue;
			
			// Credits for the below codes go to abdul-rehman
			// Make a screen fade 
			message_begin(MSG_ONE, g_msgScreenFade, _, id)
			write_short(UNIT_SECOND*3) // duration
			write_short(0) // hold time
			write_short(FFADE_IN) // fade type
			write_byte(cvar_assnvgcolor[0]) // red-250
			write_byte(cvar_assnvgcolor[1]) // green
			write_byte(cvar_assnvgcolor[2]) // blue
			write_byte(255) // alpha
			message_end()
			
			// Make a screen shake [Make it horrorful]
			message_begin(MSG_ONE_UNRELIABLE, g_msgScreenShake, _, id)
			write_short(UNIT_SECOND*57) // amplitude
			write_short(UNIT_SECOND*3) // duration
			write_short(UNIT_SECOND*57) // frequency
			message_end()
		}
		
		if (g_nemround)
		{
			// Play Nemesis sound
			ArrayGetString(sound_nemesis, random_num(0, ArraySize(sound_nemesis) - 1), sound, 63)
			PlaySound(sound);
			
			// Show Nemesis HUD notice
			set_dhudmessage(cvar_nemnvgcolor[0], cvar_nemnvgcolor[1], cvar_nemnvgcolor[2], HUD_EVENT_X, HUD_EVENT_Y, 1, 6.0, 1.1, 0.0, 2.0) //255, 20, 20 | , -1)
//			ShowSyncHudMsg(0, g_MsgSync, "%L", LANG_PLAYER, "NOTICE_NEMESIS", g_playername[forward_id])
			show_dhudmessage(0, "%L", LANG_PLAYER, "NOTICE_NEMESIS", g_playername[forward_id])
			
			// Mode fully started!
			g_modestarted = true
			
			// Round start forward
			ExecuteForward(g_fwRoundStart, g_fwDummyResult, MODE_NEMESIS, forward_id);
		}
		else if (g_assround)
		{
			// Play Assassin sound
			ArrayGetString(sound_assassin, random_num(0, ArraySize(sound_assassin) - 1), sound, 63)
			PlaySound(sound);
			
			// Show Assassin HUD notice
			set_dhudmessage(cvar_assnvgcolor[0], cvar_assnvgcolor[1], cvar_assnvgcolor[2], HUD_EVENT_X, HUD_EVENT_Y, 1, 6.0, 1.1, 0.0, 2.0) //255, 7, 7 | , -1)
//			ShowSyncHudMsg(0, g_MsgSync, "%L", LANG_PLAYER, "NOTICE_ASSASSIN", g_playername[forward_id])
			show_dhudmessage(0, "%L", LANG_PLAYER, "NOTICE_ASSASSIN", g_playername[forward_id])
			
			// Mode fully started!
			g_modestarted = true
			
			// Round start forward
			ExecuteForward(g_fwRoundStart, g_fwDummyResult, MODE_ASSASSIN, forward_id);
		}
		else
		{
			// Show First Zombie HUD notice
			set_dhudmessage(cvar_nvgcolor[0], cvar_nvgcolor[1], cvar_nvgcolor[2], HUD_EVENT_X, HUD_EVENT_Y, 1, 6.0, 1.1, 0.0, 2.0) //255, 0, 0 | , -1)
//			ShowSyncHudMsg(0, g_MsgSync, "%L",LANG_PLAYER, "NOTICE_FIRST", g_playername[forward_id])
			show_dhudmessage(0, "%L",LANG_PLAYER, "NOTICE_FIRST", g_playername[forward_id])
			
			// Mode fully started!
			g_modestarted = true
			
			// Round start forward
			ExecuteForward(g_fwRoundStart, g_fwDummyResult, MODE_INFECTION, forward_id);
		}
	}
	
	// Start ambience sounds after a mode begins
	if ((g_ambience_sounds[AMBIENCE_SOUNDS_NEMESIS] && g_nemround) || (g_ambience_sounds[AMBIENCE_SOUNDS_SURVIVOR] && g_survround) || (g_ambience_sounds[AMBIENCE_SOUNDS_SWARM] && g_swarmround) || (g_ambience_sounds[AMBIENCE_SOUNDS_PLAGUE] && g_plagueround)
	|| (g_ambience_sounds[AMBIENCE_SOUNDS_SNIPER] && g_snipround) || (g_ambience_sounds[AMBIENCE_SOUNDS_ASSASSIN] && g_assround) || (g_ambience_sounds[AMBIENCE_SOUNDS_INFECTION] && !g_nemround && !g_assround && !g_survround && !g_snipround && !g_swarmround && !g_plagueround))
	{
		remove_task(TASK_AMBIENCESOUNDS)
		set_task(2.0, "ambience_sound_effects", TASK_AMBIENCESOUNDS)
	}
}

// Zombie Me Function (player id, infector, turn into a nemesis, silent mode, deathmsg and rewards, turn into an assassin)
zombieme(id, infector, nemesis, silentmode, rewards, assassin = 0, nade = 0)
{
	// User infect attempt forward
	ExecuteForward(g_fwUserInfect_attempt, g_fwDummyResult, id, infector, nemesis, assassin, nade)
	
	// One or more plugins blocked the infection. Only allow this after making sure it's
	// not going to leave us with no zombies. Take into account a last player leaving case.
	// BUGFIX: only allow after a mode has started, to prevent blocking first zombie e.g.
	if (g_fwDummyResult >= ZP_PLUGIN_HANDLED && g_modestarted && fnGetZombies() > g_lastplayerleaving)
		return;
	
	// Player is killed by the infection bomb - no reason to continue
	if (nade && g_lasthuman[id])
	{
		ExecuteHamB(Ham_Killed, id, infector, 0)
		
		return;
	}
	
	// Pre user infect forward
	ExecuteForward(g_fwUserInfected_pre, g_fwDummyResult, id, infector, nemesis, assassin, nade)
	
	if (get_pcvar_num(cvar_zclasses))
	{
		// Show zombie class menu if they haven't chosen any (e.g. just connected)
		if (g_zombieclassnext[id] == HZCLASS_NONE)
			show_menu_zclass(id) //set_task(0.2, "show_menu_zclass", id)
		else
			// Set selected zombie class
			g_zombieclass[id] = g_zombieclassnext[id]
	}
	// If no class selected yet, use the first (default) one
//	if (g_zombieclass[id] == HZCLASS_NONE) g_zombieclass[id] = 0
	
	// Way to go...
	g_zombie[id] = true
	g_nemesis[id] = false
	g_survivor[id] = false
	g_firstzombie[id] = false
	g_sniper[id] = false
	g_assassin[id] = false
	g_infammo[id] = 0
	
	// Remove survivor's aura (bugfix)
	set_pev(id, pev_effects, pev(id, pev_effects) &~ EF_BRIGHTLIGHT)
	
	// Remove spawn protection (bugfix)
	g_nodamage[id] = false
	set_pev(id, pev_effects, pev(id, pev_effects) &~ EF_NODRAW)
	
	// Reset burning duration counter (bugfix)
	g_burning_duration[id] = 0
	
	// Show deathmsg and reward infector?
	if (rewards && infector)
	{
		// Send death notice and fix the "dead" attrib on scoreboard
		SendDeathMsg(infector, id)
		FixDeadAttrib(id)
		
		// Reward frags, deaths, health, and ammo packs
		UpdateFrags(infector, id, get_pcvar_num(cvar_fragsinfect), 1, 1)
		
		new reward = get_pcvar_num(cvar_ammoinfect)
		
		g_ammopacks[infector] += reward
		
		fm_set_user_health(infector, pev(infector, pev_health) + get_pcvar_num(cvar_zombiebonushp))
		
		ExecuteForward(g_fwUserGetAmmoPacks, g_fwDummyResult, infector, reward, 2);
	}
	
	// Cache speed, knockback, and name for player's class
	g_zombie_spd[id] = float(ArrayGetCell(g_zclass_spd, g_zombieclass[id]))
	g_cached_zmknockback[id] = Float:ArrayGetCell(g_zclass_kb, g_zombieclass[id])
	ArrayGetString(g_zclass_name, g_zombieclass[id], g_zombie_classname[id], 31)
	
	// Set zombie attributes based on the mode
	static sound[64]
	if (!silentmode)
	{
		if (nemesis)
		{
			// Nemesis
			g_nemesis[id] = true
			
			// Set health [0 = auto]
			if (get_pcvar_num(cvar_nemhp) == 0)
			{
				if (get_pcvar_num(cvar_nembasehp) == 0)
					fm_set_user_health(id, ArrayGetCell(g_zclass_hp, g_zombieclass[id]) * fnGetAlive())
				else
					fm_set_user_health(id, get_pcvar_num(cvar_nembasehp) * fnGetAlive())
			}
			else
				fm_set_user_health(id, get_pcvar_num(cvar_nemhp))
			
			// Set gravity, if frozen set the restore gravity value instead
			if (!g_frozen[id]) set_pev(id, pev_gravity, get_pcvar_float(cvar_nemgravity))
			else g_frozen_gravity[id] = get_pcvar_float(cvar_nemgravity)
			
			// Set nemesis maxspeed
			ExecuteHamB(Ham_Player_ResetMaxSpeed, id)
		}
		else if (assassin)
		{
			// Assassin
			g_assassin[id] = true
			
			// Set health [0 = auto]
			if (get_pcvar_num(cvar_asshp) == 0)
			{
				if (get_pcvar_num(cvar_assbasehp) == 0)
					fm_set_user_health(id, ArrayGetCell(g_zclass_hp, g_zombieclass[id]) * fnGetAlive())
				else
					fm_set_user_health(id, get_pcvar_num(cvar_assbasehp) * fnGetAlive())
			}
			else
				fm_set_user_health(id, get_pcvar_num(cvar_asshp))
			
			// Set gravity, if frozen set the restore gravity value instead
			if (!g_frozen[id]) set_pev(id, pev_gravity, get_pcvar_float(cvar_assgravity))
			else g_frozen_gravity[id] = get_pcvar_float(cvar_assgravity)
			
			// Set assassin maxspeed
			ExecuteHamB(Ham_Player_ResetMaxSpeed, id)
		}
		else if (fnGetZombies() == 1)
		{
			// First zombie
			g_firstzombie[id] = true
			
			// Set health
			fm_set_user_health(id, floatround(float(ArrayGetCell(g_zclass_hp, g_zombieclass[id])) * get_pcvar_float(cvar_zombiefirsthp)))
			
			// Set gravity, if frozen set the restore gravity value instead
			if (!g_frozen[id]) set_pev(id, pev_gravity, Float:ArrayGetCell(g_zclass_grav, g_zombieclass[id]))
			else g_frozen_gravity[id] = Float:ArrayGetCell(g_zclass_grav, g_zombieclass[id])
			
			// Set zombie maxspeed
			ExecuteHamB(Ham_Player_ResetMaxSpeed, id)
			
			// Infection sound
			static pointers[10], end
			ArrayGetArray(pointer_class_sound_infect, g_zombieclass[id], pointers)

			for (new i; i < 10; i++)
			{
				if (pointers[i] != -1)
					end = i
			}

			ArrayGetString(class_sound_infect, random_num(pointers[0], pointers[end]), sound, 63)
			emit_sound(id, CHAN_VOICE, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		else
		{
			// Infected by someone
			
			// Set health
			fm_set_user_health(id, ArrayGetCell(g_zclass_hp, g_zombieclass[id]))
			
			// Set gravity, if frozen set the restore gravity value instead
			if (!g_frozen[id]) set_pev(id, pev_gravity, Float:ArrayGetCell(g_zclass_grav, g_zombieclass[id]))
			else g_frozen_gravity[id] = Float:ArrayGetCell(g_zclass_grav, g_zombieclass[id])
			
			// Set zombie maxspeed
			ExecuteHamB(Ham_Player_ResetMaxSpeed, id)
			
			// Infection sound
			static pointers[10], end
			ArrayGetArray(pointer_class_sound_infect, g_zombieclass[id], pointers)

			for (new i; i < 10; i++)
			{
				if (pointers[i] != -1)
					end = i
			}

			ArrayGetString(class_sound_infect, random_num(pointers[0], pointers[end]), sound, 63)
			emit_sound(id, CHAN_VOICE, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
			
			// Show Infection HUD notice
			set_hudmessage(cvar_nvgcolor[0], cvar_nvgcolor[1], cvar_nvgcolor[2], HUD_INFECT_X, HUD_INFECT_Y, 0, 0.0, 5.0, 1.0, 1.0, -1) //255, 0, 0
			
			if (infector) // infected by someone?
				ShowSyncHudMsg(0, g_MsgSync, "%L", LANG_PLAYER, "NOTICE_INFECT2", g_playername[id], g_playername[infector])
//				show_dhudmessage(0, "%L", LANG_PLAYER, "NOTICE_INFECT2", g_playername[id], g_playername[infector])
			else
				ShowSyncHudMsg(0, g_MsgSync, "%L", LANG_PLAYER, "NOTICE_INFECT", g_playername[id])
//				show_dhudmessage(0, "%L", LANG_PLAYER, "NOTICE_INFECT", g_playername[id])
		}
	}
	else
	{
		// Silent mode, no HUD messages, no infection sounds
		
		// Set health
		fm_set_user_health(id, ArrayGetCell(g_zclass_hp, g_zombieclass[id]))
		
		// Set gravity, if frozen set the restore gravity value instead
		if (!g_frozen[id]) set_pev(id, pev_gravity, Float:ArrayGetCell(g_zclass_grav, g_zombieclass[id]))
		else g_frozen_gravity[id] = Float:ArrayGetCell(g_zclass_grav, g_zombieclass[id])
		
		// Set zombie maxspeed
		ExecuteHamB(Ham_Player_ResetMaxSpeed, id)
		
		if (nade)
		{
			// Infected victim's sound
			ArrayGetString(grenade_infect_player, random_num(0, ArraySize(grenade_infect_player) - 1), sound, 63)
			emit_sound(id, CHAN_VOICE, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
	}
	
	// Remove previous tasks
	remove_task(id+TASK_MODEL)
	remove_task(id+TASK_BLOOD)
	remove_task(id+TASK_AURA)
	remove_task(id+TASK_BURN)
	
	// Switch to T
	if (fm_cs_get_user_team(id) != FM_CS_TEAM_T) // need to change team?
	{
		remove_task(id+TASK_TEAM)
		fm_cs_set_user_team(id, FM_CS_TEAM_T)
		fm_user_team_update(id)
	}
	
	// Custom models stuff
	static currentmodel[32], tempmodel[32]
	new already_has_model = false, i, iRand, size
	
	if (g_handle_models_on_separate_ent)
	{
		// Set the right model
		if (g_nemesis[id])
		{
			iRand = random_num(0, ArraySize(model_nemesis) - 1)
			ArrayGetString(model_nemesis, iRand, g_playermodel[id], 31)
			if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_modelindex_nemesis, iRand))
		}
		else if (g_assassin[id])
		{
			iRand = random_num(0, ArraySize(model_assassin) - 1)
			ArrayGetString(model_assassin, iRand, g_playermodel[id], 31)
			if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_modelindex_assassin, iRand))
		}
		else
		{
			if (get_pcvar_num(cvar_adminmodelszombie) && (get_user_flags(id) & g_access_flag[ACCESS_ADMIN_MODELS]))
			{
				iRand = random_num(0, ArraySize(model_admin_zombie) - 1)
				ArrayGetString(model_admin_zombie, iRand, g_playermodel[id], 31)
				if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_modelindex_admin_zombie, iRand))
			}
			else
			{
				iRand = random_num(ArrayGetCell(g_zclass_modelsstart, g_zombieclass[id]), ArrayGetCell(g_zclass_modelsend, g_zombieclass[id]) - 1)
				ArrayGetString(g_zclass_playermodel, iRand, g_playermodel[id], 31)
				if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_zclass_modelindex, iRand))
			}
		}
		
		// Set model on player model entity
		fm_set_playermodel_ent(id)
		
		// Nemesis glow / remove glow on player model entity, unless frozen
		if (!g_frozen[id])
		{
			if (g_nemesis[id] && get_pcvar_num(cvar_nemglow))
				fm_set_rendering(g_ent_playermodel[id], kRenderFxGlowShell, cvar_nemnvgcolor[0], cvar_nemnvgcolor[1], cvar_nemnvgcolor[2], kRenderNormal) //255, 0, 0
			else if (g_assassin[id] && get_pcvar_num(cvar_assglow))
				fm_set_rendering(g_ent_playermodel[id], kRenderFxGlowShell, cvar_assnvgcolor[0], cvar_assnvgcolor[1], cvar_assnvgcolor[2], kRenderNormal) //255, 0, 0
			else
				fm_set_rendering(g_ent_playermodel[id])
		}
	}
	else
	{
		// Get current model for comparing it with the current one
		fm_cs_get_user_model(id, currentmodel, 31)
		
		// Set the right model, after checking that we don't already have it
		if (g_nemesis[id])
		{
			size = ArraySize(model_nemesis)
			for (i = 0; i < size; i++)
			{
				ArrayGetString(model_nemesis, i, tempmodel, 31)
				if (equali(currentmodel, tempmodel)) already_has_model = true
			}
			
			if (!already_has_model)
			{
				iRand = random_num(0, size - 1)
				ArrayGetString(model_nemesis, iRand, g_playermodel[id], 31)
				if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_modelindex_nemesis, iRand))
			}
		}
		else if (g_assassin[id])
		{
			size = ArraySize(model_assassin)
			for (i = 0; i < size; i++)
			{
				ArrayGetString(model_assassin, i, tempmodel, 31)
				if (equali(currentmodel, tempmodel)) already_has_model = true
			}
			
			if (!already_has_model)
			{
				iRand = random_num(0, size - 1)
				ArrayGetString(model_assassin, iRand, g_playermodel[id], 31)
				if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_modelindex_assassin, iRand))
			}
		}
		else
		{
			if (get_pcvar_num(cvar_adminmodelszombie) && (get_user_flags(id) & g_access_flag[ACCESS_ADMIN_MODELS]))
			{
				size = ArraySize(model_admin_zombie)
				for (i = 0; i < size; i++)
				{
					ArrayGetString(model_admin_zombie, i, tempmodel, 31)
					if (equali(currentmodel, tempmodel)) already_has_model = true
				}
				
				if (!already_has_model)
				{
					iRand = random_num(0, size - 1)
					ArrayGetString(model_admin_zombie, iRand, g_playermodel[id], 31)
					if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_modelindex_admin_zombie, iRand))
				}
			}
			else
			{
				for (i = ArrayGetCell(g_zclass_modelsstart, g_zombieclass[id]); i < ArrayGetCell(g_zclass_modelsend, g_zombieclass[id]); i++)
				{
					ArrayGetString(g_zclass_playermodel, i, tempmodel, 31)
					if (equali(currentmodel, tempmodel)) already_has_model = true
				}
				
				if (!already_has_model)
				{
					iRand = random_num(ArrayGetCell(g_zclass_modelsstart, g_zombieclass[id]), ArrayGetCell(g_zclass_modelsend, g_zombieclass[id]) - 1)
					ArrayGetString(g_zclass_playermodel, iRand, g_playermodel[id], 31)
					if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_zclass_modelindex, iRand))
				}
			}
		}
		
		// Need to change the model?
		if (!already_has_model)
		{
			// An additional delay is offset at round start
			// since SVC_BAD is more likely to be triggered there
			if (g_newround)
				set_task(5.0 * g_modelchange_delay, "fm_user_model_update", id+TASK_MODEL)
			else
				fm_user_model_update(id+TASK_MODEL)
		}
		
		// Nemesis glow / remove glow, unless frozen
		if (!g_frozen[id])
		{
			if (g_nemesis[id] && get_pcvar_num(cvar_nemglow))
				fm_set_rendering(id, kRenderFxGlowShell, cvar_nemnvgcolor[0], cvar_nemnvgcolor[1], cvar_nemnvgcolor[2], kRenderNormal) //255, 0, 0
			else if (g_assassin[id] && get_pcvar_num(cvar_assglow))
				fm_set_rendering(id, kRenderFxGlowShell, cvar_assnvgcolor[0], cvar_assnvgcolor[1], cvar_assnvgcolor[2], kRenderNormal) //255, 0, 0
			else
				fm_set_rendering(id)
		}
	}
	
	// Remove any zoom (bugfix)
	cs_set_user_zoom(id, CS_RESET_ZOOM, 1)
	
	// Remove armor
	cs_set_user_armor(id, 0, CS_ARMOR_NONE)
	
	// Drop weapons when infected
	drop_weapons(id, 1)
	drop_weapons(id, 2)
	
	// Strip zombies from guns and give them a knife
	fm_strip_user_weapons(id)
	fm_give_item(id, "weapon_knife")
	
	// Fancy effects
	infection_effects(id)
	
	// Nemesis aura task
	if (g_nemesis[id] && get_pcvar_num(cvar_nemaura) || g_assassin[id] && get_pcvar_num(cvar_assaura))
		set_task(0.1, "zombie_aura", id+TASK_AURA, _, _, "b")
	
	// Remove CS nightvision if player owns one (bugfix)
	if (cs_get_user_nvg(id))
	{
		cs_set_user_nvg(id, 0)
		if (get_pcvar_num(cvar_customnvg)) remove_task(id+TASK_NVISION)
		else if (g_nvisionenabled[id]) set_user_gnvision(id, 0)
	}
	
	// Give Zombies Night Vision?
	new nvggive = get_pcvar_num(cvar_nvggive)
	if (nvggive || assassin)
	{
		g_nvision[id] = true
	
		if (!g_isbot[id])
		{
			// Turn on Night Vision automatically?
			if (nvggive == 1 || assassin)
			{
				g_nvisionenabled[id] = true
				
				// Custom nvg?
				if (get_pcvar_num(cvar_customnvg))
				{
					remove_task(id+TASK_NVISION)
					set_task(0.1, "set_user_nvision", id+TASK_NVISION, _, _, "b")
				}
				else
					set_user_gnvision(id, 1)
			}
			// Turn off nightvision when infected (bugfix)
			else if (g_nvisionenabled[id])
			{
				if (get_pcvar_num(cvar_customnvg)) remove_task(id+TASK_NVISION)
				else set_user_gnvision(id, 0)
				g_nvisionenabled[id] = false
			}
		}
		else
			cs_set_user_nvg(id, 1); // turn on NVG for bots
	}
	// Disable nightvision when infected (bugfix)
	else if (g_nvision[id])
	{
		if (get_pcvar_num(cvar_customnvg)) remove_task(id+TASK_NVISION)
		else if (g_nvisionenabled[id]) set_user_gnvision(id, 0)
		g_nvision[id] = false
		g_nvisionenabled[id] = false
	}
	
	// Call the bloody task
	if (!g_nemesis[id] && !g_assassin[id])
	{
		if (get_pcvar_num(cvar_zombiebleeding))
			set_task(0.7, "make_blood", id+TASK_BLOOD, _, _, "b")
		
		// Idle sounds task
		set_task(random_float(50.0, 70.0), "zombie_play_idle", id+TASK_BLOOD, _, _, "b")
	}
	
	// Turn off zombie's flashlight
	turn_off_flashlight(id)
	
	// Post user infect forward
	ExecuteForward(g_fwUserInfected_post, g_fwDummyResult, id, infector, nemesis, assassin, nade)
	
	// Last Zombie Check
	fnCheckLastZombie()
	
	// Finish round if no humans left
	if(fnGetHumans() == 0)
		RoundEndForceControl(WINSTATUS_TERRORIST, 15.0)
}

// Function Human Me (player id, turn into a survivor, silent mode, turn into a sniper)
humanme(id, survivor, silentmode, sniper = 0)
{
	// User humanize attempt forward
	ExecuteForward(g_fwUserHumanize_attempt, g_fwDummyResult, id, survivor, sniper)
	
	// One or more plugins blocked the "humanization". Only allow this after making sure it's
	// not going to leave us with no humans. Take into account a last player leaving case.
	// BUGFIX: only allow after a mode has started, to prevent blocking first survivor e.g.
	if (g_fwDummyResult >= ZP_PLUGIN_HANDLED && g_modestarted && fnGetHumans() > g_lastplayerleaving)
		return;
	
	// Pre user humanize forward
	ExecuteForward(g_fwUserHumanized_pre, g_fwDummyResult, id, survivor, sniper)
	
	// Remove previous tasks
	remove_task(id+TASK_MODEL)
	remove_task(id+TASK_BLOOD)
	remove_task(id+TASK_AURA)
	remove_task(id+TASK_BURN)
	remove_task(id+TASK_NVISION)
	
	if (get_pcvar_num(cvar_hclasses))
	{
		// Show human class menu if they haven't chosen any (e.g. just connected)
		if (g_humanclassnext[id] == HZCLASS_NONE)
			show_menu_hclass(id) //set_task(0.2, "show_menu_hclass", id)
		else
			// Set selected human class
			g_humanclass[id] = g_humanclassnext[id]
	}
	
	// Reset some vars
	g_zombie[id] = false
	g_nemesis[id] = false
	g_survivor[id] = false
	g_firstzombie[id] = false
	g_canbuy[id] = true
	g_buytime[id] = get_gametime()
	g_sniper[id] = false
	g_assassin[id] = false
	
	// Remove survivor's aura (bugfix)
	set_pev(id, pev_effects, pev(id, pev_effects) &~ EF_BRIGHTLIGHT)
	remove_task(id+TASK_AURA)
	
	// Remove spawn protection (bugfix)
	g_nodamage[id] = false
	set_pev(id, pev_effects, pev(id, pev_effects) &~ EF_NODRAW)
	
	// Reset burning duration counter (bugfix)
	g_burning_duration[id] = 0
	
	// Remove CS nightvision if player owns one (bugfix)
	if (cs_get_user_nvg(id))
	{
		cs_set_user_nvg(id, 0)
		if (get_pcvar_num(cvar_customnvg)) remove_task(id+TASK_NVISION)
		else if (g_nvisionenabled[id]) set_user_gnvision(id, 0)
	}
	
	// Cache speed and name for player's class
	g_human_spd[id] = float(ArrayGetCell(g_hclass_spd, g_humanclass[id]))
	ArrayGetString(g_hclass_name, g_humanclass[id], g_human_classname[id], 31)
	
	// Drop previous weapons
	drop_weapons(id, 1)
	drop_weapons(id, 2)
	
	// Strip off from weapons
	fm_strip_user_weapons(id)
	fm_give_item(id, "weapon_knife")
	
	// Set human attributes based on the mode
	if (survivor)
	{
		// Survivor
		g_survivor[id] = true
		
		// Set Health [0 = auto]
		if (get_pcvar_num(cvar_survhp) == 0)
		{
			if (get_pcvar_num(cvar_survbasehp) == 0)
				fm_set_user_health(id, ArrayGetCell(g_hclass_hp, g_humanclass[id]) * fnGetAlive())
			else
				fm_set_user_health(id, get_pcvar_num(cvar_survbasehp) * fnGetAlive())
		}
		else
			fm_set_user_health(id, get_pcvar_num(cvar_survhp))
		
		// Set gravity, if frozen set the restore gravity value instead
		if (!g_frozen[id]) set_pev(id, pev_gravity, get_pcvar_float(cvar_survgravity))
		else g_frozen_gravity[id] = get_pcvar_float(cvar_survgravity)
		
		// Set survivor maxspeed
		ExecuteHamB(Ham_Player_ResetMaxSpeed, id)
		
		// Give survivor his own weapon
		static survweapon[32]
		get_pcvar_string(cvar_survweapon, survweapon, 31)
		fm_give_item(id, survweapon)
		new weaponid = cs_weapon_name_to_id(survweapon)
		ExecuteHamB(Ham_GiveAmmo, id, MAXBPAMMO[weaponid], AMMOTYPE[weaponid], MAXBPAMMO[weaponid])
		
		// Turn off his flashlight
		turn_off_flashlight(id)
		
		// Give the survivor a bright light
		if (get_pcvar_num(cvar_survaura)) set_pev(id, pev_effects, pev(id, pev_effects) | EF_BRIGHTLIGHT)
		
		// Survivor bots will also need nightvision to see in the dark
		if (g_isbot[id])
		{
			g_nvision[id] = true
			cs_set_user_nvg(id, 1)
		}
		
		g_infammo[id] = get_pcvar_num(cvar_survinfammo)
	}
	else if (sniper)
	{
		// Sniper
		g_sniper[id] = true
		
		// Set Health [0 = auto]
		if (get_pcvar_num(cvar_sniphp) == 0)
		{
			if (get_pcvar_num(cvar_snipbasehp) == 0)
				fm_set_user_health(id, ArrayGetCell(g_hclass_hp, g_humanclass[id]) * fnGetAlive())
			else
				fm_set_user_health(id, get_pcvar_num(cvar_snipbasehp) * fnGetAlive())
		}
		else
			fm_set_user_health(id, get_pcvar_num(cvar_sniphp))
		
		// Set gravity, if frozen set the restore gravity value instead
		set_pev(id, pev_gravity, get_pcvar_float(cvar_snipgravity))
		
		// Set sniper maxspeed
		ExecuteHamB(Ham_Player_ResetMaxSpeed, id)
		
		// Give sniper his own weapon
		fm_give_item(id, "weapon_awp")
		ExecuteHamB(Ham_GiveAmmo, id, MAXBPAMMO[CSW_AWP], AMMOTYPE[CSW_AWP], MAXBPAMMO[CSW_AWP])
		
		// Turn off his flashlight
		turn_off_flashlight(id)
		
		// Give the sniper a bright light
		if (get_pcvar_num(cvar_snipaura))
			set_task(0.1, "human_aura", id+TASK_AURA, _, _, "b")
		
		// Sniper bots will also need nightvision to see in the dark
		if (g_isbot[id])
		{
			g_nvision[id] = true
			cs_set_user_nvg(id, 1)
		}
		
		g_infammo[id] = get_pcvar_num(cvar_snipinfammo)
	}
	else
	{
		// Human taking an antidote
		
		// Set health
		fm_set_user_health(id, ArrayGetCell(g_hclass_hp, g_humanclass[id]))
		
		// Set gravity, if frozen set the restore gravity value instead
		set_pev(id, pev_gravity, Float:ArrayGetCell(g_hclass_grav, g_humanclass[id]))
		
		// Show custom buy menu?
		if (get_pcvar_num(cvar_buycustom))
			show_menu_buy1(id+TASK_SPAWN) //set_task(0.2, "show_menu_buy1", id+TASK_SPAWN)
		
		// Silent mode = no HUD messages, no antidote sound
		if (!silentmode)
		{
			// Antidote sound
			static sound[64]
			ArrayGetString(sound_antidote, random_num(0, ArraySize(sound_antidote) - 1), sound, 63)
			emit_sound(id, CHAN_ITEM, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
			
			// Show Antidote HUD notice
			set_hudmessage(cvar_humnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], HUD_INFECT_X, HUD_INFECT_Y, 0, 0.0, 5.0, 1.0, 1.0, -1) //0, 0, 255
			ShowSyncHudMsg(0, g_MsgSync, "%L", LANG_PLAYER, "NOTICE_ANTIDOTE", g_playername[id])
//			show_dhudmessage(0, "%L", LANG_PLAYER, "NOTICE_ANTIDOTE", g_playername[id])
		}
		
		g_infammo[id] = get_pcvar_num(cvar_infammo)
	}
	
	// Switch to CT
	if (fm_cs_get_user_team(id) != FM_CS_TEAM_CT) // need to change team?
	{
		remove_task(id+TASK_TEAM)
		fm_cs_set_user_team(id, FM_CS_TEAM_CT)
		fm_user_team_update(id)
	}
	
	// Custom models stuff
	static currentmodel[32], tempmodel[32]
	new already_has_model = false, i, iRand, size
	
	if (g_handle_models_on_separate_ent)
	{
		// Set the right model
		if (g_survivor[id])
		{
			iRand = random_num(0, ArraySize(model_survivor) - 1)
			ArrayGetString(model_survivor, iRand, g_playermodel[id], 31)
			if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_modelindex_survivor, iRand))
		}
		else if (g_sniper[id])
		{
			iRand = random_num(0, ArraySize(model_sniper) - 1)
			ArrayGetString(model_sniper, iRand, g_playermodel[id], 31)
			if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_modelindex_sniper, iRand))
		}
		else
		{
			iRand = random_num(ArrayGetCell(g_hclass_modelsstart, g_humanclass[id]), ArrayGetCell(g_hclass_modelsend, g_humanclass[id]) - 1)
			ArrayGetString(g_hclass_playermodel, iRand, g_playermodel[id], 31)
			if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_hclass_modelindex, iRand))
		}
		
		// Set model on player model entity
		fm_set_playermodel_ent(id)
		
		// Set survivor glow / remove glow on player model entity, unless frozen
		if (!g_frozen[id])
		{
			if (g_survivor[id] && get_pcvar_num(cvar_survglow))
				fm_set_rendering(g_ent_playermodel[id], kRenderFxGlowShell, cvar_humnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], kRenderNormal) //0, 0, 255
			else if (g_sniper[id] && get_pcvar_num(cvar_snipglow))
				fm_set_rendering(g_ent_playermodel[id], kRenderFxGlowShell, cvar_assnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], kRenderNormal) //0, 0, 255
			else
				fm_set_rendering(g_ent_playermodel[id])
		}
	}
	else
	{
		// Get current model for comparing it with the current one
		fm_cs_get_user_model(id, currentmodel, 31)
		
		// Set the right model, after checking that we don't already have it
		if (g_survivor[id])
		{
			size = ArraySize(model_survivor)
			for (i = 0; i < size; i++)
			{
				ArrayGetString(model_survivor, i, tempmodel, 31)
				if (equali(currentmodel, tempmodel)) already_has_model = true
			}
			
			if (!already_has_model)
			{
				iRand = random_num(0, size - 1)
				ArrayGetString(model_survivor, iRand, g_playermodel[id], 31)
				if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_modelindex_survivor, iRand))
			}
		}
		else if (g_sniper[id])
		{
			size = ArraySize(model_sniper)
			for (i = 0; i < size; i++)
			{
				ArrayGetString(model_sniper, i, tempmodel, 31)
				if (equali(currentmodel, tempmodel)) already_has_model = true
			}
			
			if (!already_has_model)
			{
				iRand = random_num(0, size - 1)
				ArrayGetString(model_sniper, iRand, g_playermodel[id], 31)
				if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_modelindex_sniper, iRand))
			}
		}
		else
		{
			if (get_pcvar_num(cvar_adminmodelshuman) && (get_user_flags(id) & g_access_flag[ACCESS_ADMIN_MODELS]))
			{
				size = ArraySize(model_admin_human)
				for (i = 0; i < size; i++)
				{
					ArrayGetString(model_admin_human, i, tempmodel, 31)
					if (equali(currentmodel, tempmodel)) already_has_model = true
				}
				
				if (!already_has_model)
				{
					iRand = random_num(0, size - 1)
					ArrayGetString(model_admin_human, iRand, g_playermodel[id], 31)
					if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_modelindex_admin_human, iRand))
				}
			}
			else
			{
				for (i = ArrayGetCell(g_hclass_modelsstart, g_humanclass[id]); i < ArrayGetCell(g_hclass_modelsend, g_humanclass[id]); i++)
				{
					ArrayGetString(g_hclass_playermodel, i, tempmodel, 31)
					if (equali(currentmodel, tempmodel)) already_has_model = true
				}
				
				if (!already_has_model)
				{
					iRand = random_num(ArrayGetCell(g_hclass_modelsstart, g_humanclass[id]), ArrayGetCell(g_hclass_modelsend, g_humanclass[id]) - 1)
					ArrayGetString(g_hclass_playermodel, iRand, g_playermodel[id], 31)
					if (g_set_modelindex_offset) fm_cs_set_user_model_index(id, ArrayGetCell(g_hclass_modelindex, iRand))
				}
			}
		}
		
		// Need to change the model?
		if (!already_has_model)
		{
			// An additional delay is offset at round start
			// since SVC_BAD is more likely to be triggered there
			if (g_newround)
				set_task(5.0 * g_modelchange_delay, "fm_user_model_update", id+TASK_MODEL)
			else
				fm_user_model_update(id+TASK_MODEL)
		}
		
		// Set survivor glow / remove glow, unless frozen
		if (!g_frozen[id])
		{
			if (g_survivor[id] && get_pcvar_num(cvar_survglow))
				fm_set_rendering(id, kRenderFxGlowShell, cvar_humnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], kRenderNormal) //0, 0, 255
			else if (g_sniper[id] && get_pcvar_num(cvar_snipglow))
				fm_set_rendering(id, kRenderFxGlowShell, cvar_assnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], kRenderNormal) //0, 0, 255
			else
				fm_set_rendering(id)
		}
	}
	
	// Restore FOV?
	new zombiefov = get_pcvar_num(cvar_zombiefov)
	if (zombiefov != 90 && zombiefov != 0)
	{
		message_begin(MSG_ONE, g_msgSetFOV, _, id)
		write_byte(90) // angle
		message_end()
	}
	
	// Disable nightvision when turning into human/survivor (bugfix)
	if (g_nvision[id])
	{
		if (get_pcvar_num(cvar_customnvg)) remove_task(id+TASK_NVISION)
		else if (g_nvisionenabled[id]) set_user_gnvision(id, 0)
		g_nvision[id] = false
		g_nvisionenabled[id] = false
	}
	
	// Post user humanize forward
	ExecuteForward(g_fwUserHumanized_post, g_fwDummyResult, id, survivor, sniper)
	
	// Last Zombie Check
	fnCheckLastZombie()
}

/*================================================================================
 [Other Functions and Tasks]
=================================================================================*/

public cache_cvars()
{
/*	g_cached_zombiesilent = get_pcvar_num(cvar_zombiesilent)
	g_cached_customflash = get_pcvar_num(cvar_customflash)
	g_cached_leapzombies = get_pcvar_num(cvar_leapzombies)*/
	g_cached_leapzombiescooldown = get_pcvar_float(cvar_leapzombiescooldown)
//	g_cached_leapnemesis = get_pcvar_num(cvar_leapnemesis)
	g_cached_leapnemesiscooldown = get_pcvar_float(cvar_leapnemesiscooldown)
//	g_cached_leapsurvivor = get_pcvar_num(cvar_leapsurvivor)
	g_cached_leapsurvivorcooldown = get_pcvar_float(cvar_leapsurvivorcooldown)
	g_cached_buytime = get_pcvar_float(cvar_buyzonetime)
//	g_cached_leapsniper = get_pcvar_num(cvar_leapsniper)
	g_cached_leapsnipercooldown = get_pcvar_float(cvar_leapsnipercooldown)
//	g_cached_leapassassin = get_pcvar_num(cvar_leapassassin)
	g_cached_leapassassincooldown = get_pcvar_float(cvar_leapassassincooldown)
}

public cache_settings()
{
	cvar_zombiesilent = get_pcvar_num(cvar_zombiesilent)
	cvar_customflash = get_pcvar_num(cvar_customflash)
	cvar_leapzombies = get_pcvar_num(cvar_leapzombies)
	cvar_leapnemesis = get_pcvar_num(cvar_leapnemesis)
	cvar_leapsurvivor = get_pcvar_num(cvar_leapsurvivor)
	cvar_leapsniper = get_pcvar_num(cvar_leapsniper)
	cvar_leapassassin = get_pcvar_num(cvar_leapassassin)
	
	cvar_gravity = get_pcvar_float(get_cvar_pointer("sv_gravity"))
	cvar_nvgcolor[0] = get_pcvar_num(cvar_nvgcolor[0])
	cvar_nvgcolor[1] = get_pcvar_num(cvar_nvgcolor[1])
	cvar_nvgcolor[2] = get_pcvar_num(cvar_nvgcolor[2])
	cvar_humnvgcolor[0] = get_pcvar_num(cvar_humnvgcolor[0])
	cvar_humnvgcolor[1] = get_pcvar_num(cvar_humnvgcolor[1])
	cvar_humnvgcolor[2] = get_pcvar_num(cvar_humnvgcolor[2])
	cvar_nemnvgcolor[0] = get_pcvar_num(cvar_nemnvgcolor[0])
	cvar_nemnvgcolor[1] = get_pcvar_num(cvar_nemnvgcolor[1])
	cvar_nemnvgcolor[2] = get_pcvar_num(cvar_nemnvgcolor[2])
	cvar_assnvgcolor[0] = get_pcvar_num(cvar_assnvgcolor[0])
	cvar_assnvgcolor[1] = get_pcvar_num(cvar_assnvgcolor[1])
	cvar_assnvgcolor[2] = get_pcvar_num(cvar_assnvgcolor[2])
	cvar_flashcolor[0] = get_pcvar_num(cvar_flashcolor[0])
	cvar_flashcolor[1] = get_pcvar_num(cvar_flashcolor[1])
	cvar_flashcolor[2] = get_pcvar_num(cvar_flashcolor[2])
	cvar_flashsize = get_pcvar_num(cvar_flashsize)
	cvar_flashshowall = get_pcvar_num(cvar_flashshowall)
	
	cvar_firegrenades = get_pcvar_num(cvar_firegrenades)
	cvar_frostgrenades = get_pcvar_num(cvar_frostgrenades)
	cvar_flaregrenades = get_pcvar_num(cvar_flaregrenades)
/*	cvar_extrainfbomb = get_pcvar_num(cvar_extrainfbomb)
	
	cvar_survinfammo = get_pcvar_num(cvar_survinfammo)
	cvar_snipinfammo = get_pcvar_num(cvar_snipinfammo)
	cvar_infammo = get_pcvar_num(cvar_infammo)
	
	cvar_randspawn = get_pcvar_num(cvar_randspawn)
	cvar_removemoney = get_pcvar_num(cvar_removemoney)
	cvar_hclasses = get_pcvar_num(cvar_hclasses)
	cvar_respawnworldspawnkill = get_pcvar_num(cvar_respawnworldspawnkill)
	cvar_buycustom = get_pcvar_num(cvar_buycustom)
	cvar_adminmodelshuman = get_pcvar_num(cvar_adminmodelshuman)
	cvar_extraitems = get_pcvar_num(cvar_extraitems)
	cvar_nvggive = get_pcvar_num(cvar_nvggive)
	cvar_customnvg = get_pcvar_num(cvar_customnvg)
	cvar_nemignorefrags = get_pcvar_num(cvar_nemignorefrags)
	cvar_fragskill = get_pcvar_num(cvar_fragskill)
	cvar_fragsinfect = get_pcvar_num(cvar_fragsinfect)
	cvar_survignorefrags = get_pcvar_num(cvar_survignorefrags)
	cvar_snipignorefrags = get_pcvar_num(cvar_snipignorefrags)
	cvar_assignorefrags = get_pcvar_num(cvar_assignorefrags)
	cvar_nemignoreammo = get_pcvar_num(cvar_nemignoreammo)
	cvar_assignoreammo = get_pcvar_num(cvar_assignoreammo)*/
	cvar_survignoreammo = get_pcvar_num(cvar_survignoreammo)
	cvar_snipignoreammo = get_pcvar_num(cvar_snipignoreammo)
/*	cvar_ammoinfect = get_pcvar_num(cvar_ammoinfect)
	cvar_deathmatch = get_pcvar_num(cvar_deathmatch)
	cvar_respawnonsuicide = get_pcvar_num(cvar_respawnonsuicide)
	cvar_respawnlimit = get_pcvar_num(cvar_respawnlimit)
	cvar_respawnzomb = get_pcvar_num(cvar_respawnzomb)
	cvar_respawnhum = get_pcvar_num(cvar_respawnhum)
	cvar_respawnnem = get_pcvar_num(cvar_respawnnem)
	cvar_respawnsurv = get_pcvar_num(cvar_respawnsurv)
	cvar_respawnsnip = get_pcvar_num(cvar_respawnsnip)
	cvar_respawnass = get_pcvar_num(cvar_respawnass)*/
	cvar_ammodamage_human = get_pcvar_num(cvar_ammodamage_human)
	cvar_ammodamage_zombie = get_pcvar_num(cvar_ammodamage_zombie)
	cvar_humanarmor = get_pcvar_num(cvar_humanarmor)
	cvar_nempainfree = get_pcvar_num(cvar_nempainfree)
	cvar_asspainfree = get_pcvar_num(cvar_asspainfree)
	cvar_zombiepainfree = get_pcvar_num(cvar_zombiepainfree)
	cvar_survpainfree = get_pcvar_num(cvar_survpainfree)
	cvar_snippainfree = get_pcvar_num(cvar_snippainfree)
	cvar_hitzones = get_pcvar_num(cvar_hitzones)
	cvar_knockback = get_pcvar_num(cvar_knockback)
	cvar_knockbackdist = get_pcvar_num(cvar_knockbackdist)
	cvar_knockbackdamage = get_pcvar_num(cvar_knockbackdamage)
	cvar_knockbackpower = get_pcvar_num(cvar_knockbackpower)
	cvar_knockbackzvel = get_pcvar_num(cvar_knockbackzvel)
/*	cvar_flareduration = get_pcvar_num(cvar_flareduration)
	cvar_leapsurvivorforce = get_pcvar_num(cvar_leapsurvivorforce)
	cvar_leapsniperforce = get_pcvar_num(cvar_leapsniperforce)
	cvar_leapnemesisforce = get_pcvar_num(cvar_leapnemesisforce)
	cvar_leapassassinforce = get_pcvar_num(cvar_leapassassinforce)
	cvar_leapzombiesforce = get_pcvar_num(cvar_leapzombiesforce)
	cvar_leapsurvivorheight = get_pcvar_num(cvar_leapsurvivorheight)
	cvar_leapsniperheight = get_pcvar_num(cvar_leapsniperheight)
	cvar_leapnemesisheight = get_pcvar_num(cvar_leapnemesisheight)
	cvar_leapassassinheight = get_pcvar_num(cvar_leapassassinheight)
	cvar_leapzombiesheight = get_pcvar_num(cvar_leapzombiesheight)
	cvar_zclasses = get_pcvar_num(cvar_zclasses)*/
	cvar_blocksuicide = get_pcvar_num(cvar_blocksuicide)
/*	cvar_randweapons = get_pcvar_num(cvar_randweapons)
	cvar_extranvision = get_pcvar_num(cvar_extranvision)
	cvar_extraantidote = get_pcvar_num(cvar_extraantidote)
	cvar_antidotelimit = get_pcvar_num(cvar_antidotelimit)
	cvar_extramadness = get_pcvar_num(cvar_extramadness)
	cvar_madnesslimit = get_pcvar_num(cvar_madnesslimit)
	cvar_infbomblimit = get_pcvar_num(cvar_infbomblimit)
	cvar_extraweapons = get_pcvar_num(cvar_extraweapons)*/
	cvar_plaguesurvnum = get_pcvar_num(cvar_plaguesurvnum)
	cvar_plaguenemnum = get_pcvar_num(cvar_plaguenemnum)
/*	cvar_nemhp = get_pcvar_num(cvar_nemhp)
	cvar_nembasehp = get_pcvar_num(cvar_nembasehp)
	cvar_asshp = get_pcvar_num(cvar_asshp)
	cvar_assbasehp = get_pcvar_num(cvar_assbasehp)
	cvar_adminmodelszombie = get_pcvar_num(cvar_adminmodelszombie)
	cvar_nemglow = get_pcvar_num(cvar_nemglow)
	cvar_assglow = get_pcvar_num(cvar_assglow)
	cvar_nemaura = get_pcvar_num(cvar_nemaura)
	cvar_assaura = get_pcvar_num(cvar_assaura)
	cvar_zombiefov = get_pcvar_num(cvar_zombiefov)
	cvar_zombiebleeding = get_pcvar_num(cvar_zombiebleeding)
	cvar_survhp = get_pcvar_num(cvar_survhp)
	cvar_survbasehp = get_pcvar_num(cvar_survbasehp)
	cvar_survaura = get_pcvar_num(cvar_survaura)
	cvar_sniphp = get_pcvar_num(cvar_sniphp)
	cvar_snipbasehp = get_pcvar_num(cvar_snipbasehp)
	cvar_snipaura = get_pcvar_num(cvar_snipaura)
	cvar_survglow = get_pcvar_num(cvar_survglow)
	cvar_snipglow = get_pcvar_num(cvar_snipglow)
	cvar_allowrespawnsurv = get_pcvar_num(cvar_allowrespawnsurv)
	cvar_allowrespawnswarm = get_pcvar_num(cvar_allowrespawnswarm)
	cvar_allowrespawnnem = get_pcvar_num(cvar_allowrespawnnem)
	cvar_allowrespawnplague = get_pcvar_num(cvar_allowrespawnplague)
	cvar_allowrespawnsnip = get_pcvar_num(cvar_allowrespawnsnip)
	cvar_allowrespawnass = get_pcvar_num(cvar_allowrespawnass)
	cvar_allowrespawninfection = get_pcvar_num(cvar_allowrespawninfection)
	cvar_respawnafterlast = get_pcvar_num(cvar_respawnafterlast)*/
	cvar_flashdrain = get_pcvar_num(cvar_flashdrain)
	cvar_flashcharge = get_pcvar_num(cvar_flashcharge)
/*	cvar_hudicons = get_pcvar_num(cvar_hudicons)
	cvar_fireduration = get_pcvar_num(cvar_fireduration)*/
	cvar_adminknifemodelszombie = get_pcvar_num(cvar_adminknifemodelszombie)
	cvar_adminknifemodelshuman = get_pcvar_num(cvar_adminknifemodelshuman)
	cvar_nvgsize = get_pcvar_num(cvar_nvgsize)
/*	cvar_infectionscreenfade = get_pcvar_num(cvar_infectionscreenfade)
	cvar_infectionscreenshake = get_pcvar_num(cvar_infectionscreenshake)
	cvar_infectiontracers = get_pcvar_num(cvar_infectiontracers)
	cvar_infectionparticles = get_pcvar_num(cvar_infectionparticles)
	cvar_infectionsparkle = get_pcvar_num(cvar_infectionsparkle)*/
}

is_mp3(const sound[])
	return equali(sound[strlen(sound)-4], ".mp3") ? true : false

load_customization_from_files()
{
	// Build customization file path
	new path[64]
	get_configsdir(path, 63)
	format(path, 63, "%s/%s", path, ZP_CUSTOMIZATION_FILE)
	
	// File not present
	if (!file_exists(path))
	{
		new error[100]
		formatex(error, 99, "Cannot load customization file %s!", path)
		set_fail_state(error)
		return;
	}
	
	// Set up some vars to hold parsing info
	new linedata[1024], key[64], value[960], section, teams
	
	// Open customization file for reading
	new file = fopen(path, "rt")
	
	while (file && !feof(file))
	{
		// Read one line at a time
		fgets(file, linedata, 1023)
		
		// Replace newlines with a null character to prevent headaches
		replace(linedata, 1023, "^n", "")
		
		// Blank line or comment
		if (!linedata[0] || linedata[0] == ';') continue;
		
		// New section starting
		if (linedata[0] == '[')
		{
			section++
			continue;
		}
		
		// Get key and value(s)
		strtok(linedata, key, 63, value, 959, '=')
		
		// Trim spaces
		trim(key)
		trim(value)
		
		switch (section)
		{
			case SECTION_ACCESS_FLAGS:
			{
				if (equali(key, "ENABLE/DISABLE MOD"))
					g_access_flag[ACCESS_ENABLE_MOD] = read_flags(value)
				else if (equali(key, "ADMIN MENU"))
					g_access_flag[ACCESS_ADMIN_MENU] = read_flags(value)
				else if (equali(key, "START MODE INFECTION"))
					g_access_flag[ACCESS_MODE_INFECTION] = read_flags(value)
				else if (equali(key, "START MODE NEMESIS"))
					g_access_flag[ACCESS_MODE_NEMESIS] = read_flags(value)
				else if (equali(key, "START MODE SURVIVOR"))
					g_access_flag[ACCESS_MODE_SURVIVOR] = read_flags(value)
				else if (equali(key, "START MODE SWARM"))
					g_access_flag[ACCESS_MODE_SWARM] = read_flags(value)
				else if (equali(key, "START MODE MULTI"))
					g_access_flag[ACCESS_MODE_MULTI] = read_flags(value)
				else if (equali(key, "START MODE PLAGUE"))
					g_access_flag[ACCESS_MODE_PLAGUE] = read_flags(value)
				else if (equali(key, "MAKE ZOMBIE"))
					g_access_flag[ACCESS_MAKE_ZOMBIE] = read_flags(value)
				else if (equali(key, "MAKE HUMAN"))
					g_access_flag[ACCESS_MAKE_HUMAN] = read_flags(value)
				else if (equali(key, "MAKE NEMESIS"))
					g_access_flag[ACCESS_MAKE_NEMESIS] = read_flags(value)
				else if (equali(key, "MAKE SURVIVOR"))
					g_access_flag[ACCESS_MAKE_SURVIVOR] = read_flags(value)
				else if (equali(key, "RESPAWN PLAYERS"))
					g_access_flag[ACCESS_RESPAWN_PLAYERS] = read_flags(value)
				else if (equali(key, "ADMIN MODELS"))
					g_access_flag[ACCESS_ADMIN_MODELS] = read_flags(value)
				else if (equali(key, "START MODE SNIPER"))
					g_access_flag[ACCESS_MODE_SNIPER] = read_flags(value)
				else if (equali(key, "MAKE SNIPER"))
					g_access_flag[ACCESS_MAKE_SNIPER] = read_flags(value)
				else if (equali(key, "START MODE ASSASSIN"))
					g_access_flag[ACCESS_MODE_ASSASSIN] = read_flags(value)
				else if (equali(key, "MAKE ASSASSIN"))
					g_access_flag[ACCESS_MAKE_ASSASSIN] = read_flags(value)
			}
			case SECTION_PLAYER_MODELS:
			{
				if (equali(key, "NEMESIS"))
				{
					// Parse models
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to models array
						ArrayPushString(model_nemesis, key)
					}
				}
				else if (equali(key, "SURVIVOR"))
				{
					// Parse models
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to models array
						ArrayPushString(model_survivor, key)
					}
				}
				else if (equali(key, "SNIPER"))
				{
					// Parse models
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to models array
						ArrayPushString(model_sniper, key)
					}
				}
				if (equali(key, "ASSASSIN"))
				{
					// Parse models
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to models array
						ArrayPushString(model_assassin, key)
					}
				}
				else if (equali(key, "ADMIN ZOMBIE"))
				{
					// Parse models
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to models array
						ArrayPushString(model_admin_zombie, key)
					}
				}
				else if (equali(key, "ADMIN HUMAN"))
				{
					// Parse models
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to models array
						ArrayPushString(model_admin_human, key)
					}
				}
				else if (equali(key, "FORCE CONSISTENCY"))
					g_force_consistency = str_to_num(value)
				else if (equali(key, "SAME MODELS FOR ALL"))
					g_same_models_for_all = str_to_num(value)
				else if (g_same_models_for_all && equali(key, "ZOMBIE"))
				{
					// Parse models
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to models array
						ArrayPushString(g_zclass_playermodel, key)
						
						// Precache model and retrieve its modelindex
						formatex(linedata, 1023, "models/player/%s/%s.mdl", key, key)
						ArrayPushCell(g_zclass_modelindex, engfunc(EngFunc_PrecacheModel, linedata))
						if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, linedata)
						if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, linedata)
						// Precache modelT.mdl files too
						copy(linedata[strlen(linedata)-4], 1023 - (strlen(linedata)-4), "T.mdl")
						if (file_exists(linedata)) engfunc(EngFunc_PrecacheModel, linedata)
					}
				}
				else if (g_same_models_for_all && equali(key, "HUMAN"))
				{
					// Parse models
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to models array
						ArrayPushString(g_hclass_playermodel, key)
						
						// Precache model and retrieve its modelindex
						formatex(linedata, 1023, "models/player/%s/%s.mdl", key, key)
						ArrayPushCell(g_hclass_modelindex, engfunc(EngFunc_PrecacheModel, linedata))
						if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, linedata)
						if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, linedata)
						// Precache modelT.mdl files too
						copy(linedata[strlen(linedata)-4], 1023 - (strlen(linedata)-4), "T.mdl")
						if (file_exists(linedata)) engfunc(EngFunc_PrecacheModel, linedata)
					}
				}
			}
			case SECTION_WEAPON_MODELS:
			{
				if (equali(key, "V_KNIFE NEMESIS"))
					copy(model_vknife_nemesis, 63, value)
/*=====				else if (equal(key, "V_M249 SURVIVOR")) // backwards compatibility with old configs
					copy(model_vweapon_survivor, 63, value) */
				else if (equali(key, "V_WEAPON SURVIVOR"))
					copy(model_vweapon_survivor, 63, value)
				else if (equali(key, "V_AWP SNIPER"))
					copy(model_vweapon_sniper, 63, value)
				else if (equali(key, "V_KNIFE ASSASSIN"))
					copy(model_vknife_assassin, 63, value)
				else if (equali(key, "GRENADEINFECT"))
					copy(model_v_grenade_infection, 63, value)
				else if (equali(key, "P_GRENADE_INFECT"))
					copy(model_p_grenade_infection, 63, value)
				else if (equali(key, "W_GRENADE_INFECT"))
					copy(model_w_grenade_infection, 63, value)
				else if (equali(key, "GRENADEFIRE"))
					copy(model_v_grenade_fire, 63, value)
				else if (equali(key, "P_GRENADE_FIRE"))
					copy(model_p_grenade_fire, 63, value)
				else if (equali(key, "W_GRENADE_FIRE"))
					copy(model_w_grenade_fire, 63, value)
				else if (equali(key, "GRENADEFROST"))
					copy(model_v_grenade_frost, 63, value)
				else if (equali(key, "P_GRENADE_FROST"))
					copy(model_p_grenade_frost, 63, value)
				else if (equali(key, "W_GRENADE_FROST"))
					copy(model_w_grenade_frost, 63, value)
				else if (equali(key, "GRENADEFLARE"))
					copy(model_v_grenade_flare, 63, value)
				else if (equali(key, "P_GRENADE_FLARE"))
					copy(model_p_grenade_flare, 63, value)
				else if (equali(key, "W_GRENADE_FLARE"))
					copy(model_w_grenade_flare, 63, value)
				else if (equali(key, "V_KNIFE ADMIN HUMAN"))
					copy(model_vknife_admin_human, 63, value)
				else if (equali(key, "V_KNIFE ADMIN ZOMBIE"))
					copy(model_vknife_admin_zombie, 63, value)
			}
			case SECTION_GRENADE_SPRITES:
			{
				if (equali(key, "TALRASHA_FIRE"))
					copy(trail_grenade_fire, 63, value)
				else if (equali(key, "TALRASHA_FROST"))
					copy(trail_grenade_frost, 63, value)
				else if (equali(key, "TALRASHA_FLARE"))
					copy(trail_grenade_flare, 63, value)
				else if (equali(key, "TALRASHA_INFECT"))
					copy(trail_grenade_infect, 63, value)
				else if (equali(key, "RING"))
					copy(sprite_grenade_ring, 63, value)
				else if (equali(key, "FIRE"))
					copy(sprite_grenade_fire, 63, value)
				else if (equali(key, "SMOKE"))
					copy(sprite_grenade_smoke, 63, value)
				else if (equali(key, "GLASS"))
					copy(sprite_grenade_glass, 63, value)
			}
			case SECTION_SOUNDS:
			{
				if (equali(key, "WIN ZOMBIES"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_win_zombies, key)
//						ArrayPushCell(sound_win_zombies_ismp3, equali(key[strlen(key)-4], ".mp3") ? 1 : 0)
					}
				}
				else if (equali(key, "WIN HUMANS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_win_humans, key)
//						ArrayPushCell(sound_win_humans_ismp3, equali(key[strlen(key)-4], ".mp3") ? 1 : 0)
					}
				}
				else if (equali(key, "WIN NO ONE"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_win_no_one, key)
//						ArrayPushCell(sound_win_no_one_ismp3, equali(key[strlen(key)-4], ".mp3") ? 1 : 0)
					}
				}
				else if (equal(key, "NEMESIS PAIN"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(nemesis_pain, key)
					}
				}
				else if (equal(key, "NEMESIS IDLE"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(nemesis_idle, key)
					}
				}
				else if (equal(key, "NEMESIS DIE"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(nemesis_die, key)
					}
				}
				else if (equal(key, "NEMESIS FALL"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(nemesis_fall, key)
					}
				}
				else if (equal(key, "NEMESIS MISS SLASH"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(nemesis_miss_slash, key)
					}
				}
				else if (equal(key, "NEMESIS MISS WALL"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(nemesis_miss_wall, key)
					}
				}
				else if (equal(key, "NEMESIS HIT NORMAL"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(nemesis_hit_normal, key)
					}
				}
				else if (equal(key, "NEMESIS HIT STAB"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(nemesis_hit_stab, key)
					}
				}
				else if (equal(key, "ASSASSIN PAIN"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(assassin_pain, key)
					}
				}
				else if (equal(key, "ASSASSIN IDLE"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(assassin_idle, key)
					}
				}
				else if (equal(key, "ASSASSIN DIE"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(assassin_die, key)
					}
				}
				else if (equal(key, "ASSASSIN FALL"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(assassin_fall, key)
					}
				}
				else if (equal(key, "ASSASSIN MISS SLASH"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(assassin_miss_slash, key)
					}
				}
				else if (equal(key, "ASSASSIN MISS WALL"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(assassin_miss_wall, key)
					}
				}
				else if (equal(key, "ASSASSIN HIT NORMAL"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(assassin_hit_normal, key)
					}
				}
				else if (equal(key, "ASSASSIN HIT STAB"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(assassin_hit_stab, key)
					}
				}
				else if (equali(key, "ROUND NEMESIS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_nemesis, key)
					}
				}
				else if (equali(key, "ROUND SURVIVOR"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_survivor, key)
					}
				}
				else if (equali(key, "ROUND SWARM"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_swarm, key)
					}
				}
				else if (equali(key, "ROUND MULTI"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_multi, key)
					}
				}
				else if (equali(key, "ROUND PLAGUE"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_plague, key)
					}
				}
				else if (equali(key, "GRENADE INFECT EXPLODE"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(grenade_infect, key)
					}
				}
				else if (equali(key, "GRENADE INFECT PLAYER"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(grenade_infect_player, key)
					}
				}
				else if (equali(key, "GRENADE FIRE EXPLODE"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(grenade_fire, key)
					}
				}
				else if (equali(key, "GRENADE FROST EXPLODE"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(grenade_frost, key)
					}
				}
				else if (equali(key, "GRENADE FROST PLAYER"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(grenade_frost_player, key)
					}
				}
				else if (equali(key, "GRENADE FROST BREAK"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(grenade_frost_break, key)
					}
				}
				else if (equali(key, "GRENADE FLARE"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(grenade_flare, key)
					}
				}
				else if (equali(key, "ANTIDOTE"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_antidote, key)
					}
				}
				else if (equali(key, "THUNDER"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_thunder, key)
					}
				}
				else if (equali(key, "ROUND SNIPER"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_sniper, key)
					}
				}
				else if (equali(key, "ROUND ASSASSIN"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_assassin, key)
					}
				}
			}
			case SECTION_AMBIENCE_SOUNDS:
			{
				if (equali(key, "INFECTION ENABLE"))
					g_ambience_sounds[AMBIENCE_SOUNDS_INFECTION] = str_to_num(value)
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_INFECTION] && equali(key, "INFECTION SOUNDS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_ambience1, key)
//						ArrayPushCell(sound_ambience1_ismp3, equali(key[strlen(key)-4], ".mp3") ? 1 : 0)
					}
				}
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_INFECTION] && equali(key, "INFECTION DURATIONS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushCell(sound_ambience1_duration, str_to_num(key))
					}
				}
				else if (equali(key, "NEMESIS ENABLE"))
					g_ambience_sounds[AMBIENCE_SOUNDS_NEMESIS] = str_to_num(value)
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_NEMESIS] && equali(key, "NEMESIS SOUNDS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_ambience2, key)
//						ArrayPushCell(sound_ambience2_ismp3, equali(key[strlen(key)-4], ".mp3") ? 1 : 0)
					}
				}
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_NEMESIS] && equali(key, "NEMESIS DURATIONS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushCell(sound_ambience2_duration, str_to_num(key))
					}
				}
				else if (equali(key, "SURVIVOR ENABLE"))
					g_ambience_sounds[AMBIENCE_SOUNDS_SURVIVOR] = str_to_num(value)
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_SURVIVOR] && equali(key, "SURVIVOR SOUNDS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_ambience3, key)
//						ArrayPushCell(sound_ambience3_ismp3, equali(key[strlen(key)-4], ".mp3") ? 1 : 0)
					}
				}
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_SURVIVOR] && equali(key, "SURVIVOR DURATIONS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushCell(sound_ambience3_duration, str_to_num(key))
					}
				}
				else if (equali(key, "SWARM ENABLE"))
					g_ambience_sounds[AMBIENCE_SOUNDS_SWARM] = str_to_num(value)
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_SWARM] && equali(key, "SWARM SOUNDS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_ambience4, key)
//						ArrayPushCell(sound_ambience4_ismp3, equali(key[strlen(key)-4], ".mp3") ? 1 : 0)
					}
				}
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_SWARM] && equali(key, "SWARM DURATIONS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushCell(sound_ambience4_duration, str_to_num(key))
					}
				}
				else if (equali(key, "PLAGUE ENABLE"))
					g_ambience_sounds[AMBIENCE_SOUNDS_PLAGUE] = str_to_num(value)
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_PLAGUE] && equali(key, "PLAGUE SOUNDS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_ambience5, key)
//						ArrayPushCell(sound_ambience5_ismp3, equali(key[strlen(key)-4], ".mp3") ? 1 : 0)
					}
				}
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_PLAGUE] && equali(key, "PLAGUE DURATIONS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushCell(sound_ambience5_duration, str_to_num(key))
					}
				}
				else if (equali(key, "SNIPER ENABLE"))
					g_ambience_sounds[AMBIENCE_SOUNDS_SNIPER] = str_to_num(value)
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_SNIPER] && equali(key, "SNIPER SOUNDS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_ambience6, key)
//						ArrayPushCell(sound_ambience6_ismp3, equali(key[strlen(key)-4], ".mp3") ? 1 : 0)
					}
				}
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_SNIPER] && equali(key, "SNIPER DURATIONS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushCell(sound_ambience6_duration, str_to_num(key))
					}
				}
				else if (equali(key, "ASSASSIN ENABLE"))
					g_ambience_sounds[AMBIENCE_SOUNDS_ASSASSIN] = str_to_num(value)
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_ASSASSIN] && equali(key, "ASSASSIN SOUNDS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushString(sound_ambience7, key)
//						ArrayPushCell(sound_ambience7_ismp3, equali(key[strlen(key)-4], ".mp3") ? 1 : 0)
					}
				}
				else if (g_ambience_sounds[AMBIENCE_SOUNDS_ASSASSIN] && equali(key, "ASSASSIN DURATIONS"))
				{
					// Parse sounds
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to sounds array
						ArrayPushCell(sound_ambience7_duration, str_to_num(key))
					}
				}
			}
			case SECTION_BUY_MENU_WEAPONS:
			{
				if (equali(key, "PRIMARY"))
				{
					// Parse weapons
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to weapons array
						ArrayPushString(g_primary_items, key)
						ArrayPushCell(g_primary_weaponids, cs_weapon_name_to_id(key))
					}
				}
				else if (equali(key, "SECONDARY"))
				{
					// Parse weapons
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to weapons array
						ArrayPushString(g_secondary_items, key)
						ArrayPushCell(g_secondary_weaponids, cs_weapon_name_to_id(key))
					}
				}
				else if (equali(key, "ADDITIONAL ITEMS"))
				{
					// Parse weapons
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to weapons array
						ArrayPushString(g_additional_items, key)
					}
				}
			}
			case SECTION_EXTRA_ITEMS_WEAPONS:
			{
				if (equali(key, "NAMES"))
				{
					// Parse weapon items
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to weapons array
						ArrayPushString(g_extraweapon_names, key)
					}
				}
				else if (equali(key, "ITEMS"))
				{
					// Parse weapon items
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to weapons array
						ArrayPushString(g_extraweapon_items, key)
					}
				}
				else if (equali(key, "COSTS"))
				{
					// Parse weapon items
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to weapons array
						ArrayPushCell(g_extraweapon_costs, str_to_num(key))
					}
				}
			}
			case SECTION_HARD_CODED_ITEMS_COSTS:
			{
				if (equali(key, "NIGHT VISION"))
					g_extra_costs2[EXTRA_NVISION] = str_to_num(value)
				else if (equali(key, "ANTIDOTE"))
					g_extra_costs2[EXTRA_ANTIDOTE] = str_to_num(value)
				else if (equali(key, "ZOMBIE MADNESS"))
					g_extra_costs2[EXTRA_MADNESS] = str_to_num(value)
				else if (equali(key, "INFECTION BOMB"))
					g_extra_costs2[EXTRA_INFBOMB] = str_to_num(value)
			}
			case SECTION_WEATHER_EFFECTS:
			{
				if (equali(key, "RAIN"))
					g_ambience_rain = str_to_num(value)
				else if (equali(key, "SNOW"))
					g_ambience_snow = str_to_num(value)
				else if (equali(key, "FOG"))
					g_ambience_fog = str_to_num(value)
				else if (equali(key, "FOG DENSITY"))
					copy(g_fog_density, 9, value)
				else if (equali(key, "FOG COLOR"))
					copy(g_fog_color, 11, value)
			}
			case SECTION_SKY:
			{
				if (equali(key, "ENABLE"))
					g_sky_enable = str_to_num(value)
				else if (equali(key, "SKY NAMES"))
				{
					// Parse sky names
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to skies array
						ArrayPushString(g_sky_names, key)
/*=====						
						// Preache custom sky files
						formatex(linedata, 1023, "gfx/env/%sbk.tga", key)
						engfunc(EngFunc_PrecacheGeneric, linedata)
						formatex(linedata, 1023, "gfx/env/%sdn.tga", key)
						engfunc(EngFunc_PrecacheGeneric, linedata)
						formatex(linedata, 1023, "gfx/env/%sft.tga", key)
						engfunc(EngFunc_PrecacheGeneric, linedata)
						formatex(linedata, 1023, "gfx/env/%slf.tga", key)
						engfunc(EngFunc_PrecacheGeneric, linedata)
						formatex(linedata, 1023, "gfx/env/%srt.tga", key)
						engfunc(EngFunc_PrecacheGeneric, linedata)
						formatex(linedata, 1023, "gfx/env/%sup.tga", key)
						engfunc(EngFunc_PrecacheGeneric, linedata)
=======*/
					}
					
					ArrayGetString(g_sky_names, random_num(0, ArraySize(g_sky_names) - 1), g_sky_name, 31)
					
					// Preache custom sky files
					formatex(linedata, 1023, "gfx/env/%sbk.tga", g_sky_name)
					engfunc(EngFunc_PrecacheGeneric, linedata)
					formatex(linedata, 1023, "gfx/env/%sdn.tga", g_sky_name)
					engfunc(EngFunc_PrecacheGeneric, linedata)
					formatex(linedata, 1023, "gfx/env/%sft.tga", g_sky_name)
					engfunc(EngFunc_PrecacheGeneric, linedata)
					formatex(linedata, 1023, "gfx/env/%slf.tga", g_sky_name)
					engfunc(EngFunc_PrecacheGeneric, linedata)
					formatex(linedata, 1023, "gfx/env/%srt.tga", g_sky_name)
					engfunc(EngFunc_PrecacheGeneric, linedata)
					formatex(linedata, 1023, "gfx/env/%sup.tga", g_sky_name)
					engfunc(EngFunc_PrecacheGeneric, linedata)
					
					ArrayDestroy(g_sky_names)
				}
			}
			case SECTION_LIGHTNING:
			{
				if (equali(key, "LIGHTS"))
				{
					// Parse lights
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to lightning array
						ArrayPushString(lights_thunder, key)
					}
				}
			}
			case SECTION_ZOMBIE_DECALS:
			{
				if (equali(key, "DECALS"))
				{
					// Parse decals
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to zombie decals array
						ArrayPushCell(zombie_decals, str_to_num(key))
					}
				}
			}
			case SECTION_KNOCKBACK:
			{
				// Format weapon entity name
				strtolower(key)
				format(key, 63, "weapon_%s", key)
				
				// Add value to knockback power array
				kb_weapon_power[cs_weapon_name_to_id(key)] = str_to_float(value)
			}
			case SECTION_OBJECTIVE_ENTS:
			{
				if (equali(key, "CLASSNAMES"))
				{
					// Parse classnames
					while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
					{
						// Trim spaces
						trim(key)
						trim(value)
						
						// Add to objective ents array
						ArrayPushString(g_objective_ents, key)
					}
				}
			}
			case SECTION_SVC_BAD:
			{
				if (equali(key, "MODELCHANGE DELAY"))
					g_modelchange_delay = str_to_float(value)
				else if (equali(key, "HANDLE MODELS ON SEPARATE ENT"))
					g_handle_models_on_separate_ent = str_to_num(value)
				else if (equali(key, "SET MODELINDEX OFFSET"))
					g_set_modelindex_offset = str_to_num(value)
			}
		}
	}
	if (file) fclose(file)
	
	// Build zombie classes file path
	get_configsdir(path, 63)
	format(path, 63, "%s/%s", path, ZP_ZOMBIECLASSES_FILE)
	
	// Parse if present
	if (file_exists(path))
	{
		// Open zombie classes file for reading
		file = fopen(path, "rt")
		
		while (file && !feof(file))
		{
			static pos, temparr[64]
			
			// Read one line at a time
			fgets(file, linedata, 1023)
			
			// Replace newlines with a null character to prevent headaches
			replace(linedata, 1023, "^n", "")
			
			// Blank line or comment
			if (!linedata[0] || linedata[0] == ';') continue;
			
			// New class starting
			if (linedata[0] == '[')
			{
				// Remove first and last characters (braces)
				linedata[strlen(linedata) - 1] = 0
				copy(linedata, 1023, linedata[1])
				
				// Store its real name for future reference
				ArrayPushString(g_zclass2_realname, linedata)
				continue;
			}
			
			// Get key and value(s)
			strtok(linedata, key, 63, value, 959, '=')
			
			// Trim spaces
			trim(key)
			trim(value)
			
			if (equali(key, "NAME"))
				ArrayPushString(g_zclass2_name, value)
			else if (equali(key, "INFO"))
				ArrayPushString(g_zclass2_info, value)
			else if (equali(key, "MODELS"))
			{
				// Set models start index
				ArrayPushCell(g_zclass2_modelsstart, ArraySize(g_zclass2_playermodel))
				
				// Parse class models
				while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					// Add to class models array
					ArrayPushString(g_zclass2_playermodel, key)
					ArrayPushCell(g_zclass2_modelindex, -1)
				}
				
				// Set models end index
				ArrayPushCell(g_zclass2_modelsend, ArraySize(g_zclass2_playermodel))
			}
			else if (equali(key, "CLAWMODEL"))
				ArrayPushString(g_zclass2_clawmodel, value)
			else if (equali(key, "HEALTH"))
				ArrayPushCell(g_zclass2_hp, str_to_num(value))
			else if (equali(key, "SPEED"))
				ArrayPushCell(g_zclass2_spd, str_to_num(value))
			else if (equali(key, "GRAVITY"))
				ArrayPushCell(g_zclass2_grav, str_to_float(value))
			else if (equali(key, "KNOCKBACK"))
				ArrayPushCell(g_zclass2_kb, str_to_float(value))
			else if (equal(key, "INFECT"))
			{
				pos = 0
				arrayset(temparr, -1, sizeof(temparr))
				while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
			
					ArrayPushString(class_sound_infect, key)
					temparr[pos++] = ArraySize(class_sound_infect) - 1
				}
				ArrayPushArray(pointer_class_sound_infect, temparr)
			}
			else if (equal(key, "BURN"))
			{
				pos = 0
				arrayset(temparr, -1, sizeof(temparr))
				while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					ArrayPushString(class_sound_burn, key)
					temparr[pos++] = ArraySize(class_sound_burn) - 1
				}
				ArrayPushArray(pointer_class_sound_burn, temparr)
			}
			else if (equal(key, "PAIN"))
			{
				pos = 0
				arrayset(temparr, -1, sizeof(temparr))
				while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					ArrayPushString(class_sound_pain, key)
					temparr[pos++] = ArraySize(class_sound_pain) - 1
				}
				ArrayPushArray(pointer_class_sound_pain, temparr)
			}
			else if (equal(key, "DIE"))
			{
				pos = 0
				arrayset(temparr, -1, sizeof(temparr))
				while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					ArrayPushString(class_sound_die, key)
					temparr[pos++] = ArraySize(class_sound_die) - 1
				}
				ArrayPushArray(pointer_class_sound_die, temparr)
			}
			else if (equal(key, "IDLE"))
			{
				pos = 0
				arrayset(temparr, -1, sizeof(temparr))
				while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					ArrayPushString(class_sound_idle, key)
					temparr[pos++] = ArraySize(class_sound_idle) - 1
				}
				ArrayPushArray(pointer_class_sound_idle, temparr)
			}
			else if (equal(key, "IDLE LAST"))
			{
				pos = 0
				arrayset(temparr, -1, sizeof(temparr))
				while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					ArrayPushString(class_sound_idle_last, key)
					temparr[pos++] = ArraySize(class_sound_idle_last) - 1
				}
				ArrayPushArray(pointer_class_sound_idle_last, temparr)
			}
			else if (equal(key, "MISS SLASH"))
			{
				pos = 0
				arrayset(temparr, -1, sizeof(temparr))
				while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					ArrayPushString(class_sound_miss_slash, key)
					temparr[pos++] = ArraySize(class_sound_miss_slash) - 1
				}
				ArrayPushArray(pointer_class_sound_miss_slash, temparr)
			}
			else if (equal(key, "MISS WALL"))
			{
				pos = 0
				arrayset(temparr, -1, sizeof(temparr))
				while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					ArrayPushString(class_sound_miss_wall, key)
					temparr[pos++] = ArraySize(class_sound_miss_wall) - 1
				}
				ArrayPushArray(pointer_class_sound_miss_wall, temparr)
			}
			else if (equal(key, "HIT NORMAL"))
			{
				pos = 0
				arrayset(temparr, -1, sizeof(temparr))
				while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					ArrayPushString(class_sound_hit_normal, key)
					temparr[pos++] = ArraySize(class_sound_hit_normal) - 1
				}
				ArrayPushArray(pointer_class_sound_hit_normal, temparr)
			}
			else if (equal(key, "HIT STAB"))
			{
				pos = 0
				arrayset(temparr, -1, sizeof(temparr))
				while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					ArrayPushString(class_sound_hit_stab, key)
					temparr[pos++] = ArraySize(class_sound_hit_stab) - 1
				}
				ArrayPushArray(pointer_class_sound_hit_stab, temparr)
			}
			else if (equal(key, "FALL"))
			{
				pos = 0
				arrayset(temparr, -1, sizeof(temparr))
				while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					ArrayPushString(class_sound_fall, key)
					temparr[pos++] = ArraySize(class_sound_fall) - 1
				}
				ArrayPushArray(pointer_class_sound_fall, temparr)
			}
			else if (equal(key, "MADNESS"))
			{
				pos = 0
				arrayset(temparr, -1, sizeof(temparr))
				while (value[0] != 0 && strtok(value, key, charsmax(key), value, charsmax(value), ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					ArrayPushString(class_sound_madness, key)
					temparr[pos++] = ArraySize(class_sound_madness) - 1
				}
				ArrayPushArray(pointer_class_sound_madness, temparr)
			}
		}
		if (file) fclose(file)
	}
	
	// Build extra items file path
	get_configsdir(path, 63)
	format(path, 63, "%s/%s", path, ZP_EXTRAITEMS_FILE)
	
	// Parse if present
	if (file_exists(path))
	{
		// Open extra items file for reading
		file = fopen(path, "rt")
		
		while (file && !feof(file))
		{
			// Read one line at a time
			fgets(file, linedata, 1023)
			
			// Replace newlines with a null character to prevent headaches
			replace(linedata, 1023, "^n", "")
			
			// Blank line or comment
			if (!linedata[0] || linedata[0] == ';') continue;
			
			// New item starting
			if (linedata[0] == '[')
			{
				// Remove first and last characters (braces)
				linedata[strlen(linedata) - 1] = 0
				copy(linedata, 1023, linedata[1])
				
				// Store its real name for future reference
				ArrayPushString(g_extraitem2_realname, linedata)
				continue;
			}
			
			// Get key and value(s)
			strtok(linedata, key, 63, value, 959, '=')
			
			// Trim spaces
			trim(key)
			trim(value)
			
			if (equali(key, "NAME"))
				ArrayPushString(g_extraitem2_name, value)
			else if (equali(key, "COST"))
				ArrayPushCell(g_extraitem2_cost, str_to_num(value))
			else if (equali(key, "TEAMS"))
			{
				// Clear teams bitsum
				teams = 0
				
				// Parse teams
				while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					if (equali(key, ZP_TEAM_NAMES[ZP_TEAM_ZOMBIE]))
						teams |= ZP_TEAM_ZOMBIE
					else if (equali(key, ZP_TEAM_NAMES[ZP_TEAM_HUMAN]))
						teams |= ZP_TEAM_HUMAN
					else if (equali(key, ZP_TEAM_NAMES[ZP_TEAM_NEMESIS]))
						teams |= ZP_TEAM_NEMESIS
					else if (equali(key, ZP_TEAM_NAMES[ZP_TEAM_SURVIVOR]))
						teams |= ZP_TEAM_SURVIVOR
					else if (equali(key, ZP_TEAM_NAMES[ZP_TEAM_SNIPER]))
						teams |= ZP_TEAM_SNIPER
					else if (equali(key, ZP_TEAM_NAMES[ZP_TEAM_ASSASSIN]))
						teams |= ZP_TEAM_ASSASSIN
				}
				
				// Add to teams array
				ArrayPushCell(g_extraitem2_team, teams)
			}
		}
		if (file) fclose(file)
	}
	
	// Build human classes file path
	get_configsdir(path, 63)
	format(path, 63, "%s/%s", path, ZP_HUMANCLASSES_FILE)
	
	// Parse if present
	if (file_exists(path))
	{
		// Open human classes file for reading
		file = fopen(path, "rt")
		
		while (file && !feof(file))
		{
			// Read one line at a time
			fgets(file, linedata, 1023)
			
			// Replace newlines with a null character to prevent headaches
			replace(linedata, 1023, "^n", "")
			
			// Blank line or comment
			if (!linedata[0] || linedata[0] == ';') continue;
			
			// New class starting
			if (linedata[0] == '[')
			{
				// Remove first and last characters (braces)
				linedata[strlen(linedata) - 1] = 0
				copy(linedata, 1023, linedata[1])
				
				// Store its real name for future reference
				ArrayPushString(g_hclass2_realname, linedata)
				continue;
			}
			
			// Get key and value(s)
			strtok(linedata, key, 63, value, 959, '=')
			
			// Trim spaces
			trim(key)
			trim(value)
			
			if (equali(key, "NAME"))
				ArrayPushString(g_hclass2_name, value)
			else if (equali(key, "INFO"))
				ArrayPushString(g_hclass2_info, value)
			else if (equali(key, "MODELS"))
			{
				// Set models start index
				ArrayPushCell(g_hclass2_modelsstart, ArraySize(g_hclass2_playermodel))
				
				// Parse class models
				while (value[0] != 0 && strtok(value, key, 63, value, 959, ','))
				{
					// Trim spaces
					trim(key)
					trim(value)
					
					// Add to class models array
					ArrayPushString(g_hclass2_playermodel, key)
					ArrayPushCell(g_hclass2_modelindex, -1)
				}
				
				// Set models end index
				ArrayPushCell(g_hclass2_modelsend, ArraySize(g_hclass2_playermodel))
			}
			else if (equali(key, "HANDMODEL"))
				ArrayPushString(g_hclass2_handmodel, value)
			else if (equali(key, "HEALTH"))
				ArrayPushCell(g_hclass2_hp, str_to_num(value))
			else if (equali(key, "SPEED"))
				ArrayPushCell(g_hclass2_spd, str_to_num(value))
			else if (equali(key, "GRAVITY"))
				ArrayPushCell(g_hclass2_grav, str_to_float(value))
		}
		if (file) fclose(file)
	}
}

save_customization()
{
	new i, k, buffer[512]
	
	// Build zombie classes file path
	new path[64]
	get_configsdir(path, 63)
	format(path, 63, "%s/%s", path, ZP_ZOMBIECLASSES_FILE)
	
	// Open zombie classes file for appending data
	new file = fopen(path, "at"), size = ArraySize(g_zclass_name)
	
	// Add any new zombie classes data at the end if needed
	for (i = 0; i < size; i++)
	{
		if (ArrayGetCell(g_zclass_new, i))
		{
			// Add real name
			ArrayGetString(g_zclass_name, i, buffer, 511)
			format(buffer, 511, "^n[%s]", buffer)
			fputs(file, buffer)
			
			// Add caption
			ArrayGetString(g_zclass_name, i, buffer, 511)
			format(buffer, 511, "^nNAME = %s", buffer)
			fputs(file, buffer)
			
			// Add info
			ArrayGetString(g_zclass_info, i, buffer, 511)
			format(buffer, 511, "^nINFO = %s", buffer)
			fputs(file, buffer)
			
			// Add models
			for (k = ArrayGetCell(g_zclass_modelsstart, i); k < ArrayGetCell(g_zclass_modelsend, i); k++)
			{
				if (k == ArrayGetCell(g_zclass_modelsstart, i))
				{
					// First model, overwrite buffer
					ArrayGetString(g_zclass_playermodel, k, buffer, 511)
				}
				else
				{
					// Successive models, append to buffer
					ArrayGetString(g_zclass_playermodel, k, path, 63)
					format(buffer, 511, "%s , %s", buffer, path)
				}
			}
			format(buffer, 511, "^nMODELS = %s", buffer)
			fputs(file, buffer)
			
			// Add clawmodel
			ArrayGetString(g_zclass_clawmodel, i, buffer, 511)
			format(buffer, 511, "^nCLAWMODEL = %s", buffer)
			fputs(file, buffer)
			
			// Add health
			formatex(buffer, 511, "^nHEALTH = %d", ArrayGetCell(g_zclass_hp, i))
			fputs(file, buffer)
			
			// Add speed
			formatex(buffer, 511, "^nSPEED = %d", ArrayGetCell(g_zclass_spd, i))
			fputs(file, buffer)
			
			// Add gravity
			formatex(buffer, 511, "^nGRAVITY = %.2f", Float:ArrayGetCell(g_zclass_grav, i))
			fputs(file, buffer)
			
			// Add knockback
			formatex(buffer, 511, "^nKNOCKBACK = %.2f^n", Float:ArrayGetCell(g_zclass_kb, i))
			fputs(file, buffer)
			
			// Add infect sound
			fputs(file, "^nINFECT = zombie_plague/zombie_infec1.wav")
			
			// Add burn sound
			fputs(file, "^nBURN = zombie_plague/zombie_burn3.wav")
			
			// Add pain sound
			fputs(file, "^nPAIN = zombie_plague/zombie_pain1.wav")
			
			// Add die sound
			fputs(file, "^nDIE = zombie_plague/zombie_die1.wav")
			
			// Add idle sound
			fputs(file, "^nIDLE = zombie_plague/zombie_brains1.wav")
			
			// Add idle last sound
			fputs(file, "^nIDLE LAST = zombie_plague/zombie_brains1.wav")
			
			// Add miss slash sound
			fputs(file, "^nMISS SLASH = weapons/knife_slash1.wav")
			
			// Add miss wall sound
			fputs(file, "^nMISS WALL = weapons/knife_hitwall1.wav")
			
			// Add hit normal sound
			fputs(file, "^nHIT NORMAL = weapons/knife_hit1.wav")
			
			// Add hit stab sound
			fputs(file, "^nHIT STAB = weapons/knife_stab.wav")

			// Add fall sound
			fputs(file, "^nFALL = zombie_plague/zombie_fall1.wav")

			// Add madness sound
			fputs(file, "^nMADNESS = zombie_plague/zombie_madness1.wav^n")
		}
	}
	fclose(file)
	
	// Build extra items file path
	get_configsdir(path, 63)
	format(path, 63, "%s/%s", path, ZP_EXTRAITEMS_FILE)
	
	// Open extra items file for appending data
	file = fopen(path, "at")
	size = ArraySize(g_extraitem_name)
	
	// Add any new extra items data at the end if needed
	for (i = EXTRAS_CUSTOM_STARTID; i < size; i++)
	{
		if (ArrayGetCell(g_extraitem_new, i))
		{
			// Add real name
			ArrayGetString(g_extraitem_name, i, buffer, 511)
			format(buffer, 511, "^n[%s]", buffer)
			fputs(file, buffer)
			
			// Add caption
			ArrayGetString(g_extraitem_name, i, buffer, 511)
			format(buffer, 511, "^nNAME = %s", buffer)
			fputs(file, buffer)
			
			// Add cost
			formatex(buffer, 511, "^nCOST = %d", ArrayGetCell(g_extraitem_cost, i))
			fputs(file, buffer)
			
			// Add team
			formatex(buffer, 511, "^nTEAMS = %s^n", ZP_TEAM_NAMES[ArrayGetCell(g_extraitem_team, i)])
			fputs(file, buffer)
		}
	}
	fclose(file)
	
	// Build human classes file path
	get_configsdir(path, 63)
	format(path, 63, "%s/%s", path, ZP_HUMANCLASSES_FILE)
	
	// Open human classes file for appending data
	file = fopen(path, "at")
	size = ArraySize(g_hclass_name)
	
	// Add any new human classes data at the end if needed
	for (i = 0; i < size; i++)
	{
		if (ArrayGetCell(g_hclass_new, i))
		{
			// Add real name
			ArrayGetString(g_hclass_name, i, buffer, 511)
			format(buffer, 511, "^n[%s]", buffer)
			fputs(file, buffer)
			
			// Add caption
			ArrayGetString(g_hclass_name, i, buffer, 511)
			format(buffer, 511, "^nNAME = %s", buffer)
			fputs(file, buffer)
			
			// Add info
			ArrayGetString(g_hclass_info, i, buffer, 511)
			format(buffer, 511, "^nINFO = %s", buffer)
			fputs(file, buffer)
			
			// Add models
			for (k = ArrayGetCell(g_hclass_modelsstart, i); k < ArrayGetCell(g_hclass_modelsend, i); k++)
			{
				if (k == ArrayGetCell(g_hclass_modelsstart, i))
				{
					// First model, overwrite buffer
					ArrayGetString(g_hclass_playermodel, k, buffer, 511)
				}
				else
				{
					// Successive models, append to buffer
					ArrayGetString(g_hclass_playermodel, k, path, 63)
					format(buffer, 511, "%s , %s", buffer, path)
				}
			}
			format(buffer, 511, "^nMODELS = %s", buffer)
			fputs(file, buffer)
			
			// Add handmodel
			ArrayGetString(g_hclass_handmodel, i, buffer, 511)
			format(buffer, 511, "^nHANDMODEL = %s", buffer)
			fputs(file, buffer)
			
			// Add health
			formatex(buffer, 511, "^nHEALTH = %d", ArrayGetCell(g_hclass_hp, i))
			fputs(file, buffer)
			
			// Add speed
			formatex(buffer, 511, "^nSPEED = %d", ArrayGetCell(g_hclass_spd, i))
			fputs(file, buffer)
			
			// Add gravity
			formatex(buffer, 511, "^nGRAVITY = %.2f^n", Float:ArrayGetCell(g_hclass_grav, i))
			fputs(file, buffer)
		}
	}
	fclose(file)
	
	// Free arrays containing class/item overrides
	ArrayDestroy(g_zclass2_realname)
	ArrayDestroy(g_zclass2_name)
	ArrayDestroy(g_zclass2_info)
	ArrayDestroy(g_zclass2_modelsstart)
	ArrayDestroy(g_zclass2_modelsend)
	ArrayDestroy(g_zclass2_playermodel)
	ArrayDestroy(g_zclass2_modelindex)
	ArrayDestroy(g_zclass2_clawmodel)
	ArrayDestroy(g_zclass2_hp)
	ArrayDestroy(g_zclass2_spd)
	ArrayDestroy(g_zclass2_grav)
	ArrayDestroy(g_zclass2_kb)
	ArrayDestroy(g_zclass_new)
	ArrayDestroy(g_extraitem2_realname)
	ArrayDestroy(g_extraitem2_name)
	ArrayDestroy(g_extraitem2_cost)
	ArrayDestroy(g_extraitem2_team)
	ArrayDestroy(g_extraitem_new)
	ArrayDestroy(g_hclass2_realname)
	ArrayDestroy(g_hclass2_name)
	ArrayDestroy(g_hclass2_info)
	ArrayDestroy(g_hclass2_modelsstart)
	ArrayDestroy(g_hclass2_modelsend)
	ArrayDestroy(g_hclass2_playermodel)
	ArrayDestroy(g_hclass2_modelindex)
	ArrayDestroy(g_hclass2_handmodel)
	ArrayDestroy(g_hclass2_hp)
	ArrayDestroy(g_hclass2_spd)
	ArrayDestroy(g_hclass2_grav)
	ArrayDestroy(g_hclass_new)
}

// Register Ham Forwards for CZ bots
public register_ham_czbots(id)
{
	// Make sure it's a CZ bot and it's still connected
	if (g_hamczbots || !g_isconnected[id] || !get_pcvar_num(cvar_botquota))
		return;
	
	RegisterHamFromEntity(Ham_Spawn, id, "fw_PlayerSpawn")
	RegisterHamFromEntity(Ham_Spawn, id, "fw_PlayerSpawn_Post", 1)
	RegisterHamFromEntity(Ham_Killed, id, "fw_PlayerKilled")
	RegisterHamFromEntity(Ham_Killed, id, "fw_PlayerKilled_Post", 1)
	RegisterHamFromEntity(Ham_TakeDamage, id, "fw_TakeDamage")
	RegisterHamFromEntity(Ham_TakeDamage, id, "fw_TakeDamage_Post", 1)
	RegisterHamFromEntity(Ham_TraceAttack, id, "fw_TraceAttack")
	RegisterHamFromEntity(Ham_Player_ResetMaxSpeed, id, "fw_ResetMaxSpeed_Post", 1)
	
	ExecuteForward(g_fwCzBotsRegisterHam, g_fwDummyResult, id);
	
	// Ham forwards for CZ bots succesfully registered
	g_hamczbots = true
	
	// If the bot has already spawned, call the forward manually for him
	if (is_user_alive(id))
	{
		fw_PlayerSpawn(id)
		fw_PlayerSpawn_Post(id)
	}
}

// Disable minmodels task
public disable_minmodels(id)
{
	if (!g_isconnected[id]) return;
	client_cmd(id, "cl_minmodels 0")
}

// Bots automatically buy extra items
public bot_buy_extras(taskid)
{
	// Nemesis or Survivor bots have nothing to buy by default
	if (!g_isalive[ID_SPAWN] || g_survivor[ID_SPAWN] || g_sniper[ID_SPAWN] || g_nemesis[ID_SPAWN] || g_assassin[ID_SPAWN])
		return;
	
	if (!g_zombie[ID_SPAWN]) // human bots
	{
		// Attempt to buy Night Vision
		buy_extra_item(ID_SPAWN, EXTRA_NVISION)
		
		// Attempt to buy a weapon
		buy_extra_item(ID_SPAWN, random_num(EXTRA_WEAPONS_STARTID, EXTRAS_CUSTOM_STARTID-1))
	}
	else // zombie bots
	{
		// Attempt to buy an Antidote
		buy_extra_item(ID_SPAWN, EXTRA_ANTIDOTE)
	}
}

// Refill BP Ammo Task
public refill_bpammo(const args[], id)
{
	// Player died or turned into a zombie
	if (!g_isalive[id] || g_zombie[id])
		return;
	
	set_msg_block(g_msgAmmoPickup, BLOCK_ONCE)
	ExecuteHamB(Ham_GiveAmmo, id, MAXBPAMMO[REFILL_WEAPONID], AMMOTYPE[REFILL_WEAPONID], MAXBPAMMO[REFILL_WEAPONID])
}

// Balance Teams Task
balance_teams()
{
	// Get amount of users playing
	new iPlayersnum = fnGetPlaying()
	
	// No players, don't bother
	if (iPlayersnum < 1) return;
	
	// Split players evenly
	new iTerrors, iMaxTerrors = iPlayersnum/2, id
	static team[33]
	
	// First, set everyone to CT
	for (id = 1; id <= g_maxplayers; id++)
	{
		// Skip if not connected
		if (!g_isconnected[id])
			continue;
		
		team[id] = fm_cs_get_user_team(id)
		
		// Skip if not playing
		if (team[id] == FM_CS_TEAM_SPECTATOR || team[id] == FM_CS_TEAM_UNASSIGNED)
			continue;
		
		// Set team
		remove_task(id+TASK_TEAM)
		fm_cs_set_user_team(id, FM_CS_TEAM_CT)
		team[id] = FM_CS_TEAM_CT
	}
	
	// Then randomly set half of the players to Terrorists
	while (iTerrors < iMaxTerrors)
	{
		// Keep looping through all players
		if (++id > g_maxplayers) id = 1
		
		// Skip if not connected
		if (!g_isconnected[id])
			continue;
		
		// Skip if not playing or already a Terrorist
		if (team[id] != FM_CS_TEAM_CT)
			continue;
		
		// Random chance
		if (random_num(0, 1))
		{
			fm_cs_set_user_team(id, FM_CS_TEAM_T)
			team[id] = FM_CS_TEAM_T
			iTerrors++
		}
	}
}

// Welcome Message Task
public welcome_msg()
{
	// Show mod info
	zp_colored_print(0, "***** ^4Zombie Plague 4.3 Fix5a^1 *****")
	zp_colored_print(0, "^4%s^1 edition by ^3T a l R a s h a^1. Contact: ^4http://vk.com/talrasha/", PLUGIN_VERSION)
	zp_colored_print(0, "^4%L", LANG_PLAYER, "NOTICE_INFO1")
	if (!get_pcvar_num(cvar_infammo)) zp_colored_print(0, "^4%L", LANG_PLAYER, "NOTICE_INFO2")
	
	// Show T-virus HUD notice
	set_dhudmessage(cvar_nvgcolor[0], cvar_nemnvgcolor[1], cvar_assnvgcolor[2], HUD_EVENT_X, HUD_EVENT_Y, 1, 6.0, 1.1, 0.0, 2.0) //0, 125, 200 | , -1)
//	ShowSyncHudMsg(0, g_MsgSync, "%L", LANG_PLAYER, "NOTICE_VIRUS_FREE")
	show_dhudmessage(0, "%L", LANG_PLAYER, "NOTICE_VIRUS_FREE")
}

// Respawn Player Task (deathmatch)
public respawn_player_task(taskid)
{
	// Already alive or round ended
	if (g_isalive[ID_SPAWN] || g_endround)
		return;
	
	// Get player's team
	new team = fm_cs_get_user_team(ID_SPAWN)
	
	// Player moved to spectators
	if (team == FM_CS_TEAM_SPECTATOR || team == FM_CS_TEAM_UNASSIGNED)
		return;
	
	// Respawn player automatically if allowed on current round
	if ((!g_survround || get_pcvar_num(cvar_allowrespawnsurv)) && (!g_swarmround || get_pcvar_num(cvar_allowrespawnswarm))
	&& (!g_nemround || get_pcvar_num(cvar_allowrespawnnem)) && (!g_plagueround || get_pcvar_num(cvar_allowrespawnplague))
	&& (!g_snipround || get_pcvar_num(cvar_allowrespawnsnip)) && (!g_assround || get_pcvar_num(cvar_allowrespawnass)))
	{
		// Infection rounds = none of the above
		if (!cvar_allowrespawninfection && !g_survround && !g_nemround && !g_swarmround && !g_plagueround && !g_snipround && !g_assround)
			return;
		
		// Respawn if only the last human is left? (ignore this setting on survivor rounds)
		if (!g_survround && !g_snipround && !get_pcvar_num(cvar_respawnafterlast) && fnGetHumans() < 2)
			return;
		
		// Respawn as zombie?
		new deathmatch = get_pcvar_num(cvar_deathmatch)
		if (g_survround || g_snipround || deathmatch == 2 || (deathmatch == 3 && random_num(0, 1)) || (deathmatch == 4 && fnGetZombies() < fnGetAlive()/3))
			g_respawn_as_zombie[ID_SPAWN] = true
		else if (g_nemround || g_assround) g_respawn_as_zombie[ID_SPAWN] = false
/*=====		
		// Override respawn as zombie setting on nemesis and survivor rounds
		if (g_survround || g_snipround) g_respawn_as_zombie[ID_SPAWN] = true =======*/
		
		respawn_player_manually(ID_SPAWN)
	}
}

// Respawn Player Check Task (if killed by worldspawn)
public respawn_player_check_task(taskid)
{
	// Successfully spawned or round ended
	if (g_isalive[ID_SPAWN] || g_endround)
		return;
	
	// Get player's team
	new team = fm_cs_get_user_team(ID_SPAWN)
	
	// Player moved to spectators
	if (team == FM_CS_TEAM_SPECTATOR || team == FM_CS_TEAM_UNASSIGNED)
		return;
	
	// If player was being spawned as a zombie, set the flag again
	if (g_zombie[ID_SPAWN]) g_respawn_as_zombie[ID_SPAWN] = true
	else g_respawn_as_zombie[ID_SPAWN] = false
	
	respawn_player_manually(ID_SPAWN)
}

// Respawn Player Manually (called after respawn checks are done)
respawn_player_manually(id)
{
	// Set proper team before respawning, so that the TeamInfo message that's sent doesn't confuse PODBots
	if (g_respawn_as_zombie[id])
		fm_cs_set_user_team(id, FM_CS_TEAM_T)
	else
		fm_cs_set_user_team(id, FM_CS_TEAM_CT)
	
	// Respawning a player has never been so easy
	ExecuteHamB(Ham_CS_RoundRespawn, id)
	
	g_respawn_count[id]++
}

// Check Round Task -check that we still have both zombies and humans on a round-
check_round(leaving_player)
{
	// Round ended or make_a_zombie task still active
	if (g_endround || task_exists(TASK_MAKEZOMBIE))
		return;
	
	// Get alive players count
	new iPlayersnum = fnGetAlive(), id
	
	// Last alive player, don't bother
	if (iPlayersnum < 2)
		return;
	
	// Last zombie disconnecting
	if (g_zombie[leaving_player] && fnGetZombies() == 1)
	{
		// Only one CT left, don't bother
		if (fnGetHumans() == 1 && fnGetCTs() == 1)
			return;
		
		// Pick a random one to take his place
		while ((id = fnGetRandomAlive(random_num(1, iPlayersnum))) == leaving_player ) { /* keep looping */ }
		
		// Show last zombie left notice
		zp_colored_print(0, "^3%L", LANG_PLAYER, "LAST_ZOMBIE_LEFT", g_playername[id])
		
		// Set player leaving flag
		g_lastplayerleaving = true
		
		// Turn into a Nemesis or just a zombie?
		if (g_nemesis[leaving_player])
			zombieme(id, 0, 1, 0, 0)
		else if (g_assassin[leaving_player])
			zombieme(id, 0, 0, 0, 0, 1)
		else
			zombieme(id, 0, 0, 0, 0)
		
		// Remove player leaving flag
		g_lastplayerleaving = false
		
		// If Nemesis, set chosen player's health to that of the one who's leaving
		if (get_pcvar_num(cvar_keephealthondisconnect) && (g_nemesis[leaving_player] || g_assassin[leaving_player]))
			fm_set_user_health(id, pev(leaving_player, pev_health))
	}
	
	// Last human disconnecting
	else if (!g_zombie[leaving_player] && fnGetHumans() == 1)
	{
		// Only one T left, don't bother
		if (fnGetZombies() == 1 && fnGetTs() == 1)
			return;
		
		// Pick a random one to take his place
		while ((id = fnGetRandomAlive(random_num(1, iPlayersnum))) == leaving_player ) { /* keep looping */ }
		
		// Show last human left notice
		zp_colored_print(0, "^3%L", LANG_PLAYER, "LAST_HUMAN_LEFT", g_playername[id])
		
		// Set player leaving flag
		g_lastplayerleaving = true
		
		// Turn into a Survivor or just a human?
		if (g_survivor[leaving_player])
			humanme(id, 1, 0)
		else if (g_sniper[leaving_player])
			humanme(id, 0, 0, 1)
		else
			humanme(id, 0, 0)
		
		// Remove player leaving flag
		g_lastplayerleaving = false
		
		// If Survivor, set chosen player's health to that of the one who's leaving
		if (get_pcvar_num(cvar_keephealthondisconnect) && (g_survivor[leaving_player] || g_sniper[leaving_player]))
			fm_set_user_health(id, pev(leaving_player, pev_health))
	}
}

// Lighting Effects Task
public lighting_effects()
{
	// Cache some CVAR values at every 5 secs
	cache_cvars()
	
	if (g_assround)
	{
		engfunc(EngFunc_LightStyle, 0, "a")
		
		return;
	}
	
	// Get lighting style
	new lighting[2]
	get_pcvar_string(cvar_lighting, lighting, 1)
	strtolower(lighting)
	
	// Lighting disabled? ["0"]
	if (lighting[0] == '0')
		return;
	
	// Darkest light settings?
	if (lighting[0] >= 'a' && lighting[0] <= 'f')
	{
		new thunderclap_in_progress = task_exists(TASK_THUNDER), Float:thunder = get_pcvar_float(cvar_thunder)
		
		// Set thunderclap tasks if not existant
		if (thunder > 0.0 && !task_exists(TASK_THUNDER_PRE) && !thunderclap_in_progress)
		{
			g_lights_i = 0
			ArrayGetString(lights_thunder, random_num(0, ArraySize(lights_thunder) - 1), g_lights_cycle, 31)
			g_lights_cycle_len = strlen(g_lights_cycle)
			set_task(thunder, "thunderclap", TASK_THUNDER_PRE)
		}
		
		// Set lighting only when no thunderclaps are going on
		if (!thunderclap_in_progress) engfunc(EngFunc_LightStyle, 0, lighting)
	}
	else
	{
		// Remove thunderclap tasks
		remove_task(TASK_THUNDER_PRE)
		remove_task(TASK_THUNDER)
		
		// Set lighting
		engfunc(EngFunc_LightStyle, 0, lighting)
	}
}

// Thunderclap task
public thunderclap()
{
	// Play thunder sound
	if (g_lights_i == 0)
	{
		static sound[64]
		ArrayGetString(sound_thunder, random_num(0, ArraySize(sound_thunder) - 1), sound, 63)
		PlaySound(sound)
	}
	
	// Set lighting
	static light[2]
	light[0] = g_lights_cycle[g_lights_i]
	engfunc(EngFunc_LightStyle, 0, light)
	
	g_lights_i++
	
	// Lighting cycle end?
	if (g_lights_i >= g_lights_cycle_len)
	{
		remove_task(TASK_THUNDER)
		lighting_effects()
	}
	// Lighting cycle start?
	else if (!task_exists(TASK_THUNDER))
		set_task(0.1, "thunderclap", TASK_THUNDER, _, _, "b")
}

// Ambience Sound Effects Task
public ambience_sound_effects(taskid)
{
	// Play a random sound depending on the round
	static sound[64]
	new iRand, duration
	
	if (g_nemround) // Nemesis Mode
	{
		iRand = random_num(0, ArraySize(sound_ambience2) - 1)
		ArrayGetString(sound_ambience2, iRand, sound, 63)
		duration = ArrayGetCell(sound_ambience2_duration, iRand)
	}
	else if (g_survround) // Survivor Mode
	{
		iRand = random_num(0, ArraySize(sound_ambience3) - 1)
		ArrayGetString(sound_ambience3, iRand, sound, 63)
		duration = ArrayGetCell(sound_ambience3_duration, iRand)
	}
	else if (g_swarmround) // Swarm Mode
	{
		iRand = random_num(0, ArraySize(sound_ambience4) - 1)
		ArrayGetString(sound_ambience4, iRand, sound, 63)
		duration = ArrayGetCell(sound_ambience4_duration, iRand)
	}
	else if (g_plagueround) // Plague Mode
	{
		iRand = random_num(0, ArraySize(sound_ambience5) - 1)
		ArrayGetString(sound_ambience5, iRand, sound, 63)
		duration = ArrayGetCell(sound_ambience5_duration, iRand)
	}
	else if (g_snipround) // Sniper Mode
	{
		iRand = random_num(0, ArraySize(sound_ambience6) - 1)
		ArrayGetString(sound_ambience6, iRand, sound, 63)
		duration = ArrayGetCell(sound_ambience6_duration, iRand)
	}
	else if (g_assround) // Assassin Mode
	{
		iRand = random_num(0, ArraySize(sound_ambience7) - 1)
		ArrayGetString(sound_ambience7, iRand, sound, 63)
		duration = ArrayGetCell(sound_ambience7_duration, iRand)
	}
	else // Infection Mode
	{
		iRand = random_num(0, ArraySize(sound_ambience1) - 1)
		ArrayGetString(sound_ambience1, iRand, sound, 63)
		duration = ArrayGetCell(sound_ambience1_duration, iRand)
	}
	
	if (!(taskid - TASK_AMBIENCESOUNDS))
		for (new iID = 1; iID <= g_maxplayers; iID++)
			if (task_exists(iID + TASK_AMBIENCESOUNDS))
			{
				remove_task(iID + TASK_AMBIENCESOUNDS)
				client_cmd(iID, "stopsound")
			}
	
	// Play it on clients
	PlaySound(sound, taskid - TASK_AMBIENCESOUNDS)
	
	// Set the task for when the sound is done playing
	set_task(float(duration), "ambience_sound_effects", taskid)
}
/*
// Ambience Sounds Stop Task
ambience_sound_stop()
{
	client_cmd(0, "mp3 stop; stopsound")
}*/

// Flashlight Charge Task
public flashlight_charge(taskid)
{
	// Drain or charge?
	if (g_flashlight[ID_CHARGE])
		g_flashbattery[ID_CHARGE] -= cvar_flashdrain
	else
		g_flashbattery[ID_CHARGE] += cvar_flashcharge
	
	// Battery fully charged
	if (g_flashbattery[ID_CHARGE] >= 100)
	{
		// Don't exceed 100%
		g_flashbattery[ID_CHARGE] = 100
		
		// Update flashlight battery on HUD
		message_begin(MSG_ONE, g_msgFlashBat, _, ID_CHARGE)
		write_byte(100) // battery
		message_end()
		
		// Task not needed anymore
		remove_task(taskid);
		return;
	}
	
	// Battery depleted
	if (g_flashbattery[ID_CHARGE] <= 0)
	{
		// Turn it off
		g_flashlight[ID_CHARGE] = false
		g_flashbattery[ID_CHARGE] = 0
		
		// Play flashlight toggle sound
		emit_sound(ID_CHARGE, CHAN_ITEM, sound_flashlight, 1.0, ATTN_NORM, 0, PITCH_NORM)
		
		// Update flashlight status on HUD
		message_begin(MSG_ONE, g_msgFlashlight, _, ID_CHARGE)
		write_byte(0) // toggle
		write_byte(0) // battery
		message_end()
		
		// Remove flashlight task for this player
		remove_task(ID_CHARGE+TASK_FLASH)
	}
	else
	{
		// Update flashlight battery on HUD
		message_begin(MSG_ONE_UNRELIABLE, g_msgFlashBat, _, ID_CHARGE)
		write_byte(g_flashbattery[ID_CHARGE]) // battery
		message_end()
	}
}

// Remove Spawn Protection Task
public remove_spawn_protection(taskid)
{
	// Not alive
	if (!g_isalive[ID_SPAWN])
		return;
	
	// Remove spawn protection
	g_nodamage[ID_SPAWN] = false
	set_pev(ID_SPAWN, pev_effects, pev(ID_SPAWN, pev_effects) & ~EF_NODRAW)
	
	if (g_handle_models_on_separate_ent)
	{
		// Set survivor glow / remove glow on player model entity, unless frozen
		if (!g_frozen[ID_SPAWN])
		{
			if (g_survivor[ID_SPAWN] && get_pcvar_num(cvar_survglow))
				fm_set_rendering(g_ent_playermodel[ID_SPAWN], kRenderFxGlowShell, cvar_humnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], kRenderNormal) //0, 0, 255
			else if (g_sniper[ID_SPAWN] && get_pcvar_num(cvar_snipglow))
				fm_set_rendering(g_ent_playermodel[ID_SPAWN], kRenderFxGlowShell, cvar_assnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], kRenderNormal) //0, 0, 255
		}
	}
	else
	{
		// Set survivor glow / remove glow, unless frozen
		if (!g_frozen[ID_SPAWN])
		{
			if (g_survivor[ID_SPAWN] && get_pcvar_num(cvar_survglow))
				fm_set_rendering(ID_SPAWN, kRenderFxGlowShell, cvar_humnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], kRenderNormal) //0, 0, 255
			else if (g_sniper[ID_SPAWN] && get_pcvar_num(cvar_snipglow))
				fm_set_rendering(ID_SPAWN, kRenderFxGlowShell, cvar_assnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], kRenderNormal) //0, 0, 255
		}
	}
}

// Hide Player's Money Task
public task_hide_money(taskid)
{
	// Not alive
	if (!g_isalive[ID_SPAWN])
		return;
	
	// Hide money
	message_begin(MSG_ONE, g_msgHideWeapon, _, ID_SPAWN)
	write_byte(HIDE_MONEY) // what to hide bitsum
	message_end()
	
	// Hide the HL crosshair that's drawn
	message_begin(MSG_ONE, g_msgCrosshair, _, ID_SPAWN)
	write_byte(0) // toggle
	message_end()
}

// Turn Off Flashlight and Restore Batteries
turn_off_flashlight(id)
{
	// Restore batteries for the next use
	fm_cs_set_user_batteries(id, 100)
	
	// Check if flashlight is on
	if (pev(id, pev_effects) & EF_DIMLIGHT)
	{
		// Turn it off
		set_pev(id, pev_impulse, IMPULSE_FLASHLIGHT)
	}
	else
	{
		// Clear any stored flashlight impulse (bugfix)
		set_pev(id, pev_impulse, 0)
	}
	
	// Turn off custom flashlight
	if (cvar_customflash)
	{
		// Turn it off
		g_flashlight[id] = false
		g_flashbattery[id] = 100
		
		// Update flashlight HUD
		message_begin(MSG_ONE, g_msgFlashlight, _, id)
		write_byte(0) // toggle
		write_byte(100) // battery
		message_end()
		
		// Remove previous tasks
		remove_task(id+TASK_CHARGE)
		remove_task(id+TASK_FLASH)
	}
}

// Infection Bomb Explosion
infection_explode(ent)
{
	// Round ended (bugfix)
	if (g_endround) return;
	
	// Get origin
	new Float:originF[3]
	pev(ent, pev_origin, originF)
	
	// Make the explosion
	create_blast(originF)
	
	message_begin (MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( TE_SPRITETRAIL ) // Throws a shower of sprites or models
	engfunc(EngFunc_WriteCoord, originF[ 0 ]) // start pos
	engfunc(EngFunc_WriteCoord, originF[ 1 ])
	engfunc(EngFunc_WriteCoord, originF[ 2 ] + 200.0)
	engfunc(EngFunc_WriteCoord, originF[ 0 ]) // velocity
	engfunc(EngFunc_WriteCoord, originF[ 1 ])
	engfunc(EngFunc_WriteCoord, originF[ 2 ] + 30.0)
	write_short(g_talrasha_infection) // spr
	write_byte(60) // (count)
	write_byte(random_num(27,30)) // (life in 0.1's)
	write_byte(2) // byte (scale in 0.1's)
	write_byte(50) // (velocity along vector in 10's)
	write_byte(10) // (randomness of velocity in 10's)
	message_end()
	
	// Infection nade explode sound
	static sound[64]
	ArrayGetString(grenade_infect, random_num(0, ArraySize(grenade_infect) - 1), sound, 63)
	emit_sound(ent, CHAN_WEAPON, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	
	// Get attacker
	new attacker = pev(ent, pev_owner)
	
	// Infection bomb owner disconnected? (bugfix)
	if (!is_user_valid_connected(attacker))
	{
		// Get rid of the grenade
		engfunc(EngFunc_RemoveEntity, ent)
		return;
	}
	
	// Collisions
	new victim = -1
	
	while ((victim = engfunc(EngFunc_FindEntityInSphere, victim, originF, NADE_EXPLOSION_RADIUS)) != 0)
	{
		// Only effect alive non-spawnprotected humans
		if (!is_user_valid_alive(victim) || g_zombie[victim] || g_nodamage[victim])
			continue;
		
		// Turn into zombie or kill(if last human)
		zombieme(victim, attacker, 0, 1, 1, 0, 1)
	}
	
	// Get rid of the grenade
	engfunc(EngFunc_RemoveEntity, ent)
}

// Fire Grenade Explosion
fire_explode(ent)
{		
	// Get origin
	new Float:originF[3]
	pev(ent, pev_origin, originF)
	
	// Make the explosion
	create_blast2(originF)
	
	message_begin (MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( TE_SPRITETRAIL ) // Throws a shower of sprites or models
	engfunc(EngFunc_WriteCoord, originF[ 0 ]) // start pos
	engfunc(EngFunc_WriteCoord, originF[ 1 ])
	engfunc(EngFunc_WriteCoord, originF[ 2 ] + 200.0)
	engfunc(EngFunc_WriteCoord, originF[ 0 ]) // velocity
	engfunc(EngFunc_WriteCoord, originF[ 1 ])
	engfunc(EngFunc_WriteCoord, originF[ 2 ] + 30.0)
	write_short(g_talrasha_fire2) // spr
	write_byte(60) // (count)
	write_byte(random_num(27,30)) // (life in 0.1's)
	write_byte(2) // byte (scale in 0.1's)
	write_byte(50) // (velocity along vector in 10's)
	write_byte(10) // (randomness of velocity in 10's)
	message_end()
	
	// Fire nade explode sound
	static sound[64]
	ArrayGetString(grenade_fire, random_num(0, ArraySize(grenade_fire) - 1), sound, 63)
	emit_sound(ent, CHAN_WEAPON, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	
	// Get attacker
	new attacker[2]
	attacker[0] = pev(ent, pev_owner)
	
	// Collisions
	new victim = -1
	
	while ((victim = engfunc(EngFunc_FindEntityInSphere, victim, originF, NADE_EXPLOSION_RADIUS)) != 0)
	{
		// Only effect alive zombies
		if (!is_user_valid_alive(victim) || !g_zombie[victim]) // || g_nodamage[victim]
			continue;
		
		// Heat icon?
		if (get_pcvar_num(cvar_hudicons))
		{
			message_begin(MSG_ONE_UNRELIABLE, g_msgDamage, _, victim)
			write_byte(0) // damage save
			write_byte(0) // damage take
			write_long(DMG_BURN) // damage type
			write_coord(0) // x
			write_coord(0) // y
			write_coord(0) // z
			message_end()
		}
		
		if (g_nemesis[victim] || g_assassin[victim]) // fire duration (nemesis is fire resistant)
			g_burning_duration[victim] += get_pcvar_num(cvar_fireduration)
		else
			g_burning_duration[victim] += get_pcvar_num(cvar_fireduration) * 5
		
		// Set burning task on victim if not present
		if (!task_exists(victim+TASK_BURN))
			set_task(0.2, "burning_flame", victim+TASK_BURN, attacker, 1, "b")
	}
		
	// Get rid of the grenade
	engfunc(EngFunc_RemoveEntity, ent)
}

// Frost Grenade Explosion
frost_explode(ent)
{
	// Get origin
	new Float:originF[3]
	pev(ent, pev_origin, originF)
	
	// Make the explosion
	create_blast3(originF)
	
	message_begin (MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( TE_SPRITETRAIL ) // Throws a shower of sprites or models
	engfunc(EngFunc_WriteCoord, originF[ 0 ]) // start pos
	engfunc(EngFunc_WriteCoord, originF[ 1 ])
	engfunc(EngFunc_WriteCoord, originF[ 2 ] + 200.0)
	engfunc(EngFunc_WriteCoord, originF[ 0 ]) // velocity
	engfunc(EngFunc_WriteCoord, originF[ 1 ])
	engfunc(EngFunc_WriteCoord, originF[ 2 ] + 30.0)
	write_short(g_talrasha_frost2) // spr
	write_byte(60) // (count)
	write_byte(random_num(27,30)) // (life in 0.1's)
	write_byte(2) // byte (scale in 0.1's)
	write_byte(50) // (velocity along vector in 10's)
	write_byte(10) // (randomness of velocity in 10's)
	message_end() 
	
	// Frost nade explode sound
	static sound[64]
	ArrayGetString(grenade_frost, random_num(0, ArraySize(grenade_frost) - 1), sound, 63)
	emit_sound(ent, CHAN_WEAPON, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	
	// Get attacker
	new attacker[2]
	attacker[0] = pev(ent, pev_owner)
	
	// Collisions
	new victim = -1
	
	while ((victim = engfunc(EngFunc_FindEntityInSphere, victim, originF, NADE_EXPLOSION_RADIUS)) != 0)
	{
		// Only effect alive unfrozen zombies
		if (!is_user_valid_alive(victim) || !g_zombie[victim] || g_frozen[victim] || g_nodamage[victim])
			continue;
		
		// Nemesis shouldn't be frozen
		if (g_nemesis[victim] || g_assassin[victim])
		{
			// Get player's origin
			static origin2[3]
			get_user_origin(victim, origin2)
			
			// Broken glass sound
			ArrayGetString(grenade_frost_break, random_num(0, ArraySize(grenade_frost_break) - 1), sound, 63)
			emit_sound(victim, CHAN_BODY, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
			
			// Glass shatter
			message_begin(MSG_PVS, SVC_TEMPENTITY, origin2)
			write_byte(TE_BREAKMODEL) // TE id
			write_coord(origin2[0]) // x
			write_coord(origin2[1]) // y
			write_coord(origin2[2]+24) // z
			write_coord(16) // size x
			write_coord(16) // size y
			write_coord(16) // size z
			write_coord(random_num(-50, 50)) // velocity x
			write_coord(random_num(-50, 50)) // velocity y
			write_coord(25) // velocity z
			write_byte(10) // random velocity
			write_short(g_glassSpr) // model
			write_byte(10) // count
			write_byte(25) // life
			write_byte(BREAK_GLASS) // flags
			message_end()
			
			continue;
		}
		
		// Freeze player
		set_freeze(victim, attacker[0])
		
		// Set a task to remove the freeze
		set_task(get_pcvar_float(cvar_freezeduration), "remove_freeze", victim+TASK_UNFREEZE, attacker, 1)
	}
	
	// Get rid of the grenade
	engfunc(EngFunc_RemoveEntity, ent)
}

// Flare Grenade Explosion
flare_explode(ent)
{
	// Get origin
	new Float:originF[3]
	pev(ent, pev_origin, originF)
	
	// Make the explosion
	create_blast4(originF)
	
	message_begin (MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte( TE_SPRITETRAIL ) // Throws a shower of sprites or models
	engfunc(EngFunc_WriteCoord, originF[ 0 ]) // start pos
	engfunc(EngFunc_WriteCoord, originF[ 1 ])
	engfunc(EngFunc_WriteCoord, originF[ 2 ] + 200.0)
	engfunc(EngFunc_WriteCoord, originF[ 0 ]) // velocity
	engfunc(EngFunc_WriteCoord, originF[ 1 ])
	engfunc(EngFunc_WriteCoord, originF[ 2 ] + 30.0)
	write_short(g_talrasha_flare2) // spr
	write_byte(60) // (count)
	write_byte(random_num(27,30)) // (life in 0.1's)
	write_byte(2) // byte (scale in 0.1's)
	write_byte(50) // (velocity along vector in 10's)
	write_byte(10) // (randomness of velocity in 10's)
	message_end() 
}

// Freeze player
set_freeze(const victim, const attacker = 0)
{
	static sound[64]
	
	// Freeze icon?
	if (get_pcvar_num(cvar_hudicons))
	{
		message_begin(MSG_ONE_UNRELIABLE, g_msgDamage, _, victim)
		write_byte(0) // damage save
		write_byte(0) // damage take
		write_long(DMG_DROWN) // damage type - DMG_FREEZE
		write_coord(0) // x
		write_coord(0) // y
		write_coord(0) // z
		message_end()
	}
	
	// Light blue glow while frozen
	if (g_handle_models_on_separate_ent)
		fm_set_rendering(g_ent_playermodel[victim], kRenderFxGlowShell, 0, 100, 200, kRenderNormal)
	else
		fm_set_rendering(victim, kRenderFxGlowShell, 0, 100, 200, kRenderNormal)
	
	// Freeze sound
	ArrayGetString(grenade_frost_player, random_num(0, ArraySize(grenade_frost_player) - 1), sound, 63)
	emit_sound(victim, CHAN_BODY, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	
	// Add a blue tint to their screen
	message_begin(MSG_ONE, g_msgScreenFade, _, victim)
	write_short(0) // duration
	write_short(0) // hold time
	write_short(FFADE_STAYOUT) // fade type
	write_byte(0) // red
	write_byte(50) // green
	write_byte(200) // blue
	write_byte(100) // alpha
	message_end()
	
	// Set the frozen flag
	g_frozen[victim] = true
	
	// Save player's old gravity (bugfix)
	pev(victim, pev_gravity, g_frozen_gravity[victim])
	
	// Prevent from jumping
	if (pev(victim, pev_flags) & FL_ONGROUND)
		set_pev(victim, pev_gravity, 999999.9) // set really high
	else
		set_pev(victim, pev_gravity, 0.000001) // no gravity
	
	// Prevent from moving
	ExecuteHamB(Ham_Player_ResetMaxSpeed, victim)
	
	ExecuteForward(g_fwUserFrozen, g_fwDummyResult, victim, attacker);
}

// Remove freeze task
public remove_freeze(attacker[], taskid)
{
	// Not alive or not frozen anymore
	if (!g_isalive[ID_UNFREEZE] || !g_frozen[ID_UNFREEZE])
		return;
	
	// Unfreeze
	g_frozen[ID_UNFREEZE] = false;
	
	// Restore gravity and maxspeed (bugfix)
	set_pev(ID_UNFREEZE, pev_gravity, g_frozen_gravity[ID_UNFREEZE])
	ExecuteHamB(Ham_Player_ResetMaxSpeed, ID_UNFREEZE)
	
	// Restore rendering
	if (g_handle_models_on_separate_ent)
	{
		// Nemesis or Survivor glow / remove glow on player model entity
		if (g_nemesis[ID_UNFREEZE] && get_pcvar_num(cvar_nemglow))
			fm_set_rendering(g_ent_playermodel[ID_UNFREEZE], kRenderFxGlowShell, cvar_nemnvgcolor[0], cvar_nemnvgcolor[1], cvar_nemnvgcolor[2], kRenderNormal) //255, 0, 0
		else if (g_assassin[ID_UNFREEZE] && get_pcvar_num(cvar_assglow))
			fm_set_rendering(g_ent_playermodel[ID_UNFREEZE], kRenderFxGlowShell, cvar_assnvgcolor[0], cvar_assnvgcolor[1], cvar_assnvgcolor[2], kRenderNormal) //255, 0, 0
		else if (g_survivor[ID_UNFREEZE] && get_pcvar_num(cvar_survglow))
			fm_set_rendering(g_ent_playermodel[ID_UNFREEZE], kRenderFxGlowShell, cvar_humnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], kRenderNormal) //0, 0, 255
		else if (g_sniper[ID_UNFREEZE] && get_pcvar_num(cvar_snipglow))
			fm_set_rendering(g_ent_playermodel[ID_UNFREEZE], kRenderFxGlowShell, cvar_assnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], kRenderNormal) //0, 0, 255
		else
			fm_set_rendering(g_ent_playermodel[ID_UNFREEZE])
	}
	else
	{
		// Nemesis or Survivor glow / remove glow
		if (g_nemesis[ID_UNFREEZE] && get_pcvar_num(cvar_nemglow))
			fm_set_rendering(ID_UNFREEZE, kRenderFxGlowShell, cvar_nemnvgcolor[0], cvar_nemnvgcolor[1], cvar_nemnvgcolor[2], kRenderNormal) //255, 0, 0
		else if (g_assassin[ID_UNFREEZE] && get_pcvar_num(cvar_assglow))
			fm_set_rendering(ID_UNFREEZE, kRenderFxGlowShell, cvar_assnvgcolor[0], cvar_assnvgcolor[1], cvar_assnvgcolor[2], kRenderNormal) //255, 0, 0
		else if (g_survivor[ID_UNFREEZE] && get_pcvar_num(cvar_survglow))
			fm_set_rendering(ID_UNFREEZE, kRenderFxGlowShell, cvar_humnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], kRenderNormal) //0, 0, 255
		else if (g_sniper[ID_UNFREEZE] && get_pcvar_num(cvar_snipglow))
			fm_set_rendering(ID_UNFREEZE, kRenderFxGlowShell, cvar_assnvgcolor[0], cvar_humnvgcolor[1], cvar_humnvgcolor[2], kRenderNormal) //0, 0, 255
		else
			fm_set_rendering(ID_UNFREEZE)
	}
	
	// Gradually remove screen's blue tint
	message_begin(MSG_ONE, g_msgScreenFade, _, ID_UNFREEZE)
	write_short(UNIT_SECOND) // duration
	write_short(0) // hold time
	write_short(FFADE_IN) // fade type
	write_byte(0) // red
	write_byte(50) // green
	write_byte(200) // blue
	write_byte(100) // alpha
	message_end()
	
	// Broken glass sound
	static sound[64]
	ArrayGetString(grenade_frost_break, random_num(0, ArraySize(grenade_frost_break) - 1), sound, 63)
	emit_sound(ID_UNFREEZE, CHAN_BODY, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	
	// Get player's origin
	new origin2[3]
	get_user_origin(ID_UNFREEZE, origin2)
	
	// Glass shatter
	message_begin(MSG_PVS, SVC_TEMPENTITY, origin2)
	write_byte(TE_BREAKMODEL) // TE ID_UNFREEZE
	write_coord(origin2[0]) // x
	write_coord(origin2[1]) // y
	write_coord(origin2[2]+24) // z
	write_coord(16) // size x
	write_coord(16) // size y
	write_coord(16) // size z
	write_coord(random_num(-50, 50)) // velocity x
	write_coord(random_num(-50, 50)) // velocity y
	write_coord(25) // velocity z
	write_byte(10) // random velocity
	write_short(g_glassSpr) // model
	write_byte(10) // count
	write_byte(25) // life
	write_byte(BREAK_GLASS) // flags
	message_end()
	
	ExecuteForward(g_fwUserUnfrozen, g_fwDummyResult, ID_UNFREEZE, attacker[0]);
}

// Remove Stuff Task
public remove_stuff()
{
	new ent
	
	// Remove rotating doors
	if (get_pcvar_num(cvar_removedoors) > 0)
	{
		ent = -1;
		while ((ent = engfunc(EngFunc_FindEntityByString, ent, "classname", "func_door_rotating")) != 0)
			engfunc(EngFunc_SetOrigin, ent, Float:{ 8192.0, 8192.0, 8192.0 })
	}
	
	// Remove all doors
	if (get_pcvar_num(cvar_removedoors) > 1)
	{
		ent = -1;
		while ((ent = engfunc(EngFunc_FindEntityByString, ent, "classname", "func_door")) != 0)
			engfunc(EngFunc_SetOrigin, ent, Float:{ 8192.0, 8192.0, 8192.0 })
	}
	
	// Triggered lights
	if (!get_pcvar_num(cvar_triggered))
	{
		ent = -1
		while ((ent = engfunc(EngFunc_FindEntityByString, ent, "classname", "light")) != 0)
		{
			dllfunc(DLLFunc_Use, ent, 0); // turn off the light
			set_pev(ent, pev_targetname, 0) // prevent it from being triggered
		}
	}
}

// Set Custom Weapon Models
replace_weapon_models(id, weaponid)
{
	switch (weaponid)
	{
		case CSW_KNIFE: // Custom knife models
		{
			if (g_zombie[id])
			{
				if (g_nemesis[id]) // Nemesis
					set_pev(id, pev_viewmodel2, model_vknife_nemesis)
				else if (g_assassin[id]) // Assassin
					set_pev(id, pev_viewmodel2, model_vknife_assassin)
				else // Zombies
				{
					// Admin knife models?
					if (cvar_adminknifemodelszombie && get_user_flags(id) & g_access_flag[ACCESS_ADMIN_MODELS])
						set_pev(id, pev_viewmodel2, model_vknife_admin_zombie)
					else
					{
						static clawmodel[175]
						ArrayGetString(g_zclass_clawmodel, g_zombieclass[id], clawmodel, 174)
						format(clawmodel, 174, "models/%s", clawmodel)
						set_pev(id, pev_viewmodel2, clawmodel)
					}
				}
				
				set_pev(id, pev_weaponmodel2, "")
			}
			else // Humans
			{
				// Admin knife models?
				if (cvar_adminknifemodelshuman && get_user_flags(id) & g_access_flag[ACCESS_ADMIN_MODELS])
					set_pev(id, pev_viewmodel2, model_vknife_admin_human)
				else
				{
					static handmodel[175]
					ArrayGetString(g_hclass_handmodel, g_humanclass[id], handmodel, 174)
					format(handmodel, 174, "models/%s", handmodel)
					set_pev(id, pev_viewmodel2, handmodel)
				}
				
				set_pev(id, pev_weaponmodel2, "models/p_knife.mdl")
			}
		}
		case CSW_HEGRENADE: // Infection bomb or fire grenade
		{
			if (g_zombie[id])
			{
				if (get_pcvar_num(cvar_extrainfbomb))
					set_pev(id, pev_viewmodel2, model_v_grenade_infection)
				set_pev(id, pev_weaponmodel2, model_p_grenade_infection)
			}
			else
			{
				if (cvar_firegrenades)
					set_pev(id, pev_viewmodel2, model_v_grenade_fire)
				set_pev(id, pev_weaponmodel2, model_p_grenade_fire)
			}
		}
		case CSW_FLASHBANG: // Frost grenade
		{
			if (cvar_frostgrenades)
				set_pev(id, pev_viewmodel2, model_v_grenade_frost)
			set_pev(id, pev_weaponmodel2, model_p_grenade_frost)
		}
		case CSW_SMOKEGRENADE: // Flare grenade
		{
			if (cvar_flaregrenades)
				set_pev(id, pev_viewmodel2, model_v_grenade_flare)
			set_pev(id, pev_weaponmodel2, model_p_grenade_flare)
		}
	}
	
	// Survivor's custom weapon model
	static survweaponname[32]
	get_pcvar_string(cvar_survweapon, survweaponname, 31)
	if (g_survivor[id] && weaponid == cs_weapon_name_to_id(survweaponname))
		set_pev(id, pev_viewmodel2, model_vweapon_survivor)
	else if (g_sniper[id] && weaponid == CSW_AWP)
		set_pev(id, pev_viewmodel2, model_vweapon_sniper)
	
	// Update model on weaponmodel ent
	if (g_handle_models_on_separate_ent) fm_set_weaponmodel_ent(id)
}

// Reset Player Vars
reset_vars(id, resetall)
{
	g_zombie[id] = false
	g_nemesis[id] = false
	g_survivor[id] = false
	g_firstzombie[id] = false
	g_lastzombie[id] = false
	g_lasthuman[id] = false
	g_frozen[id] = false
	g_nodamage[id] = false
	g_nvision[id] = false
	g_nvisionenabled[id] = false
	g_flashlight[id] = false
	g_flashbattery[id] = 100
	g_canbuy[id] = true
	g_burning_duration[id] = 0
	g_sniper[id] = false
	g_assassin[id] = false
	
	if (resetall)
	{
//		g_respawn_as_zombie[id] = false
		new start = get_pcvar_num(cvar_startammopacks)
		if (start)
		{
			g_ammopacks[id] = start
			
			ExecuteForward(g_fwUserGetAmmoPacks, g_fwDummyResult, id, start, 3);
		}
		
		g_zombieclass[id] = 0
		g_zombieclassnext[id] = HZCLASS_NONE
		g_damagedealt_human[id] = 0
		g_damagedealt_zombie[id] = 0
		WPN_AUTO_ON = 0
		WPN_STARTID = 0
		PL_ACTION = 0
		MENU_PAGE_ZCLASS = 0
		MENU_PAGE_EXTRAS = 0
		MENU_PAGE_PLAYERS = 0
		g_humanclass[id] = 0
		g_humanclassnext[id] = HZCLASS_NONE
		MENU_PAGE_HCLASS = 0
	}
	else
		ExecuteForward(g_fwUserUnfrozen, g_fwDummyResult, id, 0);
}

// Set spectators nightvision
public spec_nvision(id)
{
	// Not connected, alive, or bot
	if (!g_isconnected[id] || g_isalive[id] || g_isbot[id])
		return;
	
	// Give Night Vision?
	new nvggive = get_pcvar_num(cvar_nvggive)
	if (nvggive)
	{
		g_nvision[id] = true
		
		// Turn on Night Vision automatically?
		if (nvggive == 1)
		{
			g_nvisionenabled[id] = true
			
			// Custom nvg?
			if (get_pcvar_num(cvar_customnvg))
			{
				remove_task(id+TASK_NVISION)
				set_task(0.1, "set_user_nvision", id+TASK_NVISION, _, _, "b")
			}
			else
				set_user_gnvision(id, 1)
		}
	}
}

// Show HUD Task
public ShowHUD(taskid)
{
	static id, text[512]
	id = ID_SHOWHUD;
	
	new UserName[32]
	get_user_name(id,UserName,31)
	
	// Player died?
	if (!g_isalive[id])
	{
		// Get spectating target
		id = pev(id, PEV_SPEC_TARGET)
		
		// Target not alive
		if (!g_isalive[id]) return;
	}
	
	// Format classname
	static class[32]
	new Float:post_x, Float:post_y
	
	if(g_position[id] == POSITION_LEFT) 
	{
		post_x = 0.01
		post_y = 0.9
	} 
	else if(g_position[id] == POSITION_CENTER) 
	{
		post_x = -1.0
		post_y = 0.9
	} 
	else if(g_position[id] == POSITION_RIGHT) 
	{
		post_x = 0.9
		post_y = 0.9
	}
	
	if (g_zombie[id]) // zombies
	{
		if (g_nemesis[id])
			formatex(class, 31, "%L", ID_SHOWHUD, "CLASS_NEMESIS")
		else if (g_assassin[id])
			formatex(class, 31, "%L", ID_SHOWHUD, "CLASS_ASSASSIN")
		else
			copy(class, 31, g_zombie_classname[id])
	}
	else // humans
	{
		if (g_survivor[id])
			formatex(class, 31, "%L", ID_SHOWHUD, "CLASS_SURVIVOR")
		else if (g_sniper[id])
			formatex(class, 31, "%L", ID_SHOWHUD, "CLASS_SNIPER")
		else
			copy(class, 31, g_human_classname[id])
	}
	
	// Spectating someone else?
	if (id != ID_SHOWHUD)
	{
		// Show name, health, class, and ammo packs
		set_hudmessage(random_num(57, 255), random_num(0, 255), random_num(0, 255), 0.01, 0.25, 0, 6.0, 1.1, 0.0, 0.0, -1);
		ShowSyncHudMsg(ID_SHOWHUD, g_MsgSync2, "%L %s^n%L: %d / %L: %d^n%L: %s^n%L: %d", ID_SHOWHUD, "SPECTATING", g_playername[id], ID_SHOWHUD, "ZOMBIE_ATTRIB1", pev(id, pev_health), ID_SHOWHUD, "ZOMBIE_ATTRIB5", pev(id, pev_armorvalue), ID_SHOWHUD, "CLASS_SPEC", class, ID_SHOWHUD, "AMMO_PACKS1", g_ammopacks[id])
	}
	else if(g_informer[id] == INFORMER_STYLE1)
	{
		// Show health, class and ammo packs
		set_dhudmessage(random_num(57, 255), random_num(0, 255), random_num(0, 255), post_x, post_y, 0, 6.0, 1.1, 0.0, -0.1);
		show_dhudmessage(ID_SHOWHUD, "[%L: %d | %L: %d | %L: %s]", id, "ZOMBIE_ATTRIB1", pev(id, pev_health), id, "ARMOR", pev(id, pev_armorvalue), id, "CLASS_CLASS", class)
		
		formatex(text, 511, "");

		message_begin(MSG_ONE_UNRELIABLE,get_user_msgid("StatusText"),_,id);
		write_byte(0);
		write_string(text);
		message_end();
	}
	else if(g_informer[id] == INFORMER_STYLE2)
	{
		// Show health, class and ammo packs
		set_hudmessage(random_num(57, 255), random_num(0, 255), random_num(0, 255), post_x, post_y, 0, 6.0, 1.1, 0.0, 0.0, -1);
		ShowSyncHudMsg(ID_SHOWHUD, g_MsgSync2, "[%L: %d | %L: %d | %L: %s]", id, "ZOMBIE_ATTRIB1", pev(id, pev_health), id, "ARMOR", pev(id, pev_armorvalue), id, "CLASS_CLASS", class)
		
		formatex(text, 511, "");

		message_begin(MSG_ONE_UNRELIABLE,get_user_msgid("StatusText"),_,id);
		write_byte(0);
		write_string(text);
		message_end();
	}
	else if(g_informer[id] == INFORMER_STYLE3)
	{
		// Show health, class and ammo packs
		formatex(text, 511, "[%L: %d | %L: %d | %L: %s]", id, "ZOMBIE_ATTRIB1", pev(id, pev_health), id, "ARMOR", pev(id, pev_armorvalue), id, "CLASS_CLASS", class)

		message_begin(MSG_ONE_UNRELIABLE,get_user_msgid("StatusText"),_,id);
		write_byte(0);
		write_string(text);
		message_end();
	}
	else if(g_informer[id] == INFORMER_STYLE4)
	{
		formatex(text, 511, "");

		message_begin(MSG_ONE_UNRELIABLE,get_user_msgid("StatusText"),_,id);
		write_byte(0);
		write_string(text);
		message_end();
	}
	if (id != ID_SHOWHUD)
	{
		// Show Spec Damage
		set_dhudmessage(0, 255, 0, 0.01, 0.14, 0, 6.0, 1.1, 0.0, -0.1)
		show_dhudmessage(ID_SHOWHUD, "[%L: %.1f]", ID_SHOWHUD, "TALRASHA_DAMAGE", user_damage[id])
	}
	else
	{
		// Show Your Damage
		set_dhudmessage(0, 255, 0, 0.01, 0.14, 0, 6.0, 1.1, 0.0, -0.1)
		show_dhudmessage(ID_SHOWHUD, "[%L: %.1f]", id, "TALRASHA_DAMAGE", user_damage[id])
	}
	if (id != ID_SHOWHUD)
	{
		// Show Spec Level and Exp
		set_dhudmessage(0, 0, 255, 0.01, 0.18, 0, 6.0, 1.1, 0.0, -0.1)
		show_dhudmessage(ID_SHOWHUD,  "[%L: %d/%d]^n[%L: %d/%d]", ID_SHOWHUD, "TALRASHA_LEVEL_SYSTEM", get_user_lvl(id), get_num_lvls(id) , ID_SHOWHUD, "TALRASHA_LEVEL_SYSTEM_XP", get_user_xp(id), get_lvl_xp(id))
	}
	else
	{
		// Show Your Level and Exp
		set_dhudmessage(0, 0, 255, 0.01, 0.18, 0, 6.0, 1.1, 0.0, -0.1) 
		show_dhudmessage(ID_SHOWHUD, "[%L: %d/%d]^n[%L: %d/%d]", id, "TALRASHA_LEVEL_SYSTEM", get_user_lvl(id), get_num_lvls(id), id, "TALRASHA_LEVEL_SYSTEM_XP", get_user_xp(id), get_lvl_xp(id))
	}
}

// Play idle zombie sounds
public zombie_play_idle(taskid)
{
	// Round ended/new one starting
	if (g_endround || g_newround)
		return;
	
	static sound[64]
	
	// Last zombie?
	if (g_lastzombie[ID_BLOOD])
	{
		static pointers[10], end
		ArrayGetArray(pointer_class_sound_idle_last, g_zombieclass[ID_BLOOD], pointers)
		
		for (new i; i < 10; i++)
		{
			if (pointers[i] != -1)
			end = i
		}
		ArrayGetString(class_sound_idle_last, random_num(pointers[0], pointers[end]), sound, 63)
		emit_sound(ID_BLOOD, CHAN_VOICE, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
	else if(g_nemesis[ID_BLOOD])
	{
		ArrayGetString(nemesis_idle, random_num(0, ArraySize(nemesis_idle) - 1), sound, 63)
		emit_sound(ID_BLOOD, CHAN_VOICE, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
	else if(g_assassin[ID_BLOOD])
	{
		ArrayGetString(assassin_idle, random_num(0, ArraySize(assassin_idle) - 1), sound, 63)
		emit_sound(ID_BLOOD, CHAN_VOICE, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
	else
	{
		static pointers[10], end
		ArrayGetArray(pointer_class_sound_idle, g_zombieclass[ID_BLOOD], pointers)

		for (new i; i < 10; i++)
		{
			if (pointers[i] != -1)
			end = i
		}
		ArrayGetString(class_sound_idle, random_num(pointers[0], pointers[end]), sound, charsmax(sound))
		emit_sound(ID_BLOOD, CHAN_VOICE, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
}

// Madness Over Task
public madness_over(taskid)
{
	g_nodamage[ID_BLOOD] = false
}

// Place user at a random spawn
do_random_spawn(id, regularspawns = 0)
{
	new hull, sp_index, i
	
	// Get whether the player is crouching
	hull = (pev(id, pev_flags) & FL_DUCKING) ? HULL_HEAD : HULL_HUMAN
	
	// Use regular spawns?
	if (!regularspawns)
	{
		// No spawns?
		if (!g_spawnCount)
			return;
		
		// Choose random spawn to start looping at
		sp_index = random_num(0, g_spawnCount - 1)
		
		// Try to find a clear spawn
		for (i = sp_index + 1; /*no condition*/; i++)
		{
			// Start over when we reach the end
			if (i >= g_spawnCount) i = 0
			
			// Free spawn space?
			if (is_hull_vacant(g_spawns[i], hull))
			{
				// Engfunc_SetOrigin is used so ent's mins and maxs get updated instantly
				engfunc(EngFunc_SetOrigin, id, g_spawns[i])
				break;
			}
			
			// Loop completed, no free space found
			if (i == sp_index) break;
		}
	}
	else
	{
		// No spawns?
		if (!g_spawnCount2)
			return;
		
		// Choose random spawn to start looping at
		sp_index = random_num(0, g_spawnCount2 - 1)
		
		// Try to find a clear spawn
		for (i = sp_index + 1; /*no condition*/; i++)
		{
			// Start over when we reach the end
			if (i >= g_spawnCount2) i = 0
			
			// Free spawn space?
			if (is_hull_vacant(g_spawns2[i], hull))
			{
				// Engfunc_SetOrigin is used so ent's mins and maxs get updated instantly
				engfunc(EngFunc_SetOrigin, id, g_spawns2[i])
				break;
			}
			
			// Loop completed, no free space found
			if (i == sp_index) break;
		}
	}
}

// Get Zombies -returns alive zombies number-
fnGetZombies()
{
	new iZombies, id
	
	for (id = 1; id <= g_maxplayers; id++)
	{
		if (g_isalive[id] && g_zombie[id])
			iZombies++
	}
	
	return iZombies;
}

// Get Humans -returns alive humans number-
fnGetHumans()
{
	new iHumans, id
	
	for (id = 1; id <= g_maxplayers; id++)
	{
		if (g_isalive[id] && !g_zombie[id])
			iHumans++
	}
	
	return iHumans;
}

// Get Nemesis -returns alive nemesis number-
fnGetNemesis()
{
	new iNemesis, id
	
	for (id = 1; id <= g_maxplayers; id++)
	{
		if (g_isalive[id] && g_nemesis[id])
			iNemesis++
	}
	
	return iNemesis;
}

// Get Survivors -returns alive survivors number-
fnGetSurvivors()
{
	new iSurvivors, id
	
	for (id = 1; id <= g_maxplayers; id++)
	{
		if (g_isalive[id] && g_survivor[id])
			iSurvivors++
	}
	
	return iSurvivors;
}

// Get Alive -returns alive players number-
fnGetAlive()
{
	new iAlive, id
	
	for (id = 1; id <= g_maxplayers; id++)
	{
		if (g_isalive[id])
			iAlive++
	}
	
	return iAlive;
}

// Get Random Alive -returns index of alive player number n -
fnGetRandomAlive(n)
{
	new iAlive, id
	
	for (id = 1; id <= g_maxplayers; id++)
	{
		if (g_isalive[id])
			iAlive++
		
		if (iAlive == n)
			return id;
	}
	
	return -1;
}

// Get Playing -returns number of users playing-
fnGetPlaying()
{
	new iPlaying, id, team
	
	for (id = 1; id <= g_maxplayers; id++)
	{
		if (g_isconnected[id])
		{
			team = fm_cs_get_user_team(id)
			
			if (team != FM_CS_TEAM_SPECTATOR && team != FM_CS_TEAM_UNASSIGNED)
				iPlaying++
		}
	}
	
	return iPlaying;
}

// Get CTs -returns number of CTs connected-
fnGetCTs()
{
	new iCTs, id
	
	for (id = 1; id <= g_maxplayers; id++)
	{
		if (g_isconnected[id])
		{			
			if (fm_cs_get_user_team(id) == FM_CS_TEAM_CT)
				iCTs++
		}
	}
	
	return iCTs;
}

// Get Ts -returns number of Ts connected-
fnGetTs()
{
	new iTs, id
	
	for (id = 1; id <= g_maxplayers; id++)
	{
		if (g_isconnected[id])
		{			
			if (fm_cs_get_user_team(id) == FM_CS_TEAM_T)
				iTs++
		}
	}
	
	return iTs;
}

// Get Alive CTs -returns number of CTs alive-
fnGetAliveCTs()
{
	new iCTs, id
	
	for (id = 1; id <= g_maxplayers; id++)
	{
		if (g_isalive[id])
		{			
			if (fm_cs_get_user_team(id) == FM_CS_TEAM_CT)
				iCTs++
		}
	}
	
	return iCTs;
}

// Get Alive Ts -returns number of Ts alive-
fnGetAliveTs()
{
	new iTs, id
	
	for (id = 1; id <= g_maxplayers; id++)
	{
		if (g_isalive[id])
		{			
			if (fm_cs_get_user_team(id) == FM_CS_TEAM_T)
				iTs++
		}
	}
	
	return iTs;
}

// Last Zombie Check -check for last zombie and set its flag-
fnCheckLastZombie()
{
	static id
	for (id = 1; id <= g_maxplayers; id++)
	{
		// Last zombie
		if (g_isalive[id] && g_zombie[id] && !g_nemesis[id] && !g_assassin[id] && fnGetZombies() == 1)
		{
			if (!g_lastzombie[id])
			{
				// Last zombie forward
				ExecuteForward(g_fwUserLastZombie, g_fwDummyResult, id);
			}
			g_lastzombie[id] = true
		}
		else
			g_lastzombie[id] = false
		
		// Last human
		if (g_isalive[id] && !g_zombie[id] && !g_survivor[id] && !g_sniper[id] && fnGetHumans() == 1)
		{
			if (!g_lasthuman[id])
			{
				// Reward extra hp
				fm_set_user_health(id, pev(id, pev_health) + get_pcvar_num(cvar_humanlasthp))
				
				// Last human forward
				ExecuteForward(g_fwUserLastHuman, g_fwDummyResult, id);
			}
			g_lasthuman[id] = true
		}
		else
			g_lasthuman[id] = false
	}
}

// Get Snipers -returns alive snipers number-
fnGetSnipers()
{
	new iSnipers, id
	
	for (id = 1; id <= g_maxplayers; id++)
	{
		if (g_isalive[id] && g_sniper[id])
			iSnipers++
	}
	
	return iSnipers;
}

// Get Assassins -returns alive assassins number-
fnGetAssassins()
{
	new iAssassins, id
	
	for (id = 1; id <= g_maxplayers; id++)
	{
		if (g_isalive[id] && g_assassin[id])
			iAssassins++
	}
	
	return iAssassins;
}

// Save player's stats to database
save_stats(id)
{
	// Check whether there is another record already in that slot
//	if (db_name[id][0] && !equal(g_playername[id], db_name[id]))
	if (db_address[id][0] && !equali(g_szPlayerAddress[id], db_address[id]))
	{
		// If DB size is exceeded, write over old records
//		if (db_slot_i >= sizeof db_name)
		if (db_slot_i >= sizeof db_address)
			db_slot_i = g_maxplayers+1
		
		// Move previous record onto an additional save slot
//		copy(db_name[db_slot_i], 31, db_name[id])
		copy(db_address[db_slot_i], 25, db_address[id])
		db_ammopacks[db_slot_i] = db_ammopacks[id]
		db_zombieclass[db_slot_i] = db_zombieclass[id]
		db_humanclass[db_slot_i] = db_humanclass[id]
		db_slot_i++
	}
	
	// Now save the current player stats
//	copy(db_name[id], 31, g_playername[id]) // name
	copy(db_address[id], 25, g_szPlayerAddress[id]) // ip
	db_ammopacks[id] = g_ammopacks[id]  // ammo packs
	db_zombieclass[id] = g_zombieclassnext[id] // zombie class
	db_humanclass[id] = g_humanclassnext[id] // human class
}

// Load player's stats from database (if a record is found)
load_stats(id)
{
	// Look for a matching record
//	for (i = 0; i < sizeof db_name; i++)
	for (new i = 0; i < sizeof db_address; i++)
	{
//		if (equal(g_playername[id], db_name[i]))
		if (equali(g_szPlayerAddress[id], db_address[i]))
		{
			// Bingo!
			g_ammopacks[id] = db_ammopacks[i]
			
			ExecuteForward(g_fwUserGetAmmoPacks, g_fwDummyResult, id, db_ammopacks[i], 3);
			
			g_zombieclass[id] = (db_zombieclass[i] > HZCLASS_NONE) ? db_zombieclass[i] : 0
			g_zombieclassnext[id] = db_zombieclass[i]
			g_humanclass[id] = (db_humanclass[i] > HZCLASS_NONE) ? db_humanclass[i] : 0
			g_humanclassnext[id] = db_humanclass[i]
			return;
		}
	}
}

// Checks if a player is allowed to be zombie
allowed_zombie(id)
{
	if ((g_zombie[id] && !g_nemesis[id] && !g_assassin[id]) || g_endround || !g_isalive[id] || task_exists(TASK_WELCOMEMSG) || (!g_newround && !g_zombie[id] && g_lasthuman[id]))
		return false;
	
	return true;
}

// Checks if a player is allowed to be human
allowed_human(id)
{
	if ((!g_zombie[id] && !g_survivor[id] && !g_sniper[id]) || g_endround || !g_isalive[id] || task_exists(TASK_WELCOMEMSG) || (!g_newround && g_zombie[id] && fnGetZombies() == 1))
		return false;
	
	return true;
}

// Checks if a player is allowed to be survivor
allowed_survivor(id)
{
	if (g_endround || g_survivor[id] || !g_isalive[id] || task_exists(TASK_WELCOMEMSG) || (!g_newround && g_zombie[id] && fnGetZombies() == 1))
		return false;
	
	return true;
}

// Checks if a player is allowed to be nemesis
allowed_nemesis(id)
{
	if (g_endround || g_nemesis[id] || !g_isalive[id] || task_exists(TASK_WELCOMEMSG) || (!g_newround && !g_zombie[id] && g_lasthuman[id]))
		return false;
	
	return true;
}

// Checks if a player is allowed to respawn
allowed_respawn(id)
{
	new team = fm_cs_get_user_team(id)
	
	if (g_endround || team == FM_CS_TEAM_SPECTATOR || team == FM_CS_TEAM_UNASSIGNED || g_isalive[id])
		return false;
	
	return true;
}

// Checks if swarm mode is allowed
allowed_swarm()
{
	if (g_endround || !g_newround || task_exists(TASK_WELCOMEMSG))
		return false;
	
	return true;
}

// Checks if multi infection mode is allowed
allowed_multi()
{
	if (g_endround || !g_newround || task_exists(TASK_WELCOMEMSG) || floatround(fnGetAlive()*get_pcvar_float(cvar_multiratio), floatround_ceil) < 2 || floatround(fnGetAlive()*get_pcvar_float(cvar_multiratio), floatround_ceil) >= fnGetAlive())
		return false;
	
	return true;
}

// Checks if plague mode is allowed
allowed_plague()
{
	if (g_endround || !g_newround || task_exists(TASK_WELCOMEMSG) || floatround((fnGetAlive()-(cvar_plaguenemnum+cvar_plaguesurvnum))*get_pcvar_float(cvar_plagueratio), floatround_ceil) < 1
	|| fnGetAlive()-(cvar_plaguesurvnum+cvar_plaguenemnum+floatround((fnGetAlive()-(cvar_plaguenemnum+cvar_plaguesurvnum))*get_pcvar_float(cvar_plagueratio), floatround_ceil)) < 1)
		return false;
	
	return true;
}

// Checks if a player is allowed to be sniper
allowed_sniper(id)
{
	if (g_endround || g_sniper[id] || !g_isalive[id] || task_exists(TASK_WELCOMEMSG) || (!g_newround && g_zombie[id] && fnGetZombies() == 1))
		return false;
	
	return true;
}

// Checks if a player is allowed to be assassin
allowed_assassin(id)
{
	if (g_endround || g_assassin[id] || !g_isalive[id] || task_exists(TASK_WELCOMEMSG) || (!g_newround && !g_zombie[id] && g_lasthuman[id]))
		return false;
	
	return true;
}

// Admin Command. zp_zombie
command_zombie(id, player)
{
	// Show activity?
	switch (get_pcvar_num(cvar_showactivity))
	{
		case 1: zp_colored_print(0, "ADMIN - ^3%s^1 %L", g_playername[player], LANG_PLAYER, "CMD_INFECT")
		case 2: zp_colored_print(0, "ADMIN ^3%s^1 - ^4%s^1 %L", g_playername[id], g_playername[player], LANG_PLAYER, "CMD_INFECT")
	}
	
	// Log to Zombie Plague log file?
	if (get_pcvar_num(cvar_logcommands))
		zp_log("ADMIN %s <%s><%s> - %s %L (Players: %d/%d)", g_playername[id], g_playerauthid[id], g_szPlayerAddress[id], g_playername[player], LANG_SERVER, "CMD_INFECT", fnGetPlaying(), g_maxplayers)
	
	// New round?
	if (g_newround)
	{
		// Set as first zombie
		remove_task(TASK_MAKEZOMBIE)
		make_a_zombie(MODE_INFECTION, player)
	}
	else
	{
		// Just infect
		zombieme(player, 0, 0, 0, 0)
	}
}

// Admin Command. zp_human
command_human(id, player)
{
	// Show activity?
	switch (get_pcvar_num(cvar_showactivity))
	{
		case 1: zp_colored_print(0, "ADMIN - ^3%s^1 %L", g_playername[player], LANG_PLAYER, "CMD_DISINFECT")
		case 2: zp_colored_print(0, "ADMIN ^3%s^1 - ^4%s^1 %L", g_playername[id], g_playername[player], LANG_PLAYER, "CMD_DISINFECT")
	}
	
	// Log to Zombie Plague log file?
	if (get_pcvar_num(cvar_logcommands))
		zp_log("ADMIN %s <%s><%s> - %s %L (Players: %d/%d)", g_playername[id], g_playerauthid[id], g_szPlayerAddress[id], g_playername[player], LANG_SERVER,"CMD_DISINFECT", fnGetPlaying(), g_maxplayers)
	
	// Turn to human
	humanme(player, 0, 0)
}

// Admin Command. zp_survivor
command_survivor(id, player)
{
	// Show activity?
	switch (get_pcvar_num(cvar_showactivity))
	{
		case 1: zp_colored_print(0, "ADMIN - ^3%s^1 %L", g_playername[player], LANG_PLAYER, "CMD_SURVIVAL")
		case 2: zp_colored_print(0, "ADMIN ^3%s^1 - ^4%s^1 %L", g_playername[id], g_playername[player], LANG_PLAYER, "CMD_SURVIVAL")
	}
	
	 // Log to Zombie Plague log file?
	if (get_pcvar_num(cvar_logcommands))
		zp_log("ADMIN %s <%s><%s> - %s %L (Players: %d/%d)", g_playername[id], g_playerauthid[id], g_szPlayerAddress[id], g_playername[player], LANG_SERVER,"CMD_SURVIVAL", fnGetPlaying(), g_maxplayers)
	
	// New round?
	if (g_newround)
	{
		// Set as first survivor
		remove_task(TASK_MAKEZOMBIE)
		make_a_zombie(MODE_SURVIVOR, player)
	}
	else
	{
		// Turn player into a Survivor
		humanme(player, 1, 0)
	}
}

// Admin Command. zp_nemesis
command_nemesis(id, player)
{
	// Show activity?
	switch (get_pcvar_num(cvar_showactivity))
	{
		case 1: zp_colored_print(0, "ADMIN - ^3%s^1 %L", g_playername[player], LANG_PLAYER, "CMD_NEMESIS")
		case 2: zp_colored_print(0, "ADMIN ^3%s^1 - ^4%s^1 %L", g_playername[id], g_playername[player], LANG_PLAYER, "CMD_NEMESIS")
	}
	
	// Log to Zombie Plague log file?
	if (get_pcvar_num(cvar_logcommands))
		zp_log("ADMIN %s <%s><%s> - %s %L (Players: %d/%d)", g_playername[id], g_playerauthid[id], g_szPlayerAddress[id], g_playername[player], LANG_SERVER,"CMD_NEMESIS", fnGetPlaying(), g_maxplayers)
	
	// New round?
	if (g_newround)
	{
		// Set as first nemesis
		remove_task(TASK_MAKEZOMBIE)
		make_a_zombie(MODE_NEMESIS, player)
	}
	else
	{
		// Turn player into a Nemesis
		zombieme(player, 0, 1, 0, 0)
	}
}

// Admin Command. zp_respawn
command_respawn(id, player)
{
	// Show activity?
	switch (get_pcvar_num(cvar_showactivity))
	{
		case 1: zp_colored_print(0, "ADMIN - ^3%s^1 %L", g_playername[player], LANG_PLAYER, "CMD_RESPAWN")
		case 2: zp_colored_print(0, "ADMIN ^3%s^1 - ^4%s^1 %L", g_playername[id], g_playername[player], LANG_PLAYER, "CMD_RESPAWN")
	}
	
	// Log to Zombie Plague log file?
	if (get_pcvar_num(cvar_logcommands))
		zp_log("ADMIN %s <%s><%s> - %s %L (Players: %d/%d)", g_playername[id], g_playerauthid[id], g_szPlayerAddress[id], g_playername[player], LANG_SERVER, "CMD_RESPAWN", fnGetPlaying(), g_maxplayers)
	
	// Respawn as zombie?
	new deathmatch = get_pcvar_num(cvar_deathmatch)
	if (g_survround || g_snipround || deathmatch == 2 || (deathmatch == 3 && random_num(0, 1)) || (deathmatch == 4 && fnGetZombies() < fnGetAlive()/3))
		g_respawn_as_zombie[player] = true
	else if (g_nemround || g_assround) g_respawn_as_zombie[player] = false
/*=====	
	// Override respawn as zombie setting on nemesis and survivor rounds
	if (g_survround || g_snipround) g_respawn_as_zombie[player] = true =======*/
	
	respawn_player_manually(player);
}

// Admin Command. zp_swarm
command_swarm(id)
{
	// Show activity?
	switch (get_pcvar_num(cvar_showactivity))
	{
		case 1: zp_colored_print(0, "ADMIN - %L", LANG_PLAYER, "CMD_SWARM")
		case 2: zp_colored_print(0, "ADMIN ^3%s^1 - ^4%L", g_playername[id], LANG_PLAYER, "CMD_SWARM")
	}
	
	// Log to Zombie Plague log file?
	if (get_pcvar_num(cvar_logcommands))
		zp_log("ADMIN %s <%s><%s> - %L (Players: %d/%d)", g_playername[id], g_playerauthid[id], g_szPlayerAddress[id], LANG_SERVER, "CMD_SWARM", fnGetPlaying(), g_maxplayers)
	
	// Call Swarm Mode
	remove_task(TASK_MAKEZOMBIE)
	make_a_zombie(MODE_SWARM, 0)
}

// Admin Command. zp_multi
command_multi(id)
{
	// Show activity?
	switch (get_pcvar_num(cvar_showactivity))
	{
		case 1: zp_colored_print(0, "ADMIN - %L", LANG_PLAYER, "CMD_MULTI")
		case 2: zp_colored_print(0, "ADMIN ^3%s^1 - ^4%L", g_playername[id], LANG_PLAYER, "CMD_MULTI")
	}
	
	// Log to Zombie Plague log file?
	if (get_pcvar_num(cvar_logcommands))
		zp_log("ADMIN %s <%s><%s> - %L (Players: %d/%d)", g_playername[id], g_playerauthid[id], g_szPlayerAddress[id], LANG_SERVER,"CMD_MULTI", fnGetPlaying(), g_maxplayers)
	
	// Call Multi Infection
	remove_task(TASK_MAKEZOMBIE)
	make_a_zombie(MODE_MULTI, 0)
}

// Admin Command. zp_plague
command_plague(id)
{
	// Show activity?
	switch (get_pcvar_num(cvar_showactivity))
	{
		case 1: zp_colored_print(0, "ADMIN - %L", LANG_PLAYER, "CMD_PLAGUE")
		case 2: zp_colored_print(0, "ADMIN ^3%s^1 - ^4%L", g_playername[id], LANG_PLAYER, "CMD_PLAGUE")
	}
	
	// Log to Zombie Plague log file?
	if (get_pcvar_num(cvar_logcommands))
		zp_log("ADMIN %s <%s><%s> - %L (Players: %d/%d)", g_playername[id], g_playerauthid[id], g_szPlayerAddress[id], LANG_SERVER,"CMD_PLAGUE", fnGetPlaying(), g_maxplayers)
	
	// Call Plague Mode
	remove_task(TASK_MAKEZOMBIE)
	make_a_zombie(MODE_PLAGUE, 0)
}

// Admin Command. zp_sniper
command_sniper(id, player)
{
	// Show activity?
	switch (get_pcvar_num(cvar_showactivity))
	{
		case 1: zp_colored_print(0, "ADMIN - ^3%s^1 %L", g_playername[player], LANG_PLAYER, "CMD_SNIPER")
		case 2: zp_colored_print(0, "ADMIN ^3%s^1 - ^4%s^1 %L", g_playername[id], g_playername[player], LANG_PLAYER, "CMD_SNIPER")
	}
	
	 // Log to Zombie Plague log file?
	if (get_pcvar_num(cvar_logcommands))
		zp_log("ADMIN %s <%s><%s> - %s %L (Players: %d/%d)", g_playername[id], g_playerauthid[id], g_szPlayerAddress[id], g_playername[player], LANG_SERVER,"CMD_SNIPER", fnGetPlaying(), g_maxplayers)
	
	// New round?
	if (g_newround)
	{
		// Set as first sniper
		remove_task(TASK_MAKEZOMBIE)
		make_a_zombie(MODE_SNIPER, player)
	}
	else
	{
		// Turn player into a Sniper
		humanme(player, 0, 0, 1)
	}
}

// Admin Command. zp_assassin
command_assassin(id, player)
{
	// Show activity?
	switch (get_pcvar_num(cvar_showactivity))
	{
		case 1: zp_colored_print(0, "ADMIN - ^3%s^1 %L", g_playername[player], LANG_PLAYER, "CMD_ASSASSIN")
		case 2: zp_colored_print(0, "ADMIN ^3%s^1 - ^4%s^1 %L", g_playername[id], g_playername[player], LANG_PLAYER, "CMD_ASSASSIN")
	}
	
	// Log to Zombie Plague log file?
	if (get_pcvar_num(cvar_logcommands))
/*	{
		static logdata[157]*/
		zp_log("ADMIN %s <%s><%s> - %s %L (Players: %d/%d)", g_playername[id], g_playerauthid[id], g_szPlayerAddress[id], g_playername[player], LANG_SERVER,"CMD_ASSASSIN", fnGetPlaying(), g_maxplayers)
/*		log_to_file("zombieplaguenightmare.log", logdata)
	}*/
	
	// New round?
	if (g_newround)
	{
		// Set as first assassin
		remove_task(TASK_MAKEZOMBIE)
		make_a_zombie(MODE_ASSASSIN, player)
	}
	else
	{
		// Turn player into an Assassin
		zombieme(player, 0, 0, 0, 0, 1)
	}
}

// Set proper maxspeed for player
set_player_maxspeed(id)
{
	// If frozen, prevent from moving
	if (g_frozen[id])
	{
		set_pev(id, pev_maxspeed, 1.0)
	}
	// Otherwise, set maxspeed directly
	else
	{
		if (g_zombie[id])
		{
			if (g_nemesis[id])
				set_pev(id, pev_maxspeed, get_pcvar_float(cvar_nemspd))
			else if (g_assassin[id])
				set_pev(id, pev_maxspeed, get_pcvar_float(cvar_assspd))
			else
				set_pev(id, pev_maxspeed, g_zombie_spd[id])
		}
		else
		{
			if (g_survivor[id])
				set_pev(id, pev_maxspeed, get_pcvar_float(cvar_survspd))
			else if (g_sniper[id])
				set_pev(id, pev_maxspeed, get_pcvar_float(cvar_snipspd))
			else
				set_pev(id, pev_maxspeed, g_human_spd[id])
		}
	}
}

/*================================================================================
 [Custom Natives]
=================================================================================*/

// Native: zp_get_user_zombie
public native_get_user_zombie(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_zombie[id];
}

// Native: zp_get_user_nemesis
public native_get_user_nemesis(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_nemesis[id];
}

// Native: zpnm_get_user_assassin
public native_get_user_assassin(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_assassin[id];
}

// Native: zp_get_user_survivor
public native_get_user_survivor(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_survivor[id];
}

// Native: zpnm_get_user_sniper
public native_get_user_sniper(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_sniper[id];
}

public native_get_user_first_zombie(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_firstzombie[id];
}

// Native: zp_get_user_last_zombie
public native_get_user_last_zombie(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_lastzombie[id];
}

// Native: zp_get_user_last_human
public native_get_user_last_human(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_lasthuman[id];
}

// Native: zp_get_user_zombie_class
public native_get_user_zombie_class(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_zombieclass[id];
}

// Native: zp_get_user_next_class
public native_get_user_next_class(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_zombieclassnext[id];
}

// Native: zp_set_user_zombie_class
public native_set_user_zombie_class(id, classid)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	
	if (classid < 0 || classid >= g_zclass_i)
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid zombie class id (%d)", classid)
		return false;
	}
	
	g_zombieclassnext[id] = classid
	return true;
}

// Native: zpnm_get_user_human_class
public native_get_user_human_class(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_humanclass[id];
}

// Native: zpnm_get_user_next_hclass
public native_get_user_next_hclass(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_humanclassnext[id];
}

// Native: zpnm_set_user_human_class
public native_set_user_human_class(id, classid)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	
	if (classid < 0 || classid >= g_hclass_i)
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid human class id (%d)", classid)
		return false;
	}
	
	g_humanclassnext[id] = classid
	
	return true;
}

// Native: zp_get_user_ammo_packs
public native_get_user_ammo_packs(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_ammopacks[id];
}

// Native: zp_set_user_ammo_packs
public native_set_user_ammo_packs(id, amount)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	else if (amount == g_ammopacks[id])
		return false;
	
	new oldammo = g_ammopacks[id]
	
	g_ammopacks[id] = amount;
	
	ExecuteForward(g_fwUserGetAmmoPacks, g_fwDummyResult, id, amount - oldammo, 4);
	
	return true;
}

// Native: zp_get_zombie_maxhealth
public native_get_zombie_maxhealth(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	if (!g_zombie[id] || g_nemesis[id] || g_assassin[id])
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Player not a normal zombie (%d)", id)
		return -1;
	}
	
	if (g_firstzombie[id])
		return floatround(float(ArrayGetCell(g_zclass_hp, g_zombieclass[id])) * get_pcvar_float(cvar_zombiefirsthp));
	
	return ArrayGetCell(g_zclass_hp, g_zombieclass[id]);
}

// Native: zpnm_get_human_maxhealth
public native_get_human_maxhealth(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	if (g_zombie[id] || g_survivor[id] || g_sniper[id])
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Player is a zombie, a survivor or a sniper (%d)", id)
		return -1;
	}
	
	return ArrayGetCell(g_hclass_hp, g_humanclass[id]);
}

// Native: zp_get_user_batteries
public native_get_user_batteries(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_flashbattery[id];
}

// Native: zp_set_user_batteries
public native_set_user_batteries(id, value)
{
	// ZP disabled
	if (!g_pluginenabled)
		return false;
	
	if (!is_user_valid_connected(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	
	g_flashbattery[id] = clamp(value, 0, 100);
	
	if (cvar_customflash)
	{
		// Set the flashlight charge task to update battery status
		remove_task(id+TASK_CHARGE)
		set_task(1.0, "flashlight_charge", id+TASK_CHARGE, _, _, "b")
	}
	return true;
}

// Native: zp_get_user_nightvision
public native_get_user_nightvision(id)
{
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_nvision[id];
}

// Native: zp_set_user_nightvision
public native_set_user_nightvision(id, set)
{
	// ZP disabled
	if (!g_pluginenabled)
		return false;
	
	if (!is_user_valid_connected(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	
	if (set)
	{
		g_nvision[id] = true
		
		if (!g_isbot[id])
		{
			g_nvisionenabled[id] = true
			
			// Custom nvg?
			if (get_pcvar_num(cvar_customnvg))
			{
				remove_task(id+TASK_NVISION)
				set_task(0.1, "set_user_nvision", id+TASK_NVISION, _, _, "b")
			}
			else
				set_user_gnvision(id, 1)
		}
		else
			cs_set_user_nvg(id, 1)
	}
	else
	{
		// Remove CS nightvision if player owns one (bugfix)
		cs_set_user_nvg(id, 0)
		
		if (get_pcvar_num(cvar_customnvg)) remove_task(id+TASK_NVISION)
		else if (g_nvisionenabled[id]) set_user_gnvision(id, 0)
		g_nvision[id] = false
		g_nvisionenabled[id] = false
	}
	return true;
}

// Native: zp_infect_user
public native_infect_user(id, infector, silent, rewards)
{
	// ZP disabled
	if (!g_pluginenabled)
		return false;
	
	if (!is_user_valid_alive(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	
	// Not allowed to be zombie
	if (!allowed_zombie(id))
		return false;
	
	// New round?
	if (g_newround)
	{
		// Set as first zombie
		remove_task(TASK_MAKEZOMBIE)
		make_a_zombie(MODE_INFECTION, id)
	}
	else
	{
		// Just infect (plus some checks)
		zombieme(id, is_user_valid_alive(infector) ? infector : 0, 0, (silent == 1) ? 1 : 0, (rewards == 1) ? 1 : 0)
	}
	return true;
}

// Native: zp_disinfect_user
public native_disinfect_user(id, silent)
{
	// ZP disabled
	if (!g_pluginenabled)
		return false;
	
	if (!is_user_valid_alive(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	
	// Not allowed to be human
	if (!allowed_human(id))
		return false;
	
	// Turn to human
	humanme(id, 0, (silent == 1) ? 1 : 0)
	return true;
}

// Native: zp_make_user_nemesis
public native_make_user_nemesis(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return false;
	
	if (!is_user_valid_alive(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	
	// Not allowed to be nemesis
	if (!allowed_nemesis(id))
		return false;
	
	// New round?
	if (g_newround)
	{
		// Set as first nemesis
		remove_task(TASK_MAKEZOMBIE)
		make_a_zombie(MODE_NEMESIS, id)
	}
	else
	{
		// Turn player into a Nemesis
		zombieme(id, 0, 1, 0, 0)
	}
	return true;
}

// Native: zpnm_make_user_assassin
public native_make_user_assassin(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return false;
	
	if (!is_user_valid_alive(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	
	// Not allowed to be assassin
	if (!allowed_assassin(id))
		return false;
	
	// New round?
	if (g_newround)
	{
		// Set as first assassin
		remove_task(TASK_MAKEZOMBIE)
		make_a_zombie(MODE_ASSASSIN, id)
	}
	else
	{
		// Turn player into a Assassin
		zombieme(id, 0, 0, 0, 0, 1)
	}
	return true;
}

// Native: zp_make_user_survivor
public native_make_user_survivor(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return false;
	
	if (!is_user_valid_alive(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	
	// Not allowed to be survivor
	if (!allowed_survivor(id))
		return false;
	
	// New round?
	if (g_newround)
	{
		// Set as first survivor
		remove_task(TASK_MAKEZOMBIE)
		make_a_zombie(MODE_SURVIVOR, id)
	}
	else
	{
		// Turn player into a Survivor
		humanme(id, 1, 0)
	}
	
	return true;
}

// Native: zpnm_make_user_sniper
public native_make_user_sniper(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return false;
	
	if (!is_user_valid_alive(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	
	// Not allowed to be sniper
	if (!allowed_sniper(id))
		return false;
	
	// New round?
	if (g_newround)
	{
		// Set as first sniper
		remove_task(TASK_MAKEZOMBIE)
		make_a_zombie(MODE_SNIPER, id)
	}
	else
	{
		// Turn player into a Sniper
		humanme(id, 0, 0, 1)
	}
	
	return true;
}

// Native: zp_respawn_user
public native_respawn_user(id, team)
{
	// ZP disabled
	if (!g_pluginenabled)
		return false;
	
	if (!is_user_valid_connected(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	
	// Respawn not allowed
	if (!allowed_respawn(id))
		return false;
	
	// Respawn as zombie?
	if (team != ZP_TEAM_ANY)
		g_respawn_as_zombie[id] = (team == ZP_TEAM_ZOMBIE) ? true : false
	
	// Respawnish!
	respawn_player_manually(id)
	return true;
}

// Native: zp_force_buy_extra_item
public native_force_buy_extra_item(id, itemid, ignorecost)
{
	// ZP disabled
	if (!g_pluginenabled)
		return false;
	
	if (!is_user_valid_alive(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	
	if (itemid < 0 || itemid >= g_extraitem_i)
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid extra item id (%d)", itemid)
		return false;
	}
	
	buy_extra_item(id, itemid, ignorecost)
	return true;
}

// Native: zp_override_user_model
public native_override_user_model(id, const newmodel[], modelindex)
{
	// ZP disabled
	if (!g_pluginenabled)
		return false;
	
	if (!is_user_valid_connected(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return false;
	}
	
	// Strings passed byref
	param_convert(2)
	
	// Remove previous tasks
	remove_task(id+TASK_MODEL)
	
	// Custom models stuff
	static currentmodel[32]
	
	if (g_handle_models_on_separate_ent)
	{
		// Set the right model
		copy(g_playermodel[id], 31, newmodel)
		if (g_set_modelindex_offset && modelindex) fm_cs_set_user_model_index(id, modelindex)
		
		// Set model on player model entity
		fm_set_playermodel_ent(id)
	}
	else
	{
		// Get current model for comparing it with the current one
		fm_cs_get_user_model(id, currentmodel, 31)
		
		// Set the right model, after checking that we don't already have it
		if (!equali(currentmodel, newmodel))
		{
			copy(g_playermodel[id], 31, newmodel)
			if (g_set_modelindex_offset && modelindex) fm_cs_set_user_model_index(id, modelindex)
			
			// An additional delay is offset at round start
			// since SVC_BAD is more likely to be triggered there
			if (g_newround)
				set_task(5.0 * g_modelchange_delay, "fm_user_model_update", id+TASK_MODEL)
			else
				fm_user_model_update(id+TASK_MODEL)
		}
	}
	return true;
}

// Native: zp_has_round_started
public native_has_round_started()
{
	if (g_newround) return 0; // not started
	else if (g_modestarted) return 1; // started
	return 2; // starting
}

// Native: zp_is_nemesis_round
public native_is_nemesis_round()
{
	return g_nemround;
}

// Native: zpnm_is_assassin_round
public native_is_assassin_round()
{
	return g_assround;
}

// Native: zp_is_survivor_round
public native_is_survivor_round()
{
	return g_survround;
}

// Native: zpnm_is_sniper_round
public native_is_sniper_round()
{
	return g_snipround;
}

// Native: zp_is_swarm_round
public native_is_swarm_round()
{
	return g_swarmround;
}

// Native: zp_is_plague_round
public native_is_plague_round()
{
	return g_plagueround;
}

// Native: zp_get_zombie_count
public native_get_zombie_count()
{
	return fnGetZombies();
}

// Native: zp_get_human_count
public native_get_human_count()
{
	return fnGetHumans();
}

// Native: zp_get_nemesis_count
public native_get_nemesis_count()
{
	return fnGetNemesis();
}

// Native: zpnm_get_assassin_count
public native_get_assassin_count()
{
	return fnGetAssassins();
}

// Native: zp_get_survivor_count
public native_get_survivor_count()
{
	return fnGetSurvivors();
}

// Native: zpnm_get_sniper_count
public native_get_sniper_count()
{
	return fnGetSnipers();
}

// Native: zp_register_extra_item
public native_register_extra_item(const name[], cost, team)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	// Strings passed byref
	param_convert(1)
	
	// Arrays not yet initialized
	if (!g_arrays_created)
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Can't register extra item yet (%s)", name)
		return -1;
	}
	
	if (strlen(name) < 1)
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Can't register extra item with an empty name")
		return -1;
	}
	
	new index, extraitem_name[32]
	for (index = 0; index < g_extraitem_i; index++)
	{
		ArrayGetString(g_extraitem_name, index, extraitem_name, 31)
		if (equali(name, extraitem_name))
		{
			log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Extra item already registered (%s)", name)
			return -1;
		}
	}
	
	// For backwards compatibility
	if (team == ZP_TEAM_ANY)
		team = (ZP_TEAM_ZOMBIE|ZP_TEAM_HUMAN)
	
	// Add the item
	ArrayPushString(g_extraitem_name, name)
	ArrayPushCell(g_extraitem_cost, cost)
	ArrayPushCell(g_extraitem_team, team)
	
	// Set temporary new item flag
	ArrayPushCell(g_extraitem_new, 1)
	
	// Override extra items data with our customizations
	new i, buffer[32], size = ArraySize(g_extraitem2_realname)
	for (i = 0; i < size; i++)
	{
		ArrayGetString(g_extraitem2_realname, i, buffer, 31)
		
		// Check if this is the intended item to override
		if (!equali(name, buffer))
			continue;
		
		// Remove new item flag
		ArraySetCell(g_extraitem_new, g_extraitem_i, 0)
		
		// Replace caption
		ArrayGetString(g_extraitem2_name, i, buffer, 31)
		ArraySetString(g_extraitem_name, g_extraitem_i, buffer)
		
		// Replace cost
		buffer[0] = ArrayGetCell(g_extraitem2_cost, i)
		ArraySetCell(g_extraitem_cost, g_extraitem_i, buffer[0])
		
		// Replace team
		buffer[0] = ArrayGetCell(g_extraitem2_team, i)
		ArraySetCell(g_extraitem_team, g_extraitem_i, buffer[0])
	}
	
	// Increase registered items counter
	g_extraitem_i++
	
	// Return id under which we registered the item
	return g_extraitem_i-1;
}

// Function: zp_register_extra_item (to be used within this plugin only)
native_register_extra_item2(const name[], cost, team)
{
	// Add the item
	ArrayPushString(g_extraitem_name, name)
	ArrayPushCell(g_extraitem_cost, cost)
	ArrayPushCell(g_extraitem_team, team)
	
	// Set temporary new item flag
	ArrayPushCell(g_extraitem_new, 1)
	
	// Increase registered items counter
	g_extraitem_i++
}

// Native: zp_register_zombie_class
public native_register_zombie_class(const name[], const info[], const model[], const clawmodel[], hp, speed, Float:gravity, Float:knockback)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	// Strings passed byref
	param_convert(1)
	param_convert(2)
	param_convert(3)
	param_convert(4)
	
	// Arrays not yet initialized
	if (!g_arrays_created)
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Can't register zombie class yet (%s)", name)
		return -1;
	}
	
	if (strlen(name) < 1)
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Can't register zombie class with an empty name")
		return -1;
	}
	
	new index, zombieclass_name[32]
	for (index = 0; index < g_zclass_i; index++)
	{
		ArrayGetString(g_zclass_name, index, zombieclass_name, 31)
		if (equali(name, zombieclass_name))
		{
			log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Zombie class already registered (%s)", name)
			return -1;
		}
	}
	
	// Add the class
	ArrayPushString(g_zclass_name, name)
	ArrayPushString(g_zclass_info, info)
	
	// Using same zombie models for all classes?
	if (g_same_models_for_all)
	{
		ArrayPushCell(g_zclass_modelsstart, 0)
		ArrayPushCell(g_zclass_modelsend, ArraySize(g_zclass_playermodel))
	}
	else
	{
		ArrayPushCell(g_zclass_modelsstart, ArraySize(g_zclass_playermodel))
		ArrayPushString(g_zclass_playermodel, model)
		ArrayPushCell(g_zclass_modelsend, ArraySize(g_zclass_playermodel))
		ArrayPushCell(g_zclass_modelindex, -1)
	}
	
	ArrayPushString(g_zclass_clawmodel, clawmodel)
	ArrayPushCell(g_zclass_hp, hp)
	ArrayPushCell(g_zclass_spd, speed)
	ArrayPushCell(g_zclass_grav, gravity)
	ArrayPushCell(g_zclass_kb, knockback)
	
	// Set temporary new class flag
	ArrayPushCell(g_zclass_new, 1)
	
	// Override zombie classes data with our customizations
	new i, k, buffer[64], Float:buffer2, nummodels_custom, nummodels_default, prec_mdl[175], size = ArraySize(g_zclass2_realname)
	for (i = 0; i < size; i++)
	{
		ArrayGetString(g_zclass2_realname, i, buffer, 63)
		
		// Check if this is the intended class to override
		if (!equali(name, buffer))
			continue;
		
		// Remove new class flag
		ArraySetCell(g_zclass_new, g_zclass_i, 0)
		
		// Replace caption
		ArrayGetString(g_zclass2_name, i, buffer, 63)
		ArraySetString(g_zclass_name, g_zclass_i, buffer)
		
		// Replace info
		ArrayGetString(g_zclass2_info, i, buffer, 63)
		ArraySetString(g_zclass_info, g_zclass_i, buffer)
		
		// Replace models, unless using same models for all classes
		if (!g_same_models_for_all)
		{
			nummodels_custom = ArrayGetCell(g_zclass2_modelsend, i) - ArrayGetCell(g_zclass2_modelsstart, i)
			nummodels_default = ArrayGetCell(g_zclass_modelsend, g_zclass_i) - ArrayGetCell(g_zclass_modelsstart, g_zclass_i)
			
			// Replace each player model and model index
			for (k = 0; k < min(nummodels_custom, nummodels_default); k++)
			{
				ArrayGetString(g_zclass2_playermodel, ArrayGetCell(g_zclass2_modelsstart, i) + k, buffer, 63)
				ArraySetString(g_zclass_playermodel, ArrayGetCell(g_zclass_modelsstart, g_zclass_i) + k, buffer)
				
				// Precache player model and replace its modelindex with the real one
				formatex(prec_mdl, 174, "models/player/%s/%s.mdl", buffer, buffer)
				ArraySetCell(g_zclass_modelindex, ArrayGetCell(g_zclass_modelsstart, g_zclass_i) + k, engfunc(EngFunc_PrecacheModel, prec_mdl))
				if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, prec_mdl)
				if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, prec_mdl)
				// Precache modelT.mdl files too
				copy(prec_mdl[strlen(prec_mdl)-4], 174 - (strlen(prec_mdl)-4), "T.mdl")
				if (file_exists(prec_mdl)) engfunc(EngFunc_PrecacheModel, prec_mdl)
			}
			
			// We have more custom models than what we can accommodate,
			// Let's make some space...
			if (nummodels_custom > nummodels_default)
			{
				for (k = nummodels_default; k < nummodels_custom; k++)
				{
					ArrayGetString(g_zclass2_playermodel, ArrayGetCell(g_zclass2_modelsstart, i) + k, buffer, 63)
					ArrayInsertStringAfter(g_zclass_playermodel, ArrayGetCell(g_zclass_modelsstart, g_zclass_i) + k - 1, buffer)
					
					// Precache player model and retrieve its modelindex
					formatex(prec_mdl, 174, "models/player/%s/%s.mdl", buffer, buffer)
					ArrayInsertCellAfter(g_zclass_modelindex, ArrayGetCell(g_zclass_modelsstart, g_zclass_i) + k - 1, engfunc(EngFunc_PrecacheModel, prec_mdl))
					if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, prec_mdl)
					if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, prec_mdl)
					// Precache modelT.mdl files too
					copy(prec_mdl[strlen(prec_mdl)-4], 174 - (strlen(prec_mdl)-4), "T.mdl")
					if (file_exists(prec_mdl)) engfunc(EngFunc_PrecacheModel, prec_mdl)
				}
				
				// Fix models end index for this class
				ArraySetCell(g_zclass_modelsend, g_zclass_i, ArrayGetCell(g_zclass_modelsend, g_zclass_i) + (nummodels_custom - nummodels_default))
			}
			
			/* --- Not needed since classes can't have more than 1 default model for now ---
			// We have less custom models than what this class has by default,
			// Get rid of those extra entries...
			if (nummodels_custom < nummodels_default)
			{
				for (k = nummodels_custom; k < nummodels_default; k++)
				{
					ArrayDeleteItem(g_zclass_playermodel, ArrayGetCell(g_zclass_modelsstart, g_zclass_i) + nummodels_custom)
				}
				
				// Fix models end index for this class
				ArraySetCell(g_zclass_modelsend, g_zclass_i, ArrayGetCell(g_zclass_modelsend, g_zclass_i) - (nummodels_default - nummodels_custom))
			}
			*/
		}
		
		// Replace clawmodel
		ArrayGetString(g_zclass2_clawmodel, i, buffer, 63)
		ArraySetString(g_zclass_clawmodel, g_zclass_i, buffer)
		
		// Precache clawmodel
		formatex(prec_mdl, 174, "models/%s", buffer)
		engfunc(EngFunc_PrecacheModel, prec_mdl)
		
		// Replace health
		buffer[0] = ArrayGetCell(g_zclass2_hp, i)
		ArraySetCell(g_zclass_hp, g_zclass_i, buffer[0])
		
		// Replace speed
		buffer[0] = ArrayGetCell(g_zclass2_spd, i)
		ArraySetCell(g_zclass_spd, g_zclass_i, buffer[0])
		
		// Replace gravity
		buffer2 = Float:ArrayGetCell(g_zclass2_grav, i)
		ArraySetCell(g_zclass_grav, g_zclass_i, buffer2)
		
		// Replace knockback
		buffer2 = Float:ArrayGetCell(g_zclass2_kb, i)
		ArraySetCell(g_zclass_kb, g_zclass_i, buffer2)
	}
	
	// If class was not overriden with customization data
	if (ArrayGetCell(g_zclass_new, g_zclass_i))
	{
		// If not using same models for all classes
		if (!g_same_models_for_all)
		{
			// Precache default class model and replace modelindex with the real one
			formatex(prec_mdl, 174, "models/player/%s/%s.mdl", model, model)
			ArraySetCell(g_zclass_modelindex, ArrayGetCell(g_zclass_modelsstart, g_zclass_i), engfunc(EngFunc_PrecacheModel, prec_mdl))
			if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, prec_mdl)
			if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, prec_mdl)
			// Precache modelT.mdl files too
			copy(prec_mdl[strlen(prec_mdl)-4], 174 - (strlen(prec_mdl)-4), "T.mdl")
			if (file_exists(prec_mdl)) engfunc(EngFunc_PrecacheModel, prec_mdl)
		}
		
		// Precache default clawmodel
		formatex(prec_mdl, 174, "models/%s", clawmodel)
		engfunc(EngFunc_PrecacheModel, prec_mdl)
	}
	
	// Increase registered classes counter
	g_zclass_i++
	
	// Return id under which we registered the class
	return g_zclass_i-1;
}

// Native: zpnm_register_human_class
public native_register_human_class(const name[], const info[], const model[], const handmodel[], hp, speed, Float:gravity)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	// Strings passed byref
	param_convert(1)
	param_convert(2)
	param_convert(3)
	param_convert(4)
	
	// Arrays not yet initialized
	if (!g_arrays_created)
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Can't register human class yet (%s)", name)
		return -1;
	}
	
	if (strlen(name) < 1)
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Can't register human class with an empty name")
		return -1;
	}
	
	new index, humanclass_name[32]
	for (index = 0; index < g_hclass_i; index++)
	{
		ArrayGetString(g_hclass_name, index, humanclass_name, 31)
		if (equali(name, humanclass_name))
		{
			log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Human class already registered (%s)", name)
			return -1;
		}
	}
	
	// Add the class
	ArrayPushString(g_hclass_name, name)
	ArrayPushString(g_hclass_info, info)
	
	// Using same human models for all classes?
	if (g_same_models_for_all)
	{
		ArrayPushCell(g_hclass_modelsstart, 0)
		ArrayPushCell(g_hclass_modelsend, ArraySize(g_hclass_playermodel))
	}
	else
	{
		ArrayPushCell(g_hclass_modelsstart, ArraySize(g_hclass_playermodel))
		ArrayPushString(g_hclass_playermodel, model)
		ArrayPushCell(g_hclass_modelsend, ArraySize(g_hclass_playermodel))
		ArrayPushCell(g_hclass_modelindex, -1)
	}
	
	ArrayPushString(g_hclass_handmodel, handmodel)
	ArrayPushCell(g_hclass_hp, hp)
	ArrayPushCell(g_hclass_spd, speed)
	ArrayPushCell(g_hclass_grav, gravity)
	
	// Set temporary new class flag
	ArrayPushCell(g_hclass_new, 1)
	
	// Override human classes data with our customizations
	new i, k, buffer[64], Float:buffer2, nummodels_custom, nummodels_default, prec_mdl[175], size = ArraySize(g_hclass2_realname)
	for (i = 0; i < size; i++)
	{
		ArrayGetString(g_hclass2_realname, i, buffer, 63)
		
		// Check if this is the intended class to override
		if (!equali(name, buffer))
			continue;
		
		// Remove new class flag
		ArraySetCell(g_hclass_new, g_hclass_i, 0)
		
		// Replace caption
		ArrayGetString(g_hclass2_name, i, buffer, 63)
		ArraySetString(g_hclass_name, g_hclass_i, buffer)
		
		// Replace info
		ArrayGetString(g_hclass2_info, i, buffer, 63)
		ArraySetString(g_hclass_info, g_hclass_i, buffer)
		
		// Replace models, unless using same models for all classes
		if (!g_same_models_for_all)
		{
			nummodels_custom = ArrayGetCell(g_hclass2_modelsend, i) - ArrayGetCell(g_hclass2_modelsstart, i)
			nummodels_default = ArrayGetCell(g_hclass_modelsend, g_hclass_i) - ArrayGetCell(g_hclass_modelsstart, g_hclass_i)
			
			// Replace each player model and model index
			for (k = 0; k < min(nummodels_custom, nummodels_default); k++)
			{
				ArrayGetString(g_hclass2_playermodel, ArrayGetCell(g_hclass2_modelsstart, i) + k, buffer, 63)
				ArraySetString(g_hclass_playermodel, ArrayGetCell(g_hclass_modelsstart, g_hclass_i) + k, buffer)
				
				// Precache player model and replace its modelindex with the real one
				formatex(prec_mdl, 174, "models/player/%s/%s.mdl", buffer, buffer)
				ArraySetCell(g_hclass_modelindex, ArrayGetCell(g_hclass_modelsstart, g_hclass_i) + k, engfunc(EngFunc_PrecacheModel, prec_mdl))
				if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, prec_mdl)
				if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, prec_mdl)
				// Precache modelT.mdl files too
				copy(prec_mdl[strlen(prec_mdl)-4], 174 - (strlen(prec_mdl)-4), "T.mdl")
				if (file_exists(prec_mdl)) engfunc(EngFunc_PrecacheModel, prec_mdl)
			}
			
			// We have more custom models than what we can accommodate,
			// Let's make some space...
			if (nummodels_custom > nummodels_default)
			{
				for (k = nummodels_default; k < nummodels_custom; k++)
				{
					ArrayGetString(g_hclass2_playermodel, ArrayGetCell(g_hclass2_modelsstart, i) + k, buffer, 63)
					ArrayInsertStringAfter(g_hclass_playermodel, ArrayGetCell(g_hclass_modelsstart, g_hclass_i) + k - 1, buffer)
					
					// Precache player model and retrieve its modelindex
					formatex(prec_mdl, 174, "models/player/%s/%s.mdl", buffer, buffer)
					ArrayInsertCellAfter(g_hclass_modelindex, ArrayGetCell(g_hclass_modelsstart, g_hclass_i) + k - 1, engfunc(EngFunc_PrecacheModel, prec_mdl))
					if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, prec_mdl)
					if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, prec_mdl)
					// Precache modelT.mdl files too
					copy(prec_mdl[strlen(prec_mdl)-4], 174 - (strlen(prec_mdl)-4), "T.mdl")
					if (file_exists(prec_mdl)) engfunc(EngFunc_PrecacheModel, prec_mdl)
				}
				
				// Fix models end index for this class
				ArraySetCell(g_hclass_modelsend, g_hclass_i, ArrayGetCell(g_hclass_modelsend, g_hclass_i) + (nummodels_custom - nummodels_default))
			}
			
			/* --- Not needed since classes can't have more than 1 default model for now ---
			// We have less custom models than what this class has by default,
			// Get rid of those extra entries...
			if (nummodels_custom < nummodels_default)
			{
				for (k = nummodels_custom; k < nummodels_default; k++)
				{
					ArrayDeleteItem(g_hclass_playermodel, ArrayGetCell(g_hclass_modelsstart, g_hclass_i) + nummodels_custom)
				}
				
				// Fix models end index for this class
				ArraySetCell(g_hclass_modelsend, g_hclass_i, ArrayGetCell(g_hclass_modelsend, g_hclass_i) - (nummodels_default - nummodels_custom))
			}
			*/
		}
		
		// Replace handmodel
		ArrayGetString(g_hclass2_handmodel, i, buffer, 63)
		ArraySetString(g_hclass_handmodel, g_hclass_i, buffer)
		
		// Precache handmodel
		formatex(prec_mdl, 174, "models/%s", buffer)
		engfunc(EngFunc_PrecacheModel, prec_mdl)
		
		// Replace health
		buffer[0] = ArrayGetCell(g_hclass2_hp, i)
		ArraySetCell(g_hclass_hp, g_hclass_i, buffer[0])
		
		// Replace speed
		buffer[0] = ArrayGetCell(g_hclass2_spd, i)
		ArraySetCell(g_hclass_spd, g_hclass_i, buffer[0])
		
		// Replace gravity
		buffer2 = Float:ArrayGetCell(g_hclass2_grav, i)
		ArraySetCell(g_hclass_grav, g_hclass_i, buffer2)
	}
	
	// If class was not overriden with customization data
	if (ArrayGetCell(g_hclass_new, g_hclass_i))
	{
		// If not using same models for all classes
		if (!g_same_models_for_all)
		{
			// Precache default class model and replace modelindex with the real one
			formatex(prec_mdl, 174, "models/player/%s/%s.mdl", model, model)
			ArraySetCell(g_hclass_modelindex, ArrayGetCell(g_hclass_modelsstart, g_hclass_i), engfunc(EngFunc_PrecacheModel, prec_mdl))
			if (g_force_consistency == 1) force_unmodified(force_model_samebounds, {0,0,0}, {0,0,0}, prec_mdl)
			if (g_force_consistency == 2) force_unmodified(force_exactfile, {0,0,0}, {0,0,0}, prec_mdl)
			// Precache modelT.mdl files too
			copy(prec_mdl[strlen(prec_mdl)-4], 174 - (strlen(prec_mdl)-4), "T.mdl")
			if (file_exists(prec_mdl)) engfunc(EngFunc_PrecacheModel, prec_mdl)
		}
		
		// Precache default handmodel
		formatex(prec_mdl, 174, "models/%s", handmodel)
		engfunc(EngFunc_PrecacheModel, prec_mdl)
	}
	
	// Increase registered classes counter
	g_hclass_i++
	
	// Return id under which we registered the class
	return g_hclass_i-1;
}

// Native: zp_get_extra_item_id
public native_get_extra_item_id(const name[])
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	// Strings passed byref
	param_convert(1)
	
	// Loop through every item (not using Tries since ZP should work on AMXX 1.8.0)
	static item_name[32]
	for (new i = 0; i < g_extraitem_i; i++)
	{
		ArrayGetString(g_extraitem_name, i, item_name, 31)
		
		// Check if this is the item to retrieve
		if (equali(name, item_name))
			return i;
	}
	
	return -1;
}

// Native: zp_get_zombie_class_id
public native_get_zombie_class_id(const name[])
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	// Strings passed byref
	param_convert(1)
	
	// Loop through every class (not using Tries since ZP should work on AMXX 1.8.0)
	static class_name[32]
	for (new i = 0; i < g_zclass_i; i++)
	{
		ArrayGetString(g_zclass_name, i, class_name, 31)
		
		// Check if this is the class to retrieve
		if (equali(name, class_name))
			return i;
	}
	
	return -1;
}

// Native: zp_get_zombie_class_info
public native_get_zombie_class_info(classid, info[], len)
{
	// ZP disabled
	if (!g_pluginenabled)
		return false;
	
	// Invalid class
	if (classid < 0 || classid >= g_zclass_i)
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid zombie class id (%d)", classid)
		return false;
	}
	
	// Strings passed byref
	param_convert(2)
	
	// Fetch zombie class info
	ArrayGetString(g_zclass_info, classid, info, len)
	return true;
}

// Native: zpnm_get_human_class_id
public native_get_human_class_id(const name[])
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	// Strings passed byref
	param_convert(1)
	
	// Loop through every class (not using Tries since ZP should work on AMXX 1.8.0)
	static class_name[32]
	for (new i = 0; i < g_hclass_i; i++)
	{
		ArrayGetString(g_hclass_name, i, class_name, 31)
		
		// Check if this is the class to retrieve
		if (equali(name, class_name))
			return i;
	}
	
	return -1;
}

// Native: zpnm_get_human_class_info
public native_get_human_class_info(classid, info[], len)
{
	// ZP disabled
	if (!g_pluginenabled)
		return false;
	
	// Invalid class
	if (classid < 0 || classid >= g_hclass_i)
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid human class id (%d)", classid)
		return false;
	}
	
	// Strings passed byref
	param_convert(2)
	
	// Fetch human class info
	ArrayGetString(g_hclass_info, classid, info, len)
	return true;
}

// Native: zpnm_set_user_health
public native_set_user_health(id, health, killer, shouldgib)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	if (!health && !is_user_valid(killer))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Killer (%d)", killer)
		return -1;
	}
	
	if (health > 0)
		fm_set_user_health(id, health)
	else
		ExecuteHamB(Ham_Killed, id, killer, shouldgib)
	
	return true;
}

// Native: zpnm_set_user_armor
public native_set_user_armor(id, armor)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	if (armor < 100)
		cs_set_user_armor(id, armor, CS_ARMOR_NONE)
	else
		cs_set_user_armor(id, armor, CS_ARMOR_VESTHELM)
	
	return true;
}

// Native: zpnm_get_user_burning
public native_get_user_burning(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	if (!task_exists(id+TASK_BURN))
		return false;
	
	return g_burning_duration[id];
}

// Native: zpnm_set_user_burning
public native_set_user_burning(id, timer, attacker)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	if (attacker && !is_user_valid(attacker))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Attacker (%d)", attacker)
		return -1;
	}
	
	static atk[2]
	atk[0] = attacker
	
	if (timer)
	{
		if (task_exists(id+TASK_BURN) || g_burning_duration[id] > 0)
			remove_task(id+TASK_BURN)
		
		g_burning_duration[id] = timer
		set_task(0.2, "burning_flame", id+TASK_BURN, atk, 1, "b")
	}
	else
	{
		if (!task_exists(id+TASK_BURN) || g_burning_duration[id] < 1)
			return 0;
		
		remove_task(id+TASK_BURN)
		g_burning_duration[id] = 0
		burning_flame(atk, id+TASK_BURN)
	}
	
	return true;
}

// Native: zpnm_get_user_frozen
public native_get_user_frozen(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_frozen[id];
}

// Native: zpnm_set_user_frozen
public native_set_user_frozen(id, set, attacker)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	if (attacker && !is_user_valid(attacker))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Attacker (%d)", attacker)
		return -1;
	}
	
	static atk[2]
	atk[0] = attacker
	
	// Unfreeze the player if he is frozen
	if (!set)
	{
		if (!g_frozen[id])
			return false;
		
		remove_task(id+TASK_UNFREEZE)
		remove_freeze(atk, id+TASK_UNFREEZE)
	}
	else
	{
		// If he's already frozen, then keep him that way or else freeze him
		if (g_frozen[id])
			remove_task(id+TASK_UNFREEZE)
		else
			set_freeze(id, attacker)
	}
	
	return true;
}

// Native: zpnm_get_user_no_damage
public native_get_user_no_damage(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_nodamage[id];
}

// Native: zpnm_set_user_no_damage
public native_set_user_no_damage(id, Float:timer, effects)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	if (timer > 0.0)
	{
		if (g_nodamage[id])
			native_set_user_no_damage(id, 0.0, 0)
		
		g_nodamage[id] = true
		set_task(timer, "madness_over", id+TASK_BLOOD)
		
		if (!effects)
			return true;
		
		static sound[64]
		
		if (g_zombie[id])
		{
			ArrayGetString(class_sound_madness, random_num(0, ArraySize(class_sound_madness) - 1), sound, 63)
			emit_sound(id, CHAN_VOICE, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		else
		{
			ArrayGetString(sound_survivor, random_num(0, ArraySize(sound_survivor) - 1), sound, 63)
			emit_sound(id, CHAN_VOICE, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		
		if (task_exists(id+TASK_AURA))
			return true;
		
		if (g_zombie[id])
			set_task(0.1, "zombie_aura", id+TASK_AURA, _, _, "b")
		else
			set_task(0.1, "human_aura", id+TASK_AURA, _, _, "b")
	}
	else
	{
		if (!g_nodamage[id])
			return false;
		
		// Stop the scheduled no damage removal(this also stops 2 more zombie tasks)
		remove_task(id+TASK_BLOOD)
		
		// Manually remove it
		g_nodamage[id] = false
		
		// Re-start the zombie tasks if they meet the right conditions
		if (g_zombie[id])
		{
			// Make sure it's just a zombie
			if (g_nemesis[id] || g_assassin[id])
				return true;
			
			// Call the bloody task
			if (get_pcvar_num(cvar_zombiebleeding))
				set_task(0.7, "make_blood", id+TASK_BLOOD, _, _, "b")
			
			// Idle sounds task
			set_task(random_float(50.0, 70.0), "zombie_play_idle", id+TASK_BLOOD, _, _, "b")
			
			// Aura will automatically stop if it's no longer needed
			zombie_aura(id+TASK_AURA)
		}
		else
			human_aura(id+TASK_AURA)
	}
	
	return true;
}

// Native: zpnm_get_user_model
public native_get_user_model(id, model[], len)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	// Strings passed byref
	param_convert(2)
	
	return copy(model, len, g_playermodel[id]);
}

// Native: zpnm_get_user_maxspeed
public native_get_user_maxspeed(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return pev(id, pev_maxspeed);
}

// Native: zpnm_set_user_maxspeed
public native_set_user_maxspeed(id, maxspeed)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	set_pev(id, pev_maxspeed, maxspeed)
	
	return true;
}

// Native: zpnm_reset_user_maxspeed
public native_reset_user_maxspeed(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	fw_ResetMaxSpeed_Post(id)
	
	return true;
}

// Native: zpnm_get_user_gravity
public native_get_user_gravity(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	if (!g_frozen[id])
		return pev(id, pev_gravity);
	
	return floatround(g_frozen_gravity[id]);
}

// Native: zpnm_set_user_gravity
public native_set_user_gravity(id, gravity)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	if (!g_frozen[id])
		set_pev(id, pev_gravity, Float:gravity)
	else
		g_frozen_gravity[id] = Float:gravity
	
	return true;
}

// Native: zpnm_get_user_knockback
public Float:native_get_user_knockback(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1.0;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1.0;
	}
	
	if (!g_zombie[id])
		return Float:false;
	
	if (g_nemesis[id])
		return g_cached_nemkb[id];
	else if (g_assassin[id])
		return g_cached_asskb[id];
	else
		return g_cached_zmknockback[id];
	
	return Float:true;
}

// Native: zpnm_set_user_knockback
public native_set_user_knockback(id, Float:knockback)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	if (!g_zombie[id])
		return false;
	
	if (knockback >= 0.0)
	{
		g_cached_zmknockback[id] = knockback
		g_cached_nemkb[id] = knockback
		g_cached_asskb[id] = knockback
	}
	else
	{
		g_cached_zmknockback[id] = Float:ArrayGetCell(g_zclass_kb, g_zombieclass[id])
		g_cached_nemkb[id] = get_pcvar_float(cvar_nemknockback)
		g_cached_asskb[id] = get_pcvar_float(cvar_assknockback)
	}
	
	return true;
}

// Native: zpnm_strip_user_weapons
public native_strip_user_weapons(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	fm_strip_user_weapons(id)
	
	return true;
}

// Native: zpnm_give_user_item
public native_give_user_item(const id, const item[], const ammo)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	// Give the new weapon
	fm_give_item(id, item)
	
	// Give full ammo
	if (ammo)
	{
		new weaponid = cs_weapon_name_to_id(item)
		ExecuteHamB(Ham_GiveAmmo, id, MAXBPAMMO[weaponid], AMMOTYPE[weaponid], MAXBPAMMO[weaponid])
	}
	
	return true;
}

// Native: zpnm_get_user_valid
public native_get_user_valid(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
		return false;
	
	return true;
}

// Native: zpnm_get_user_connected
public native_get_user_connected(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_isconnected[id];
}

// Native: zpnm_get_user_alive
public native_get_user_alive(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_isalive[id];
}

// Native: zpnm_get_class_name
public native_get_class_name(team, classid, info[], len)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (classid < 0)
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Given class id must be higher than 0")
		return -1;
	}
		
	param_convert(3)
	
	if (!team) // zombies
	{
		if (classid >= g_zclass_i)
		{
			log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Given zombie class id exceeds the current existing class count")
			return -1;
		}
		
		ArrayGetString(g_zclass_name, classid, info, len)
	}
	else // humans
	{
		if (classid >= g_hclass_i)
		{
			log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Given human class id exceeds the current existing class count")
			return -1;
		}
		
		ArrayGetString(g_hclass_name, classid, info, len)
	}
	
	return true;
}

// Native: zpnm_drop_user_weapons
public native_drop_user_weapons(id, type)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	drop_weapons(id, type)
	
	return true;
}

// Native: zpnm_set_game_mode
public native_set_game_mode(gamemode, id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (id && !is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	if (!g_newround)
		return false;
	
	remove_task(TASK_MAKEZOMBIE)
	
	if (gamemode > -1)
		make_a_zombie(gamemode, id)
	
	return true;
}

// Native: zpnm_teleport_user
public native_teleport_user(id, base)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id) || !g_isalive[id])
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid or Dead Player (%d)", id)
		return -1;
	}
	
	do_random_spawn(id, base)
	
	return true;
}

// Native: zpnm_get_user_unlimited_ammo
public native_get_user_unlimited_ammo(id)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	
	return g_infammo[id];
}

// Native: zpnm_set_user_unlimited_ammo
public native_set_user_unlimited_ammo(id, set)
{
	// ZP disabled
	if (!g_pluginenabled)
		return -1;
	
	if (!is_user_valid(id))
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Invalid Player (%d)", id)
		return -1;
	}
	else if (!g_isalive[id])
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Dead Player (%d)", id)
		return -1;
	}
	else if (g_zombie[id])
	{
		log_error(AMX_ERR_NATIVE, "[ Zombie Server ] Zombie Player (%d)", id)
		return -1;
	}
	
	g_infammo[id] = set
	
	return true;
}

/*================================================================================
 [Custom Messages]
=================================================================================*/

// Custom Night Vision
public set_user_nvision(taskid)
{
	// Get player's origin
	static origin[3]
	get_user_origin(ID_NVISION, origin)
	
	// Nightvision message
	message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, _, ID_NVISION)
	write_byte(TE_DLIGHT) // TE id
	write_coord(origin[0]) // x
	write_coord(origin[1]) // y
	write_coord(origin[2]) // z
	write_byte(cvar_nvgsize) // radius
	
	// Nemesis / Madness / Spectator in nemesis round
	if (g_nemesis[ID_NVISION] || (g_zombie[ID_NVISION] && g_nodamage[ID_NVISION]) || (!g_isalive[ID_NVISION] && g_nemround))
	{
		write_byte(cvar_nemnvgcolor[0]) // r
		write_byte(cvar_nemnvgcolor[1]) // g
		write_byte(cvar_nemnvgcolor[2]) // b
	}
	else if (g_assassin[ID_NVISION] || (g_zombie[ID_NVISION] && g_nodamage[ID_NVISION]) || (!g_isalive[ID_NVISION] && g_assround))
	{
		write_byte(cvar_assnvgcolor[0]) // r
		write_byte(cvar_assnvgcolor[1]) // g
		write_byte(cvar_assnvgcolor[2]) // b
	}
	// Human / Spectator in normal round
	else if (!g_zombie[ID_NVISION] || !g_isalive[ID_NVISION])
	{
		write_byte(cvar_humnvgcolor[0]) // r
		write_byte(cvar_humnvgcolor[1]) // g
		write_byte(cvar_humnvgcolor[2]) // b
	}
	// Zombie
	else
	{
		write_byte(cvar_nvgcolor[0]) // r
		write_byte(cvar_nvgcolor[1]) // g
		write_byte(cvar_nvgcolor[2]) // b
	}
	
	write_byte(2) // life
	write_byte(0) // decay rate
	message_end()
}

// Game Nightvision
set_user_gnvision(id, toggle)
{
	// Toggle NVG message
	message_begin(MSG_ONE, g_msgNVGToggle, _, id)
	write_byte(toggle) // toggle
	message_end()
}

// Custom Flashlight
public set_user_flashlight(taskid)
{
	// Get player and aiming origins
	static Float:originF[3], Float:destoriginF[3]
	pev(ID_FLASH, pev_origin, originF)
	fm_get_aim_origin(ID_FLASH, destoriginF)
	
	// Max distance check
	if (get_distance_f(originF, destoriginF) > get_pcvar_float(cvar_flashdist))
		return;
	
	static rgb[3]
	new size
	
	if (!g_assround)
	{
		rgb[0] = cvar_flashcolor[0]
		rgb[1] = cvar_flashcolor[1]
		rgb[2] = cvar_flashcolor[2]
		size = cvar_flashsize
	}
	else
	{
		rgb[0] = cvar_assnvgcolor[0]
		rgb[1] = cvar_assnvgcolor[1]
		rgb[2] = cvar_assnvgcolor[2]
		size = 9
	}
	
	// Send to all players?
	if (cvar_flashshowall)
		engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, destoriginF, 0)
	else
		message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, _, ID_FLASH)
	
	// Flashlight
	write_byte(TE_DLIGHT) // TE id
	engfunc(EngFunc_WriteCoord, destoriginF[0]) // x
	engfunc(EngFunc_WriteCoord, destoriginF[1]) // y
	engfunc(EngFunc_WriteCoord, destoriginF[2]) // z
	write_byte(size) // radius
	write_byte(rgb[0]) // r
	write_byte(rgb[1]) // g
	write_byte(rgb[2]) // b
	write_byte(3) // life
	write_byte(0) // decay rate
	message_end()
}

// Infection special effects
infection_effects(id)
{
	// Screen fade? (unless frozen)
	if (!g_frozen[id] && get_pcvar_num(cvar_infectionscreenfade))
	{
		message_begin(MSG_ONE_UNRELIABLE, g_msgScreenFade, _, id)
		write_short(UNIT_SECOND) // duration
		write_short(0) // hold time
		write_short(FFADE_IN) // fade type
		if (g_nemesis[id])
		{
			write_byte(cvar_nemnvgcolor[0]) // r
			write_byte(cvar_nemnvgcolor[1]) // g
			write_byte(cvar_nemnvgcolor[2]) // b
		}
		else if (g_assassin[id])
		{
			write_byte(cvar_assnvgcolor[0]) // r
			write_byte(cvar_assnvgcolor[1]) // g
			write_byte(cvar_assnvgcolor[2]) // b
		}
		else
		{
			write_byte(cvar_nvgcolor[0]) // r
			write_byte(cvar_nvgcolor[1]) // g
			write_byte(cvar_nvgcolor[2]) // b
		}
		write_byte (255) // alpha
		message_end()
	}
	
	// Screen shake?
	if (get_pcvar_num(cvar_infectionscreenshake))
	{
		message_begin(MSG_ONE_UNRELIABLE, g_msgScreenShake, _, id)
		write_short(UNIT_SECOND*4) // amplitude
		write_short(UNIT_SECOND*2) // duration
		write_short(UNIT_SECOND*10) // frequency
		message_end()
	}
	
	// Infection icon?
	if (get_pcvar_num(cvar_hudicons))
	{
		message_begin(MSG_ONE_UNRELIABLE, g_msgDamage, _, id)
		write_byte(0) // damage save
		write_byte(0) // damage take
		write_long(DMG_NERVEGAS) // damage type - DMG_RADIATION
		write_coord(0) // x
		write_coord(0) // y
		write_coord(0) // z
		message_end()
	}
	
	// Get player's origin
	static origin[3]
	get_user_origin(id, origin)
	
	// Tracers?
	if (get_pcvar_num(cvar_infectiontracers))
	{
		message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
		write_byte(TE_IMPLOSION) // TE id
		write_coord(origin[0]) // x
		write_coord(origin[1]) // y
		write_coord(origin[2]) // z
		write_byte(128) // radius
		write_byte(20) // count
		write_byte(3) // duration
		message_end()
	}
	
	// Particle burst?
	if (get_pcvar_num(cvar_infectionparticles))
	{
		message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
		write_byte(TE_PARTICLEBURST) // TE id
		write_coord(origin[0]) // x
		write_coord(origin[1]) // y
		write_coord(origin[2]) // z
		write_short(50) // radius
		write_byte(70) // color
		write_byte(3) // duration (will be randomized a bit)
		message_end()
	}
	
	// Light sparkle?
	if (get_pcvar_num(cvar_infectionsparkle))
	{
		message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
		write_byte(TE_DLIGHT) // TE id
		write_coord(origin[0]) // x
		write_coord(origin[1]) // y
		write_coord(origin[2]) // z
		write_byte(20) // radius
		write_byte(cvar_nvgcolor[0]) // r
		write_byte(cvar_nvgcolor[1]) // g
		write_byte(cvar_nvgcolor[2]) // b
		write_byte(2) // life
		write_byte(0) // decay rate
		message_end()
	}
}

// Nemesis/madness aura task
public zombie_aura(taskid)
{
	// Not nemesis, not in zombie madness
	if (!g_nemesis[ID_AURA] && !g_assassin[ID_AURA] && !g_nodamage[ID_AURA])
	{
		// Task not needed anymore
		remove_task(taskid);
		return;
	}
	
	aura(ID_AURA, 1)
}

// Survivor/madness aura task
public human_aura(taskid)
{
	// Not survivor, not in zombie madness
	if (!g_survivor[ID_AURA] && !g_sniper[ID_AURA] && !g_nodamage[ID_AURA])
	{
		// Task not needed anymore
		remove_task(taskid)
		
		return;
	}
	
	aura(ID_AURA, 0)
}

aura(id, zombie)
{
	// Get player's origin
	static origin[3]
	get_user_origin(id, origin)
	
	// Colored Aura
	message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
	write_byte(TE_DLIGHT) // TE id
	write_coord(origin[0]) // x
	write_coord(origin[1]) // y
	write_coord(origin[2]) // z
	write_byte(31) // radius
	switch (zombie)
	{
		case 0:
		{
			write_byte(cvar_humnvgcolor[0]) // r
			write_byte(cvar_humnvgcolor[1]) // g
			write_byte(cvar_humnvgcolor[2]) // b
		}
		case 1:
		{
			switch (g_assassin[id])
			{
				case false:
				{
					write_byte(cvar_nemnvgcolor[0]) // r
					write_byte(cvar_nemnvgcolor[1]) // g
					write_byte(cvar_nemnvgcolor[2]) // b
				}
				case true:
				{
					write_byte(cvar_assnvgcolor[0]) // r
					write_byte(cvar_assnvgcolor[1]) // g
					write_byte(cvar_assnvgcolor[2]) // b
				}
			}
		}
	}
	write_byte(2) // life
	write_byte(0) // decay rate
	message_end()
}

// Make zombies leave footsteps and bloodstains on the floor
public make_blood(taskid)
{
	// Only bleed when moving on ground
	if (!(pev(ID_BLOOD, pev_flags) & FL_ONGROUND) || fm_get_speed(ID_BLOOD) < 80)
		return;
	
	// Get user origin
	static Float:originF[3]
	pev(ID_BLOOD, pev_origin, originF)
	
	// If ducking set a little lower
	if (pev(ID_BLOOD, pev_bInDuck))
		originF[2] -= 18.0
	else
		originF[2] -= 36.0
	
	// Send the decal message
	engfunc(EngFunc_MessageBegin, MSG_PAS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_WORLDDECAL) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	write_byte(ArrayGetCell(zombie_decals, random_num(0, ArraySize(zombie_decals) - 1)) + (g_czero * 12)) // random decal number (offsets +12 for CZ)
	message_end()
}

// Flare Lighting Effects
flare_lighting(entity, duration)
{
	// Get origin and color
	static Float:originF[3], color[3], size
	pev(entity, pev_origin, originF)
	
	if (!g_assround)
	{
		pev(entity, PEV_FLARE_COLOR, color)
		size = get_pcvar_num(cvar_flaresize)
	}
	else
	{
		color[0] = cvar_assnvgcolor[0]
		color[1] = cvar_assnvgcolor[1]
		color[2] = cvar_assnvgcolor[2]
		size = 15
	}
	
	fm_set_rendering(entity, kRenderFxGlowShell, color[0], color[1], color[2], kRenderNormal);
	
	// Lighting
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_DLIGHT) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	write_byte(size) // radius
	write_byte(color[0]) // r
	write_byte(color[1]) // g
	write_byte(color[2]) // b
	write_byte(21) //life
	write_byte((duration < 2) ? 3 : 0) //decay rate
	message_end()
	
	// Sparks
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_SPARKS) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	message_end()
}

// Burning Flames
public burning_flame(attacker[], taskid)
{
	static damage
	damage = floatround(get_pcvar_float(cvar_firedamage), floatround_ceil)
	
	ExecuteForward(g_fwUserBurn, g_fwDummyResult, ID_BURN, attacker[0], damage, 0);
	
	// Get player origin and flags
	static origin[3], flags
	get_user_origin(ID_BURN, origin)
	flags = pev(ID_BURN, pev_flags)
	
	// Madness mode - in water - burning stopped
	if (g_nodamage[ID_BURN] || (flags & FL_INWATER) || g_burning_duration[ID_BURN] < 1)
	{
		// Smoke sprite
		message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
		write_byte(TE_SMOKE) // TE id
		write_coord(origin[0]) // x
		write_coord(origin[1]) // y
		write_coord(origin[2]-50) // z
		write_short(g_smokeSpr) // sprite
		write_byte(random_num(15, 20)) // scale
		write_byte(random_num(10, 20)) // framerate
		message_end()
		
		// Task not needed anymore
		remove_task(taskid);
		return;
	}
	
	// Randomly play burning zombie scream sounds (not for nemesis)
	if (!g_nemesis[ID_BURN] && !g_assassin[ID_BURN] && !random_num(0, 20))
	{
		static sound[64]
		static pointers[10], end
		ArrayGetArray(pointer_class_sound_burn, g_zombieclass[ID_BURN], pointers)
		
		for (new i; i < 10; i++)
		{
			if (pointers[i] != -1)
			end = i
		}
		ArrayGetString(class_sound_burn, random_num(pointers[0], pointers[end]), sound, 63)
		emit_sound(ID_BURN, CHAN_VOICE, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	}
	
	// Fire slow down, unless nemesis
	if (!g_nemesis[ID_BURN] && !g_assassin[ID_BURN] && (flags & FL_ONGROUND) && get_pcvar_float(cvar_fireslowdown) > 0.0)
	{
		static Float:velocity[3]
		pev(ID_BURN, pev_velocity, velocity)
		xs_vec_mul_scalar(velocity, get_pcvar_float(cvar_fireslowdown), velocity)
		set_pev(ID_BURN, pev_velocity, velocity)
	}
	
	// Get player's health
	static health
	health = pev(ID_BURN, pev_health)
	
	// Take damage from the fire
	if (health - damage > 0)
		fm_set_user_health(ID_BURN, health - damage)
	
	// Flame sprite
	message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
	write_byte(TE_SPRITE) // TE id
	write_coord(origin[0]+random_num(-5, 5)) // x
	write_coord(origin[1]+random_num(-5, 5)) // y
	write_coord(origin[2]+random_num(0, 3)) // z
	write_short(g_flameSpr) // sprite
	write_byte(random_num(5, 10)) // scale
	write_byte(200) // brightness
	message_end()
	
	// Decrease burning duration counter
	g_burning_duration[ID_BURN]--
	
	ExecuteForward(g_fwUserBurn, g_fwDummyResult, ID_BURN, attacker[0], damage, 1);
}

// Infection Bomb: Green Blast
create_blast(const Float:originF[3])
{
	// Smallest ring
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_BEAMCYLINDER) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	engfunc(EngFunc_WriteCoord, originF[0]) // x axis
	engfunc(EngFunc_WriteCoord, originF[1]) // y axis
	engfunc(EngFunc_WriteCoord, originF[2]+385.0) // z axis
	write_short(g_exploSpr) // sprite
	write_byte(0) // startframe
	write_byte(0) // framerate
	write_byte(4) // life
	write_byte(60) // width
	write_byte(0) // noise
	write_byte(cvar_nvgcolor[0]) // red-0
	write_byte(cvar_nvgcolor[1]) // green-200
	write_byte(cvar_nvgcolor[2]) // blue-0
	write_byte(200) // brightness
	write_byte(0) // speed
	message_end()
	
	// Infect Sprite
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte (TE_SPRITE) // TE ID
	engfunc(EngFunc_WriteCoord, originF[0]) // Position X
	engfunc(EngFunc_WriteCoord, originF[1]) // Y
	engfunc(EngFunc_WriteCoord, originF[2] + 50.0) // Z
	write_short(g_talrasha_infection2) // Sprite index
	write_byte(40) // Size of sprite
	write_byte(200) // Framerate
	message_end()
	
	// Medium ring
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_BEAMCYLINDER) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	engfunc(EngFunc_WriteCoord, originF[0]) // x axis
	engfunc(EngFunc_WriteCoord, originF[1]) // y axis
	engfunc(EngFunc_WriteCoord, originF[2]+470.0) // z axis
	write_short(g_exploSpr) // sprite
	write_byte(0) // startframe
	write_byte(0) // framerate
	write_byte(4) // life
	write_byte(60) // width
	write_byte(0) // noise
	write_byte(cvar_nvgcolor[0]) // red-0
	write_byte(cvar_nvgcolor[1]) // green-200
	write_byte(cvar_nvgcolor[2]) // blue-0
	write_byte(200) // brightness
	write_byte(0) // speed
	message_end()
	
	// Largest ring
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_BEAMCYLINDER) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	engfunc(EngFunc_WriteCoord, originF[0]) // x axis
	engfunc(EngFunc_WriteCoord, originF[1]) // y axis
	engfunc(EngFunc_WriteCoord, originF[2]+555.0) // z axis
	write_short(g_exploSpr) // sprite
	write_byte(0) // startframe
	write_byte(0) // framerate
	write_byte(4) // life
	write_byte(60) // width
	write_byte(0) // noise
	write_byte(cvar_nvgcolor[0]) // red-0
	write_byte(cvar_nvgcolor[1]) // green-200
	write_byte(cvar_nvgcolor[2]) // blue-0
	write_byte(200) // brightness
	write_byte(0) // speed
	message_end()
}

// Fire Grenade: Fire Blast
create_blast2(const Float:originF[3])
{
	// Smallest ring
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_BEAMCYLINDER) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	engfunc(EngFunc_WriteCoord, originF[0]) // x axis
	engfunc(EngFunc_WriteCoord, originF[1]) // y axis
	engfunc(EngFunc_WriteCoord, originF[2]+385.0) // z axis
	write_short(g_exploSpr) // sprite
	write_byte(0) // startframe
	write_byte(0) // framerate
	write_byte(4) // life
	write_byte(60) // width
	write_byte(0) // noise
	write_byte(200) // red
	write_byte(100) // green
	write_byte(0) // blue
	write_byte(200) // brightness
	write_byte(0) // speed
	message_end()
	
	// Fire Sprite
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte (TE_SPRITE) // TE ID
	engfunc(EngFunc_WriteCoord, originF[0]) // Position X
	engfunc(EngFunc_WriteCoord, originF[1]) // Y
	engfunc(EngFunc_WriteCoord, originF[2] + 50.0) // Z
	write_short(g_talrasha_fire) // Sprite index
	write_byte(40) // Size of sprite
	write_byte(200) // Framerate
	message_end()
	
	// Medium ring
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_BEAMCYLINDER) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	engfunc(EngFunc_WriteCoord, originF[0]) // x axis
	engfunc(EngFunc_WriteCoord, originF[1]) // y axis
	engfunc(EngFunc_WriteCoord, originF[2]+470.0) // z axis
	write_short(g_exploSpr) // sprite
	write_byte(0) // startframe
	write_byte(0) // framerate
	write_byte(4) // life
	write_byte(60) // width
	write_byte(0) // noise
	write_byte(200) // red
	write_byte(50) // green
	write_byte(0) // blue
	write_byte(200) // brightness
	write_byte(0) // speed
	message_end()
	
	// Largest ring
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_BEAMCYLINDER) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	engfunc(EngFunc_WriteCoord, originF[0]) // x axis
	engfunc(EngFunc_WriteCoord, originF[1]) // y axis
	engfunc(EngFunc_WriteCoord, originF[2]+555.0) // z axis
	write_short(g_exploSpr) // sprite
	write_byte(0) // startframe
	write_byte(0) // framerate
	write_byte(4) // life
	write_byte(60) // width
	write_byte(0) // noise
	write_byte(200) // red
	write_byte(0) // green
	write_byte(0) // blue
	write_byte(200) // brightness
	write_byte(0) // speed
	message_end()
}

// Frost Grenade: Freeze Blast
create_blast3(const Float:originF[3])
{
	// Smallest ring
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_BEAMCYLINDER) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	engfunc(EngFunc_WriteCoord, originF[0]) // x axis
	engfunc(EngFunc_WriteCoord, originF[1]) // y axis
	engfunc(EngFunc_WriteCoord, originF[2]+385.0) // z axis
	write_short(g_exploSpr) // sprite
	write_byte(0) // startframe
	write_byte(0) // framerate
	write_byte(4) // life
	write_byte(60) // width
	write_byte(0) // noise
	write_byte(0) // red
	write_byte(100) // green
	write_byte(200) // blue
	write_byte(200) // brightness
	write_byte(0) // speed
	message_end()
	
	// Frost Sprite
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte (TE_SPRITE) // TE ID
	engfunc(EngFunc_WriteCoord, originF[0]) // Position X
	engfunc(EngFunc_WriteCoord, originF[1]) // Y
	engfunc(EngFunc_WriteCoord, originF[2] + 50.0) // Z
	write_short(g_talrasha_frost) // Sprite index
	write_byte(40) // Size of sprite
	write_byte(200) // Framerate
	message_end()
	
	// Medium ring
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_BEAMCYLINDER) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	engfunc(EngFunc_WriteCoord, originF[0]) // x axis
	engfunc(EngFunc_WriteCoord, originF[1]) // y axis
	engfunc(EngFunc_WriteCoord, originF[2]+470.0) // z axis
	write_short(g_exploSpr) // sprite
	write_byte(0) // startframe
	write_byte(0) // framerate
	write_byte(4) // life
	write_byte(60) // width
	write_byte(0) // noise
	write_byte(0) // red
	write_byte(100) // green
	write_byte(200) // blue
	write_byte(200) // brightness
	write_byte(0) // speed
	message_end()
	
	// Largest ring
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, originF, 0)
	write_byte(TE_BEAMCYLINDER) // TE id
	engfunc(EngFunc_WriteCoord, originF[0]) // x
	engfunc(EngFunc_WriteCoord, originF[1]) // y
	engfunc(EngFunc_WriteCoord, originF[2]) // z
	engfunc(EngFunc_WriteCoord, originF[0]) // x axis
	engfunc(EngFunc_WriteCoord, originF[1]) // y axis
	engfunc(EngFunc_WriteCoord, originF[2]+555.0) // z axis
	write_short(g_exploSpr) // sprite
	write_byte(0) // startframe
	write_byte(0) // framerate
	write_byte(4) // life
	write_byte(60) // width
	write_byte(0) // noise
	write_byte(0) // red
	write_byte(100) // green
	write_byte(200) // blue
	write_byte(200) // brightness
	write_byte(0) // speed
	message_end()
}

// Flare Grenade: Flare Blast
create_blast4(const Float:originF[3])
{	
	// Flare Sprite
	message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
	write_byte (TE_SPRITE) // TE ID
	engfunc(EngFunc_WriteCoord, originF[0]) // Position X
	engfunc(EngFunc_WriteCoord, originF[1]) // Y
	engfunc(EngFunc_WriteCoord, originF[2] + 50.0) // Z
	write_short(g_talrasha_flare) // Sprite index
	write_byte(60) // Size of sprite
	write_byte(500) // Framerate
	message_end()
}

// Fix Dead Attrib on scoreboard
FixDeadAttrib(id)
{
	message_begin(MSG_BROADCAST, g_msgScoreAttrib)
	write_byte(id) // id
	write_byte(0) // attrib
	message_end()
}

// Send Death Message for infections
SendDeathMsg(attacker, victim)
{
	message_begin(MSG_BROADCAST, g_msgDeathMsg)
	write_byte(attacker) // killer
	write_byte(victim) // victim
	write_byte(1) // headshot flag
	write_string("infection") // killer's weapon
	message_end()
}

// Update Player Frags and Deaths
UpdateFrags(attacker, victim, frags, deaths, scoreboard)
{
	// Set attacker frags
	set_pev(attacker, pev_frags, float(pev(attacker, pev_frags) + frags))
	
	// Set victim deaths
	if (is_user_connected(victim))
		fm_cs_set_user_deaths(victim, cs_get_user_deaths(victim) + deaths)
	
	// Update scoreboard with attacker and victim info
	if (scoreboard)
	{
		message_begin(MSG_BROADCAST, g_msgScoreInfo)
		write_byte(attacker) // id
		write_short(pev(attacker, pev_frags)) // frags
		write_short(cs_get_user_deaths(attacker)) // deaths
		write_short(0) // class?
		write_short(fm_cs_get_user_team(attacker)) // team
		message_end()
		
		message_begin(MSG_BROADCAST, g_msgScoreInfo)
		write_byte(victim) // id
		write_short(pev(victim, pev_frags)) // frags
		write_short(cs_get_user_deaths(victim)) // deaths
		write_short(0) // class?
		write_short(fm_cs_get_user_team(victim)) // team
		message_end()
	}
}

// Remove Player Frags (when Nemesis/Survivor ignore_frags cvar is enabled)
RemoveFrags(attacker, victim)
{
	// Remove attacker frags
	set_pev(attacker, pev_frags, float(pev(attacker, pev_frags) - 1))
	
	// Remove victim deaths
	fm_cs_set_user_deaths(victim, cs_get_user_deaths(victim) - 1)
}

// Plays a sound on clients
PlaySound(const sound[], id = 0)
{
	if (is_mp3(sound)) //equali(sound[strlen(sound)-4], ".mp3")
		client_cmd(id, "mp3 play ^"sound/%s^"", sound)
	else
		client_cmd(id, "spk ^"%s^"", sound)
}

// Prints a colored message to target (use 0 for everyone), supports ML formatting.
// Note: I still need to make something like gungame's LANG_PLAYER_C to avoid unintended
// argument replacement when a function passes -1 (it will be considered a LANG_PLAYER)
zp_colored_print(target, const message[], any:...)
{
	static buffer[192], i, argscount, msgSayText;
	argscount = numargs()
	
	if (!msgSayText)
		msgSayText = get_user_msgid("SayText")
	
	// Send to everyone
	if (!target)
	{
		static player
		for (player = 1; player <= g_maxplayers; player++)
		{
			// Not connected
			if (!g_isconnected[player])
				continue;
			
			// Remember changed arguments
			static changed[5], changedcount // [5] = max LANG_PLAYER occurencies
			changedcount = 0
			
			// Replace LANG_PLAYER with player id
			for (i = 2; i < argscount; i++)
			{
				if (getarg(i) == LANG_PLAYER)
				{
					setarg(i, 0, player)
					changed[changedcount] = i
					changedcount++
				}
			}
			
			// Format message for player
			vformat(buffer, 191, message, 3)
			format(buffer, 191, "^1[^4SERVER^1] %s", buffer)
			
			// Send it
			message_begin(MSG_ONE_UNRELIABLE, msgSayText, _, player)
			write_byte(player)
			write_string(buffer)
			message_end()
			
			// Replace back player id's with LANG_PLAYER
			for (i = 0; i < changedcount; i++)
				setarg(changed[i], 0, LANG_PLAYER)
		}
	}
	// Send to specific target
	else
	{
		// Format message for player
		vformat(buffer, 191, message, 3)
		format(buffer, 191, "^1[^4SERVER^1] %s", buffer)
		
		// Send it
		message_begin(MSG_ONE, msgSayText, _, target)
		write_byte(target)
		write_string(buffer)
		message_end()
	}
}

/*================================================================================
 [Stocks]
=================================================================================*/

// Set an entity's key value (from fakemeta_util)
stock fm_set_kvd(entity, const key[], const value[], const classname[])
{
	set_kvd(0, KV_ClassName, classname)
	set_kvd(0, KV_KeyName, key)
	set_kvd(0, KV_Value, value)
	set_kvd(0, KV_fHandled, 0)

	dllfunc(DLLFunc_KeyValue, entity, 0)
}

// Set entity's rendering type (from fakemeta_util)
stock fm_set_rendering(entity, fx = kRenderFxNone, r = 255, g = 255, b = 255, render = kRenderNormal, amount = 19)
{
	new Float:color[3]
	color[0] = float(r)
	color[1] = float(g)
	color[2] = float(b)
	
	set_pev(entity, pev_renderfx, fx)
	set_pev(entity, pev_rendercolor, color)
	set_pev(entity, pev_rendermode, render)
	set_pev(entity, pev_renderamt, float(amount))
}

// Get entity's speed (from fakemeta_util)
stock fm_get_speed(entity)
{
	static Float:velocity[3]
	pev(entity, pev_velocity, velocity)
	
	return floatround(vector_length(velocity));
}

// Get entity's aim origins (from fakemeta_util)
stock fm_get_aim_origin(id, Float:origin[3])
{
	static Float:origin1F[3], Float:origin2F[3]
	pev(id, pev_origin, origin1F)
	pev(id, pev_view_ofs, origin2F)
	xs_vec_add(origin1F, origin2F, origin1F)

	pev(id, pev_v_angle, origin2F);
	engfunc(EngFunc_MakeVectors, origin2F)
	global_get(glb_v_forward, origin2F)
	xs_vec_mul_scalar(origin2F, 9999.0, origin2F)
	xs_vec_add(origin1F, origin2F, origin2F)

	engfunc(EngFunc_TraceLine, origin1F, origin2F, 0, id, 0)
	get_tr2(0, TR_vecEndPos, origin)
}

// Find entity by its owner (from fakemeta_util)
stock fm_find_ent_by_owner(entity, const classname[], owner)
{
	while ((entity = engfunc(EngFunc_FindEntityByString, entity, "classname", classname)) && pev(entity, pev_owner) != owner) { /* keep looping */ }
	return entity;
}

// Set player's health (from fakemeta_util)
stock fm_set_user_health(id, health)
{
	(health > 0) ? set_pev(id, pev_health, float(health)) : dllfunc(DLLFunc_ClientKill, id);
}

// Give an item to a player (from fakemeta_util)
stock fm_give_item(id, const item[])
{
	new ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, item))
	if (!pev_valid(ent)) return;
	
	new Float:originF[3]
	pev(id, pev_origin, originF)
	set_pev(ent, pev_origin, originF)
	set_pev(ent, pev_spawnflags, pev(ent, pev_spawnflags) | SF_NORESPAWN)
	dllfunc(DLLFunc_Spawn, ent)
	
	new save = pev(ent, pev_solid)
	dllfunc(DLLFunc_Touch, ent, id)
	if (pev(ent, pev_solid) != save)
		return;
	
	engfunc(EngFunc_RemoveEntity, ent)
}

// Strip user weapons (from fakemeta_util)
public fm_strip_user_weapons(id) // stock
{
	new ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "player_weaponstrip"))
	if (!pev_valid(ent)) return;
	
	dllfunc(DLLFunc_Spawn, ent)
	dllfunc(DLLFunc_Use, ent, id)
	engfunc(EngFunc_RemoveEntity, ent)
}

// Collect random spawn points
stock load_spawns()
{
	// Check for CSDM spawns of the current map
	new cfgdir[32], mapname[32], filepath[100], linedata[64]
	get_configsdir(cfgdir, 31)
	get_mapname(mapname, 31)
	formatex(filepath, 99, "%s/csdm/%s.spawns.cfg", cfgdir, mapname)
	
	// Load CSDM spawns if present
	if (file_exists(filepath))
	{
		new csdmdata[10][6], file = fopen(filepath,"rt")
		
		while (file && !feof(file))
		{
			fgets(file, linedata, 63)
			
			// invalid spawn
			if(!linedata[0] || str_count(linedata,' ') < 2) continue;
			
			// get spawn point data
			parse(linedata,csdmdata[0],5,csdmdata[1],5,csdmdata[2],5,csdmdata[3],5,csdmdata[4],5,csdmdata[5],5,csdmdata[6],5,csdmdata[7],5,csdmdata[8],5,csdmdata[9],5)
			
			// origin
			g_spawns[g_spawnCount][0] = floatstr(csdmdata[0])
			g_spawns[g_spawnCount][1] = floatstr(csdmdata[1])
			g_spawns[g_spawnCount][2] = floatstr(csdmdata[2])
			
			// increase spawn count
			g_spawnCount++
			if (g_spawnCount >= sizeof g_spawns) break;
		}
		if (file) fclose(file)
	}
	else
	{
		// Collect regular spawns
		collect_spawns_ent("info_player_start")
		collect_spawns_ent("info_player_deathmatch")
	}
	
	// Collect regular spawns for non-random spawning unstuck
	collect_spawns_ent2("info_player_start")
	collect_spawns_ent2("info_player_deathmatch")
}

// Collect spawn points from entity origins
stock collect_spawns_ent(const classname[])
{
	new ent = -1
	while ((ent = engfunc(EngFunc_FindEntityByString, ent, "classname", classname)) != 0)
	{
		// get origin
		new Float:originF[3]
		pev(ent, pev_origin, originF)
		g_spawns[g_spawnCount][0] = originF[0]
		g_spawns[g_spawnCount][1] = originF[1]
		g_spawns[g_spawnCount][2] = originF[2]
		
		// increase spawn count
		g_spawnCount++
		if (g_spawnCount >= sizeof g_spawns) break;
	}
}

// Collect spawn points from entity origins
stock collect_spawns_ent2(const classname[])
{
	new ent = -1
	while ((ent = engfunc(EngFunc_FindEntityByString, ent, "classname", classname)) != 0)
	{
		// get origin
		new Float:originF[3]
		pev(ent, pev_origin, originF)
		g_spawns2[g_spawnCount2][0] = originF[0]
		g_spawns2[g_spawnCount2][1] = originF[1]
		g_spawns2[g_spawnCount2][2] = originF[2]
		
		// increase spawn count
		g_spawnCount2++
		if (g_spawnCount2 >= sizeof g_spawns2) break;
	}
}

// Drop primary/secondary weapons
stock drop_weapons(id, dropwhat)
{
	// Get user weapons
	static weapons[32]
	new num = 0, i, weaponid
//	num = 0 // reset passed weapons count (bugfix)
	get_user_weapons(id, weapons, num)
	
	// Loop through them and drop primaries or secondaries
	for (i = 0; i < num; i++)
	{
		// Prevent re-indexing the array
		weaponid = weapons[i]
		
		if ((dropwhat == 1 && ((1<<weaponid) & PRIMARY_WEAPONS_BIT_SUM)) || (dropwhat == 2 && ((1<<weaponid) & SECONDARY_WEAPONS_BIT_SUM)))
		{
			// Get weapon entity
			static wname[32]
			get_weaponname(weaponid, wname, 31)
			new weapon_ent = fm_find_ent_by_owner(-1, wname, id)
			
			// Hack: store weapon bpammo on PEV_ADDITIONAL_AMMO
			set_pev(weapon_ent, PEV_ADDITIONAL_AMMO, cs_get_user_bpammo(id, weaponid))
			
			// Player drops the weapon and looses his bpammo
			engclient_cmd(id, "drop", wname)
			cs_set_user_bpammo(id, weaponid, 0)
		}
	}
}

// Stock by (probably) Twilight Suzuka -counts number of chars in a string
stock str_count(const str[], searchchar)
{
	new count, i, len = strlen(str)
	
	for (i = 0; i <= len; i++)
	{
		if(str[i] == searchchar)
			count++
	}
	
	return count;
}

// Checks if a space is vacant (credits to VEN)
stock is_hull_vacant(Float:origin[3], hull)
{
	engfunc(EngFunc_TraceHull, origin, origin, 0, hull, 0, 0)
	
	if (!get_tr2(0, TR_StartSolid) && !get_tr2(0, TR_AllSolid) && get_tr2(0, TR_InOpen))
		return true;
	
	return false;
}

// Check if a player is stuck (credits to VEN)
stock is_player_stuck(id)
{
	new Float:originF[3]
	pev(id, pev_origin, originF)
	
	engfunc(EngFunc_TraceHull, originF, originF, 0, (pev(id, pev_flags) & FL_DUCKING) ? HULL_HEAD : HULL_HUMAN, id, 0)
	
	if (get_tr2(0, TR_StartSolid) || get_tr2(0, TR_AllSolid) || !get_tr2(0, TR_InOpen))
		return true;
	
	return false;
}

// Simplified get_weaponid (CS only)
stock cs_weapon_name_to_id(const weapon[])
{
	for (new i = 0; i < sizeof WEAPONENTNAMES; i++)
	{
		if (equali(weapon, WEAPONENTNAMES[i]))
			return i;
	}
	
	return 0;
}

// Get User Current Weapon Entity
stock fm_cs_get_current_weapon_ent(id)
{
	// Prevent server crash if entity's private data not initalized
	if (pev_valid(id) != PDATA_SAFE)
		return -1;
	
	return get_pdata_cbase(id, OFFSET_ACTIVE_ITEM, OFFSET_LINUX);
}

// Get Weapon Entity's Owner
stock fm_cs_get_weapon_ent_owner(ent)
{
	// Prevent server crash if entity's private data not initalized
	if (pev_valid(ent) != PDATA_SAFE)
		return -1;
	
	return get_pdata_cbase(ent, OFFSET_WEAPONOWNER, OFFSET_LINUX_WEAPONS);
}

// Set User Deaths
stock fm_cs_set_user_deaths(id, value)
{
	// Prevent server crash if entity's private data not initalized
	if (pev_valid(id) != PDATA_SAFE)
		return;
	
	set_pdata_int(id, OFFSET_CSDEATHS, value, OFFSET_LINUX)
}

// Get User Team
stock fm_cs_get_user_team(id)
{
	// Prevent server crash if entity's private data not initalized
	if (pev_valid(id) != PDATA_SAFE)
		return FM_CS_TEAM_UNASSIGNED;
	
	return get_pdata_int(id, OFFSET_CSTEAMS, OFFSET_LINUX);
}

// Set a Player's Team
stock fm_cs_set_user_team(id, team)
{
	// Prevent server crash if entity's private data not initalized
	if (pev_valid(id) != PDATA_SAFE)
		return;
	
	set_pdata_int(id, OFFSET_CSTEAMS, team, OFFSET_LINUX)
}

// Set User Money
stock fm_cs_set_user_money(id, value)
{
	// Prevent server crash if entity's private data not initalized
	if (pev_valid(id) != PDATA_SAFE)
		return;
	
	set_pdata_int(id, OFFSET_CSMONEY, value, OFFSET_LINUX)
}

// Set User Flashlight Batteries
stock fm_cs_set_user_batteries(id, value)
{
	// Prevent server crash if entity's private data not initalized
	if (pev_valid(id) != PDATA_SAFE)
		return;
	
	set_pdata_int(id, OFFSET_FLASHLIGHT_BATTERY, value, OFFSET_LINUX)
}

// Update Player's Team on all clients (adding needed delays)
stock fm_user_team_update(id)
{
	new Float:current_time = get_gametime()
	
	if (current_time - g_teams_targettime >= 0.1)
	{
		set_task(0.1, "fm_cs_set_user_team_msg", id+TASK_TEAM)
		g_teams_targettime = current_time + 0.1
	}
	else
	{
		set_task((g_teams_targettime + 0.1) - current_time, "fm_cs_set_user_team_msg", id+TASK_TEAM)
		g_teams_targettime = g_teams_targettime + 0.1
	}
}

// Send User Team Message
public fm_cs_set_user_team_msg(taskid)
{
	// Note to self: this next message can now be received by other plugins
	
	// Set the switching team flag
	g_switchingteam = true
	
	// Tell everyone my new team
	emessage_begin(MSG_ALL, g_msgTeamInfo)
	ewrite_byte(ID_TEAM) // player
	ewrite_string(CS_TEAM_NAMES[fm_cs_get_user_team(ID_TEAM)]) // team
	emessage_end()
	
	// Done switching team
	g_switchingteam = false
}

// Set the precached model index (updates hitboxes server side)
stock fm_cs_set_user_model_index(id, value)
{
	// Prevent server crash if entity's private data not initalized
	if (pev_valid(id) != PDATA_SAFE)
		return;
	
	set_pdata_int(id, OFFSET_MODELINDEX, value, OFFSET_LINUX)
}

// Set Player Model on Entity
stock fm_set_playermodel_ent(id)
{
	// Make original player entity invisible without hiding shadows or firing effects
	fm_set_rendering(id, kRenderFxNone, 255, 255, 255, kRenderTransTexture)
	
	// Format model string
	static model[100]
	formatex(model, 99, "models/player/%s/%s.mdl", g_playermodel[id], g_playermodel[id])
	
	// Set model on entity or make a new one if unexistant
	if (!pev_valid(g_ent_playermodel[id]))
	{
		g_ent_playermodel[id] = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))
		if (!pev_valid(g_ent_playermodel[id])) return;
		
		set_pev(g_ent_playermodel[id], pev_classname, MODEL_ENT_CLASSNAME)
		set_pev(g_ent_playermodel[id], pev_movetype, MOVETYPE_FOLLOW)
		set_pev(g_ent_playermodel[id], pev_aiment, id)
		set_pev(g_ent_playermodel[id], pev_owner, id)
	}
	
	engfunc(EngFunc_SetModel, g_ent_playermodel[id], model)
}

// Set Weapon Model on Entity
stock fm_set_weaponmodel_ent(id)
{
	// Get player's p_ weapon model
	static model[100]
	pev(id, pev_weaponmodel2, model, 99)
	
	// Set model on entity or make a new one if unexistant
	if (!pev_valid(g_ent_weaponmodel[id]))
	{
		g_ent_weaponmodel[id] = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))
		if (!pev_valid(g_ent_weaponmodel[id])) return;
		
		set_pev(g_ent_weaponmodel[id], pev_classname, WEAPON_ENT_CLASSNAME)
		set_pev(g_ent_weaponmodel[id], pev_movetype, MOVETYPE_FOLLOW)
		set_pev(g_ent_weaponmodel[id], pev_aiment, id)
		set_pev(g_ent_weaponmodel[id], pev_owner, id)
	}
	
	engfunc(EngFunc_SetModel, g_ent_weaponmodel[id], model)
}

// Remove Custom Model Entities
stock fm_remove_model_ents(id)
{
	// Remove "playermodel" ent if present
	if (pev_valid(g_ent_playermodel[id]))
	{
		engfunc(EngFunc_RemoveEntity, g_ent_playermodel[id])
		g_ent_playermodel[id] = 0
	}
	// Remove "weaponmodel" ent if present
	if (pev_valid(g_ent_weaponmodel[id]))
	{
		engfunc(EngFunc_RemoveEntity, g_ent_weaponmodel[id])
		g_ent_weaponmodel[id] = 0
	}
}

// Set User Model
public fm_cs_set_user_model(taskid)
{
	set_user_info(ID_MODEL, "model", g_playermodel[ID_MODEL])
}

// Get User Model -model passed byref-
stock fm_cs_get_user_model(player, model[], len)
{
	get_user_info(player, "model", model, len)
}

// Update Player's Model on all clients (adding needed delays)
public fm_user_model_update(taskid)
{
	new Float:current_time = get_gametime()
	
	if (current_time - g_models_targettime >= g_modelchange_delay)
	{
		fm_cs_set_user_model(taskid)
		g_models_targettime = current_time
	}
	else
	{
		set_task((g_models_targettime + g_modelchange_delay) - current_time, "fm_cs_set_user_model", taskid)
		g_models_targettime = g_models_targettime + g_modelchange_delay
	}
}

stock ChatColor(const id, const input[], any:...)
{
    new count = 1, players[32]
    static msg[191]
    vformat(msg, 190, input, 3)
    
    replace_all(msg, 190, "!g", "^4") // Green Color
    replace_all(msg, 190, "!y", "^1") // Default Color
    replace_all(msg, 190, "!team", "^3") // Team Color
    replace_all(msg, 190, "!team2", "^0") // Team2 Color
    
    if (id) players[0] = id; else get_players(players, count, "ch")
    {
        for (new i = 0; i < count; i++)
        {
            if (is_user_connected(players[i]))
            {
                message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i])
                write_byte(players[i]);
                write_string(msg);
                message_end();
            }
        }
    }
}